<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%-- jsf:pagecode language="java" location="/JavaSource/pagecode/admin/repository/AdvancedConfiguration.java" --%><%-- /jsf:pagecode --%>
<%------------------------------------------------------------------------------
- Licensed Materials - Property of IBM
-
- (C) Copyright IBM Corporation 2006. All Rights Reserved.
- Note to U.S. Government Users Restricted Rights: Use, duplication or disclosure
- restricted by GSA ADP Schedule Contract with IBM Corp.
-----------------------------------------------------------------------------%>
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8"%>
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>

<html>
<head> 
	<%@include file="/theme/metaHeader.jspf"%>
	<%@include file="/theme/css.jspf"%>	
	<link rel="csh" href="${applicationScope.cshPath}">
	<title>${bundle.adminTitle}</title>
	<script type="text/javascript"> 
		function updateHiddenField(thisObj, thisEvent, id, value) {
			//use 'thisObj' to refer directly to this component instead of keyword 'this'
			//use 'thisEvent' to refer to the event generated instead of keyword 'event'
			//use 'SchemaName' to refer to schema to be removed 
			
			var hidden = document.getElementById(id);			
			hidden.value = value;
		} 
		 
	</script>
	

</head>
<f:view>
	<body class="ram">
	<hx:scriptCollector id="scriptCollector1">
		<%@include file="/theme/header.jspf"%>

		<div id="rightColumn">
		<div class="inside">
		<%@include file="/includes/administrationSideBar.jspf"%>
		<%@include file="/includes/repositoryStatisticsSideBar.jspf"%>
		</div>
		</div>
		
		<!-- Create Attribute Dialog -->

		<ram:form id="createForm">
			<hx:panelDialog type="modeless" align="center" valign="middle" id="createDialog" 
				styleClass="panelDialog panelDialog" title="#{bundle.dialogTitle_admin_createFeaturedContent}">
				<h:panelGroup id="createGroup1">
					<hx:panelFormBox helpPosition="under" labelPosition="left" id="createFormBox1" styleClass="panelFormBox">
						<hx:formItem id="createFormItem1" styleClass="formItem" label="#{bundle.label_file_type}">
							<h:inputText id="fileNameText" value="#{pc_AdvancedConfiguration.featuredContentFile}" styleClass="shortField" />
						</hx:formItem>
					</hx:panelFormBox>
					<h:inputHidden id="addIndex" value="#{pc_AdvancedConfiguration.addIndex}" /> 
				</h:panelGroup>

				<h:panelGroup id="createActionGroup" styleClass="dialogActionGroup">
					<hx:commandExButton id="okCreate" styleClass="commandExButton"
						iconDepressed="/theme/images/transparent.gif" type="submit"
						value="#{bundle.button_ok}" action="#{pc_AdvancedConfiguration.doAddFeatureContent}"> 
						 
					</hx:commandExButton>
					<hx:commandExButton id="cancelCreate" styleClass="commandExButton"
						iconDepressed="/theme/images/transparent.gif" type="button"
						value="#{bundle.button_cancel}">
						<hx:behaviorKeyPress id="cancelCreateBehavior1" key="ENTER"
							behaviorAction="click" targetAction="cancel" />
						<hx:behavior id="cancelCreateBehavior2" event="onclick"
							behaviorAction="hide;stop" targetAction="createDialog" />
					</hx:commandExButton>
				</h:panelGroup>
				<ram:infopop id="createAttributeInfopop" styleClass="dialogInfopop" 
					image="/theme/images/icons/obj16/info_indicator.gif" contextId="raac0042" />
			</hx:panelDialog>
		</ram:form>
		
<!-- End Create Attribute Dialog -->
		

		<div id="contentColumn">
		<div class="inside">
		<ram:form id="configurationForm">
		<ram:messagesEx id="statement" messages="#{pc_AdvancedConfiguration.statementMessage}" />
		<div class="primaryActionGroup_float_top">
			<hx:commandExButton id="topSaveButton" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" value="#{bundle.button_save}" type="submit" action="#{pc_AdvancedConfiguration.doSaveConfiguration}" />
		</div>	
		<h1>${bundle.navigation_admin_repos_advanced_config}</h1>

		<ram:messagesEx id="messages" globalOnly="true" />
		
		
		<h:panelGrid id="panelGridId1" columns="2" cellpadding="0" cellspacing="0" style="vertical-align: top" columnClasses="configGrid1, configGrid2">
				
			<hx:jspPanel id="artifactIndexerPanelId">
				<div class="primarySectionHeader" style="margin-top: 0"><h2>${bundle.admin_repository_config_indexing}</h2></div>
				<p class="sectionInstructions">${bundle.admin_repository_config_artifact_info_message}</p>
				
				<h:outputText id="timerText1" value="#{bundle.label_asset_index_schedule}" style="display:block; padding-bottom: 2px; padding-top: 8px;" styleClass="label"/>
				<h:panelGroup id="assetBuilderGroup" style="display:block;">
					<h:inputText id="assetbuilderText" value="#{pc_AdvancedConfiguration.assetIndexSchedule}" styleClass="shortField" />
					<h:selectOneMenu id="assetBuilderSelect" value="#{pc_AdvancedConfiguration.assetBuilderMenu}"  styleClass="shortSelect" style="width:auto; margin-left: 3px">
						<f:selectItems id="intervalTimeValues1" value="#{pc_AdvancedConfiguration.timeValues}"/>
					</h:selectOneMenu>
				</h:panelGroup> 
					
				<h:outputText id="timerText2" value="#{bundle.label_artifact_index_schedule}" style="display:block; padding-bottom: 2px; padding-top: 8px;" styleClass="label"/>
				<h:panelGroup id="artifactBuilderGroup" style="display:block;">	
					<h:inputText id="artifactbuilderText" value="#{pc_AdvancedConfiguration.artifactIndexSchedule}" styleClass="shortField" />
					<h:selectOneMenu id="artifactBuilderSelect" value="#{pc_AdvancedConfiguration.artifactBuilderMenu}"  styleClass="shortSelect" style="width:auto; margin-left: 3px">
						<f:selectItems id="intervalTimeValues2" value="#{pc_AdvancedConfiguration.timeValues}"/>
					</h:selectOneMenu>
				</h:panelGroup>
				
				<h:outputText id="timerText4" value="#{bundle.label_forum_index_schedule}" style="display:block; padding-bottom: 2px; padding-top: 8px;" styleClass="label"/>
				<h:panelGroup id="forumBuilderGroup" style="display:block;">	
						<h:inputText id="forumBuilderText" value="#{pc_AdvancedConfiguration.forumIndexSchedule}" styleClass="shortField" />
						<h:selectOneMenu id="forumBuilderSelect" value="#{pc_AdvancedConfiguration.forumBuilderMenu}"  styleClass="shortSelect" style="width:auto; margin-left: 3px">
						<f:selectItems id="intervalTimeValues4" value="#{pc_AdvancedConfiguration.timeValues}"/>
					</h:selectOneMenu>
				</h:panelGroup>
				
				<h:outputText id="timerText3" value="#{bundle.label_immediate_notification_sender_schedule}" style="display:block; padding-bottom: 2px; padding-top: 8px;" styleClass="label"/>
				<h:panelGroup id="immediateNotificationSenderBuilderGroup" style="display:block;">	
						<h:inputText id="immediateNotificationSenderBuilderText" value="#{pc_AdvancedConfiguration.immediateNotificationSchedule}" styleClass="shortField" />
						<h:selectOneMenu id="immediateNotificationSenderBuilderSelect" value="#{pc_AdvancedConfiguration.immediateNotificationBuilderMenu}"  styleClass="shortSelect" style="width:auto; margin-left: 3px">
						<f:selectItems id="intervalTimeValues3" value="#{pc_AdvancedConfiguration.timeValues}"/>
					</h:selectOneMenu>
				</h:panelGroup>
				
				
				<hx:panelFormBox id="indexBox" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
					<hx:formItem id="remoteArtifactCacheTimeoutFormItem" label="#{bundle.label_remote_artifact_cache_timeout}" infoText="#{bundle.help_time_in_seconds}">
						<h:inputText id="remoteArtifactCacheTimeoutText" value="#{pc_AdvancedConfiguration.remoteArtifactCacheTimeoutSeconds}" styleClass="shortField" />
					</hx:formItem>
					<hx:formItem id="stellentTimeoutFormItem" label="#{bundle.label_artifact_indexer_timeout}" infoText="#{bundle.help_time_in_minutes}">
						<h:inputText id="stellentTimeoutText" value="#{pc_AdvancedConfiguration.stellentTimeoutMinutes}" styleClass="shortField" />
					</hx:formItem>
					<hx:formItem id="stellentFileSizeFormItem" label="#{bundle.label_artifact_indexer_file_size}" infoText="#{bundle.heip_artifact_file_size}">
						<h:inputText id="stellentFileSizeText" value="#{pc_AdvancedConfiguration.stellentMaxFileSize}" styleClass="shortField" />
					</hx:formItem>
					<hx:formItem id="artifactIndexerCharset" label="#{bundle.label_artifact_indexer_charset}">
						<h:selectOneMenu id="selectedArtifactIndexerCharset" value="#{pc_AdvancedConfiguration.selectedArtifactIndexContentCharset}" styleClass="shortSelect">
							<f:selectItems id="artifactIndexerCharsetOptions" value="#{pc_AdvancedConfiguration.artifactIndexContentCharsets}" />
						</h:selectOneMenu>
					</hx:formItem>
					<hx:formItem id="artifactIndexerConcurrentThreadsFormItem" label="#{bundle.label_artifact_indexer_concurrent_threads}" infoText="#{bundle.help_artifact_indexer_concurrent_threads}">
						<h:inputText id="artifactIndexerConcurrentThreadsText" value="#{pc_AdvancedConfiguration.artifactIndexConcurrentThreads}" styleClass="shortField" />
					</hx:formItem>					
					<hx:formItem id="artifactIndexerThreadPoolSizeFormItem" label="#{bundle.label_artifact_indexer_thread_pool_size}" infoText="#{bundle.help_artifact_indexer_thread_pool_size}">
						<h:inputText id="artifactIndexerThreadPoolSizeText" value="#{pc_AdvancedConfiguration.artifactIndexThreadPoolSize}" styleClass="shortField" />
					</hx:formItem>					
					<hx:formItem id="useStellent">
						<h:panelGroup id="stellentCheckBoxGroup">
							<h:selectBooleanCheckbox id="stellentCheckBox" value="#{pc_AdvancedConfiguration.stellentOn}" styleClass="checkboxText" />
							<h:outputLabel id="stellentOnLabel" value="#{bundle.admin_repository_config_index_artifact_content}" 
						  		for="stellentCheckBox" styleClass="checkboxText" />
					  	</h:panelGroup>
					</hx:formItem>
					<hx:formItem id="useJobServer">
						<h:panelGroup id="jobServerCheckBoxGroup">
							<h:selectBooleanCheckbox id="jobServerCheckBox" value="#{pc_AdvancedConfiguration.jobServerOn}" styleClass="checkboxText" />
							<h:outputLabel id="jobServerOnLabel" value="#{bundle.admin_repository_config_enable_job_server}" 
						  		for="jobServerCheckBox" styleClass="checkboxText" />
					  	</h:panelGroup>
					</hx:formItem>
					<hx:formItem id="useCQServer">
						<h:panelGroup id="useCQServerCheckBoxGroup">
							<h:selectBooleanCheckbox id="selectCQProcess" value="#{pc_AdvancedConfiguration.CQServerEnabled}"  styleClass="checkboxText" title="#{bundle.advanced_repository_config_cq_process}"/>
							<h:outputLabel value="#{bundle.advanced_repository_config_cq_process}"  for="selectCQProcess" id="selectCQProcessLabel" styleClass="checkboxText"></h:outputLabel>
					  	</h:panelGroup>
					</hx:formItem>
					<hx:formItem id="enableExternalServerKeys">
						<h:panelGroup id="externalServerKeysCheckBoxGroup">
							<h:selectBooleanCheckbox id="externalServerKeysCheckBox" value="#{pc_AdvancedConfiguration.externalServerProductionKeysEnabled}" styleClass="checkboxText" />
							<h:outputLabel id="externalServerKeysLabel" value="#{bundle.admin_repository_config_enable_external_server_production_keys}" 
						  		for="externalServerKeysCheckBox" styleClass="checkboxText" />
					  	</h:panelGroup>
					</hx:formItem>
					<hx:formItem id="enableExternalServerDebug">
						<h:panelGroup id="externalServerDebugCheckBoxGroup">
							<h:selectBooleanCheckbox id="externalServerDebugCheckBox" value="#{pc_AdvancedConfiguration.externalServerDebugEnabled}" styleClass="checkboxText" />
							<h:outputLabel id="externalServerDebugLabel" value="#{bundle.admin_repository_config_enable_external_server_debug}" 
						  		for="externalServerDebugCheckBox" styleClass="checkboxText" />
					  	</h:panelGroup>
					</hx:formItem>					
				</hx:panelFormBox>				
			</hx:jspPanel>	

			
			<hx:jspPanel id="debugPanelId">
				<div class="primarySectionHeader" style="margin-top: 0"><h2>${bundle.admin_repository_config_debug}</h2></div>
				<p class="sectionInstructions">${bundle.admin_repository_config_debug_info_message}</p>
				<hx:panelFormBox id="debugPanel" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
					
					<hx:formItem id="ramDebugLevelFormItem" label="#{pc_AdvancedConfiguration.ramPackageName}">
						<h:selectOneMenu id="selectedDebugLevelRam" value="#{pc_AdvancedConfiguration.ramLoggingLevel}" styleClass="shortSelect">
							<f:selectItems id="debugLevelsRam" value="#{pc_AdvancedConfiguration.debugLevels}" />
						</h:selectOneMenu>
					</hx:formItem>

					<hx:formItem id="fsearchDebugLevelFormItem" label="#{pc_AdvancedConfiguration.fsearchPackageName}">
						<h:selectOneMenu id="selectedDebugLevelFsearch" value="#{pc_AdvancedConfiguration.fsearchLoggingLevel}" styleClass="shortSelect">
							<f:selectItems id="debugLevelsFsearch" value="#{pc_AdvancedConfiguration.debugLevels}" />
						</h:selectOneMenu>
					</hx:formItem>
						
					<hx:formItem id="pagecodeDebugLevelFormItem" label="#{pc_AdvancedConfiguration.pagecodePackageName}">
						<h:selectOneMenu id="selectedDebugLevelPagecode" value="#{pc_AdvancedConfiguration.pagecodeLoggingLevel}" styleClass="shortSelect">
							<f:selectItems id="debugLevelsPagecode" value="#{pc_AdvancedConfiguration.debugLevels}" />
						</h:selectOneMenu>
					</hx:formItem>

					<hx:formItem id="userLoggingDebugLevelFormItem" label="#{pc_AdvancedConfiguration.userLoggingPackageName}">
						<h:selectOneMenu id="selectedDebugLevelUserLogging" value="#{pc_AdvancedConfiguration.userLoggingLevel}" styleClass="shortSelect">
							<f:selectItems id="debugLevelsUserLogging" value="#{pc_AdvancedConfiguration.debugLevels}" />
						</h:selectOneMenu>
					</hx:formItem>					
				</hx:panelFormBox>
				<div style="sectionInstructions">${bundle.admin_repository_config_debug_other_info_message}</div>
				<hx:panelFormBox id="debugOtherPanel" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
					<hx:formItem id="addOtherLoggerFormItem" label="#{bundle.admin_repository_config_debug_other_add_label}">
						<h:inputText value="#{pc_AdvancedConfiguration.addLogger}" id="addLoggerText" styleClass="shortField" style="margin-right: 3px">
							<hx:behaviorKeyPress id="addLoggerTextBehavior" key="ENTER" targetAction="addLoggerGrpButton" behaviorAction="click" />
						</h:inputText>
						<hx:commandExButton value="#{bundle.button_add}" id="addLoggerGrpButton" styleClass="commandExButton"  
								action="#{pc_AdvancedConfiguration.doAddLogger}">
							<hx:behavior id="addLoggerGrpButtonBehavior" event="onclick" behaviorAction="get;stop" targetAction="debugOtherPanel"/>
						</hx:commandExButton>	
					</hx:formItem>
					
					<ram:context id="loggersSerialized" explicitValue="#{pc_AdvancedConfiguration.loggersSerialized}" name="loggersSerialized"/>
					
					<hx:dataTableEx cellpadding="2" cellspacing="3" border="0"
						id="otherLoggersTable" 
						value="#{pc_AdvancedConfiguration.otherLoggers}" var="varLogger"
						styleClass="displayTable secondaryTable" columnClasses="noclass">
						
						<hx:columnEx id="loggerCol">
							<h:outputText id="loggerLevelOutput" value="#{varLogger.levelDisplay}"/>
							<!-- Put the required break into an output text because my local Faces in Tomcat was throwing the break away if it was just hardcoded in here. -->
							<h:outputText id="loggerLevelOutputRequiredBreak" escape="false" value="<br/>"/>
							<h:selectOneMenu id="selectedLevelLogger" value="#{varLogger.setLevel}" styleClass="shortSelect">
								<f:selectItems id="debugLevelsLogger" value="#{pc_AdvancedConfiguration.debugLevels}" />
							</h:selectOneMenu>
						</hx:columnEx>
						
					</hx:dataTableEx>
					<hx:ajaxRefreshSubmit id="ajaxDebugOtherSubmit" target="debugOtherPanel"/>	
					
					<hx:formItem id="displayStackTraceItem">
						<h:selectBooleanCheckbox id="displayStackTraceCheckbox" value="#{pc_AdvancedConfiguration.showStackTraceOnErrorPage}" styleClass="checkboxText" />
							<h:outputLabel id="displayStackTraceLabel" value="#{bundle.label_enable_stack_trace_on_error_page}" 
						  		for="displayStackTraceCheckbox" styleClass="checkboxText" />
					</hx:formItem>	
					
					<hx:formItem id="displayUnknownErrorsItem">
						<h:selectBooleanCheckbox id="displayUnknownErrorsCheckbox" value="#{pc_AdvancedConfiguration.showUnknownErrorMessagesOnErrorPage}" styleClass="checkboxText" />
							<h:outputLabel id="displayUnknownErrorsLabel" value="#{bundle.label_enable_unknown_errors_on_error_page}" 
						  		for="displayUnknownErrorsCheckbox" styleClass="checkboxText" />
					</hx:formItem>
							
				</hx:panelFormBox>
			</hx:jspPanel>	
			
			<hx:jspPanel id="cachePanelId">
				<div class="primarySectionHeader"><h2>${bundle.admin_repository_adv_config_cache_title}</h2></div>
				<p class="sectionInstructions">${bundle.admin_repository_adv_config_cache_info_message}</p>
				<hx:panelFormBox id="cachePanel1" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="cacheFormItem" label="#{bundle.label_search_cache_size}" infoText="#{bundle.help_search_cache_size}">
					<h:inputText id="searchCacheSizeText" value="#{pc_AdvancedConfiguration.searchCacheSize}" styleClass="shortField" />
				</hx:formItem>					
				</hx:panelFormBox>
			</hx:jspPanel>
			
			<hx:jspPanel id="policyModPanelId">
				<div class="primarySectionHeader"><h2>${bundle.admin_repository_adv_config_policy_mod_title}</h2></div>
				<p class="sectionInstructions">${bundle.admin_repository_adv_config_policy_mod_message}</p>
				<hx:panelFormBox id="policyPanel1" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="policyFormItem" label="#{bundle.label_policy_mod_depth}" infoText="#{bundle.help_policy_mod_depth}">
					<h:inputText id="policySizeText" value="#{pc_AdvancedConfiguration.policyModDepth}" styleClass="shortField" />
				</hx:formItem>					
				</hx:panelFormBox>
			</hx:jspPanel>
			
			<hx:jspPanel id="searchPanelId">
				<div class="primarySectionHeader"><h2>${bundle.admin_repository_adv_config_search_title}</h2></div>
				<p class="sectionInstructions">${bundle.admin_repository_adv_config_search_info_message}</p>
				<hx:panelFormBox id="searchFormBox" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="synchronizedSearchFormItem">
					<h:selectBooleanCheckbox id="synchronizedSearchCheckbox" value="#{pc_AdvancedConfiguration.synchronizedSearchEnabled}" styleClass="checkboxText" />
							<h:outputLabel id="synchronizedSearchLabel" value="#{bundle.label_search_synchronzied_enabled}" 
						  		for="synchronizedSearchCheckbox" styleClass="checkboxText" />
				</hx:formItem>
				<hx:formItem id="searchFormItem">
					<h:selectBooleanCheckbox id="fuzzySearchCheckbox" value="#{pc_AdvancedConfiguration.fuzzySearchEnabled}" styleClass="checkboxText" />
							<h:outputLabel id="fuzzySearchLabel" value="#{bundle.label_search_fuzzy}" 
						  		for="fuzzySearchCheckbox" styleClass="checkboxText" />
				</hx:formItem>
				<hx:formItem id="groupVersionsFormItem">
					<h:selectBooleanCheckbox id="groupVersionsCheckbox" value="#{pc_AdvancedConfiguration.groupVersions}" styleClass="checkboxText" />
							<h:outputLabel id="groupVersionsLabel" value="#{bundle.label_search_group_versions}" 
						  		for="groupVersionsCheckbox" styleClass="checkboxText" />
				</hx:formItem>			
				<hx:formItem id="roleCacheItem">
					<h:selectBooleanCheckbox id="roleCacheCheckbox" value="#{pc_AdvancedConfiguration.searchRoleCache}" styleClass="checkboxText" />
							<h:outputLabel id="roleCacheLabel" value="Cache search roles - Experimental" 
						  		for="roleCacheCheckbox" styleClass="checkboxText" />
				</hx:formItem>					
				</hx:panelFormBox>
				
				<hx:panelFormBox id="facetCountPanel" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="facetCountFormItem" label="#{bundle.label_search_facet_count_max}" infoText="#{bundle.help_search_facet_count_max}">
					<h:inputText id="facetCountText" value="#{pc_AdvancedConfiguration.maxFacetCount}" styleClass="shortField" />
				</hx:formItem>					
				</hx:panelFormBox>
				
				<hx:panelFormBox id="tagCountPanel" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="tagCountLimitFormItem" label="#{bundle.label_search_tag_count_limit}" infoText="#{bundle.help_search_tag_count_limit}">
					<h:inputText id="tagCountLimitText" value="#{pc_AdvancedConfiguration.tagCountLimit}" styleClass="shortField" />
				</hx:formItem>					
				</hx:panelFormBox>
				
				<hx:panelFormBox id="indexReaderIntervalPanel" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="indexReaderIntervalFormItem" label="#{bundle.label_search_index_reader_interval}" infoText="#{bundle.help_search_index_reader_interval}">
					<h:inputText id="indexReaderIntervalText" value="#{pc_AdvancedConfiguration.indexReaderOpenInterval}" styleClass="shortField" />
				</hx:formItem>					
				</hx:panelFormBox>
				
				<h:outputLink id="searchRelevanceConfigurationLink" value="#{pc_AdvancedConfiguration.searchRelevanceConfigurationLink}">
					<h:outputText id="searchRelevanceConfigurationLinkText" value="#{bundle.navigation_admin_repos_index_config}"></h:outputText>
				</h:outputLink>

				<hx:panelFormBox id="communitiesPageSearchPanel" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="communitiesPageSearchFormItem" label="#{bundle.label_communities_page_hide_noaccess_panel}" infoText="">
					<h:selectOneRadio layout="pageDirection" id="communitiesPageSearchRadio" value="#{pc_AdvancedConfiguration.communitiesPageHideNoaccess}"> 
						<f:selectItem itemValue="false" itemLabel="#{bundle.label_communities_page_hide_noaccess_false}" id="showCommValue" />
						<f:selectItem itemValue="true" itemLabel="#{bundle.label_communities_page_hide_noaccess_true}" id="hideCommValue" />
					</h:selectOneRadio>  
				</hx:formItem>					
				</hx:panelFormBox>
				
				<hx:panelFormBox id="facetVersionCountingSearchPanel" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
					<hx:formItem id="facetCounterVersionFormItem" label="#{bundle.label_facet_counter_version}">
						<h:selectOneMenu id="selectedFacetCounterVersion" value="#{pc_AdvancedConfiguration.selectedFacetCounterVersion}" styleClass="shortSelect">
							<f:selectItems id="selectedFacetCounterVersionOptions" value="#{pc_AdvancedConfiguration.facetCounterVersions}" />
						</h:selectOneMenu>
					</hx:formItem>
				</hx:panelFormBox>
				
			</hx:jspPanel>
			
			
			
			<hx:jspPanel id="legacyReviewPanelId">
				<div class="primarySectionHeader"><h2>${bundle.admin_repository_adv_legacy_review_title}</h2></div>
				<p class="sectionInstructions">${bundle.admin_repository_adv_legacy_review_message}</p>
				<hx:panelFormBox id="legacyReviewPanel1" styleClass="panelFormBox" labelPosition="over" helpPosition="under">		
					<hx:formItem id="legacyReviewFormItem">
						<h:selectBooleanCheckbox id="legacyReviewCheckbox" value="#{pc_AdvancedConfiguration.allowLegacyReviews}" styleClass="checkboxText" />
							<h:outputLabel id="legacyReviewLabel" value="#{bundle.label_legacy_reviews}" for="legacyReviewCheckbox" styleClass="checkboxText" />
					</hx:formItem>	
					<hx:formItem id="retirementFormItem">
						<h:selectBooleanCheckbox id="retirementCheckbox" value="#{pc_AdvancedConfiguration.retirementSet}" styleClass="checkboxText" />
							<h:outputLabel id="retirementLabel" value="#{bundle.label_allow_retirement}" for="retirementCheckbox" styleClass="checkboxText" />
					</hx:formItem>	
				</hx:panelFormBox>
			</hx:jspPanel>
		
		<hx:jspPanel id="debugOptionsPanelId">
			<div class="primarySectionHeader"><h2>${bundle.admin_repository_adv_debug_title}</h2></div>
			<p class="sectionInstructions">${bundle.admin_repository_adv_debug_message}</p>
			<hx:panelFormBox id="compressJavascriptPanel1" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="compressJavascriptFormItem">
					<h:selectBooleanCheckbox id="compressJavascriptCheckbox" value="#{pc_AdvancedConfiguration.useUncompressedJavascript}" styleClass="checkboxText" />
						<h:outputLabel id="compressJavascriptLabel" value="#{bundle.label_uncompress_javascript}" for="compressJavascriptCheckbox" styleClass="checkboxText" />
				</hx:formItem>
			</hx:panelFormBox>
			<p class="sectionInstructions">${bundle.admin_repository_adv_direct_request_message}</p>
			<hx:panelFormBox id="directRequestPanel1" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="directRequestBaseFormItem">
					<h:selectBooleanCheckbox id="directRequestBaseCheckbox" value="#{pc_AdvancedConfiguration.useDirectRequest}" styleClass="checkboxText" />
						<h:outputLabel id="directRequestBaseLabel" value="#{bundle.label_debug_direct}" for="directRequestBaseCheckbox" styleClass="checkboxText" />
				</hx:formItem>					
			</hx:panelFormBox>					
			
		</hx:jspPanel>
						
		<hx:jspPanel id="rtcPathPanelId">
			<div class="primarySectionHeader"><h2>${bundle.admin_repository_adv_rtc_settings}</h2></div>
			<p class="sectionInstructions">${bundle.admin_repository_adv_rtc_host_override_message}</p>
			<hx:panelFormBox id="rtcHostOverride" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="rtcCheckbox">
					<h:selectBooleanCheckbox id="allowRTCOverrideCheckbox" value="#{pc_AdvancedConfiguration.RTCOverrideEnabled}" styleClass="checkboxText" />
					<h:outputLabel id="allowRTCOverrideLabel" value="#{bundle.admin_repository_adv_rtc_host_override_prompt}" 
				  		for="roleCacheCheckbox" styleClass="checkboxText" />
				</hx:formItem>
			</hx:panelFormBox>
			<p class="sectionInstructions">${bundle.admin_repository_adv_rtc_projectarea_message}</p>
			<hx:panelFormBox id="rtcPAOverride" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="rtcPAOverrideInput" label="#{bundle.admin_repository_adv_rtc_projectarea_prompt}">
					<h:inputText id="rtcPAOverrideText" value="#{pc_AdvancedConfiguration.RTCProjectAreaOverride}" styleClass="shortField" />
				</hx:formItem>					
			</hx:panelFormBox>
		</hx:jspPanel>	
		
		<hx:jspPanel id="featuredContentPanelId">
		    <div class="primarySectionHeader"><h2>${bundle.admin_repository_featured_content_settings}</h2></div>
		    <p class="sectionInstructions">${bundle.admin_repository_featured_content_settings_message}</p>
		    <h:panelGroup id="featureContentFilters" style="margin-top: 20px; display: block">
		    <hx:ajaxRefreshSubmit id="featuredContentAjax" target="featureContentFilters" />
		    <hx:panelFormBox id="featuredContentBox" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
			
			
		 
			<hx:formItem id="featuredContentInput" label="#{bundle.admin_repository_adv_max_featured_content}">
				<h:inputText id="maxNumberId"  styleClass="shortField" value="#{pc_AdvancedConfiguration.maxFeatureContent}" >
					<f:convertNumber type="number" integerOnly="true"  /> 
					<f:validateDoubleRange  minimum="1" ></f:validateDoubleRange>
				</h:inputText>
			</hx:formItem>			
			
			<hx:dataTableEx cellpadding="2" cellspacing="3" border="0"
						id="featuredContentTable" 
							binding="#{pc_AdvancedConfiguration.featuredContentTable}"
							value="#{pc_AdvancedConfiguration.featuredContentEntries}"
							var="varFeaturedContents"
						styleClass="displayTable secondaryTable" columnClasses="noclass">
			 
			 
			<hx:columnEx id="attrMove" width="18">
				<h:panelGroup id="moveLevelPanelGroups"
					style="float: left;">
					<h:panelGroup id="moveUpPanelGroupPanel" style="display:block">
						<hx:requestLink id="moveUPLevelLink"
							rendered="#{pc_AdvancedConfiguration.featuredContentTableIndex > 0}"
							onclick="updateHiddenField(this, event, 'configurationForm:movedFeatureContent', 'u#{pc_AdvancedConfiguration.featuredContentTableIndex}');">
							<hx:graphicImageEx id="moveUPLevel"
								value="/theme/images/icons/elcl16/moveup.gif"
								alt="#{bundle.alt_move_up}" />
							<hx:behavior id="behaviorClickId16" event="onclick"
								behaviorAction="get;stop" targetAction="featureContentFilters" />
						</hx:requestLink>
						<hx:graphicImageEx id="noMoveUPLevel"
							value="/theme/images/icons/dlcl16/moveup.gif" alt=""
							rendered="#{pc_AdvancedConfiguration.featuredContentTableIndex <= 0}" />
					</h:panelGroup>
					<h:panelGroup id="moveDownLevelGroupPanel" style="display:block">
						<hx:requestLink id="moveDownLEvelLink"
							onclick="updateHiddenField(this, event, 'configurationForm:movedFeatureContent', 'd#{pc_AdvancedConfiguration.featuredContentTableIndex}');"
							rendered="#{pc_AdvancedConfiguration.featuredContentTableIndex < pc_AdvancedConfiguration.featuredContentTable.rowCount-1}">
	 
							<hx:graphicImageEx id="moveDownLevelImage"
								value="/theme/images/icons/elcl16/movedown.gif"
								alt="#{bundle.alt_move_down}" />
							<hx:behavior id="behaviorClickId17" event="onclick"
								behaviorAction="get;stop" targetAction="featureContentFilters" />
						</hx:requestLink>
	
						<hx:graphicImageEx id="noMoveDownLevelImage"
							value="/theme/images/icons/dlcl16/movedown.gif" alt=""
							rendered="#{pc_AdvancedConfiguration.featuredContentTableIndex >= pc_AdvancedConfiguration.featuredContentTable.rowCount-1}" />
					</h:panelGroup>
				</h:panelGroup>
			</hx:columnEx>
			
			<hx:columnEx id="fileNameId">
				<h:outputText id="afileName1" value="#{varFeaturedContents.fileName}" />
			</hx:columnEx>
			 
			<hx:columnEx id="addcol17" width="40" align="center">
			     <hx:requestLink id="featureContentInsert" 
					onclick="updateHiddenField(this, event, 'createForm:addIndex', '#{pc_AdvancedConfiguration.featuredContentTableIndex}');">
					<h:outputText id="addTextId3" value="#{bundle.link_insert}"
						style="text-align: right" />
					 <hx:behavior event="onclick" id="createAttributeBehavior" behaviorAction="show;stop" targetAction="createDialog" />
				</hx:requestLink>
			</hx:columnEx>
			<hx:columnEx id="removecol17" width="40" align="center">
			  
				<hx:requestLink id="featureContentRemove" 
					onclick="updateHiddenField(this, event, 'configurationForm:removeFeatureContent', '#{pc_AdvancedConfiguration.featuredContentTableIndex}');">
					<h:outputText id="removeTextId3" value="#{bundle.link_delete}"
						style="text-align: right" />
					<hx:behavior id="removebehaviorClickId18" event="onclick"
						behaviorAction="get;stop" targetAction="featureContentFilters" />
				</hx:requestLink>
			</hx:columnEx>
			</hx:dataTableEx>
			<hx:commandExButton type="button" value="#{bundle.button_add}" id="createFeaturedContentButton"
			        rendered="#{empty pc_AdvancedConfiguration.featuredContentEntries}"
					styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" title="#{bundle.alt_opens_dialog}">
					<hx:behavior event="onclick" id="createFeatureBehaviour3" behaviorAction="show;stop" targetAction="createDialog" />
			</hx:commandExButton>
			
			<h:inputHidden id="movedFeatureContent" value="#{pc_AdvancedConfiguration.doMoveFeaturedContent}" />
			<h:inputHidden id="removeFeatureContent" value="#{pc_AdvancedConfiguration.doRemoveFeatureContent}" />
			</hx:panelFormBox>
			</h:panelGroup>
		</hx:jspPanel>		
		
		<hx:jspPanel id="securityPanelId">
			<div class="primarySectionHeader"><h2>${bundle.admin_repository_adv_security_settings}</h2></div>
			<p class="sectionInstructions">${bundle.admin_repository_adv_security_message}</p>
			<hx:panelFormBox id="securityPanelFormBox" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="xssFilter">
					<h:selectBooleanCheckbox id="xssFilterCheckbox" value="#{pc_AdvancedConfiguration.xssFilterEnabled}" styleClass="checkboxText" />
						<h:outputLabel id="xssFilterLabel" value="#{bundle.label_enable_xss_filter}" 
							for="xssFilterCheckbox" styleClass="checkboxText" />
				</hx:formItem>	
				<hx:formItem id="artifactDownloadWarning">
					<h:selectBooleanCheckbox id="artifactDownloadWarningCheckbox" value="#{pc_AdvancedConfiguration.downloadArtifactWarningEnabled}" styleClass="checkboxText" />
						<h:outputLabel id="artifactDownloadWarningLabel" value="#{bundle.label_enable_download_artifact_warning}" 
							for="artifactDownloadWarningCheckbox" styleClass="checkboxText" />
				</hx:formItem>
				<hx:formItem id="displayAssetNameInPermissionRequests">
					<h:selectBooleanCheckbox id="displayAssetNameInPermissionRequestsCheckbox" value="#{pc_AdvancedConfiguration.displayAssetNameInPermissionRequests}" styleClass="checkboxText" />
						<h:outputLabel id="displayAssetNameInPermissionRequestsLabel" value="#{bundle.label_display_asset_name_in_permission_requests}" 
							for="displayAssetNameInPermissionRequestsCheckbox" styleClass="checkboxText" />
				</hx:formItem>	
			</hx:panelFormBox>
		</hx:jspPanel>
		
		<hx:jspPanel id="downloadPanelId">
			<div class="primarySectionHeader"><h2>${bundle.admin_repository_adv_download_settings}</h2></div>
			<p class="sectionInstructions">${bundle.admin_repository_adv_download_message}</p>
			<hx:panelFormBox id="downloadPanelFormBox" styleClass="panelFormBox" labelPosition="over" helpPosition="under">
				<hx:formItem id="downloadContentLength">
					<h:selectBooleanCheckbox id="downloadContentLengthCheckbox" value="#{pc_AdvancedConfiguration.downloadContentLengthOverTwoGigabytesEnabled}" styleClass="checkboxText" />
						<h:outputLabel id="downloadContentLengthLabel" value="#{bundle.label_enable_download_content_length_over_two_gigabytes}" 
							for="downloadContentLengthCheckbox" styleClass="checkboxText" />
				</hx:formItem>
				<ram:messagesEx id="downloadThreadsMessage" for="downloadThreadsText" size="small" />
				<hx:formItem id="downloadThreadsFormItem" label="#{bundle.label_download_threads}" >
					<h:inputText id="downloadThreadsText" value="#{pc_AdvancedConfiguration.downloadThreads}" styleClass="shortField" />
				</hx:formItem>
				<ram:messagesEx id="rangeRequestsMessage" for="rangeRequestsText" size="small" />
				<hx:formItem id="rangeRequestsFormItem" label="#{bundle.label_range_sessions}" >
					<h:inputText id="rangeRequestsText" value="#{pc_AdvancedConfiguration.rangeRequests}" styleClass="shortField" />
				</hx:formItem>
				<ram:messagesEx id="maxBufferMessage" for="maxBufferText" size="small" />
				<hx:formItem id="maxBufferFormItem" label="#{bundle.label_maxbuffersize}" >
					<h:inputText id="maxBufferText" value="#{pc_AdvancedConfiguration.maxDownloadBufferSize}" styleClass="shortField" />
				</hx:formItem>														
																	
			</hx:panelFormBox>
		</hx:jspPanel>	
				
		</h:panelGrid>	
			<div class="primaryActionGroup">
				<hx:commandExButton id="saveButton" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" value="#{bundle.button_save}" type="submit" action="#{pc_AdvancedConfiguration.doSaveConfiguration}" />
			</div>	
		</ram:form>

		<h:panelGrid id="pandelGridId2" columns="2" columnClasses="configGrid1, configGrid2" width="100%">
			<hx:jspPanel id="exportModelPanel">
				<div class="primarySectionHeader" style="margin-top: 0"><h2>${bundle.admin_repository_adv_config_model}</h2></div>
				<p class="sectionInstructions">${bundle.admin_repository_adv_config_model_export}</p>
				<ram:form id="ExportModelForm" styleClass="toolForm">
					<hx:commandExButton id="exportModel" type="submit" styleClass="commandExButton" action="#{pc_AdvancedConfiguration.doExportModel}"
					value="#{bundle.button_export}" iconDepressed="/theme/images/transparent.gif" >
					</hx:commandExButton>		
				</ram:form>
			</hx:jspPanel>			
		</h:panelGrid>
		
		</div>
		</div>
			
		<%@include file="/theme/footer.jspf"%>
	</hx:scriptCollector>
	</body>
</f:view>
</html>

