<%
response.setHeader("Cache-Control","no-store"); //HTTP 1.1
response.setHeader("Pragma","no-cache"); //HTTP 1.0
response.setDateHeader ("Expires", 0); //prevents caching at the proxy server
%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%-- jsf:pagecode language="java" location="/JavaSource/pagecode/admin/repository/CustomExtensions.java" --%><%-- /jsf:pagecode --%>
<%------------------------------------------------------------------------------
 - Licensed Materials - Property of IBM
 - 
 - (C) Copyright IBM Corporation 2006. All Rights Reserved.
 - Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 - restricted by GSA ADP  Schedule Contract with IBM Corp.
  -----------------------------------------------------------------------------%>
<%--
 -  $$RCSfile: $$
 -  $$Revision: $$Date: $$
 --%>  
  
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8" %>

<html>
<head>
	<%@include file="/theme/metaHeader.jspf"%>
	<meta http-equiv="Pragma" content="no-cache">
	<%@include file="/theme/css.jspf"%>	
	<link rel="csh" href="${applicationScope.cshPath}">
	
	<title>${bundle.adminTitle}</title>
</head>
<f:view>
	<body class="ram">
		<script type="text/javascript">
			function setHiddenField(field, hide) {
				document.getElementById(field).value = hide;
			}	
		</script>
	
		<hx:scriptCollector id="scriptCollector1">
		<%@include file="/theme/header.jspf"%>
		
		<div id="rightColumn">
		<div class="inside">
		<%@include file="/includes/administrationSideBar.jspf"%>
		<%@include file="/includes/repositoryStatisticsSideBar.jspf"%>
		</div>
		</div>
		
		<%------------------------------------------------------------------------------%>
		<%-- Create Extension Dialog --%>
		<%------------------------------------------------------------------------------%>	
		<ram:form id="createExtensionDialogForm">
			<hx:panelDialog id="createExtensionDialog" type="modeless" align="center" valign="middle"
				styleClass="panelDialog" title="#{bundle.dialogTitle_new_extension}"
				initiallyShow="#{pc_CustomExtensions.showDialog}">
				
				<h:panelGroup id="createExtensionTopPanel">
				    <hx:ajaxRefreshSubmit id="wizardAjaxCreateExtension" />
				    <h:inputHidden id="extensionTypeInput" value="#{pc_CustomExtensions.extensionType}"/>
					<h:outputText id="help_dialog_new_extension" styleClass="sectionInstructions"
						value="#{bundle.help_dialog_new_extension}" />
			
					<hx:panelFormBox id="extensionPanelFormBox" styleClass="dialogForm" labelPosition="over">
						<hx:formItem  id="extensionClassNameLabel" label="#{bundle.label_extension_class_name}" >
							<h:inputText id="extensionClassName" style="width:98%;" value="#{pc_CustomExtensions.extensionClassName}" />
						</hx:formItem>
						<hx:formItem  id="extensionFileLabel" label="#{bundle.label_extension_jar_zip_file}">
							<hx:fileupload id="extensionFile" styleClass="fileupload" size="45" binding="#{pc_CustomExtensions.extensionFile}"/>
						</hx:formItem>
						<hx:formItem  id="extensionCreatePendingLabelItem"   rendered="#{pc_CustomExtensions.policyGovernorExtension}" >
						    <h:panelGroup id="extensionCreatePendingPanel">
							<h:selectBooleanCheckbox id="extensionCreatePending" value="#{pc_CustomExtensions.runPending}" styleClass="checkboxText"/>
							<h:outputLabel id="extensionCreatePendingLabel" for="extensionCreatePending" value="#{bundle.label_extension_pending_flag}"  
									styleClass="checkboxText" />
							</h:panelGroup>
						</hx:formItem>
					</hx:panelFormBox>
			
					<h:panelGroup styleClass="dialogActionGroup" id="actionPanelGrp">
						<hx:commandExButton id="okButton" styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif" type="submit"
							value="#{bundle.button_ok}"
							action="#{pc_CustomExtensions.doCreateExtension}">
						</hx:commandExButton>
						<hx:commandExButton id="cancelButton" styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif" type="button"
							value="#{bundle.button_cancel}">
							<hx:behaviorKeyPress id="cancelEnterBehavior" key="ENTER" behaviorAction="click" 
								targetAction="cancelButton" />
							<hx:behavior event="onclick" behaviorAction="hide;stop"
								targetAction="createExtensionDialog" id="createExtensionDialogBehavior" />
						</hx:commandExButton>
					</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
			
			
		</ram:form>	
		<%------------------------------------------------------------------------------%>
		<%-- END Create Extension Dialog --%>
		<%------------------------------------------------------------------------------%>
		
		<%------------------------------------------------------------------------------%>
		<%-- Update Extension Dialog --%>
		<%------------------------------------------------------------------------------%>	
		<ram:form id="updateExtensionDialogForm">
			<hx:panelDialog id="updateExtensionDialog" type="modeless" align="center" valign="middle" style="width:400px"
				styleClass="panelDialog" title="#{bundle.dialogTitle_update_extension}"
				initiallyShow="#{pc_CustomExtensions.showDialog}">
				
				<h:panelGroup id="updateExtensionTopPanel">
				    <h:inputHidden id="extensionUpdateID" value="#{pc_CustomExtensions.extensionUpdateID}"/>
				    <hx:ajaxRefreshSubmit id="wizardAjaxUpdateExtension" />
					<h:outputText id="help_dialog_new_extension" styleClass="sectionInstructions"
						value="#{bundle.help_dialog_update_extension}" />
			
					<hx:panelFormBox id="extensionUpdatePanelFormBox" styleClass="dialogForm" labelPosition="over">
						<hx:formItem  id="extensionUpdateFileLabel" label="#{bundle.label_extension_jar_zip_file}"  rendered="#{!pc_CustomExtensions.defaultPolicy}">
							<hx:fileupload id="extensionUpdateFile" styleClass="fileupload" size="45" binding="#{pc_CustomExtensions.extensionUpdateFile}"/>
						</hx:formItem>
						<hx:formItem  id="extensionUpdatePendingLabelItem"  rendered="#{pc_CustomExtensions.policyGovernorExtension}" >
						   <h:panelGroup id="extensionUpdatePendingPanel">
								<h:selectBooleanCheckbox id="extensionUpdatePending" value="#{pc_CustomExtensions.runPending}" styleClass="checkboxText"/>
								<h:outputLabel id="extensionUpdatePendingLabel" for="extensionUpdatePending" value="#{bundle.label_extension_pending_flag}"  
									styleClass="checkboxText" />
							</h:panelGroup>
						</hx:formItem>
					</hx:panelFormBox>
			
					<h:panelGroup styleClass="dialogActionGroup" id="actionUpdatePanelGrp">
						<hx:commandExButton id="okUpdateButton" styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif" type="submit"
							value="#{bundle.button_ok}"
							action="#{pc_CustomExtensions.doUpdateExtension}">
						</hx:commandExButton>
						<hx:commandExButton id="cancelUpdateButton" styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif" type="button"
							value="#{bundle.button_cancel}">
							<hx:behaviorKeyPress id="cancelUpdateEnterBehavior" key="ENTER" behaviorAction="click" 
								targetAction="cancelButton" />
							<hx:behavior event="onclick" behaviorAction="hide;stop"
								targetAction="updateExtensionDialog" id="updateExtensionDialogBehavior" />
						</hx:commandExButton>
					</h:panelGroup>
				</h:panelGroup>
				<ram:infopop id="updateExtensionDialogHelp" styleClass="dialogInfopop" contextId="race0030" image="/theme/images/icons/obj16/info_indicator.gif" />
			</hx:panelDialog>
		</ram:form>	
		<%------------------------------------------------------------------------------%>
		<%-- END Update Extension Dialog --%>
		<%------------------------------------------------------------------------------%>	
		
		<%------------------------------------------------------------------------------%>
		<%-- Delete Extension Dialog --%>
		<%------------------------------------------------------------------------------%>	
		<ram:form id="deleteExtensionDialogForm">
			<hx:panelDialog id="deleteExtensionDialog" type="modeless" align="center" valign="middle" style="width:400px;"
				styleClass="panelDialog" title="#{bundle.dialogTitle_delete_extension}" initiallyShow="#{pc_CustomExtensions.showDialog}">
				<h:panelGroup id="deleteExtensionTopPanel">
					<h:outputText id="deleteExtensionDialogLabel" value="#{bundle.message_confirm_delete_extension}"></h:outputText>
					<h:panelGroup id="deleteExtensionDialogButtonPanel" styleClass="dialogActionGroup">
						<hx:commandExButton id="deleteExtensionSubmit" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" 
							type="submit" value="#{bundle.button_delete}" action="#{pc_CustomExtensions.doDeleteExtension}">
						</hx:commandExButton>
						<hx:commandExButton id="deleteExtensionCancel" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" 
							type="reset" value="#{bundle.button_cancel}">
							<hx:behavior id="deleteExtensionCancelDialogBehavior" event="onclick" behaviorAction="hide;stop" targetAction="deleteExtensionDialog" />
						</hx:commandExButton>
					</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
			
			<h:inputHidden id="extensionDeleteID" value="#{pc_CustomExtensions.extensionDeleteID}"/>
		</ram:form>
		<%------------------------------------------------------------------------------%>
		<%-- END Delete Extension Dialog --%>
		<%------------------------------------------------------------------------------%>	

		<div id="contentColumn">
		<div class="inside">

		<h1>${bundle.page_title_custom_extensions}<ram:infopop id="pageHelp"
				styleClass="pageHelp" contextId="race0001" 
				image="/theme/images/icons/obj16/info_indicator.gif" /></h1>
		
		<h:outputText id="page_help" styleClass="sectionInstructions"
			value="#{bundle.help_page_custom_extension}" />
			
		<ram:messagesEx id="errMsgs" globalOnly="true" />
		
		<ram:form id="topForm">			

			<%------------------------------------------------------------------------------%>
			<%-- Policy Extension Table --%>
			<%------------------------------------------------------------------------------%>
			<div class="primarySectionHeader">
				<h2><ram:infopop id="policyExtensionsInfopop" styleClass="jazz-app-ua-TextHoverHelp" contextId="race0020" text="#{bundle.section_custom_extension_policy}" /></h2>
			</div>
			<hx:dataTableEx border="0" rowClasses="oddRow,evenRow" id="policyExtensionTable"
				styleClass="displayTable" value="#{pc_CustomExtensions.policyExtensions}" var="varpolicyextensions"
				columnClasses="noClass,noClass,actionColumn,actionColumn" rows="10">
				<hx:columnEx id="policyExtensionNameCol" width="100%">
					<h:outputText id="policyExtensionName" value="#{varpolicyextensions.name}" />
				</hx:columnEx>
				
				<hx:columnEx id="columnDownloadPolicy">
					<h:outputLink id="exportPolicyLink"   rendered="#{varpolicyextensions.name != pc_CustomExtensions.defaultPolicyName && varpolicyextensions.extAssetID != null}" 
						value="#{varpolicyextensions.downloadURL}" >
						<h:outputText id="exportPolicyLinkText" value="#{bundle.ModifyLibrary_Export}"/>
					</h:outputLink>
				</hx:columnEx>

				<hx:columnEx id="columnUpdatePolicy">
					<hx:requestLink id="updatePolicyExtension" >
						<h:outputText  id="colUpdatePolicyText" value="#{bundle.link_update}" styleClass="nowrap" />
						<hx:behavior event="onclick" id="updatePolicyBehavior" behaviorAction="get;show;stop"
						 	onActionFunction="setHiddenField('updateExtensionDialogForm:extensionUpdateID', '#{varpolicyextensions.id}');" targetAction="updateExtensionTopPanel;updateExtensionDialog" />
					</hx:requestLink>
				</hx:columnEx>
				
				<hx:columnEx id="columnDeletePolicy">
					<hx:requestLink id="removePolicyExtension" rendered="#{varpolicyextensions.name != pc_CustomExtensions.defaultPolicyName}">
						<h:outputText  id="colDelPolicyText" value="#{bundle.link_delete}" styleClass="nowrap" />
						<hx:behavior event="onclick" id="deletePolicyBehavior" behaviorAction="show;stop"
						 	onActionFunction="setHiddenField('deleteExtensionDialogForm:extensionDeleteID', '#{varpolicyextensions.id}');" targetAction="deleteExtensionDialog" />
					</hx:requestLink>
				</hx:columnEx>
			</hx:dataTableEx>

			<h:panelGrid columns="2" id="policyActionPanelGrid" styleClass="secondaryActionGroup" cellspacing="0" cellpadding="3">
				<hx:commandExButton type="button" value="#{bundle.button_new_extension_policy}" id="createPolicyExtension"
					styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif">
					<hx:behavior event="onclick" id="createPolicyBehavior" behaviorAction="get;show;stop"
						onActionFunction="setHiddenField('createExtensionDialogForm:extensionTypeInput', '1');" targetAction="createExtensionTopPanel;createExtensionDialog" />
				</hx:commandExButton>
				<h:panelGroup id="policyExtensionPagerGroup" style="display: block; text-align: right">
					<hx:pagerWeb id="policyExtensionPager" rendered="#{pc_CustomExtensions.policyExtensionsCount > 10}" for="policyExtensionTable"/>
				</h:panelGroup>
			</h:panelGrid>
			
			<%------------------------------------------------------------------------------%>
			<%-- Review Extension Table --%>
			<%------------------------------------------------------------------------------%>
			<div class="primarySectionHeader">
				<h2><ram:infopop id="reviewExtensionsInfopop" styleClass="jazz-app-ua-TextHoverHelp" contextId="race0010" text="#{bundle.section_custom_extension_review}" /></h2>
			</div>
			
			<hx:dataTableEx border="0" rowClasses="oddRow,evenRow" id="reviewExtensionTable"
				styleClass="displayTable" value="#{pc_CustomExtensions.reviewExtensions}" var="varreviewextensions"
				columnClasses="noClass,noClass,actionColumn,actionColumn" rows="10">
				<hx:columnEx id="reviewExtensionNameCol" width="100%">
					<h:outputText id="reviewExtensionName" value="#{varreviewextensions.name}" />
				</hx:columnEx>

				<hx:columnEx id="columnUpdate">
					<hx:requestLink id="updateReviewExtension">
						<h:outputText  id="colUpdateText" value="#{bundle.link_update}" styleClass="nowrap" />
						<hx:behavior event="onclick" id="updateReviewBehavior" behaviorAction="get;show;stop"
						 	onActionFunction="setHiddenField('updateExtensionDialogForm:extensionUpdateID', '#{varreviewextensions.id}');" targetAction="updateExtensionTopPanel;updateExtensionDialog" />
					</hx:requestLink>
				</hx:columnEx>
				
				<hx:columnEx id="columnDelete">
					<hx:requestLink id="removeReviewExtension">
						<h:outputText  id="colDelText" value="#{bundle.link_delete}" styleClass="nowrap" />
						<hx:behavior event="onclick" id="deleteReviewBehavior" behaviorAction="show;stop"
						 	onActionFunction="setHiddenField('deleteExtensionDialogForm:extensionDeleteID', '#{varreviewextensions.id}');" targetAction="deleteExtensionDialog" />
					</hx:requestLink>
				</hx:columnEx>
			</hx:dataTableEx>

			<h:panelGrid columns="2" id="reviewActionPanelGrid" styleClass="secondaryActionGroup" cellspacing="0" cellpadding="3">
				<hx:commandExButton type="button" value="#{bundle.button_new_extension_review}" id="createReviewExtension"
					styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif">
					<hx:behavior event="onclick" id="createReviewBehavior" behaviorAction="get;show;stop"
					 onActionFunction="setHiddenField('createExtensionDialogForm:extensionTypeInput', '0');" targetAction="createExtensionTopPanel;createExtensionDialog" />
				</hx:commandExButton>
				<h:panelGroup id="reviewExtensionPagerGroup" style="display: block; text-align: right">
					<hx:pagerWeb id="reviewExtensionPager" rendered="#{pc_CustomExtensions.reviewExtensionsCount > 10}" for="reviewExtensionTable"/>
				</h:panelGroup>
			</h:panelGrid>
			
		</ram:form>
		</div>
		</div>
		</hx:scriptCollector>
		<%@include file="/theme/footer.jspf"%>		
	</body>
</f:view>
</html>
