<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%-- jsf:pagecode language="java" location="/JavaSource/pagecode/assetDetail/DownloadRelated.java" --%><%-- /jsf:pagecode --%>

<%------------------------------------------------------------------------------
 - Licensed Materials - Property of IBM
 - 
 - (C) Copyright IBM Corporation 2006. All Rights Reserved.
 - Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 - restricted by GSA ADP  Schedule Contract with IBM Corp.
  -----------------------------------------------------------------------------%>
<!--
 -  $$RCSfile: downloadRelated.jsp,v $$
 -  $$Revision: 1.9 $$  $$Date: 2007/05/16 18:07:35 $$
 -->  

<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>

<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8" %>

<html>
<head>

	<%@include file="/theme/metaHeader.jspf" %>
	<%@include file="/theme/cssHideRightShowLeftColumn.jspf"%>
	<link rel="csh" href="${applicationScope.cshPath}">
	<%-- Dojo layer imports  --%>
	${pc_AssetDetailBase.JSLayers['ram/layers/ReviewBar']}
	<script type="text/javascript" language="JavaScript">
		dojo.require("dijit.layout.TabContainer");
		dojo.require("dijit.layout.ContentPane");
		dojo.require("dojo.fx");
		dojo.require("ram.ConditionToDo");
	</script>
		
	<script src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/rating.js"></script>
	<title>${bundle.downloadRelatedTitle}</title>
</head>
<f:view>
	<body onload="doDownload()" class="ram">
	<script type="text/javascript" language="JavaScript">
		function doDownload() {
			var hiddenCheckForContent=document.getElementById('downloadForm:hiddenCheckForContent');	
			if (hiddenCheckForContent.firstChild.data == 'true') {
				if(${pc_DownloadRelated.downloadClientSelected}){
					document.getElementById('downloadForm:assetDD_downloadClientLink').click();
				} else {
					var downloadLink=document.getElementById('downloadForm:downloadLink');
					document.location.href = downloadLink.href;
				}
			}
		}
		
		function doDownloadRelated(relatedButton) {
			// The next sibling should be the actual hidden link.
			document.location.href = relatedButton.nextElementSibling.href;
			return false;
		}
	</script>
	<hx:scriptCollector id="scriptCollector1">

		<%-- From header.jspf because asset details pages is a bit different --%>
	<div id="gutters">
	<div id="right_gutter">
	<div id="pageWrapper">
		<div id="masthead" class="jazz-ui-PageTemplate">
			<div class="access">
			<a href="#contentColumn">${bundle.link_skip_content}</a>
			<a href="#navigation">${bundle.link_skip_nav}</a>
			</div>
			<%@include file="/theme/custom/header.jspf" %>
			<%@include file="/includes/navigation-no-breadcrumbs.jspf" %>
		</div>
		
		<div id="contentHeader">
			<ram:breadcrumbs id="breadcrumbs" value="#{breadcrumbsManager.breadcrumbs}" />
			<h1><h:outputText id="assetName" value="#{pc_AssetDetailBase.assetTitle}"/></h1>
			<div class="shortDescriptionHeader"><h:outputText id="assetDesc" value="#{pc_AssetDetailBase.asset.shortDescription}" styleClass="header" /></div>
		
		</div>
		
		<div id="outerColumnContainer">
		<div id="innerColumnContainer"> 

		<ram:infopop id="pageHelp" styleClass="pageHelp" for="assetName" image="/theme/images/icons/obj16/info_indicator.gif" contextId="sdwn0001"/>
		
		<div id="leftColumn">
			<div class="inside">
				 	<ram:treeNav id="contentTabs" value="#{breadcrumbsManager.contentTreeItems}" activeLinks="#{breadcrumbsManager.activeLinks}" />
			</div>
		</div>
		
			<div id="contentColumn">
			<div class="inside">
			
			<ram:form id="downloadForm">
				
				
				<ram:messagesEx id="downloadRelatedMessages" globalOnly="false">
					<f:facet name="links">
						<h:outputLink id="downloadLink" value="#{pc_DownloadRelated.downloadURL}" rendered="#{!pc_DownloadRelated.downloadClientSelected}">
							<h:outputText id="downloadLinkText" value="#{bundle.link_download}"  />
						</h:outputLink>
					</f:facet>
				</ram:messagesEx>
				
				<ram:downloadClient id="assetDD" type="asset" guid="#{pc_DownloadRelated.asset.id}" image="/theme/images/icons/obj16/downloadasset_co.gif" version="#{pc_DownloadRelated.asset.version}" value="#{pc_DownloadRelated.asset.name}.zip" filename="#{pc_DownloadRelated.asset.name}.zip"  text="#{bundle.download_client_asset_tip}" rendered="#{pc_DownloadRelated.downloadClientSelected}" />
		
				
				<h:outputText id="hiddenCheckForContent" style="display:none;" value="#{pc_DownloadRelated.containsArtifacts}"/>
				
				<ram:context name="guid" />
				<ram:context name="v" />
				<ram:context name="submission" />
			</ram:form>

			
			<hx:jspPanel id="dlRelated" rendered="#{! empty pc_DownloadRelated.relatedAssets}">
				<div class="primarySectionHeader"><h2><h:outputText id="raHeader" value="#{bundle.section_related_assets}"/></h2></div>
				<h:outputText id="sectionHelp" styleClass="sectionInstructions" value="#{bundle.help_section_asset_download_related}" />
				<h:dataTable id="relatedTable" border="0" cellpadding="3"
					cellspacing="2" headerClass="headerClass"
					rowClasses="oddRow, evenRow"
					value="#{pc_DownloadRelated.relatedAssets}"
					styleClass="displayTable" var="relatedAsset" width="100%">
					<h:column>
						<f:facet name="header">
							<h:outputText value="#{bundle.column_name}" />
						</f:facet>
						<hx:requestLink id="detailsLink" action="assetDetails">
							<f:param id="detailParamGuid" name="guid" value="#{relatedAsset.assetId}"></f:param>
							<f:param id="detailParamV" name="v" value="#{relatedAsset.assetVersion}"></f:param>
							<h:outputText id="relatedAssetNameText" value="#{relatedAsset.assetName}" />
						</hx:requestLink>
						<f:attribute name="width" value="60%" />
					</h:column>
					<h:column>
						<f:facet name="header">
							<h:outputText value="#{bundle.column_version}" />
						</f:facet>
						<h:outputText value="#{relatedAsset.assetVersion}"></h:outputText>
					</h:column>
					<h:column>
						<f:facet name="header">
							<h:outputText value="#{bundle.column_relationship}" />
						</f:facet>
						<h:outputText value="#{relatedAsset.relationship}"></h:outputText>
					</h:column>
					<h:column>
						<f:facet name="header">
								<h:outputText id="headerDownloadOptions" value="#{bundle.column_downloadOptions}" />
							</f:facet>
						<ram:form id="download_related_form">
							
							<hx:commandExButton id="download_related" type="submit"
								styleClass="downloadButton" action=""
								value="#{bundle.button_download}" iconDepressed="/theme/images/transparent.gif"
								rendered="#{!pc_DownloadRelated.downloadClientSelected}">
								<hx:behavior event="onclick" onActionFunction="return doDownloadRelated(this)" behaviorAction="stop" id="download_related_behavior"/>
							</hx:commandExButton>
							<h:outputLink id="downloadRelatedLink" value="#{relatedAsset.downloadURL}" rendered="#{!pc_DownloadRelated.downloadClientSelected}">
								<h:outputText id="downloadRelatedLinkText" value="#{relatedAsset.assetName}" style="display:none;"/>
							</h:outputLink>
														
							<ram:downloadClient id="assetDD1" type="asset" guid="#{relatedAsset.assetId}" version="#{relatedAsset.assetVersion}" value="#{relatedAsset.assetName}.zip" filename="#{relatedAsset.assetName}.zip" image="/theme/images/icons/obj16/downloadassets_co.gif"   text="" rendered="#{pc_DownloadRelated.downloadClientSelected}" />
							
						</ram:form>
					</h:column>
				</h:dataTable>
			</hx:jspPanel>
			
		</div>
		</div>
		
		<%@include file="/theme/footer.jspf" %>
	</hx:scriptCollector>
	</body>
</f:view>
</html>
