<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<%-- jsf:pagecode language="java" location="/JavaSource/pagecode/community/CommunityConfiguration.java" --%><%-- /jsf:pagecode --%>

<%------------------------------------------------------------------------------
 - Licensed Materials - Property of IBM
 - 
 - (C) Copyright IBM Corporation 2006. All Rights Reserved.
 - Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 - restricted by GSA ADP  Schedule Contract with IBM Corp.
  -----------------------------------------------------------------------------%>
<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>
<%@taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c"%>
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8" %>
   
<html lang="${pageContext.response.locale}">
<head>
	<%@include file="/theme/metaHeader.jspf" %>
	<%@include file="/theme/cssHideRightColumn.jspf"%>
	<link rel="alternate" type="application/rss+xml" title="${bundle.community_feed}" href="${pc_CommunityConfiguration.feedUrl}" />
	<link rel="csh" href="${applicationScope.cshPath}">
	<title>${pc_CommunityConfiguration.browserTitle}</title>
</head>
<f:view>
<body class="ram">
<hx:scriptCollector id="scriptCollector1">
	
	<%@ include file="/theme/header.jspf" %>
	
	<div class="dashboard-page">
	<div id="contentColumn">
	<div class="inside">
	
	<%@include file="/includes/communityHeader.jspf" %>
	<ram:infopop id="configurationPageHelp" for="title" placement="after"
		styleClass="pageHelp" image="/theme/images/icons/obj16/info_indicator.gif"
		contextId="chom0050" />
	
	<div class="dashboard-content">
	
	<div id="column1" class="three-col">
	<ram:panelSectionEx id="typesSection" initClosed="false" styleClass="ram-section" image="/theme/images/icons/obj16/asset_type.gif">
		<f:facet name="opened">
			<h:panelGroup id="typesHeader">
			<hx:requestLink id="typesLink" action="communityTypes" value="#{bundle.section_asset_types}">
				<f:param id="tGid" value="#{pc_CommunityConfiguration.community.id}" name="gid" />
			</hx:requestLink>
			<h:outputText id="typesCount" styleClass="headerCount" value=" #{bundle.common_ltr_mark}(#{pc_CommunityConfiguration.typesCount})" />
			</h:panelGroup>
		</f:facet>
		<h:panelGroup id="typesPanel" rendered="#{not empty pc_CommunityConfiguration.types}">
			<ram:facetCounts id="typesFacetCounts" value="#{pc_CommunityConfiguration.types}" facetNameStyle="hidden" var="item" mapping="itemMapping" maxItems="20">
				<hx:requestLink id="typesFacetCountLink" action="#{pc_CommunityConfiguration.doViewType}">
					<h:outputText id="facetCountLinkText" value="#{itemMapping} #{bundle.common_ltr_mark}[#{item.displayCount}]" />
					<f:param id="assetTypeFacet" name="fType" value="#{item.itemName}" />
					<f:param id="assetTypeGid" name="gid" value="#{pc_CommunityConfiguration.community.id}" />
				</hx:requestLink>
			</ram:facetCounts>
		</h:panelGroup>
		<h:outputText id="noTypesText" rendered="#{empty pc_CommunityConfiguration.types}" value="#{bundle.text_no_community_types}" />
	</ram:panelSectionEx>
	<ram:infopop for="typesSection" styleClass="viewletInfopop" id="typesHelp" contextId="chom0101" placement="end" />
	
	<ram:panelSectionEx id="userGroupsSection" initClosed="false" styleClass="ram-section" image="/theme/images/icons/obj16/usergroup_obj.gif">
		<f:facet name="opened">
			<h:panelGroup id="userGroupsHeader">
			<hx:requestLink id="userGroupsLink" rendered="#{pc_CommunityConfiguration.communityAdmin}" action="communityUserGroups" value="#{bundle.section_user_groups}">
				<f:param id="ugGid" value="#{pc_CommunityConfiguration.community.id}" name="gid" />
			</hx:requestLink>
			<h:outputText id="userGroupsLabel" rendered="#{!pc_CommunityConfiguration.communityAdmin}" value="#{bundle.section_user_groups}" />
			<h:outputText id="userGroupsCount" styleClass="headerCount" value=" #{bundle.common_ltr_mark}(#{pc_CommunityConfiguration.userGroupsCount})" />
			</h:panelGroup>
		</f:facet>
		<hx:dataIterator id="userGroupsIterator" value="#{pc_CommunityConfiguration.userGroups}" var="userGroup" rows="20">
			<hx:requestLink id="userGroupLink" action="viewUserGroup" value="#{userGroup.groupName}" style="display:block;">
				<f:param id="userGroupGID" name="gid" value="#{pc_CommunityConfiguration.community.id}"></f:param>
				<f:param id="userGroupID" name="ugid" value="#{userGroup.groupId}"></f:param>
			</hx:requestLink>
		</hx:dataIterator>
		<h:outputText id="noUserGroupsText" rendered="#{empty pc_CommunityConfiguration.userGroups}" value="#{bundle.text_no_community_user_groups}" />
	</ram:panelSectionEx>
	<ram:infopop for="userGroupsSection" styleClass="viewletInfopop" id="userGroupsHelp" contextId="chom0130" placement="end" />
	</div>
	
	<div id="column2" class="three-col">
	<ram:panelSectionEx id="schemasSection" initClosed="false" styleClass="ram-section" image="/theme/images/icons/obj16/category_schema.gif">
		<f:facet name="opened">
			<h:panelGroup id="schemasHeader">
				<hx:requestLink id="schemasLink" action="communitySchemas" value="#{bundle.section_category_schemas}">
					<f:param id="sGid" value="#{pc_CommunityConfiguration.community.id}" name="gid" />
				</hx:requestLink>
				<h:outputText id="schemasCount" styleClass="headerCount" value=" #{bundle.common_ltr_mark}(#{pc_CommunityConfiguration.schemasCount})" />
			</h:panelGroup>
		</f:facet>
		<h:panelGroup id="schemasPanel" rendered="#{not empty pc_CommunityConfiguration.schemas}">
			<ram:facetCounts id="schemasFacetCounts" value="#{pc_CommunityConfiguration.schemas}" facetNameStyle="hidden" var="item" mapping="itemMapping" maxItems="20">
				<hx:requestLink id="schemasFacetCountLink" action="#{pc_CommunityConfiguration.doViewSchema}">
					<h:outputText id="sfacetCountLinkText" value="#{itemMapping} #{bundle.common_ltr_mark}[#{item.displayCount}]" />
					<f:param id="schemaFacet" name="Classification" value="#{item.itemName}" />
					<f:param id="schemaGid" name="gid" value="#{pc_CommunityConfiguration.community.id}" />
				</hx:requestLink>
			</ram:facetCounts>
		</h:panelGroup>
		<h:outputText id="noSchemasText" rendered="#{empty pc_CommunityConfiguration.schemas}" value="#{bundle.text_no_community_category_schemas}" />
	</ram:panelSectionEx>
	<ram:infopop for="schemasSection" styleClass="viewletInfopop" id="schemasHelp" contextId="chom0110" placement="end" />
	</div>
	
	<div id="column3" class="three-col">
	<ram:panelSectionEx id="lifecyclesSection" initClosed="false" styleClass="ram-section">
		<f:facet name="opened">
			<h:panelGroup id="lifecyclesHeader">
				<hx:requestLink id="lifecyclesLink" action="communityReviews" value="#{bundle.section_lifecycles}">
					<f:param id="lifecycleLinkGID1" value="#{pc_CommunityConfiguration.community.id}" name="gid" />
				</hx:requestLink>
				<h:outputText id="lifecyclesCount" styleClass="headerCount" value=" #{bundle.common_ltr_mark}(#{pc_CommunityConfiguration.lifecyclesCount})" />
			</h:panelGroup>
		</f:facet>
		<hx:dataIterator id="lifecyclesIt" value="#{pc_CommunityConfiguration.lifecycles}" var="varreview" rows="20">
			<hx:requestLink id="lifecycleLink" action="viewLifecycle" 
				value="#{varreview.name}"
				style="display:block;">
				<f:param id="lifecycleLinkGID2" name="gid" value="#{pc_CommunityConfiguration.community.id}"></f:param>
				<f:param id="lifecycleLinkRPID" name="rpid" value="#{varreview.identifier}"></f:param>
			</hx:requestLink>
		</hx:dataIterator>
		<h:outputText id="noLifecyclesText" rendered="#{pc_CommunityConfiguration.lifecyclesCount == 0}" value="#{bundle.text_no_community_lifecycles}" />
		<ram:infopop for="lifecyclesSection" styleClass="viewletInfopop" id="lifecyclesHelp" contextId="chom0122" placement="end" />
	</ram:panelSectionEx>
	
	<ram:panelSectionEx id="reviewsSection" initClosed="false" styleClass="ram-section" rendered="#{pc_CommunityConfiguration.reviewsCount > 0}">
		<f:facet name="opened">
			<h:panelGroup id="reviewsHeader">
				<hx:requestLink id="reviewsLink" action="communityReviews" value="#{bundle.section_legacy_review_processes}">
					<f:param id="rGid" value="#{pc_CommunityConfiguration.community.id}" name="gid" />
				</hx:requestLink>
				<h:outputText id="reviewsCount" styleClass="headerCount" value=" #{bundle.common_ltr_mark}(#{pc_CommunityConfiguration.reviewsCount})" />
			</h:panelGroup>
		</f:facet>
		<hx:dataIterator id="reviewProcIt" value="#{pc_CommunityConfiguration.reviewProcesses}" var="varreview" rows="20">
			<hx:requestLink id="reviewProcessLink" action="viewReviewProcess" 
				value="#{varreview.reviewConfiguration.name}"
				style="display:block;">
				<f:param id="reviewProcessLinkGID" name="gid" value="#{pc_CommunityConfiguration.community.id}"></f:param>
				<f:param id="reviewProcessLinkRPID" name="rpid" value="#{varreview.reviewProcessID}"></f:param>
			</hx:requestLink>
		</hx:dataIterator>
	</ram:panelSectionEx>
	<ram:infopop for="reviewsSection" styleClass="viewletInfopop" id="reviewsHelp" contextId="chom0120" placement="end" />
	</div>
	</div>
		
	
	</div>
	</div>
	</div>
	
	
	<%@ include file="/theme/footer.jspf" %>
</hx:scriptCollector>
</body>
</f:view>
</html>
