var cookieName = 'reviewCookie';
var reviewerCookie;
var COLLAB_INFO_CONTENT = 'collabInfoContent';
var COLLAB_TOGGLE_TEXT = 'collabToggleText';
var COLLAB_TAB = 'collabTab';
var COLLAB_TAB_STARTUP = COLLAB_TAB + '-startup';
var COLLAB_TAB_SELECT_CHILD = COLLAB_TAB + '-selectChild';
var LESS_LINK_CLASS = 'lessLink';
var MORE_LINK_CLASS = 'moreLink';
var SHOW_REVIEW_BAR_COOKIE = 'showReviewerBar';
var SELECTED_TAB_COOKIE = 'selectedTab';

var WIPE_TIME = 500;
var COOKE_EXPIRATION = 14;
var bundle = dojo.i18n.getLocalization("ram", "lifecycleeditor");

dojo.subscribe(COLLAB_TAB_SELECT_CHILD, function(child){
	reviewerCookie.selectedTab = child.id;
	dojo.cookie(cookieName, dojo.toJson(reviewerCookie)	 , {expires:COOKE_EXPIRATION,path:'/'});
});
 
dojo.subscribe(COLLAB_TAB_STARTUP,function() {
	reviewerCookie = dojo.fromJson(dojo.cookie(cookieName));
	if(reviewerCookie == null)
		reviewerCookie = {SHOW_REVIEW_BAR_COOKIE:true, SELECTED_TAB_COOKIE:null };
	if(reviewerCookie.showReviewerBar == true){ 
		dojo.style(COLLAB_INFO_CONTENT,'display',''); 
		dojo.addClass(COLLAB_TOGGLE_TEXT,LESS_LINK_CLASS); 
		dojo.removeClass(COLLAB_TOGGLE_TEXT,MORE_LINK_CLASS); 
		dojo.byId(COLLAB_TOGGLE_TEXT).innerHTML  = bundle.link_show_less;
		dojo.style(COLLAB_TAB,'display',''); 
	}else{	
		dojo.style(COLLAB_INFO_CONTENT,'display','none'); 
		dojo.addClass(COLLAB_TOGGLE_TEXT,MORE_LINK_CLASS); 
		dojo.removeClass(COLLAB_TOGGLE_TEXT,LESS_LINK_CLASS);
		dojo.byId(COLLAB_TOGGLE_TEXT).innerHTML = bundle.link_show_more;
	}
});

					
function toggleCollabBar(){
	flipTextValue();
	reviewerCookie.showReviewerBar = !reviewerCookie.showReviewerBar;
	writeCookieValue();
	if(reviewerCookie.showReviewerBar  != false)		
		showCollabPanel();
	else	
		hideCollabPanel();
}

function writeCookieValue(){
	dojo.cookie(cookieName, dojo.toJson(reviewerCookie), {expires:COOKE_EXPIRATION,path:'/'});
}

function flipTextValue() {
	dojo.byId(COLLAB_TOGGLE_TEXT).innerHTML  = (reviewerCookie.showReviewerBar != true) ? bundle.link_show_less : bundle.link_show_more;
}

function showCollabPanel(){
		dojo.style(COLLAB_TAB,'display','');
		dojo.fx.wipeIn({
			node: COLLAB_INFO_CONTENT, 
			duration: WIPE_TIME,
			onEnd: function() {
				dijit.byId(COLLAB_TAB).resize();
			}
		}).play();
		dojo.addClass(COLLAB_TOGGLE_TEXT,LESS_LINK_CLASS); 
		dojo.removeClass(COLLAB_TOGGLE_TEXT,MORE_LINK_CLASS); 
		dojo.byId(COLLAB_TOGGLE_TEXT).innerHTML  = bundle.link_show_less;
}

function hideCollabPanel(){
		dojo.fx.wipeOut({
			node: COLLAB_INFO_CONTENT, 
			duration: WIPE_TIME,
			onEnd: function() {
				dijit.byId(COLLAB_TAB).resize();
			}
		}).play();
		dojo.addClass(COLLAB_TOGGLE_TEXT,MORE_LINK_CLASS); 
		dojo.removeClass(COLLAB_TOGGLE_TEXT,LESS_LINK_CLASS);
}
