dojo.require('ram.RequestHandler');
var rh = new ram.RequestHandler();

function parseDojo(rootNodeId) {
	dojo.require('dojo.parser');
	var rootNode = dojo.byId(rootNodeId);
	if (rootNode) {
		dojo.parser.parse(rootNode);
	}
}

var originalClipboardText = null;
var currentClipboardElement = null;
function clipboardBlur(evt) {
	if(originalClipboardText != null) {
		clipboardData.setData("Text", originalClipboardText);
		originalClipboardText = null;
	}
	if(currentClipboardElement != null) {
		currentClipboardElement.onblur = null;
		currentClipboardElement = null;
	}
}

function convertEnterToSpace(actId){
    var text = clipboardData.getData("Text");    
    originalClipboardText = text;
    var element = document.getElementById(actId);
    if (element.tagName == "INPUT"){
    	 element.onblur = clipboardBlur;
    	 currentClipboardElement = element;
    	 while(text.indexOf("\r\n")!=-1){
    		text = text.substring(0,text.indexOf("\r\n"))+" "+text.substring(text.indexOf("\r\n")+2);
		   }
		    clipboardData.setData("Text", text);
    }
}

dojo.addOnLoad(function() {
	sizeContentArea();
	dojo.connect(window, "onresize", sizeContentArea);
});

function sizeContentArea() {
	var pw = dojo.byId("pageWrapper");
	if (pw) {
		var h = dojo.window.getBox().h + "px";
		dojo.style(pw, {minHeight: h});
	}
}

function showAboutDialog() {
	var dialog = dijit.byId('about_ram_dialog');
	if (!dialog) {
		var content = dojo.create("iframe", {id: "about_iframe", src: getAbsoluteUrl("aboutDialog.jsp"), width: "778px", scrolling: "no", frameborder: "0"});
		
		 
		  if (content.addEventListener) {
			  content.addEventListener("load", function() {sizeAboutIFrame();}, false);
		  } else if (content.attachEvent) {
		    content.attachEvent("onload",  function() {sizeAboutIFrame();});
		  }
		
		content.onload_1 = function(){alert('test');}
		
		dialog = new ram.RamDialog({id: "about_ram_dialog", title: "About IBM Rational Asset Manager"});
		dojo.place(dialog.domNode, dojo.body());
		
		dialog.attr('content', content);
	}
	dialog.show();
}

function sizeAboutIFrame() {
	setTimeout(function() {
		var f = dojo.byId("about_iframe");
		var s = f.contentWindow.document.body.scrollHeight + "px";
		dojo.style(f, {height: s});
	}, 250); // wait 250 ms for the dialog to open before setting the height of the iframe
}

function getUrlParameter(name) {
	name = name.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
	var regexS = "[\\?&]"+name+"=([^&#]*)";
	var regex = new RegExp( regexS );
	var results = regex.exec( window.location.href );
	
	return results===null ? "" : results[1];
}

function getValueFromHref(href) {
	if (href.match(/\.xml$/i)) {
		href = href.substring(0, eval(href.length-4)) + ".json";
	} else if (!href.match(/\.json$/i)) {
		href = href + ".json";
	}
	
	var returnObj;
	dojo.xhrGet({
		url: href,
		handleAs: "json",
		sync: true,
		load: function(response, ioArgs) {
			returnObj = response;
		},
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
	
	return returnObj;
}

function getBaseUrl() {
	var newURL = window.location.protocol + "//" + window.location.host + baseUrl + "/";
	return newURL;
}


function getAbsoluteUrl(path) {
	if (path.charAt(0) != "/")
		return absoluteBaseUrl+"/"+path;
	else
		return absoluteBaseUrl+path;
}

// TODO Encoded should probably be the default
function getEncodedAbsoluteUrl(path) {
	var url = getAbsoluteUrl(path);
	if(encodeURI) {
		url = encodeURI(url);
	}
	return url;
}

function setHiddenField(id, value) {
	var field = dojo.byId(id);
	if (field)
		field.value = value;
}
	
// Helper script that provides help instructions for an inputText field if nothing is typed in yet
function helpFieldBlur(htmlTextElement, msg) {
	if (htmlTextElement != null && (htmlTextElement.value == "" || htmlTextElement.value == msg)) {
		htmlTextElement.value = msg;
		htmlTextElement.style.fontStyle = "italic";
		htmlTextElement.style.color = "#AAA";
	}
}
// Helper script that clears an inputText field if the value is equal to the "msg"
function helpFieldFocus(htmlTextElement, msg) {
	if (htmlTextElement.value == msg) {
		htmlTextElement.value = "";
		htmlTextElement.style.fontStyle = "normal";
		htmlTextElement.style.color = "#000";
	}
}

function refreshWithParams(paramString) {
	window.location.href = window.location.pathname + paramString;
}
	
function refreshPagePlusSortParam(dparm) {
	var d=dparm
	var newVal = window.location.href;
	
	var parmToAdd;

	if (newVal.indexOf('?d=') != -1) {
		parmToAdd = '?d=';
	} else if (newVal.indexOf('&d=') != -1) {
		parmToAdd = '&d=';
	}
	
	if(parmToAdd) {
		// Has parameter already
		newVal = 'OLD'==d ? newVal.replace(parmToAdd+'OLD', parmToAdd +'NEW') : newVal.replace(parmToAdd+'NEW', parmToAdd+'OLD');
		window.location.href = newVal;
	} else {	
		// Doesn't have parameter
		var hasNoParams = newVal.indexOf('?') == -1
		if('OLD'==d){
			d = newVal.indexOf('?') == -1 ? '?d=NEW' : '&d=NEW';
		} else {
			d = newVal.indexOf('?') == -1 ? '?d=OLD' : '&d=OLD';
		}
		window.location.href = newVal + d;
	}
}

// For submit/update wizard... store page url string in hidden field and select the next button
function selectNextButton(thisObj, hiddenId, nextButtonId, value) {
	var hidden = document.getElementById(hiddenId);			
	hidden.value = value;
	var nextSubmitButton=document.getElementById(nextButtonId);
	nextSubmitButton.click();
	return false;			
}

function filterRowsFrom(filterValue, tableId, elementId, startingRow) {
	var doc = document;
	var tableBody = doc.getElementById(tableId).tBodies[0];
	var rowClass = startingRow%2 == 1 ? "evenRow" : "oddRow";
	var rows = tableBody.rows.length;
	
	for( var i=startingRow; i<rows; i++ ) {
		var spanId = tableId + ":" + i + ":" + elementId;
		var element = doc.getElementById(tableId + ":" + i + ":" + elementId);
		
		if( element && (filterValue == "" || element.firstChild.data.toLowerCase().indexOf(filterValue.toLowerCase()) >= 0) ) {
			tableBody.rows[i].className = rowClass + " visible";
			rowClass = rowClass=="evenRow" ? "oddRow" : "evenRow";
		}
		else {
			tableBody.rows[i].className = "hidden";
		}
	}
}
	
function filterRows(filterValue, tableId, elementId) {
	filterRowsFrom(filterValue, tableId, elementId, 0);
}
	
function filterRowsOnMultipleColumns(filterValues, tableId, elementIds, startingRow) {
	var doc = document;
	var tableBody = doc.getElementById(tableId).tBodies[0];
	var rowClass = startingRow%2 == 1 ? "evenRow" : "oddRow";
	var rows = tableBody.rows.length;
	
	for( var i=startingRow; i<rows; i++ ) {
		var show = true;
		for( var c=0; show && c<filterValues.length; c++) {
			var spanId = tableId + ":" + i + ":" + elementIds[c];
			var element = doc.getElementById(spanId);
			if( !element || (filterValues[c] != "" && element.firstChild.data.toLowerCase().indexOf(filterValues[c].toLowerCase()) < 0) ) {
				show = false;
			}
		}
		if (show) {
			tableBody.rows[i].className = rowClass + " visible";
			rowClass = rowClass=="evenRow" ? "oddRow" : "evenRow";
		}
		else {
			tableBody.rows[i].className = "hidden";
		}
	}
}	
	
// Function for disabling a form button depending on whether any check boxes are checked
// tableId = Full id to table (Ex: formId:tableId)
// elementId = id of checkbox
// buttonId = Full id to button (Ex: formId:buttonId)
function toggleButtonEnabled(tableId, elementId, buttonId) {
	var doc = document;
	if (!doc.getElementById(buttonId) || 
		!doc.getElementById(tableId + ":0:" + elementId)) {
		// Can't find button or no results, so return
		return;
	}
	if (!doc.getElementById(tableId)) {
		// Can't find table, try to set button to disabled
		if (doc.getElementById(buttonId)){
			doc.getElementById(buttonId).disabled = true;
			hX.getComponentById(buttonId).redraw();
		}
		return;
	}
	var tableBody = doc.getElementById(tableId).tBodies[0];
	var rows = tableBody.rows.length;
	// For each row
	for( var i=0; i<rows; i++) {
		// Get check box
		var box = doc.getElementById(tableId + ":" + i + ":" + elementId);

		// Is it checked?
		if (box && box.value == "true") {
			// If so, enable button and return
			doc.getElementById(buttonId).disabled = false;
			hX.getComponentById(buttonId).redraw();
			return;
		}
	}
	
	// Never found checked box, so disable button
	doc.getElementById(buttonId).disabled = true;
	if (hX.getComponentById(buttonId))
		hX.getComponentById(buttonId).redraw();
	return;
}
	
function toggleTagCounts(tagCloudId, toggleLinkId, hideTextId) {
	var doc = document;
	var tagCloud = doc.getElementById(tagCloudId);
	var hideText = doc.getElementById(hideTextId);
	var toggleLink = doc.getElementById(toggleLinkId);
	
	// Swap toggle link
	var swap = hideText.innerHTML;
	hideText.innerHTML = toggleLink.innerHTML;
	toggleLink.innerHTML = swap;
	
	var tagCount = tagCloud.childNodes.length;
	for(var i=0; i<tagCount; i++) {
		var tag = tagCloud.childNodes[i];
		if( tag.nodeName == "SPAN" ) {
			var count = tag.firstChild.firstChild.nextSibling;
			count.className = count.className == "hidden" ?	count.className = "visible" : count.className = "hidden";
		}
	}
}
	
function viewAllItems(facetName) {
	var facet = document.getElementById(facetName);
	var moreLink = document.getElementById(facetName+"more");
	var facets = facet.childNodes.length;
	for(var i=0; i<facets; i++) {
		var item = facet.childNodes[i];
		if( item.nodeName == "LI" && item.className == "hidden" )  {
			item.className = "visible";
		}
	}
	
	moreLink.className = "hidden";
}
	
function toggleDetails(link, readMoreText, hideText) {
	var details = link.nextSibling;
	if (details.style.display == "block") {
		link.innerHTML = readMoreText;
		details.style.display = "none";
	} else {
		link.innerHTML = hideText;
		details.style.display = "block";
	}
}
	
function globalSearch() {
	var searchLink = document.getElementById("navSearchForm:globalSearchLink");
	var searchTxt = document.getElementById("navSearchForm:navSearch");
	
	var searchURL = searchLink.href + "&txt=" + encodeURIComponent(searchTxt.value);
	window.location.href = searchURL;
	
	return false;
}
	
function showRAMSectionMenu(obj, menuId) {		
	var position = findPos(obj);
	var menu = document.getElementById(menuId);
	
	menu.style.display = "block";
	
	menu.style.left = position[0]- position[2]-menu.offsetWidth+20 + "px";
	menu.style.top = position[1]- position[3]+obj.offsetHeight + "px";
}
	
function showRAMSuggestMenu(obj, menuId) {
	var position = findPos(obj);
	var menu = document.getElementById(menuId);
	
	menu.style.display = "block";
	
	menu.style.left = position[0]+2 + "px";
	menu.style.top = position[1]+obj.offsetHeight + "px";
}
	
function findPos(obj) {
	var curleft = curtop = 0;
	var columleft = columntop = 0;
	var lastleft = 0;
	var lasttop = 0;
	if (obj.offsetParent) {
		do {
			// These have position: relative
			if (obj.id=='contentColumn' || obj.id=='leftColumn' || obj.id=='rightColumn' 
				|| obj.className=='dashboard-content'
				|| obj.id=='column1' || obj.id=='column2' || obj.id=='column2-span' || obj.id=='column3') {
				lastleft += obj.offsetLeft;
				lasttop += obj.offsetTop;
			}
					
			curleft += obj.offsetLeft;
			curtop += obj.offsetTop;
		} while (obj = obj.offsetParent);
	}
	return [curleft,curtop,lastleft,lasttop];
}
	
function closeMenu(menu) {
	var dropmenu= document.getElementById(menu);
	dropmenu.style.display="none";
	dropdownmenu="none";
}
	
function toggleTreeItem(item) {
	// expands or collapses the given <li> by setting its next sibling's
	// (should be a <ul> or <ol>) className to either 'hidden' or ''
	if (item) {
		var toggleImg;
		var a = item.firstChild;
		if (a) {
			toggleImg = a.firstChild;
		}
		var childList = item.lastChild;
		if (childList) {
			if (childList.className == 'hidden') {
				childList.className = '';
				if (toggleImg)
					toggleImg.className = 'toggle up';
			} else {
				childList.className = 'hidden';
				if (toggleImg)
					toggleImg.className = 'toggle down';
			}
		}
	}
}
	
function performTaskAction(action) {
	dojo.xhrGet({
		url: getAbsoluteUrl("faces/action"), 
		handleAs: "json",
		content: {task: action, url: window.location.href},
		load: taskCallbackFn,
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}

function taskCallbackFn(result, ioArgs) {
	if (result.url) {
		if (result.url.indexOf('/')==0) {
			// URL is relative, append to baseUrl
			window.location.href = baseUrl + result.url;
		} else {
			window.location.href = result.url;
		}
	} else if (result.message) {
		var existingMessage = dijit.byId('taskActionResultMessage');
		if (existingMessage)
			existingMessage.destroy();
			
		var messageContainer = new ram.RamMessage({id: "taskActionResultMessage", styleClass: result.severity, message: result.message, details: result.messageDetails});
		
		var contentColumnChildren = document.getElementById('contentColumn').childNodes;
		var j = 0;
		var c = contentColumnChildren.length;
		while (j<c) {
			if (contentColumnChildren[j].nodeName == "DIV") {
				break;
			}
			j++;
		}
		
		dojo.place(messageContainer.domNode, contentColumnChildren[j], "first")
	}
}
	
function ajax_suggestUsers(field, evt, showUID, searchLDAP) {
	if (evt.keyCode == 13) { // pressed enter
		return SuggestionMenuUtils_processEnterEvents(userSuggestions, evt);
	}
	
	if (!SuggestionMenuUtils_processKeyEvents(userSuggestions, evt)) {
		return false;
	}
		
	var users = new Array();
	users = field.value.split(', ');
	
	// Get the last tag.. eventually will want to get the tag the user is typing
	// Which would mean keeping an array of the tags and comparing with every keystroke
	// to see which one changed
	var prefix = users[users.length-1];
	
	if (prefix.length < 1) {
		return;
	}

	dojo.xhrGet({
		url: getAbsoluteUrl("suggest/users"), // TODO what is the difference btw this and the user search servlet?
		handleAs: "json",
		content: {
			user: prefix, 
			inputFieldId: field.id, 
			showUID: showUID, 
			searchLDAP: searchLDAP,
			inputValue: field.value
		},
		load: suggestUsersCallbackFn,
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}
	
function suggestUsersCallbackFn(response, ioArgs) {
	var inputField = document.getElementById(decodeURIComponent(response.inputFieldId));
	var users = response.suggestions;
	var showUID = response.showUID;
	
	var popupWindowName = userSuggestions.popup.divName; // Used also in constructor of PopupWindow
	
	var menu = SuggestionMenuUtils_createPopupWindow(popupWindowName, inputField);
	var table = SuggestionMenuUtils_createSuggestionTable();
	var tbody = document.createElement('tbody');
	
	for (var t=0; t<users.length; t++) {
		var row = document.createElement('tr');
		row.setAttribute('onmouseover', 'hoverRow(this);');
		row.setAttribute('onmouseout', 'unHoverRow(this);');
		var cell1 = document.createElement('td');
		if (showUID == 'true')
			cell1.appendChild(document.createTextNode('"'+users[t].userName+'" <'+ users[t].email+ '>'+' "'+users[t].uid+'"'));
		else 
			cell1.appendChild(document.createTextNode('"'+users[t].userName+'" <'+ users[t].email+ '>'));
		row.appendChild(cell1);
		tbody.appendChild(row);
	}
	
	table.appendChild(tbody);
	menu.appendChild(table);
	
	SuggestionMenuUtils_replaceExistingPopupWindow(menu, popupWindowName);
	
	userSuggestions.popup.showPopup(inputField.id);
	showRAMSuggestMenu(inputField, popupWindowName);
	userSuggestions.table = table;
}
	
function ajax_suggestTags(field, evt) {
	if (evt.keyCode == 13) { // pressed enter
		return SuggestionMenuUtils_processEnterEvents(tagSuggestions, evt);
	}
	
	if (!SuggestionMenuUtils_processKeyEvents(tagSuggestions, evt)) {
		return false;
	}
	
	var tags = new Array();
	tags = field.value.split(' ');
	
	// Get the last tag.. eventually will want to get the tag the user is typing
	// Which would mean keeping an array of the tags and comparing with every keystroke
	// to see which one changed
	var tagPrefix = tags[tags.length-1];
	
	if (tagPrefix.length < 1) {
		return;
	}
	
	dojo.xhrGet({
		url: getAbsoluteUrl("suggest/tags"),
		handleAs: "json",
		content: {tag: encodeURIComponent(tagPrefix), inputFieldId: encodeURIComponent(field.id)},
		load: suggestTagsCallbackFn,
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}
	
function suggestTagsCallbackFn(response, ioArgs) {
	var inputField = document.getElementById(decodeURIComponent(response.inputFieldId));
	var tags = response.suggestions;

	var popupWindowName = tagSuggestions.popup.divName;
	
	var menu = SuggestionMenuUtils_createPopupWindow(popupWindowName, inputField);
	var table = SuggestionMenuUtils_createSuggestionTable();
	var tbody = document.createElement('tbody');
	
	for (var t=0; t<tags.length; t++) {
		var row = document.createElement('tr');
		row.setAttribute('onmouseover', 'hoverRow(this);');
		row.setAttribute('onmouseout', 'unHoverRow(this);');
		var cell1 = document.createElement('td');
		cell1.appendChild(document.createTextNode(tags[t].itemName));
		var cell2 = document.createElement('td');
		cell2.className = 'numberColumn';
		cell2.appendChild(document.createTextNode(tags[t].count));
		row.appendChild(cell1);
		row.appendChild(cell2);
		tbody.appendChild(row);
	}
	
	table.appendChild(tbody);
	menu.appendChild(table);
	
	SuggestionMenuUtils_replaceExistingPopupWindow(menu, popupWindowName);
	
	tagSuggestions.popup.showPopup(inputField.id);
	showRAMSuggestMenu(inputField, popupWindowName);
	tagSuggestions.table = table;
}

function getViewportDimensions() {
    var intH = 0, intW = 0;
    
    if(self.innerHeight) {
       intH = window.innerHeight;
       intW = window.innerWidth;
    } 
    else {
    	var docElem = document.documentElement;
        if(docElem && docElem.clientHeight) {
            intH = docElem.clientHeight;
            intW = docElem.clientWidth;
        } else {
            if(document.body) {
                intH = document.body.clientHeight;
                intW = document.body.clientWidth;
            }
        }
    }

    return {
        height: parseInt(intH, 10),
        width: parseInt(intW, 10)
    };
}

function centerElement(elem) {
    var viewport = getViewportDimensions();
    var left = (viewport.width == 0) ? 50 : parseInt((viewport.width - elem.offsetWidth) / 2, 10);
    var top = (viewport.height == 0) ? 50 : parseInt((viewport.height - elem.offsetHeight) / 2, 10);

    elem.style.left = left + 'px';
    elem.style.top = top + 'px';

    viewport = left = top = elem = null;    
}

function centerElementHorizontally(elem) {
	var viewport = getViewportDimensions();
    var left = (viewport.width == 0) ? 50 : parseInt((viewport.width - elem.offsetWidth) / 2, 10);
    
    elem.style.left = left + 'px';
    
    viewport = left = elem = null; 
}

function isIE(){
	return /msie/i.test(navigator.userAgent) && !/opera/i.test(navigator.userAgent);
}

function browseGraphically(url) {
	var width;
	if(screen.width >= 1600) {
		width = 1200;
	} else if(screen.width >= 1280) {
		width = 1150;
	} else {
		width = 940;
	}
	var height;
	if(screen.height >= 1200) {
		height = 950;
	} else if(screen.height > 768) {
		height = 800;
	} else {
		height = 600;
	}
	
	var parameters = "width=" + width + ", height=" + height + ", top=50, left=50, scrollbars=no, resizable=yes, status=no"
	window.name = 'primaryWindow';
	var graphcalBrowseWindow = window.open(url,'visualBorwse', parameters);
	if (window.focus) {
		graphcalBrowseWindow.focus()
	} 
}


var warnOnPageUnload = false;
var pageUnloadMessage = '';

function enableWarnOnPageUnload(/*string*/ message) {
	warnOnPageUnload = true;
	pageUnloadMessage = message;
}

function disableWarnOnPageUnload() {
	warnOnPageUnload = false;
}

window.onbeforeunload = function (evt) {
	if(warnOnPageUnload){
		if (typeof evt == 'undefined') { // IE
			evt = window.event;
		}
		if (evt) {
			evt.returnValue = pageUnloadMessage;
		}
		return pageUnloadMessage;
	}
} 

function StringBuffer() { 
   this.buffer = [];
   Array.prototype.push.apply(this.buffer, arguments);
} 

StringBuffer.prototype.append = function append() { 
	Array.prototype.push.apply(this.buffer, arguments);
	return this; 
}; 

StringBuffer.prototype.toString = function toString() { 
	return this.buffer.join(""); 
};

// TODO remove all of the Suggestions stuff and use a dojo widget for the menu
function Suggestions() {
	if (!window.suggestionWindowIndex) { window.suggestionWindowIndex = 0; }
	if (!window.suggestionWindowObjects) { window.suggestionWindowObjects = new Array(); }
	if (!window.suggestionlistenerAttached) {
		window.suggestionlistenerAttached = true;
		Suggestions_attachListener();
	}
	this.index = suggestionWindowIndex++;
	this.suggestionPopupCreated = false;
	suggestionWindowObjects[this.index] = this;
	
	this.fieldId = arguments[0];
	this.popup = arguments[1];
	this.delim = arguments.length>2 ? arguments[2] : ' ';
	
	this.setInputValueWithSuggestion = Suggestions_setInputValueWithSuggestion;
	this.selectIfClicked = Suggestions_selectIfClicked;
	this.selectHoveredSuggestion = Suggestions_selectHoveredSuggestion;
	
	this.table;
}

function Suggestions_attachListener() {
	if (document.layers) {
		document.captureEvents(Event.MOUSEUP);
	}
	// Save old functions for later
	window.suggestionWindowOldEventListener = document.onmouseup;
	// Set function that gets called for event
	document.onmouseup = Suggestions_selectSuggestions;
}


function Suggestions_selectHoveredSuggestion(ri) {
	if (ri>=0) {
		var hoveredSuggestion;
		if (document.all) { // Need to hard-code this to trap IE for error-handling
			hoveredSuggestion = this.table.getElementsByTagName('tbody')[0].getElementsByTagName('tr')[ri].childNodes[0].innerText;
		} else {
			hoveredSuggestion = this.table.getElementsByTagName('tbody')[0].getElementsByTagName('tr')[ri].childNodes[0].textContent;
		}
		this.setInputValueWithSuggestion(hoveredSuggestion);
	}
}

// This global function checks all Suggestion objects onmouseup to see if they should be hidden
function Suggestions_selectSuggestions(e) {
	for (var i=0; i<suggestionWindowObjects.length; i++) {
		if (suggestionWindowObjects[i] != null) {
			var s = suggestionWindowObjects[i];
			if (!s.suggestionPopupCreated) {
				// Create div for the popup and add to body
				var menuDiv = document.createElement('div');
				if (document.all) {
					menuDiv.style.display = 'none';
					menuDiv.id = s.popup.divName;
				} else {
					menuDiv.setAttribute('style', 'display: none;');
					menuDiv.setAttribute('id', s.popup.divName);
				}
				
				document.body.appendChild(menuDiv);
				
				s.suggestionPopupCreated = true;
			}
		}
	}
	
	
	if (window.suggestionWindowOldEventListener != null) {
		window.suggestionWindowOldEventListener(e);
	}
	
	for (var j=0; j<suggestionWindowObjects.length; j++) {
		if (suggestionWindowObjects[j] != null) {
			var s = suggestionWindowObjects[j];
			s.selectIfClicked(e);
		}
	}
}

function Suggestions_selectIfClicked(e) {
	if (this.popup.isClicked(e)) {
		if (document.all) { // Need to hard-code this to trap IE for error-handling
			var t = window.event.srcElement;
			while (t.parentElement != null) {
				if (t.tagName=='TR') {
					this.setInputValueWithSuggestion(t.childNodes[0].innerText);
					break;
				}
				t = t.parentElement;
			}
		} else if (document.getElementById && e) {
			var t = e.originalTarget;
			try {
				while (t.parentNode != null) {
					if (t.tagName=='TR') {
						this.setInputValueWithSuggestion(t.childNodes[0].textContent);
						break;
					}
					t = t.parentNode;
				}
			} catch(ex) {}
		}
	}
	
	this.popup.hidePopup();
}

function Suggestions_setInputValueWithSuggestion(suggestion) {
	var field = document.getElementById(this.fieldId);
	
	var oldValue = field.value;
	oldValue = oldValue.substring(0, oldValue.lastIndexOf(this.delim));
	
	field.value = oldValue.length==0 ? suggestion + this.delim : oldValue + this.delim + suggestion + this.delim;
	
	field.focus();
}

// Global function that returns the row index of the row that has class = hovered, -1 if no row is hovered
function Suggestions_getHoveredRow(table) {
	var rows = table.getElementsByTagName('tbody')[0].getElementsByTagName('tr');
	var numRows = rows.length;
	
	for (var ri=0; ri<numRows; ri++) {
		if (rows[ri].className == 'hovered') {
			return ri;
		}
	}
	
	return -1;
}

function SuggestionMenuUtils_processEnterEvents(suggestion, evt) {
	var e = evt ? evt : window.event;

	var ri = Suggestions_getHoveredRow(suggestion.table);

	if (ri!=-1) {
		if (e.type == 'keyup') {
			// only select hovered suggestion for one of the three events
			suggestion.selectHoveredSuggestion(ri);
			suggestion.popup.hidePopup();
			hoverRow(suggestion.table, -1);
		}
		
		if ('function' == typeof e.preventDefault) {
			// Pressing enter when something was selected, so don't further process return
			e.preventDefault();
		} else {
			e.returnValue = false;
		}
		
		return false;
	} else {
		return true; // pressed enter without something having been hightlighted. return to bypass ajax
	}
}

function SuggestionMenuUtils_processKeyEvents(suggestion, evt) {
	var e = evt ? evt : window.event;
	
	if (e.type != 'keyup' && e.type != 'click') {
		return false; // We only want to process keyups (not keydown or keypress too) or click
	}
	
	switch (e.keyCode) {
		case 37: // left arrow
			return false;
		case 38: // up arrow
			var ri = Suggestions_getHoveredRow(suggestion.table);
			hoverRow(suggestion.table, ri-1);
			
			return false;
		case 39: // right arrow
			return false;
		case 40: // down arrow
			var ri = Suggestions_getHoveredRow(suggestion.table);
			hoverRow(suggestion.table, ri+1);
				
			if (e.cancelable) {
				e.preventDefault();
			} else {
				e.returnValue = false;
			}
			
			return false;
	}
	
	return true;
}
	
function SuggestionMenuUtils_createPopupWindow(popupWindowName, input) {
	var inputBox = dojo.position(input);
	var h = dojo.window.getBox().h - inputBox.y - inputBox.h - 10;
	var w = inputBox.w;
	var menu = dojo.create('div', {
		id: popupWindowName, 
		className: 'ram-suggest-menu', 
		style: {
			display: 'none', 
			width: w + 'px',
			overflowY: 'auto',
			maxHeight: h + 'px'
		}
	});
	return menu;
}

function SuggestionMenuUtils_createSuggestionTable() {
	var table = document.createElement('table');
	if (document.all) {
		table.className = 'listTable fixed';
		table.style.width= '100%';
	} else {
		table.setAttribute('class', 'listTable fixed');
		table.setAttribute('width', "100%");
	}
	
	return table;
}

function SuggestionMenuUtils_replaceExistingPopupWindow(menu, popupWindowName) {
	var existingSuggestions = document.getElementById(popupWindowName);
	if (existingSuggestions!=null) {
		existingSuggestions.parentNode.replaceChild(menu, existingSuggestions);
	} else {
		document.body.appendChild(menu);
	}
}

function hoverRow() {
	if (arguments[0].tagName == 'TR') {
		arguments[0].className = 'hovered';
	} else if (arguments.length == 2) {
		// arguments[1] could be negative, which would unhover everything
		var rows = arguments[0].getElementsByTagName('tbody')[0].getElementsByTagName('tr');
		var numRows = row.length;
		for (var ri=0; ri<numRows; ri++) {
			rows[ri].className = ri==arguments[1] ? 'hovered' : 'unhovered';
		}
	}
}
function unHoverRow() {
	if (arguments[0].tagName == 'TR')
		arguments[0].className = 'unhovered';
}

function encodeHtml(s) {
	return dojox.html.entities.encode(s);
}

String.prototype.startsWith = function(s) {
	return (this.match("^" + s) == s);
}

String.prototype.endsWith = function(s) {
	return (this.match(s + "$") == s);
}

function isEnterKey(event) {
	var key;
	if(window.event) {
		key = window.event.keyCode;
	} else {
		key = event.which;
	}
	return key == 13;
}

function returnKeyRate(textArea) {
	var newVal=textArea.value+"\n";
	textArea.value=newVal;
}

/******************************************
 * Attribute regular expression validation
 ******************************************/
var invalidAttributes = {};
function validateAttributePattern(inputId, exp, msg) {
	exp = decodeURIComponent(exp);
	msg = decodeURIComponent(msg);
	var input = dojo.byId(inputId);
	if (input) {
		var regexp = new RegExp(exp);
		var result = regexp.exec(input.value);
		if ((result && result.length > 0 && result[0] == input.value) || input.value == '' || exp == '') {
			dojo.removeClass(input, 'patternError');
			var popup = dijit.byId('errorMsgPopup');
			if (popup) {
				popup.close();
				popup.destroy();
			}
			delete invalidAttributes[inputId];
		} else {
			dojo.require('jazz.ui.HoverPopup');
			var createPopup = true;
			var popup = dijit.byId('errorMsgPopup');
			if (popup) {
				if (dojo.indexOf(popup._aroundNodes, input) >= 0)
					createPopup = false;
				else
					popup.destroy();
			}
			if (createPopup == true) {
				popup = new jazz.ui.HoverPopup({
					id: 'errorMsgPopup',
					around: input,
					programatic: true,
					html: '<span style="color: #67555C">' + msg + '</span>'
				});
				popup.open();
			}
			dojo.addClass(input, 'patternError');
			invalidAttributes[inputId] = true;
		}
		var invalid = false;
		if (typeof Object.keys == 'function') {
			invalid = Object.keys(invalidAttributes).length > 0;
		} else {
			for (k in invalidAttributes) {
				if (invalidAttributes.hasOwnProperty(k)) {
					invalid = true;
					break;
				}
			}
		}
		
		var updateButton = function(id, enabled) {
			var button = dojo.byId(id);
			if (button) {
				if (enabled == true) {
					button.disabled = false;
					dojo.removeClass(button, 'commandExButton_disabled');
					dojo.addClass(button, 'commandExButton');
				} else {
					button.disabled = true;
					dojo.removeClass(button, 'commandExButton');
					dojo.addClass(button, 'commandExButton_disabled');
				}
			}
		}
		
		if (invalid == true) {
			updateButton('assetUploadForm:saveButton', false);
			updateButton('assetUploadForm:topSaveButton', false);
			updateButton('assetUploadForm:topFinish_submit_update', false);
			updateButton('assetUploadForm:finish_submit_update', false);
			updateButton('form:attributesOK', false);
		} else {
			updateButton('assetUploadForm:saveButton', true);
			updateButton('assetUploadForm:topSaveButton', true);
			updateButton('assetUploadForm:topFinish_submit_update', true);
			updateButton('assetUploadForm:finish_submit_update', true);
			updateButton('form:attributesOK', true);
		}
	}
}

function cleanXSS(str) {
	var result = str;
	dojo.xhrGet({
		url: getAbsoluteUrl('internal/service/CleanXSSService.cleanXSS?s=' + str),
		sync: true,
		load: function(response) {
			result = response;
		}
	});
	return result;
}

function getText(domNode) {
	return domNode.innerText ? domNode.innerText : domNode.textContent;
}

function initCKEditor(inputID, options) {
	var editor = CKEDITOR.instances[inputID];
	if (editor)
		editor.destroy();
	editor = CKEDITOR.replace(inputID);
	editor.on('blur', function(eventInfo) {
		dojo.byId(inputID).value = editor.getData();
	});
	if (!options)
		options = {};
	CKEDITOR.on('instanceReady', function() {
		CKEDITOR.plugins.get('ramimage').options = options;
		CKEDITOR.plugins.get('ramlink').options = options;
	});
}
