require(["dojo/store/Memory", "dijit/form/FilteringSelect"]);
// Constants we need to un-consta-fy
var USER_URL = "secure/userDetail.faces?uid=";
var OSLC_USER_URL = "oslc/users/";
var USER_GROUP_URL = "admin/group/userGroupDetail.jsp?ugid=";
var COMMUNITY_USER_GROUP_URL = "community/userGroups.jsp?gid=";
var USER_SERVLET_URL = "internal/users";
var USER_GROUP_SERVLET_URL = "internal/service/UserGroupService.getUserGroups";
var USER_GROUP_REST_URL = "internal/userGroups";
var USER_REST_URL = "internal/users";
var POLICY_URL = "internal/policies";
var ASSET_TYPE_URL = "assettypes";
var CATEGORY_SCHEMA_URL = "categoryschema";
var ASSET_URL = "internal/assets";
var LIFECYLE_URL = "internal/lifecycles";
var MASTER_LIFECYLE_URL = "internal/masterLifecycles";
var COMMUNITIES_URL = "internal/communities";
var NEW_LIFECYCLE_URL = "internal/service/VisualLifecycleService.getJSONLifecycle";
var COMMUNITY_ADMIN_URL = "internal/service/PermissionService.isCommunityAdmin";
var ATTRIBUTES_URL = "internal/attributes";

var IGNORE_OWNERS_ATTRIBUTE_URI = "classif/assetTypesSchema.xmi#com.ram.owners";
var IGNORE_COMMUNITY_ATTRIBUTE_URI = "classif/assetTypesSchema.xmi#com.ram.community";
var IGNORE_TYPE_ATTRIBUTE_URI = "classif/assetTypesSchema.xmi#com.ram.type";
var IGNORE_GUID_ATTRIBUTE_URI = "classif/assetTypesSchema.xmi#com.ram.guid";

var ROLE_REVIEWER = 1;
var ROLE_REVIEW_BOARD = 2;
var ROLE_CAN_VIEW = 6;
var ROLE_CAN_MODIFY = 7;
var ROLE_CAN_DOWNLOAD = 9;


var COMPONENT_TYPE_LIFECYCLE = 0;
var COMPONENT_TYPE_STATE = 1;
var COMPONENT_TYPE_TRANSITION = 2;

var EVENT_TYPE_ASSET_SAVE = "ASSET_SAVE";
var EVENT_TYPE_ASSET_STATE_CHANGE = "STATE_ENTRANCE";
var EVENT_TYPE_ACTION = "ACTION";
var EVENT_TYPE_VOTE = "VOTE";
var EVENT_TYPE_TIMER = "TIMER";
var EVENT_TYPE_TIMER_ATTRIBUTE = "TIMER_ATTRIBUTE";
var EVENT_TYPE_DELETE = "DELETE";

var CONFIG_DETAIL_ID_TIMER_UNIT = "timerUnit";
var CONFIG_DETAIL_ID_TIMER_AMOUNT = "timerAmount";

var TIMER_UNIT_DAYS = "DAY";
var TIMER_UNIT_WEEKS = "WEEK";
var TIMER_UNIT_MONTHS = "MONTH";
var TIMER_UNIT_YEARS = "YEAR";
var TIMER_UNIT_DATE = "DATE";
var IMG_CATEGORY_SCHEMA = "/theme/images/icons/obj16/category_schema.gif";
var IMAGE_EXPAND = "/theme/images/icons/elcl16/expand-tree.gif";
var IMAGE_COLLAPSE = "/theme/images/icons/elcl16/collapse-tree.gif";

var IMG_RADIO_SELECTED_ALT = "selected radio";
var IMG_RADIO_UNSELECTED_ALT = "unselected radio";
var IMG_RADIO_CHILD_SELECTED_ALT = "A child of this radio is selected";
var IMG_CHECKBOX_SELECTED_ALT = "selected checkbox";
var IMG_CHECKBOX_UNSELECTED_ALT = "unselected checkbox";
var IMG_CHECKBOX_CHILD_SELECTED_ALT = "A child of this checkbox is selected";

// Should match VisualLifecycleAccessor.TRANSITION_IDENTIFIER_DELIM
var TRANSITION_IDENTIFIER_DELIM = "...transitionIdentifierDelim...";

var DUMMY_LIFECYCLE_IDENTIFIER = "..newlifecycle..";

var LC_UNIV_MESSAGE_ID = "lcUniversalMessage";
var LC_NAME_MESSAGE_ID = "lcNameMessage";

var cachedSchemas = null;

var bundle = dojo.i18n.getLocalization("ram", "lifecycleeditor");

var INHERITED_TEXT = "<span class=\"inherited\" style=\"margin-left: 5px \">("
	+ "<span class=\"inherited jazz-app-ua-TextHoverHelp\"  helpcontentstring=\"" + bundle.inherited_hover_help + "\" dojotype=\"jazz.app.ua.TextHoverHelp\">" 
	+ bundle.inherited + "</span>"
	+ ")</span>";

var INHERITED_TEXT_NO_UNDERLINE = "<span class=\"inherited\" style=\"margin-left: 5px \">("
	+ bundle.inherited
	+ ")</span>";

var clientLifecycle = null;
var newAttrStore = null;

var lc = null;
var	sc = null;
var	tc = null;

var assetTypes = null; // gets cached when getAssetTypes() is called

var useApplet = false;
var isMasterLifecycle = false;
var isAssetLifecycle = false;
var isCommunityLifecycle = false;
var isAppletLoaded = false;
var canEdit = true;

var saveCompleteClose = false; // A hack for Save and Finish

var DEBUG = false;

var lifecycleEditorInitialized = false;

function debug(obj) {
	if (DEBUG) {
		//console.log works in chrome and firebug console.debug only works in firebug
		console.log(obj);
	}
}
function showLoadingInfo(){
	require(["dojo/ready"], function(ready){
		  ready(function(){
			  dojo.style("waitingPanel", "display","block");
		  });
		});
}
function hideWaitingInfo(){
	require(["dojo/ready"], function(ready){
		  ready(function(){
			  dojo.style("waitingPanel", "display","none");
		  });
		});
}
function fetchAttributeData() {
	showLoadingInfo();
	dojo.xhrGet({
		url:  getAbsoluteUrl(ATTRIBUTES_URL),
		handleAs: "json",
		headers: {"Accept": "application/json"},
		sync: false,
		
		// The LOAD function will be called on a successful response.
		load: function(response, ioArgs) {
            var data = [];

            dojo.forEach(response, function(item, idx) {
           if(item.identifier != IGNORE_OWNERS_ATTRIBUTE_URI && item.identifier != IGNORE_COMMUNITY_ATTRIBUTE_URI && item.identifier != IGNORE_TYPE_ATTRIBUTE_URI && item.identifier != IGNORE_GUID_ATTRIBUTE_URI ) {
        	   
           	if(item.type == "NUMBER" || item.type == "DATE") {
         	   data.push({
                   id: item.identifier,
                   name: item.name,
                   type:item.type
               		});
        	}        	   
            	}
            });
            hideWaitingInfo();
            newAttrStore = new dojo.store.Memory({data: data});
           // newAttrStore= data;
		},
		
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			hideWaitingInfo();
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}
/*
 * All the applet call backs
 */
function appletInitialized() {
	isAppletLoaded = true;
	if (useApplet) {
		lc = null;
		sc = null;
		tc = null;
		
		initialize();
	
		//if(isAssetLifecycle) {
		//	selectCurrentWorkflowElement();
		//} 
	}
}

function selected(componentType, componentIdentifier, component) {
	if(!component) {
		componentType = COMPONENT_TYPE_LIFECYCLE;
	}
	if(isAssetLifecycle || !useApplet) {
		component = getComponentToLoad(componentType, componentIdentifier);
		if(componentType == COMPONENT_TYPE_LIFECYCLE) {
			componentIdentifier = clientLifecycle.identifier;
		}
	} else {
		if(!component) {
			component =  dojo.fromJson(getJSONLifecycle());
			componentIdentifier = component.identifier;
		} else {
			component =  dojo.fromJson(component);
		}
	}
	loadComponent(componentType*1, componentIdentifier, component);
}

function saveComplete(success, response) {
	dijit.byId('saveDialog').hide();
	if (success) {
		clientLifecycle = response;
	}else {
		alert(response);
	}
	if (isAssetLifecycle) {
		window.location.hash = '#loadEditor';
		window.location.reload();
	} else if (saveCompleteClose) {
		event_cancelEditorChanges();
	}
}

/*
 * End applet call backs
 */
 
function linksAreEqual(one, two){
	//TODO Strip off extensions
	
	 return one.href == two.href;
}
 
/*
 * Most wrappers around choosing between applet and client lifecycle object
 */
function saveStateConfiguration(stateConfig) {
	 enableWarnOnPageUnload(bundle.pageUnloadWarning);
	if (isAssetLifecycle || !useApplet) {
		for (var i in clientLifecycle.stateConfiguration) {
			if (linksAreEqual(clientLifecycle.stateConfiguration[i].state, stateConfig.state)) {
				clientLifecycle.stateConfiguration[i] = stateConfig;
				break;
			}
		}
	}
	
	if (!isAssetLifecycle && isAppletLoaded) {
		updateComponent(COMPONENT_TYPE_STATE, dojo.toJson(stateConfig));
	}
}
 
function saveLifecycleEntryConditions(rule) {
	enableWarnOnPageUnload(bundle.pageUnloadWarning);
	if (useApplet) {
		setRule(dojo.toJson(lc.selectionCondition));
	} else {
		clientLifecycle.selectionCondition = rule;
	}
}

function saveTransitionConfiguration(transConfig) {
	enableWarnOnPageUnload(bundle.pageUnloadWarning);
	if (isAssetLifecycle || !useApplet) {
		for (var i in clientLifecycle.stateConfiguration) {
			var stateConfig = clientLifecycle.stateConfiguration[i];
			if(linksAreEqual(stateConfig.state, transConfig.state)) {
				for (var ai in stateConfig.exitCondition) {
					var exitCond = stateConfig.exitCondition[ai];
					if (linksAreEqual(exitCond.action, transConfig.action)) {
						clientLifecycle.stateConfiguration[i].exitCondition[ai] = transConfig;
						break;
					}
				}
				break;
			}
		}
	} else {
		updateComponent(COMPONENT_TYPE_TRANSITION, dojo.toJson(transConfig));
	}
}

function event_selectWorkflowElement() {
	var select = dojo.byId("workflowElements");
	if(dojo.byId("lifecycleCommentSpan")) dojo.style("lifecycleCommentSpan", "display", "none");
	if (isAssetLifecycle || !useApplet) {
		var componentType = select.value.charAt(0)*1;
		var componentIdentifier = select.value.substring(2);
		var componentToLoad = getComponentToLoad(componentType, componentIdentifier);
		
		loadComponent(componentType, componentIdentifier, componentToLoad);
	} else {
		var componentType = select.value.charAt(0)*1;
		var componentIdentifier = select.value.substring(2);
		switch(componentType) {
			case COMPONENT_TYPE_LIFECYCLE:
				loadComponent(COMPONENT_TYPE_LIFECYCLE, componentIdentifier, dojo.fromJson(getJSONLifecycle()));
				break;
		}
	}
	if(isAppletLoaded) {
		switch(componentType) {
			case COMPONENT_TYPE_STATE:
				selectComponent(componentIdentifier);
				break;
			case COMPONENT_TYPE_TRANSITION:
				// TODO navigate up select's options to the first state we find
				selectComponent(componentIdentifier);
				break;
		}
	}
}

function selectCurrentWorkflowElement() {
	var select = dojo.byId("workflowElements");
	var componentType = select.value.charAt(0)*1;
	var componentIdentifier = select.value.substring(2);
	switch(componentType) {
		case COMPONENT_TYPE_STATE:
			selectComponent(componentIdentifier);
			break;
		case COMPONENT_TYPE_TRANSITION:
			// TODO navigate up select's options to the first state we find
			selectComponent(componentIdentifier);
			break;
	}
}

function getComponentToLoad(componentType, componentIdentifier) {
	// First check to see if they selected the lifecycle
	if (COMPONENT_TYPE_LIFECYCLE==componentType) {
		componentToLoad = clientLifecycle;
	} else if (COMPONENT_TYPE_STATE==componentType) {
		for (var i in clientLifecycle.stateConfiguration) {
			var stateConfig = clientLifecycle.stateConfiguration[i];
			if (editor_getState(stateConfig.state).identifier==componentIdentifier) {
				componentToLoad = stateConfig;
				break;
			}
		}
	} else if (COMPONENT_TYPE_TRANSITION==componentType) {
		var delim = componentIdentifier.indexOf(TRANSITION_IDENTIFIER_DELIM);
		var startStateId = null;
		if(delim != -1) {
			startStateId = componentIdentifier.substring(0, delim);
			componentIdentifier = componentIdentifier.substring(delim+TRANSITION_IDENTIFIER_DELIM.length);
		} else {
			for (var j=select.selectedIndex; j>0; j--) {
				// Start at the selected item and work backwards looking for a state
				var optionType = select.options[j].value.charAt(0)*1;
				if (optionType == COMPONENT_TYPE_STATE) {
					// Get the ID of this state
					startStateId = select.options[j].value.substring(2);
					break;
				}
			}
		}
		// Now find action within given start state
		for (var i in clientLifecycle.stateConfiguration) {
			var stateConfig = clientLifecycle.stateConfiguration[i];
			if (editor_getState(stateConfig.state).identifier==startStateId) {
				for (var ai in stateConfig.exitCondition) {
					var exitCond = stateConfig.exitCondition[ai];
					if (getAction(exitCond.action).identifier==componentIdentifier) {
						componentToLoad = exitCond;
						break;
					}
				}
				break;
			}
		}
	}
	return componentToLoad;
}

function lifecycleNameFieldChanged(field) {
	if (isAssetLifecycle) {
		return; // not supported from asset lifecycle editor
	} else if (!useApplet) {
		clientLifecycle.name = field.value;
	} else {
		setLifecycleName(field.value);
	}
	
	if (field.value.length>0 && dijit.byId(LC_UNIV_MESSAGE_ID)) {
		dijit.byId(LC_UNIV_MESSAGE_ID).destroyRecursive();
	}
}

function lifecycleDescriptionFieldChanged(field) {
	if (isAssetLifecycle) {
		return; // not supported from asset lifecycle editor
	} else if (useApplet) {
		setLifecycleDescription(field.value);
	} else {
		clientLifecycle.description = field.value;
	}
}

function lifecycleCommentFieldChanged(field) {
	//if (isAssetLifecycle) {
		//return; // not supported from asset lifecycle editor
	//} else {
		clientLifecycle.restrictCommentRequired.value= field.checked;
	//}
}
/**
 * @sice 7.5.1 
 * @return The current lifeyclce instruction
 */
function getCurrentInstruction(stateConfig){
	var ret = null;
	
	//Default the array if undefined
	if(!stateConfig.instruction || stateConfig.instruction == null){
		stateConfig.instruction = new Array();
	}
	
	for(var i in stateConfig.instruction) {
		var val = stateConfig.instruction[i];
		if(!val.inherited){
			ret = val;
		}
	}
	
	if(ret == null){
		ret = new Instruction();
		stateConfig.instruction[stateConfig.instruction.length] = ret;
	}
	
	return ret;
}

/**
 * @sice 7.5.1 
 * @return All Inherited instructions as a string
 */
function getInheritedInstructions(stateConfig){
	var ret = new StringBuffer();
	
	//Default the array if undefined
	if(!stateConfig.instruction || stateConfig.instruction == null){
		stateConfig.instruction = new Array();
	}
	
	for(var i in stateConfig.instruction) {
		var val = stateConfig.instruction[i];
		if(val.inherited){
			ret.append(val.body);
			ret.append("<br/>");
		}
	}
	
	return ret.toString();
}

/**
 * @since 7.5.1
 * @param field the input to enter a new instruction
 * @param stateConfig current state configuration object
 * @return
 */
function lifecycleInstructionFieldChanged(field, stateConfig) {
	if (isAssetLifecycle) {
		return; // not supported from asset lifecycle editor
	}
	else{
		var instruction = getCurrentInstruction(stateConfig);
		instruction.body = field.value;
	}
}

function editor_getReviewBoardMembers() {
	if (isAssetLifecycle || !useApplet) {
		return clientLifecycle.reviewBoardMember;
	} else {
		return dojo.fromJson(getReviewBoardMembers());
	}
}

function editor_setReviewBoardMembers(members) {
	if (isAssetLifecycle || !useApplet) {
		clientLifecycle.reviewBoardMember = members;
	} else {
		setReviewBoardMembers(dojo.toJson(members));
	}
}

function event_toggleOwnersAsReviewBoard(restrict) {
	if (isAssetLifecycle || !useApplet) {
		if(clientLifecycle.restrictOwnerAsManagers == null){
			clientLifecycle.restrictOwnerAsManagers = new BooleanProperty();
		}
		clientLifecycle.restrictOwnerAsManagers.value = restrict;
	} else {
		setRestrictOwnersFromReviewBoard(restrict);
	}
}

function event_toggleManagersHandlePerms(check) {
	clientLifecycle.managersHandlePerms.value = check;
}

function isValidLifecycle() {
	var lifecycle;
	
	var validateName = true;
	if (isAssetLifecycle) {
		validateName = false;
	} else if (!useApplet) {
		lifecycle = clientLifecycle;
	} else {
		try {
			// java 1.5 issue
			lifecycle = dojo.fromJson(getJSONLifecycle());
		} catch(e) {
			validateName = false; // ? Not sure what to do here.
		}
	}
	
	if (validateName && (lifecycle.name==null || lifecycle.name.length==0)) {
		var message = dijit.byId(LC_UNIV_MESSAGE_ID);
		if (!message) {
			var message = new ram.RamMessage({id:LC_UNIV_MESSAGE_ID, message: bundle.messageLifecycleNameRequired, styleClass: "errorBlock", style: "margin-top: 5px;"});
			dojo.place(message.domNode, 'mainForm:instructLifecycleConfig', "after");
		}
		
		return false;
	}
	
	return true;
}

function getGID(){
	var hiddenInput = dojo.byId('mainForm:communityId');
	var ret = null;
	if (hiddenInput) {
		ret = hiddenInput.value;
	}
	return ret;
}

function getLifecycleId(){
	var hiddenInput = dojo.byId('mainForm:lifecycleId');
	var ret = null;
	if (hiddenInput) {
		ret = hiddenInput.value;
	}
	return ret;
}

function event_saveLifecycle(closeEditor) {
	disableWarnOnPageUnload();
	var dlgHtml = "<div><img style=\"position: relative; top: 3px;\" src=\"" + getImageUrl("/theme/images/icon_animated_busy.gif") + "\" alt=\"\"/>";
	dlgHtml += "<span style=\"margin-left: 5px;\">"+bundle.savingLifecycleMessage+"</span>";
	dlgHtml += "</div>";
	createDialog("saveDialog", bundle.savingLifecycleTitle, dlgHtml, true, "saveDialog");
	
	if (!isValidLifecycle()) {
		dijit.byId('saveDialog').hide();
		
		return;
	}
	
	if (isAssetLifecycle) {
		var guid = unescape(getUrlParameter("guid"));
		var version = getUrlParameter("v");
		debug(clientLifecycle);
		
		var xhrArgs = {
			url: getAbsoluteUrl(LIFECYLE_URL+"/"+guid+"/"+version),
			putData: dojo.toJson(clientLifecycle),
			headers: {"Content-Type": "application/json", "Accept": "application/json"},
			handleAs: "json",
			load: function(response){
				saveComplete(true, response);
			},
			error: function(error){
				saveComplete(false, error);
			}
		};
		
		var deferred = dojo.xhrPut(xhrArgs);
	} else if (useApplet) {
		debug(dojo.fromJson(getJSONLifecycle()));
		saveCompleteClose = closeEditor;
		saveLifecycleToServer();
	} else {
		saveCompleteClose = closeEditor;
		
		var gid = getGID(); //unescape(getUrlParameter("gid"));
		var rpid = getLifecycleId(); //getUrlParameter("rpid");
		
		debug(clientLifecycle);
		
		var urlVal = "";
		//Create new community or master lifecycle
		if (clientLifecycle.identifier == DUMMY_LIFECYCLE_IDENTIFIER) {
			//The URL is different if it is the master lifecycle verses a community lifeyclce
			if(isMasterLifecycle){
				urlVal = getAbsoluteUrl(MASTER_LIFECYLE_URL);
			}
			else{
				urlVal = getAbsoluteUrl(COMMUNITIES_URL+"/"+gid+"/lifecycles");
			}
			
			var xhrArgs = {
				url : urlVal,
				handleAs: "json",
				postData: dojo.toJson(clientLifecycle),
				headers: {"Content-Type": "application/json", "Accept": "application/json"},
				sync: true,
				load: function(response, ioArgs) {
					saveComplete(true, response);
				},
				// The ERROR function will be called in an error case.
				error: function(response, ioArgs) {
					var txt = response.responseText;
					if(txt != null && txt != ""){
						var error = eval('(' + txt + ')'); 
						if(error.message != null){
							var message = new ram.RamMessage({id:LC_UNIV_MESSAGE_ID, message: error.message, styleClass: "errorBlock", style: "margin-top: 5px;"});
							dojo.place(message.domNode, 'mainForm:instructLifecycleConfig', "after");
						}
						dijit.byId('saveDialog').hide();
					}
					else{
						saveComplete(false, response);
					}
				}
			};
			var deferred = dojo.xhrPost(xhrArgs);
		} 
		//Update existing community or master lifecycle
		else {
			if (!rpid || rpid==null || rpid=="" || rpid.indexOf("/") != -1 || rpid.indexOf("\\") != -1) {
				rpid = clientLifecycle.identifier;
			}
			//The URL is different if it is the master lifecycle verses a community lifeyclce
			if(isMasterLifecycle){
				urlVal = getAbsoluteUrl(MASTER_LIFECYLE_URL+"/"+rpid);
			}
			else{
				urlVal = getAbsoluteUrl(COMMUNITIES_URL+"/"+gid+"/lifecycles/"+rpid);
			}
			var xhrArgs = {
				url : urlVal,
				putData: dojo.toJson(clientLifecycle),
				headers: {"Content-Type": "application/json", "Accept": "application/json"},
				handleAs: "json",
				load: function(response){
					saveComplete(true, response);
				},
				// The ERROR function will be called in an error case.
				error: function(response, ioArgs) {
					var txt = response.responseText;
					if(txt != null && txt != ""){
						var error = eval('(' + txt + ')'); 
						if(error.message != null){
							var message = new ram.RamMessage({id:LC_UNIV_MESSAGE_ID, message: error.message, styleClass: "errorBlock", style: "margin-top: 5px;"});
							dojo.place(message.domNode, 'mainForm:instructLifecycleConfig', "after");
						}
						dijit.byId('saveDialog').hide();
					}
					else{
						saveComplete(false, response);
					}
				}
			};
			
			var deferred = dojo.xhrPut(xhrArgs);
		}
	}
}

function event_cancelEditorChanges() {
	disableWarnOnPageUnload();
	if (isAssetLifecycle) {
		clientLifecycle = null;
		lc = null;
		tc = null;
		sc = null;
		hide(dojo.byId("lifecycle_editor"));
	} 
	else if(isMasterLifecycle){
		window.location.href = getAbsoluteUrl("admin/repository/lifecycles.jsp");
	}
	else {
		window.location.href = getAbsoluteUrl("admin/group/review.jsp?gid="+getCommunityId());
	}
}

function editor_getStartingStateConfiguration(stateId) {
	if (isAssetLifecycle || !useApplet) {
		for (var i in clientLifecycle.stateConfiguration) {
			var stateConfig = clientLifecycle.stateConfiguration[i];
			
			if (editor_getState(stateConfig.state).identifier==stateId) {
				return stateConfig;
			}
		}
	} else {
		return dojo.fromJson(getStartingStateConfiguration(stateId));
	}
}

/*
 * End wrappers
 */
 
 
function isLifecycleEditorInitialized() {
	 return lifecycleEditorInitialized;
}
 
function initialize() {
	var continueInit = true;
	if (getUrlParameter("guid") && getUrlParameter("guid").length>0){
		isAssetLifecycle = true;
		//canEdit = false;
		
		clientLifecycle = getAssetLifecycle();
		lc = clientLifecycle;
	} else {
		if (useApplet) {
			try {
				// java 1.5 issue
				lc = dojo.fromJson(getJSONLifecycle());
			} catch(e) {
				lifecycleEditorInitialized = false;
				continueInit = false;
			}
		} else {
			if(isMasterLifecycle){
				var rpid = getLifecycleId(); //getUrlParameter("rpid");
				var dupid = getUrlParameter("dupid");
				
				clientLifecycle = getMasterLifecycle(rpid, dupid);
				lc = clientLifecycle;
			}
			else{
				var gid = getGID(); //unescape(getUrlParameter("gid"));
				var rpid = getLifecycleId(); //getUrlParameter("rpid");
				var dupid = getUrlParameter("dupid");
				
				clientLifecycle = getCommunityLifecycle(gid, rpid, dupid);
				lc = clientLifecycle;
			}
		}
	}
	
	if(continueInit) {
		lifecycleEditorInitialized = true;
		debug(lc);
		
		var select = dojo.byId('workflowElements');
		
		var currentState = null;
		if (isAssetLifecycle) {
			/*var userId = dojo.byId("mainForm:userId").value;
			// TODO this is not a good way of doing this because it doesn't work if the user is 
			// in a user group that is on the review board or admin
			var auths = clientLifecycle.reviewBoardMember;
			for (var i in auths) {
				if (auths[i].user !== null && userId==getUserIdentifier(auths[i].user)) {
					canEdit = true;
				}
			}
			
			if (!canEdit) {
				// Wasn't an explicit review board member user, check if owner
				// For now, assuming this setting is turned on.
				var owners = getAsset().owner;
				for (var i in owners) {
					if (userId == getUserIdentifier(owners[i])) {
						canEdit = true;
					}
				}
			}
			
			debug(canEdit?"This user can edit the lifecycle":"This user cannot edit the lifecycle");*/
			
			// TODO get it from the asset API
			currentState = dojo.byId("mainForm:currentState").value;
		}
		
		loadEditorNavigation(lc);
		loadMasterLifecycleLink(lc);
		if (isAssetLifecycle && currentState!== null) {
			// Parse lifecycle to find the current state
			for (var i in clientLifecycle.stateConfiguration) {
				if (editor_getState(clientLifecycle.stateConfiguration[i].state).identifier==currentState) {
					sc = clientLifecycle.stateConfiguration[i];
					break;
				}
			}
			
			loadComponent(COMPONENT_TYPE_STATE, currentState, sc);
		} else {
			loadLifecycleInEditor(lc);
		}
	}
}

/**
 * Load the trasition definition from one state to an ajoining action
 * @param stateId state the action is from
 * @param actionId workflow action
 * @since 7.5.1
 */
function loadTransitionById(stateId, actionId){
	var compId = stateId+TRANSITION_IDENTIFIER_DELIM+actionId;
	var tc = getExitCondition(stateId, actionId);
	
	loadComponent(COMPONENT_TYPE_TRANSITION, compId, tc);
	
	if(isAppletLoaded) {
		selectComponent(compId);
	}
	
}

function loadStateComponent(stateId) {
	var sc = getStateConfigurationById(stateId);
	if(sc != null) {
		loadComponent(COMPONENT_TYPE_STATE, stateId, sc);
		if(isAppletLoaded) {
			selectComponent(stateId);
		}
	}
}

function loadComponent(componentType, componentIdentifier, component) {
	lc = null;
	sc = null;
	tc = null;
	
	var select = dojo.byId("workflowElements");
	
	dojo.byId("workflowElementDescription").innerHTML = "";
	dojo.byId("aligned-configs").innerHTML = "";
	
	hide(dojo.byId('lifecycle'));
	hide(dojo.byId('transition'));
	hide(dojo.byId('state'));
	hide(dojo.byId('private_state_config'));
	show(dojo.byId('loading_editor'));
	
	select.value = componentType+"_"+componentIdentifier;
	debug(component);
	switch(componentType) {
		case COMPONENT_TYPE_STATE:
			sc = component;
			loadState(sc);
			break;
		case COMPONENT_TYPE_TRANSITION:
			tc = component;	
			loadTransition(tc);
			break;
		case COMPONENT_TYPE_LIFECYCLE:
			lc = component;
			loadLifecycleInEditor(lc);
			break;
	}
}

function loadEditorNavigation(lc) {
	var select = dojo.byId("workflowElements");
	
	var oi = 0;
	select.options[oi] = new Option(bundle.menuItemGeneralSettings, COMPONENT_TYPE_LIFECYCLE+"_"+lc.identifier);
	oi++;
	
	var states = lc.stateConfiguration;
	states.sort(function(a, b) {
		// sort states alphabetically by name
		a_name = editor_getState(a.state).name.toLowerCase();
		b_name = editor_getState(b.state).name.toLowerCase();
		return a_name.localeCompare(b_name);
	});
	for (var si in states) {
		var state = editor_getState(states[si].state);
		
		select.options[oi] = new Option(state.name, COMPONENT_TYPE_STATE+"_"+state.identifier);
		oi++;
		
		var exitConditions = states[si].exitCondition;
		exitConditions.sort(function(a, b) {
			// sort exit conditions alphabetically by action name
			a_name = getAction(a.action).name.toLowerCase();
			b_name = getAction(b.action).name.toLowerCase();
			return a_name.localeCompare(b_name);
		});
		for (var ai in exitConditions) {
			// label is " -  actionName -> Target State"
			var action = getAction(exitConditions[ai].action);
			var label = String.fromCharCode(160) + "- " + action.name + " -> "+ action.targetState.title.content[0];
			select.options[oi] = new Option(label, COMPONENT_TYPE_TRANSITION+"_"+state.identifier+TRANSITION_IDENTIFIER_DELIM+action.identifier);
			oi++;
		}
	}
}

function setInfopop(/*String*/ infopopId, /*String*/ helpId) {
	var widget = dijit.byId(infopopId + '_POPUP');
	if (widget)
		widget.destroy();
	createPopup(infopopId, helpId, null, true);
}

function loadLifecycleInEditor(lc) {	
	setInfopop('mainForm:configurationHelp', 'aclc0110');
	
	hide(dojo.byId('loading_editor'));
	show(dojo.byId('lifecycle'));
	
	if (isAssetLifecycle) {
		if (lc.description) {
			dojo.byId("workflowElementDescription").innerHTML = lc.description;
		}
	} else if (isCommunityLifecycle) {
		dojo.byId('lifecycleName').innerHTML = lc.name;
		if(lc.description) {
			dojo.byId('lifecycleDescription').innerHTML = lc.description;
		}
	} else {
		if (lc.name)
			dojo.byId('lifecycleName').value = lc.name;
		if (lc.description)
			dojo.byId('lifecycleDescription').value = lc.description;
	}
	if(lc.restrictCommentRequired){
		if(lc.restrictCommentRequired.value){ 
			if(dojo.byId("lifecycleComment")) dojo.attr("lifecycleComment", "checked", lc.restrictCommentRequired.value);
		}
	}
	if(dojo.byId("lifecycleCommentSpan")) dojo.style("lifecycleCommentSpan", "display", "inline");
	if (lc.restrictCommentRequired != null  && lc.restrictCommentRequired.inherited) {
		if(dojo.byId("lifecycleComment")) dojo.attr("lifecycleComment", "disabled", true);
		if(dojo.byId("comment_checkbox_inherited_text"))dojo.style("comment_checkbox_inherited_text", "display", "inline");
	} else {
		if(dojo.byId("lifecycleComment")) dojo.attr("lifecycleComment", "disabled", false);
		if(dojo.byId("comment_checkbox_inherited_text"))dojo.style("comment_checkbox_inherited_text", "display", "none");
	}
	//if inherited style the label
	if(lc.restrictCommentRequired != null && lc.restrictCommentRequired.inherited){
		if(dojo.byId("lifecycleCommentLabel")) dojo.attr("lifecycleCommentLabel", "class", "checkboxText  inherited");
	}
	else {
		if(dojo.byId("lifecycleCommentLabel")) dojo.attr("lifecycleCommentLabel", "class", "checkboxText");
	}

	//Do not allow the users to set conditions on implict lifeycles
	if(!isImplict(lc)){
		updateLifecyleConditions(lc.selectionCondition);
	}
	
	updateReviewBoardTable(lc.reviewBoardMember);
	
	updateCommunityScopingSection();
	
	resizeEditor();
}

/**
 * @since 7.5.1
 * @param lc Lifecycle config
 * @return true if the lifecycle is an implict lifecycle
 */
function isImplict(lc){
	var IMPLICIT_ID = "com.ibm.ram.internal.lifecycle.implicit";
	//If this is a repository lifecycle it will end with the <implict id>
	if(lc.scope && "REPOSITORY" == lc.scope){
		return lc.identifier.endsWith(IMPLICIT_ID);
	}
	//If it is the community it we begin with cc_<implict id>
	else if(lc.scope && "COMMUNITY" == lc.scope){
		return lc.identifier.startsWith("cc_"+IMPLICIT_ID);
	}
}

function loadState(sc) {
	setInfopop('mainForm:configurationHelp', 'aclc0200');

	hide(dojo.byId('loading_editor'));
	show(dojo.byId('state'));
	showInline(dojo.byId('private_state_config'));
	
	updateStateDetails(sc);
	writeAdvancedStateSection(sc);
	updateReviewersTable(sc.reviewer);
	updateReviewConfiguration(sc.reviewConfiguration);
	updatePolicyConfigurations(sc.policyConfiguration);
	resizeEditor();
}

/**
 * Creates a link to the master lifecycle if one exists
 * @param lc client lifeycle
 * @return
 */
function loadMasterLifecycleLink(lc){
	var masterLifecycleDiv = dojo.byId('masterLifecycle');
	if(masterLifecycleDiv && masterLifecycleDiv != null){
		/**
		 * Set the link to the master lifecycle if available
		 */
		if(lc.master != null && lc.master.resource != null && lc.master.value != null){
			var anchor = document.createElement("a");
			
			//Add an id attribute 
			var id = document.createAttribute("id");
			id.nodeValue = "masterLifecycleLink";
			anchor.setAttributeNode(id);
			
			//Set the href
			var href = document.createAttribute("href");
			href.nodeValue = getAbsoluteUrl(lc.master.resource);
			anchor.setAttributeNode(href);
			
			//Add the inner text
			anchor.appendChild(document.createTextNode(lc.master.value));
			
			//Clear the current div
			masterLifecycleDiv.innerHTML = "";
			
			//add the link
			masterLifecycleDiv.appendChild(anchor);
		}
		
		/**
		 * Link is not available by the name is
		 */
		else if(lc.master != null && lc.master.value != null){
			//Clear the current div
			masterLifecycleDiv.innerHTML = "";
			
			//add the label
			masterLifecycleDiv.appendChild(document.createTextNode(lc.master.value));
		}
		
		/**
		 * render None - Eventually we should not hit this case
		 */
		else if(lc.master != null && lc.master.value != null){
			//Clear the current div
			masterLifecycleDiv.innerHTML = "";
			
			//add the label
			masterLifecycleDiv.appendChild(document.createTextNode('None'));
		}
	}
}

function loadTransition(tc) {
	setInfopop('mainForm:configurationHelp', 'aclc0300');

	hide(dojo.byId('loading_editor'));
	show(dojo.byId('transition'));
	
	/* TODO No Rest API for this yet
	var action = tc.action.value_Action;
	if (!action) {
		action = getValueFromHref(tc.action.href);
	}
	
	dojo.byId("workflowElementDescription").innerHTML = action.description;
	*/
	updateTransitionConditions(tc);
}

function updateLifecyleConditions(rule) {
	var configs = dojo.byId("add_lifecycle_configs");
	var elem = dojo.byId("lifecycle_conditions");
	
	if (dijit.byId("lifecycleRules")) {
		dijit.byId("lifecycleRules").destroy();
	}

	if (!rule || rule=== null) {
		elem.style.display = "none";
		
		if (!isAssetLifecycle && !isCommunityLifecycle && !dojo.byId("addLifecycleConditionsButton")) {
			var button = document.createElement("input");
			
			var id = document.createAttribute("id");
			id.nodeValue = "addLifecycleConditionsButton";
			button.setAttributeNode(id);
			
			var type = document.createAttribute("type");
			type.nodeValue = "button";
			button.setAttributeNode(type);
	
			var value = document.createAttribute("value");
			value.nodeValue = bundle.buttonAddCondition;
			button.setAttributeNode(value);
	
			button.onclick = function(){initConditionTable(this, dojo.byId('lifecycle_conditions'), 'lifecycleRules');};
			
			var classAttr = document.createAttribute("class");
			classAttr.nodeValue = "commandExButton";
			button.setAttributeNode(classAttr);
			
			configs.appendChild(button);
		}
	} else {
		elem.style.display = "block";
		
		if (dojo.byId("addLifecycleConditionsButton")) {
			var button = dojo.byId("addLifecycleConditionsButton");
			if(button && button != null)
				configs.removeChild(button);
		}
		var ruleTable = new ram.ConditionBuilder({id: "lifecycleRules"});
		ruleTable.setRule(rule);
		elem.appendChild(ruleTable.domNode);
		ruleTable.initialize();
	}
}

function createWarningMessage(id, message) {
	var warningSpan = document.createElement("span");
	
	var warningSpanId = document.createAttribute("id");
	warningSpanId.nodeValue = id;
	warningSpan.setAttributeNode(warningSpanId);
	
	var warningDiv = document.createElement("div");
	
	var warningDivClass = document.createAttribute("class");
	warningDivClass.nodeValue = "warning";
	warningDiv.setAttributeNode(warningDivClass);
	warningSpan.appendChild(warningDiv);
	
	var warningBodyDiv = document.createElement("div");
	
	var warningBodyDivClass = document.createAttribute("class");
	warningBodyDivClass.nodeValue = "body";
	warningBodyDiv.setAttributeNode(warningBodyDivClass);
	warningDiv.appendChild(warningBodyDiv);
	
	var warningMessageDiv = document.createElement("div");
	warningMessageDiv.innerHTML = message;
	
	var warningMessageDivClass = document.createAttribute("class");
	warningMessageDivClass.nodeValue = "message";
	warningMessageDiv.setAttributeNode(warningMessageDivClass);
	warningBodyDiv.appendChild(warningMessageDiv);
	return warningSpan;
}

function getStateLink(sc) {
	var stateLink = new StringBuffer();
	stateLink.append("<a href=\"#\" onclick=\"loadStateComponent('");
	stateLink.append(getLastURLSegment(sc.state.href));
	stateLink.append("');\">");
	stateLink.append(sc.state.title.content[0]);
	//stateLink.append(dojo.string.substitute(bundle.inlineHelpTransitionWithoutApprovalRules, {stateName: sc.state.title.content[0]}));
	stateLink.append("</a>");
	return stateLink.toString();
}

function getPolicyIdsInExitCondition(rule, policyIdArray) {
	if(policyIdArray == null) {
		policyIdArray = new Array();
	}
	if(rule != null) {
		if(rule.childRule != null && rule.childRule.length > 0) {
			for(var i in rule.childRule) {
				policyIdArray = getPolicyIdsInExitCondition(rule.childRule[i], policyIdArray);
			}
		} else {
			if("POLICY_RESULT" == rule.type) {
				policyIdArray.push(rule.target);
			}
		}
	}
	return policyIdArray;
}

function updateTransitionConditions(tc) {
	var rule = tc.rule;
	var configs = dojo.byId("add_transition_configs");
	var elem = document.getElementById("transition_conditions");
	
	if (dijit.byId("transitionRules")) {
		dijit.byId("transitionRules").destroy();
	}
	
	var ruleStateIdentifier = getLastURLSegment(tc.state.href);
	var ruleStateConfig;
	for (var i in clientLifecycle.stateConfiguration) {
		var stateConfig = clientLifecycle.stateConfiguration[i];
		
		if (editor_getState(stateConfig.state).identifier==ruleStateIdentifier) {
			ruleStateConfig = stateConfig;
			break;
		}
	}
	
	// check if we need to add warning
	
	// check the exit condition for approval rules
	var exitConditionsRequiringApproval = false;
	if(tc.rule != null && isReviewRuleDefined(tc.rule)) {
		exitConditionsRequiringApproval = true;
	}
	
	// check the approvers
	var approvers = false;
	var showMissingReviewConditions = false;
	for (var x in ruleStateConfig.reviewer) {
		if(ruleStateConfig.reviewer[x].canVote) {
			approvers = true;
			break;
		}
	}
	
	// check for policy IDs defined in the state, but not used in this exit condition
	var policyWarningSpan = dojo.byId("policyWarningSpan");
	if(policyWarningSpan && policyWarningSpan != null) {
		configs.removeChild(policyWarningSpan);
	}

	if(ruleStateConfig.policyConfiguration.length > 0) {
		
		var policyWarningSpanElement = document.createElement("span");
		var policyWarningSpanElementId = document.createAttribute("id");
		policyWarningSpanElementId.nodeValue = "policyWarningSpan";
		policyWarningSpanElement.setAttributeNode(policyWarningSpanElementId);
		
		var missingPolocyMessagesAdded = false;
		var policyIdsMissingFromExitCondition = getPolicyIdsInExitCondition(tc.rule);
		var policyIdsInExitCondition = new Array();
		for(var j = 0; j < ruleStateConfig.policyConfiguration.length; j++) {
			var policyConfiguration = ruleStateConfig.policyConfiguration[j];
			var policyExistsInRule = false;
			for(var i = 0; i<policyIdsMissingFromExitCondition.length; i++) {
				var id = policyIdsMissingFromExitCondition[i];
				if(policyConfiguration.identifier == id) {
					policyIdsMissingFromExitCondition.slice(i, 1);
					policyExistsInRule = true;
					break;
				}
			}
			
			if(policyExistsInRule) {
				var warningMsg = dojo.byId("missingPolicyCondition" + policyConfiguration.identifier);
				if(warningMsg && warningMsg != null) {
					//configs.removeChild(warningMsg);
				}
			} else {
				if(!dojo.byId('missingPolicyCondition' + policyConfiguration.identifier)) {
					missingPolocyMessagesAdded = true;
					policyWarningSpanElement.appendChild(createWarningMessage('missingPolicyCondition' + policyConfiguration.identifier, 
							dojo.string.substitute(bundle.inlineHelpTransitionWithoutPolicyRules, {policyName: policyConfiguration.policy.title.content[0], stateLink: getStateLink(ruleStateConfig)})));
					var button = dojo.byId("addTransitionConditionsButton");
					if(button && button != null) {
						configs.removeChild(button);
					}
				}
			}
			
		}
		
		if(missingPolocyMessagesAdded) {
			configs.appendChild(policyWarningSpanElement);
		}
	}
	
	
	if(approvers && !exitConditionsRequiringApproval) {
		if(!dojo.byId('noApprovalExitConditionsWarningSpan')) {
			configs.appendChild(createWarningMessage('noApprovalExitConditionsWarningSpan', dojo.string.substitute(bundle.inlineHelpTransitionWithoutApprovalRules, {stateLink: getStateLink(ruleStateConfig)})));
			var button = dojo.byId("addTransitionConditionsButton");
			if(button && button != null) {
				configs.removeChild(button);
			}
		}
	} else {
		var warningMsg = dojo.byId("noApprovalExitConditionsWarningSpan");
		if(warningMsg && warningMsg != null) {
			configs.removeChild(warningMsg);
		}
	}
	
	if(exitConditionsRequiringApproval && !approvers) {
		if(!dojo.byId('noApproversWarningSpan')) {
			configs.appendChild(createWarningMessage('noApproversWarningSpan', dojo.string.substitute(bundle.inlineHelpTransitionWithApprovalRules, {stateLink: getStateLink(ruleStateConfig)})));
			var button = dojo.byId("addTransitionConditionsButton");
			if(button && button != null) {
				configs.removeChild(button);
			}
		}
	} else {
		var warningMsg = dojo.byId("noApproversWarningSpan");
		if(warningMsg && warningMsg != null) {
			configs.removeChild(warningMsg);
		}
	}
	
	if (!rule || rule=== null) {
		if (!dojo.byId("noTransitionConditionsWarning")) {
			var infoSpan = document.createElement("span");
			
			var infoSpanId = document.createAttribute("id");
			infoSpanId.nodeValue = "noTransitionConditionsWarning";
			infoSpan.setAttributeNode(infoSpanId);
			
			var infoDiv = document.createElement("div");
			
			var infoDivClass = document.createAttribute("class");
			infoDivClass.nodeValue = "info";
			infoDiv.setAttributeNode(infoDivClass);
			infoSpan.appendChild(infoDiv);
			
			var infoBodyDiv = document.createElement("div");
			
			var infoBodyDivClass = document.createAttribute("class");
			infoBodyDivClass.nodeValue = "body";
			infoBodyDiv.setAttributeNode(infoBodyDivClass);
			infoDiv.appendChild(infoBodyDiv);
			
			var infoMessageDiv = document.createElement("div");
			if(clientLifecycle.scope == null || "REPOSITORY" != clientLifecycle.scope){
				infoMessageDiv.innerHTML = bundle.inlineHelpNoTransitionConditions;
			}
			else{
				infoMessageDiv.innerHTML = bundle.inlineHelpNoRepositoryTransConds;
			}
			
			var infoMessageDivClass = document.createAttribute("class");
			infoMessageDivClass.nodeValue = "message";
			infoMessageDiv.setAttributeNode(infoMessageDivClass);
			infoBodyDiv.appendChild(infoMessageDiv);
			
			configs.appendChild(infoSpan);
		}
		
		if (!dojo.byId("addTransitionConditionsButton")) {
			var button = document.createElement("input");
			
			var id = document.createAttribute("id");
			id.nodeValue = "addTransitionConditionsButton";
			button.setAttributeNode(id);
			
			var type = document.createAttribute("type");
			type.nodeValue = "button";
			button.setAttributeNode(type);
	
			var value = document.createAttribute("value");
			value.nodeValue = bundle.buttonAddCondition;
			button.setAttributeNode(value);
	
			button.onclick = function(){initConditionTable(this, dojo.byId('transition_conditions'), 'transitionRules');};
			
			var classAttr = document.createAttribute("class");
			classAttr.nodeValue = "commandExButton";
			button.setAttributeNode(classAttr);
			
			configs.appendChild(button);
		}
	} else {
		if (dojo.byId("noTransitionConditionsWarning")) {
			var warningMsg = dojo.byId("noTransitionConditionsWarning");
			if(warningMsg && warningMsg != null)
				configs.removeChild(warningMsg);
		}
		if (dojo.byId("addTransitionConditionsButton")) {
			var button = dojo.byId("addTransitionConditionsButton");
			if(button && button != null)
				configs.removeChild(button);
		}
		
		var ruleTable = new ram.ConditionBuilder({id: "transitionRules"});
		ruleTable.setRule(rule);
		ruleTable.setTransition(tc);
		elem.appendChild(ruleTable.domNode);
		ruleTable.initialize();
	}
	
}

function updateStateDetails(sc) {
	var state = editor_getState(sc.state);
	dojo.byId("workflowElementDescription").innerHTML = state.description;
	
	var configs = dojo.byId("aligned-configs");
	
	var stateHtml = new StringBuffer("<div id=\"state_buttons_bar\" class=\"buttons-bar\">");
	stateHtml.append("<span id=\"state_buttons_bar_collab\"></span>");
	stateHtml.append("<span id=\"state_buttons_bar_policy\"></span>");
	stateHtml.append("<span id=\"state_buttons_bar_advanced_link\"></span></div>");
	
	configs.innerHTML = stateHtml.toString();
	
	var privateStateCheckbox = dojo.byId("private_state_config_checkbox");
	if(isCommunityLifecycle) {
		privateStateCheckbox.disabled = true;
	} else if(sc.privateCollaboration && sc.privateCollaboration.inherited) {
		privateStateCheckbox.disabled = true;
		dojo.byId("private_state_config_checkbox_inherited_text").style.display = '';
	} else {
		privateStateCheckbox.disabled = false;
		dojo.byId("private_state_config_checkbox_inherited_text").style.display = 'none';
	}
	privateStateCheckbox.checked = sc.privateCollaboration && sc.privateCollaboration.value;
		
}


function getAssetTypeName(rule) {
	if (rule.valueDisplayName && rule.valueDisplayName.length > 0) {
		return rule.valueDisplayName;
	} else {
		var at = getAssetTypes();
		for (var i in at) {
			if (at[i].URI == rule.stringValue) {
				return at[i].name;
			}
		}
	}
}

function getCategorizationName(rule) {
	if (rule.valueDisplayName && rule.valueDisplayName.length > 0) {
		return rule.valueDisplayName;
	} else {
		return getCategorizationNameFromUri(uri);
	}
}

function isReviewRuleDefined(rule) {
	if(rule.childRule != null && rule.childRule.length > 0) {
		var retVal = false;
		for(var i in rule.childRule) {
			retVal = isReviewRuleDefined(rule.childRule[i]);
			if(retVal) {
				break;
			}
		}
		return retVal;
	} else {
		return "VOTE_RESULT" == rule.type || "GROUP_VOTES" == rule.type || "INDIVIDUAL_VOTES" == rule.type;
	}
}

function isPolicyRuleDefined(rule) {
	if(rule.childRule != null) {
		var retVal = false;
		for(var i in rule.childRule) {
			retVal = isPolicyRuleDefined(rule.childRule[i]);
			if(retVal) {
				break;
			}
		}
		return retVal;
	} else {
		return "POLICY_RESULT" == rule.type;
	}
}


/**
 * Returns a list of Exit Conditions that have a policy rule is defined
 * for a give policy configuration (or null if none match).
 * 
 * @param policyConfigId of the policy config we are trying to match
 * @param sc StateConfiguration we are looking through
 * @since 7.5.1
 */
function getECsWithPolicyRulesDefined(policyConfigId, sc){
	var ret = null;
	//at least one policy, need to check exit conditions
	for (var x in sc.exitCondition) {
		var exitCond = sc.exitCondition[x];
		//Rule could be null if there are no conditions defined on the transition
		if(exitCond.rule != null && isPolicyRuleDefined(policyConfigId, exitCond.rule)) {
			if(ret == null)ret = new Array();
			ret[ret.length] = exitCond;
		}
	}
	
	return ret;
}

/**
 * Returns a list of Exit Conditions that have a policy rule is defined
 * for a give policy configuration (or null if none match).
 * 
 * @param policyConfigId of the policy config we are trying to match
 * @param sc StateConfiguration we are looking through
 * @since 7.5.1
 */
function getExitCondition(stateId, actionId){
	var ret = null;
	
	//Find the action
	var states = clientLifecycle.stateConfiguration;
	for (var si in states) {
		var sc = states[si];
		var state = editor_getState(sc.state);
		
		if(state && state.identifier && state.identifier == stateId){
			for (var ai in sc.exitCondition) {
				// label is " -  actionName -> Target State"
				var action = getAction(sc.exitCondition[ai].action);
				
				if(action && action.identifier && action.identifier == actionId){
					ret = sc.exitCondition[ai];
					
					break;
				}
			}
			break;
		}
	}
	
	return ret;
}

/**
 * Return a state by its ID
 * 
 * @param The state ID
 * @since 7.5.1
 */
function getStateConfigurationById(stateId) {
	var ret = null;
	var states = clientLifecycle.stateConfiguration;
	for (var si in states) {
		var sc = states[si];
		var state = editor_getState(sc.state);
		if(state && state.identifier && state.identifier == stateId){
			ret = sc;
			break;
		}
	}
	
	return ret;
}

/**
 * Returns true is a policy rule is defined for a give policy configuration and a specific rule
 * @param policyConfigId The id of the policy configuration
 * @param rule The exist condition rule that may contain a match
 * 
 * @since 7.5.1
 * 
 * @return
 */
function isPolicyRuleDefined(policyConfigId, rule) {
	if(rule.childRule != null) {
		var retVal = false;
		for(var i in rule.childRule) {
			retVal = isPolicyRuleDefined(policyConfigId, rule.childRule[i]);
			if(retVal) {
				break;
			}
		}
		return retVal;
	} else {
		return policyConfigId == rule.target && "POLICY_RESULT" == rule.type;
	}
}

function getCategorizationNameFromUri(uri) {
	var schemaUri = uri.substring(0, uri.indexOf('#'));
	var schema;
	if (cachedSchemas && cachedSchemas!==null) {
		for (var i=0; i<cachedSchemas.length; i++) {
			if (cachedSchemas[i].URI && cachedSchemas[i].URI==schemaUri) {
				schema = cachedSchemas[i];
				debug("Found schema in cache");
				break;
			}
		}
	}
	if (!schema) {
		dojo.xhrGet({
			url: getAbsoluteUrl(CATEGORY_SCHEMA_URL),
			handleAs: "json",
			headers: {"Accept": "application/json"},
			sync: true,
			content: {gid: getCommunityId(), uri:schemaUri},
			
			// The LOAD function will be called on a successful response.
			load: function(response, ioArgs) {
				schema = response[0];
				if (!cachedSchemas || cachedSchemas==null) {
					cachedSchemas = new Array();
				}
				cachedSchemas[cachedSchemas.length] = schema;
			},
			
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	}
	
	var catId = uri.substring(uri.indexOf('#')+1, uri.length);
	debug(catId);
	
	var displayName = new Array();
	var levels = catId.split("_");
	var currentLevel = schema.categories;
	displayName[0] = schema.name;
	
	var foundId = true;
	
	for (var i=0; i<levels.length; i++) {
		var found = false;
		var lookingFor = schemaUri+"#"+levels[i];
		for (var ci=0; ci<currentLevel.length; ci++) {
			if (currentLevel[ci].id==lookingFor) {
				found = true;
				displayName[displayName.length] = currentLevel[ci].name;
				currentLevel = currentLevel[ci].subCategories;
				if ((levels.length-1)>i) {
					levels[i+1] = levels[i] + "_" + levels[i+1];
				}
				break;
			}
		}
		if (!found) {
			debug(lookingFor + " not found");
			foundId = false;
			break;
		}
	}
	
	if (!foundId) {
		var match;
		// Do depth first search of schema
		var categories = schema.categories;
		// Iterate across categories
		for (var ci=0; !foundId && ci<categories.length; ci++) {
			var category = categories[ci];
			// Iterate across this category's subcategories
			for (var sci=0; sci<category.subCategories.length; sci++) {
				match = searchSubCategoryAndChildren(category.subCategories[sci], uri);
				if (match && match!==null) {
					foundId = true;
					match = category.name + " > " + match;
					break;
				}
			}
		}
		
		// TODO get path to matching node
		displayName[1] = match;
	}

	var returnName = new StringBuffer(displayName[0]);
	returnName.append(": ")
	returnName.append(displayName[1]);
	for (var j=2; j<displayName.length; j++) {
		returnName.append(" > ")
		returnName.append(displayName[j]);
	}
	
	return returnName.toString();
}

function searchSubCategoryAndChildren(subCategory, lookingFor) {
	if (subCategory.id==lookingFor) {
		return subCategory.name;
	} else {
		for (var ssci=0; ssci<subCategory.subCategories.length; ssci++) {
			var node = searchSubCategoryAndChildren(subCategory.subCategories[ssci], lookingFor);
			if (node && node!==null) {
				return subCategory.name + " > " + node;
			}
		}
		return null;
	}
}

function initConditionTable(element, parent, widgetId) {
	// Remove the button
	element.parentNode.removeChild(element);
	parent.style.display = "block";
	
	// Create the widget
	var ruleTable = new ram.ConditionBuilder({id: widgetId});
	ruleTable.setRule(null);
	ruleTable.setTransition(tc);
	parent.appendChild(ruleTable.domNode);
	ruleTable.initialize();
	
	ruleTable.addInputRule();
}

function updateEditorRules(rule) {
	debug(rule);
	
	if (lc !== null) {
		lc.selectionCondition = rule;
		
		saveLifecycleEntryConditions(rule);
		updateLifecyleConditions(lc.selectionCondition);
	} else if (tc !== null) {
		tc.rule = rule;
		
		saveTransitionConfiguration(tc);
		updateTransitionConditions(tc);
	} else {
		debug(lc);
		debug(tc);
		alert("Oops, can't determine where you're adding the rule from");
	}
}


/**
 * Renders the communities section today
 */
function updateCommunityScopingSection(){
	var configs = dojo.byId("add_lifecycle_configs");
	var elem = document.getElementById("community_scoping");
	
	//If the section exists fill it in
	if(elem && elem != null){
		var rbHtml = new StringBuffer();
		
		/**
		 * Headers for the community scoping section
		 */
		rbHtml.append("<div class=\"primarySectionHeader\">");		
		rbHtml.append(getAddLink("restricCommunityEnabledAddLink", "showAddCommunityDialog();"));
		rbHtml.append("<h2>");
		rbHtml.append("<span id=\"communityScopingHeaderText\" class=\"jazz-app-ua-TextHoverHelp\">");
		rbHtml.append(bundle.sectionHeaderCommunityScoping);
		rbHtml.append("</span>");
		rbHtml.append("</h2></div>");
		
		rbHtml.append("<div class=\"primarySectionContent\">");
		rbHtml.append("<span class=\"sectionInstructions\">");
		rbHtml.append(bundle.inlineHelpCommunityScoping);
		rbHtml.append("</span>");
				
		
		/**
		 * Table of communities
		 */
		if(getCommunityScoping().communities != null && getCommunityScoping().communities.length > 0) {
			getCommunityScoping().restricted = 'RESTRICTED_TO';
			var communities = getCommunityScoping().communities;
			rbHtml.append("<table id=\"restrictedCommunitiesTable\" class=\"displayTable\" border=\"0\"><thead></thead><tbody>");
			for (var i in communities) {
				rbHtml.append("<tr><td width=\"100%\"><a class=\"outputLink\" href=\"");
				rbHtml.append(getAbsoluteUrl(communities[i].resource));
				rbHtml.append("\">");
				rbHtml.append(communities[i].value);
				rbHtml.append("</a></td>");
				rbHtml.append("<td class=\"actionColumn\" nowrap=\"true\"><a id=\"removeCommunityLink\" href=\"javascript:removeCommunity('");
				rbHtml.append(communities[i].resource);
				rbHtml.append("');\">");
				rbHtml.append(bundle.linkRemove);
				rbHtml.append("</a></td></tr>");
			}
			rbHtml.append("</tbody></table>");
		} else {
			getCommunityScoping().restricted = 'NOT_RESTRICTED';
		}
		
		rbHtml.append("</div>");
		
		elem.innerHTML = rbHtml.toString();
		dojo.parser.parse(elem);
		createPopup('communityScopingHeaderText', 'aclc0105', null, true);
	}
}

/**
 * Gets the CommunityScoping object from lifecycle.
 * One is created if it does not exist
 * 
 * @return The lifecycle CommunityScoping obejct
 */
function getCommunityScoping(){
	if(lc.communityScoping == null){
		lc.communityScoping = new CommunityScoping();
	}
	return lc.communityScoping;
}

function getAddLink(id, onclickJavascript, hide) {
	var link = new StringBuffer(); 
	var enabled = onclickJavascript != null && onclickJavascript.length > 0;
	if(enabled) {
		link.append("<a id=\"");
		link.append(id);
		link.append("\" style=\"color:#3087B3;");
		if(hide) {
			link.append("display:none;");
		}
		link.append("\" href=\"javascript:");
		link.append(onclickJavascript);
		link.append("\" >");
		link.append("<span style=\"float: right; margin-right: 20px; margin-top: 2px;\">");
	} else {
		link.append("<span class=\"deemphasized\" id=\"");
		link.append(id);
		link.append("\" style=\"float: right; margin-right: 20px; margin-top: 2px;");
		if(hide) {
			link.append("display:none;");
		}
		link.append("\">");
	}
	link.append("<img style=\"vertical-align: sub;\" src=\"");
	link.append(getImageUrl("/theme/images/icons/etool16/add-link-user.gif"));
	link.append("\" />");
	link.append(bundle.linkAdd);
	link.append("</span>");
	if(enabled) {
		link.append("</a>");
	}
	return link.toString();
}

/**
 * Renders the lifecycle managers section in the overview page of the 
 * 
 * @param auths
 * @return
 */
function updateReviewBoardTable(auths) {
	var configs = dojo.byId("add_lifecycle_configs");
	var elem = document.getElementById("review_board");
	
	var rbHtml = new StringBuffer();
	/* TODO  Add something in the model that lets the UI know if the asset owners are RBMs
	if (!auths || auths=== null || auths.length==0) {
		if (!dojo.byId("addReviewBoardButton")) {
			var button = document.createElement("input");
			
			var id = document.createAttribute("id");
			id.nodeValue = "addReviewBoardButton";
			button.setAttributeNode(id);
			
			var type = document.createAttribute("type");
			type.nodeValue = "button";
			button.setAttributeNode(type);
	
			var value = document.createAttribute("value");
			value.nodeValue = "Add Review Board...";
			button.setAttributeNode(value);
	
			var onclick = document.createAttribute("onclick");
			onclick.nodeValue = "showAddCollaboratorDialog(ROLE_REVIEW_BOARD);";
			button.setAttributeNode(onclick);
			
			var classAttr = document.createAttribute("class");
			classAttr.nodeValue = "commandExButton";
			button.setAttributeNode(classAttr);
			
			configs.appendChild(button);
		}
	} else {*/
		if (dojo.byId("addReviewBoardButton")) {
			configs.removeChild(dojo.byId("addReviewBoardButton"));
		}
		rbHtml.append("<div class=\"primarySectionHeader\">");
		if ((!isAssetLifecycle || canEdit) && !isCommunityLifecycle) {
			rbHtml.append(getAddLink("managerAddLink", "showAddCollaboratorDialog(ROLE_REVIEW_BOARD);"));
		}
		rbHtml.append("<h2>");
		rbHtml.append("<span id=\"lifecycleManagersHeaderText\" class=\"jazz-app-ua-TextHoverHelp\">");
		rbHtml.append(bundle.sectionHeaderReviewBoard);
		rbHtml.append("</span>");
		rbHtml.append("</h2></div>");
		
		rbHtml.append("<div class=\"primarySectionContent\">");
		rbHtml.append("<span class=\"sectionInstructions\">");
		rbHtml.append(bundle.inlineHelpReviewBoard);
		rbHtml.append("</span>");
		
		rbHtml.append("<table class=\"displayTable\" border=\"0\"><thead></thead><tbody>");
		for (var i in auths) {
			if (auths[i].user) {
				rbHtml.append("<tr><td width=\"100%\"><a class=\"outputLink");
				rbHtml.append("\" lazyfetch=\"\" dojotype=\"jazz.ui.ResourceLink\" presentationUri=\"");
				rbHtml.append(getAbsoluteUrl(USER_URL+getUserIdentifier(auths[i].user)));
				rbHtml.append("\" href=\"");
				rbHtml.append(getAbsoluteUrl(OSLC_USER_URL+getUserIdentifier(auths[i].user)));
				rbHtml.append(" \">");
				rbHtml.append(auths[i].user.title.content[0]);
				rbHtml.append("</a>");
				if(auths[i].inherited) {
					rbHtml.append(INHERITED_TEXT);
				}
				rbHtml.append("</td>");
				if (!auths[i].inherited && !isCommunityLifecycle) {
					rbHtml.append("<td class=\"actionColumn\" nowrap=\"true\"><a href=\"#\" onclick=\"removeBoardMember('");
					rbHtml.append(getUserIdentifier(auths[i].user));
					rbHtml.append("')\">");
					rbHtml.append(bundle.linkRemove);
					rbHtml.append("</a></td>");
				}
				rbHtml.append("</tr>");
			} else if (auths[i].userGroup) {
				rbHtml.append("<tr><td width=\"100%\"><a class=\"outputLink").
					append(auths[i].inherited?" inherited":"").
					append("\" href=\"");
				if(isAssetLifecycle) {
					rbHtml.append(getAbsoluteUrl(COMMUNITY_USER_GROUP_URL + getCommunityId() + "&ugid=" + getUserGroupIdentifier(auths[i].userGroup)));
				} else {
					rbHtml.append(getAbsoluteUrl(USER_GROUP_URL+getUserGroupIdentifier(auths[i].userGroup)));
				}
				rbHtml.append("&gid=");
				rbHtml.append(getCommunityId());
				rbHtml.append("\">");
				rbHtml.append(auths[i].userGroup.title.content[0]);
				rbHtml.append("</a></td>");
				if (!auths[i].inherited && !isCommunityLifecycle) {
					rbHtml.append("<td class=\"actionColumn\" nowrap=\"true\"><a href=\"#\" onclick=\"removeBoardMember('");
					rbHtml.append(getUserGroupIdentifier(auths[i].userGroup));
					rbHtml.append("')\">");
					rbHtml.append(bundle.linkRemove);
					rbHtml.append("</a></td>");
				}
				rbHtml.append("</tr>");
			}
		}
		rbHtml.append("</tbody></table>");
		/*
		if ((!isAssetLifecycle || canEdit) && !isCommunityLifecycle) {
			rbHtml.append("<table cellpadding=\"3\" cellspacing=\"0\" class=\"secondaryActionGroup\"><tr><td>");
			rbHtml.append("<input onclick=\"showAddCollaboratorDialog(ROLE_REVIEW_BOARD);\" class=\"commandExButton\" type=\"button\" value=\"");
			rbHtml.append(bundle.buttonAddReviewBoardMembers);
			rbHtml.append("\" />");
			rbHtml.append("</td></tr></table>");
		}
		*/
		rbHtml.append("<input type=\"checkbox\" class=\"checkboxText\" id=\"ownersBoardMember\" ");
		if (lc.restrictOwnerAsManagers == null || !lc.restrictOwnerAsManagers.value) {
			rbHtml.append("checked=\"true\" ");
		}
		
		rbHtml.append("onclick=\"event_toggleOwnersAsReviewBoard(!this.checked);\" ");
		if (isCommunityLifecycle || (lc.restrictOwnerAsManagers != null  && lc.restrictOwnerAsManagers.inherited)) {
			rbHtml.append("disabled=\true\"");
		}
		rbHtml.append("/>");
		//if inherited style the label
		if(lc.restrictOwnerAsManagers != null && lc.restrictOwnerAsManagers.inherited){
			rbHtml.append("<label for=\"ownersBoardMember\" class=\"checkboxText  inherited\">");
		}
		else{
			rbHtml.append("<label for=\"ownersBoardMember\" class=\"checkboxText\">");
		}
		rbHtml.append(bundle.labelOwnersAsReviewBoardMembers);
		rbHtml.append("</label>");
		if(lc.restrictOwnerAsManagers != null && lc.restrictOwnerAsManagers.inherited) {
			rbHtml.append(INHERITED_TEXT);
		}
			
		//Only show this checkbox if this is a community lifecycle or an asset lifecycle and the user is a community administrator
		var communityAdmin = false;
		dojo.xhrGet({
			url: getAbsoluteUrl(COMMUNITY_ADMIN_URL),
			handleAs: "text",
			headers: {"Accept": "application/json"},
			content: {communityId: getGID()},
			sync: true,
			
			// The LOAD function will be called on a successful response.
			load: function(response, ioArgs) {
				communityAdmin = "true" == response;
				return response;
			},
			
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("Error calling" + COMMUNITY_ADMIN_URL + ".  HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
		if(lc.managersHandlePerms != null && communityAdmin) {
			rbHtml.append("<br/><input type=\"checkbox\" class=\"checkboxText\" id=\"managersHandlePerm\" ");
			if (lc.managersHandlePerms.value) {
				rbHtml.append("checked=\"true\" ");
			}
			
			rbHtml.append("onclick=\"event_toggleManagersHandlePerms(this.checked);\" ");
			if (isCommunityLifecycle || lc.managersHandlePerms.inherited) {
				rbHtml.append("disabled=\true\"");
			}
			rbHtml.append("/>");
			if(lc.managersHandlePerms.inherited) {
				rbHtml.append("<label for=\"managersHandlePerm\" class=\"checkboxText inherited\">");
			} else {
				rbHtml.append("<label for=\"managersHandlePerm\" class=\"checkboxText\">");
			}
			rbHtml.append(bundle.labelManagersHandlePerms);
			if(lc.managersHandlePerms.inherited) {
				rbHtml.append(INHERITED_TEXT);
			}
			rbHtml.append("</label><br/>");
		}
		rbHtml.append("</div>");
	//}
	
	elem.innerHTML = rbHtml.toString();
	resizeEditor();
	dojo.parser.parse(elem);
	createPopup('lifecycleManagersHeaderText', 'aclc0130', null, true);
}

function writeAdvancedStateSection(sc) {
	var configs = dojo.byId("state_buttons_bar_advanced_link");
	var elem = dojo.byId("state_advanced");
		
	var stateHtml = new StringBuffer();
	stateHtml.append("<div class=\"primarySectionHeader\">");
	stateHtml.append("<h2>");
	stateHtml.append("<span id=\"advancedHelpText\" class=\"jazz-app-ua-TextHoverHelp\">");
	stateHtml.append(bundle.sectionHeaderAdvanced);
	stateHtml.append("</span>");
	stateHtml.append("</h2></div>");
		
	stateHtml.append("<div class=\"primarySectionContent\">");
	stateHtml.append("<span class=\"sectionInstructions\">");
	stateHtml.append(bundle.labelPermissionsInlineHelp);
	stateHtml.append("</span>");
	
	var noChangeInherit = isCommunityLifecycle || (sc.roleOverride != null && sc.roleOverride.inheritedValue != null && sc.roleOverride.inheritedValue != "NO_CHANGE");
	
	stateHtml.append("<span id=\"no_override_permissions\"");
	if (noChangeInherit) {
		stateHtml.append(" class=\"inherited\"");
	}
	stateHtml.append(">");
	stateHtml.append("<input type=\"radio\" name=\"permissions\" id=\"no_override_radio\" class=\"checkboxText\" onclick=\"setNoOverride(this);\" ");
	//if ((!sc.overrideRoles || sc.overrideRoles == false) && (!sc.readOnly || sc.readOnly == false)) {  //!sc.publishedState && sc.overrideRoles
	if(sc.roleOverride == null || sc.roleOverride.value == "NO_CHANGE"){
		stateHtml.append("checked=\"true\" ");
	}
	if (noChangeInherit) {
		stateHtml.append("disabled=\true\"");
	}
	stateHtml.append("\">");
	stateHtml.append("<label for=\"no_override_radio\" class=\"checkboxText\"><span id=\"noChangeText\" class=\"jazz-app-ua-TextHoverHelp\">");
	stateHtml.append(bundle.labelPermissionsRadio_NoChange_Main);
	stateHtml.append("</span>");
	stateHtml.append("</label>");
	stateHtml.append("</span>");
	if (noChangeInherit) {
		stateHtml.append(INHERITED_TEXT_NO_UNDERLINE);
	}

	var overrideAllInherit = isCommunityLifecycle || (sc.roleOverride != null && sc.roleOverride.inheritedValue == "OVERRIDE_ALL");
	stateHtml.append("<br/><span id=\"readonly_permissions\"");
	if (overrideAllInherit) {
		stateHtml.append(" class=\"inherited\"");
	}
	stateHtml.append(">");
	stateHtml.append("<input type=\"radio\" name=\"permissions\" id=\"readonly_radio\" class=\"checkboxText\" onclick=\"setReadOnly(this);\" ");
	//if (sc.readOnly) {  //!sc.publishedState && sc.overrideRoles
	if(sc.roleOverride != null && sc.roleOverride.value == "OVERRIDE_MODIFY"){
		stateHtml.append("checked=\"true\" ");
	}
	if (overrideAllInherit) {
		stateHtml.append("disabled=\true\"");
	}
	stateHtml.append("\">");
	stateHtml.append("<label for=\"readonly_radio\" class=\"checkboxText\"><span id=\"overrideModifyText\" class=\"jazz-app-ua-TextHoverHelp\">");
	stateHtml.append(bundle.labelPermissionsRadio_OverrideModify_Main);
	stateHtml.append("</span>");
	stateHtml.append("</label>");
	stateHtml.append("</span>");
	if (overrideAllInherit) {
		stateHtml.append(INHERITED_TEXT_NO_UNDERLINE);
	}

	stateHtml.append("<br/><span id=\"override_permissions\"");
	if (overrideAllInherit) {
		stateHtml.append(" class=\"inherited\"");
	}
	stateHtml.append(">");
	stateHtml.append("<input type=\"radio\" name=\"permissions\" id=\"override_roles_ck\" class=\"checkboxText\" onclick=\"setOverrideRoles(this);\" ");
	//if (sc.overrideRoles) {  //!sc.publishedState && sc.overrideRoles
	if(sc.roleOverride != null && sc.roleOverride.value == "OVERRIDE_ALL"){
		stateHtml.append("checked=\"true\" ");
	}
	if (isCommunityLifecycle) {
		stateHtml.append("disabled=\true\"");
	}
	stateHtml.append("\">");
	stateHtml.append("<label for=\"override_roles_ck\" class=\"checkboxText\"><span id=\"overrideAllText\" class=\"jazz-app-ua-TextHoverHelp\">");
	stateHtml.append(bundle.labelPermissionsRadio_OverrideAll_Main);
	stateHtml.append("</span>");
	stateHtml.append("</label>");
	stateHtml.append("</span>");
	if (isCommunityLifecycle || (sc.roleOverride != null && sc.roleOverride.inheritedValue == "OVERRIDE_ALL")) {
		stateHtml.append(INHERITED_TEXT_NO_UNDERLINE);
	}
	stateHtml.append("</div>");
	show(elem);
	elem.innerHTML = stateHtml.toString();
	createPopup('advancedHelpText', 'aclc0230', null, true);
	createPopup('noChangeText', 'aclc0245', null, true);
	createPopup('overrideModifyText', 'aclc0250', null, true);
	createPopup('overrideAllText', 'aclc0260', null, true);
}

function updateReviewersTable(auths) {
	var configs = dojo.byId("state_buttons_bar_collab");
	var elem = dojo.byId("state_users");
	
	var stateUserButton = dojo.byId("addStateCollaboratorButton");
	
	var sUsersHtml = new StringBuffer();
	// message element if there are no review conditions
	sUsersHtml.append("<span id='missingReviewConditions'></span>");
	if (!auths || auths=== null || auths.length==0) {
		if (!stateUserButton && !isCommunityLifecycle && (!isAssetLifecycle || canEdit)) {
			var button = document.createElement("input");
			
			var id = document.createAttribute("id");
			id.nodeValue = "addStateCollaboratorButton";
			button.setAttributeNode(id);
			
			var type = document.createAttribute("type");
			type.nodeValue = "button";
			button.setAttributeNode(type);
	
			var value = document.createAttribute("value");
			value.nodeValue = bundle.buttonAddCollaborators;
			button.setAttributeNode(value);
			
			button.onclick = function(){showAddCollaboratorDialog(ROLE_CAN_VIEW);};
			
			var classAttr = document.createAttribute("class");
			classAttr.nodeValue = "commandExButton";
			button.setAttributeNode(classAttr);
			
			configs.appendChild(button);
		}
	} else {
		if (stateUserButton) {
			configs.removeChild(stateUserButton);
		}
		
		// build the collaborator display table
		sUsersHtml.append("<table class=\"displayTable\" border=\"0\"><thead>");
		if (auths.length>0) {
			sUsersHtml.append("<th class=\"primarySectionHeader\">");
			sUsersHtml.append("<span id=\"reviewersHeaderText\" class=\"jazz-app-ua-TextHoverHelp\">");
			sUsersHtml.append(bundle.sectionHeaderCollaborators);
			sUsersHtml.append("</span>");
			sUsersHtml.append("</th><th class=\"primarySectionHeader\">");
			sUsersHtml.append("<span class=\"inherited jazz-app-ua-TextHoverHelp\"  helpcontentstring=\"");
			sUsersHtml.append(bundle.inlineHelpColumnEditor);
			sUsersHtml.append("\" dojotype=\"jazz.app.ua.TextHoverHelp\">" );
			sUsersHtml.append(bundle.columnEditor);
			sUsersHtml.append("</span>");
			sUsersHtml.append("</th><th class=\"primarySectionHeader\">");
			sUsersHtml.append("<span class=\"inherited jazz-app-ua-TextHoverHelp\"  helpcontentstring=\"");
			sUsersHtml.append(bundle.inlineHelpColumnReviewer);
			sUsersHtml.append("\" dojotype=\"jazz.app.ua.TextHoverHelp\">" );
			sUsersHtml.append(bundle.columnReviewer);
			sUsersHtml.append("</span>");
			sUsersHtml.append("</th><th class=\"primarySectionHeader\">");
			sUsersHtml.append("<span>&nbsp;</span></th>");
		}
		sUsersHtml.append("</thead><tbody>");
	
		for (var i in auths) {
			if (auths[i].user) {
				sUsersHtml.append("<tr");
				sUsersHtml.append("><td><a class=\"outputLink\" lazyfetch=\"\" dojotype=\"jazz.ui.ResourceLink\" presentationUri=\"");
				sUsersHtml.append(getAbsoluteUrl(USER_URL+getUserIdentifier(auths[i].user)));
				sUsersHtml.append("\" href=\"");
				sUsersHtml.append(getAbsoluteUrl(OSLC_USER_URL+getUserIdentifier(auths[i].user)));
				sUsersHtml.append("\">");
				sUsersHtml.append(auths[i].user.title.content[0]);
				sUsersHtml.append("</a>");
				if(auths[i].inherited) {
					sUsersHtml.append(INHERITED_TEXT);
				}
				sUsersHtml.append("</td>");
				sUsersHtml.append("<td class=\"checkboxColumn\">");
				if (isCommunityLifecycle) {
					if (auths[i].canUpdate) {
						sUsersHtml.append("<img src=\"");
						sUsersHtml.append(getImageUrl("/theme/images/icons/obj16/checked.gif"));
						sUsersHtml.append("\" />");
					}
				} else {
					sUsersHtml.append("<input type=\"checkbox\" id=\"collaborateAllowEditing_");
					sUsersHtml.append(i);
					sUsersHtml.append("\" onclick=\"updateUserPermission(this, ");
					sUsersHtml.append(ROLE_CAN_MODIFY);
					sUsersHtml.append(", '");
					sUsersHtml.append(getUserIdentifier(auths[i].user));
					sUsersHtml.append("')\" ");
					if (auths[i].canUpdate) {
						sUsersHtml.append("checked=\"true\"");
					}
					if(auths[i].inherited && auths[i].canUpdateInherited){
						sUsersHtml.append("disabled=\"disabled\"");
					}
					sUsersHtml.append("\>");
				}
				sUsersHtml.append("</td>");
				sUsersHtml.append("<td class=\"checkboxColumn\">");
				if (isCommunityLifecycle) {
					if (auths[i].canVote) {
						sUsersHtml.append("<img src=\"");
						sUsersHtml.append(getImageUrl("/theme/images/icons/obj16/checked.gif"));
						sUsersHtml.append("\" />");
					}
				} else {
					sUsersHtml.append("<input type=\"checkbox\" id=\"collaborateReviewer_");
					sUsersHtml.append(i);
					sUsersHtml.append("\" onclick=\"updateUserPermission(this, ");
					sUsersHtml.append(ROLE_REVIEWER);
					sUsersHtml.append(", '");
					sUsersHtml.append(getUserIdentifier(auths[i].user));
					sUsersHtml.append("')\" ");
					if (auths[i].canVote) {
						sUsersHtml.append("checked=\"true\"");
					}
					if(auths[i].inherited && auths[i].canVoteInherited){
						sUsersHtml.append("disabled=\"disabled\"");
					}
					sUsersHtml.append("\>");
				}
				sUsersHtml.append("</td><td class=\"actionColumn\" nowrap=\"true\">");
				if (!auths[i].inherited && !isCommunityLifecycle) {
					sUsersHtml.append("<a id=\"collaborateRemove_");
					sUsersHtml.append(i);
					sUsersHtml.append("\" href=\"#\" onclick=\"removeAuthorization('");
					sUsersHtml.append(getUserIdentifier(auths[i].user));
					sUsersHtml.append("')\">");
					sUsersHtml.append(bundle.linkRemove);
					sUsersHtml.append("</a>");
				}
				sUsersHtml.append("</td></tr>");
			} else if (auths[i].userGroup) {
				sUsersHtml.append("<tr><td width=\"50%\"><a href=\"");
				if(isAssetLifecycle) {
					sUsersHtml.append(getAbsoluteUrl(COMMUNITY_USER_GROUP_URL + getCommunityId() + "&ugid=" + getUserGroupIdentifier(auths[i].userGroup)));
				} else {
					sUsersHtml.append(getAbsoluteUrl(USER_GROUP_URL+getUserGroupIdentifier(auths[i].userGroup)));
				}
				sUsersHtml.append("&gid=");
				sUsersHtml.append(getCommunityId());
				sUsersHtml.append("\">");
				sUsersHtml.append(auths[i].userGroup.title.content[0]);
				sUsersHtml.append("</a></td>");
				sUsersHtml.append("<td class=\"checkboxColumn\">");
				if (isCommunityLifecycle) {
					if (auths[i].canUpdate) {
						sUsersHtml.append("<img src=\"");
						sUsersHtml.append(getImageUrl("/theme/images/icons/obj16/checked.gif"));
						sUsersHtml.append("\" />");
					}
				} else {
					sUsersHtml.append("<input type=\"checkbox\" id=\"collaborateAllowEditing_");
					sUsersHtml.append(i);
					sUsersHtml.append("\" onclick=\"updateUserPermission(this, ");
					sUsersHtml.append(ROLE_CAN_MODIFY);
					sUsersHtml.append(", '");
					sUsersHtml.append(getUserGroupIdentifier(auths[i].userGroup));
					sUsersHtml.append("')\" ");
					if (auths[i].canUpdate) {
						sUsersHtml.append("checked=\"true\"");
					}
					if(auths[i].inherited){
						sUsersHtml.append("disabled=\"disabled\"");
					}
					sUsersHtml.append("\>");
				}
				sUsersHtml.append("</td>");
				sUsersHtml.append("<td class=\"checkboxColumn\">");
				if (isCommunityLifecycle) {
					if (auths[i].canVote) {
						sUsersHtml.append("<img src=\"");
						sUsersHtml.append(getImageUrl("/theme/images/icons/obj16/checked.gif"));
						sUsersHtml.append("\" />");
					}
				} else {
					sUsersHtml.append("<input type=\"checkbox\" id=\"collaborateReviewer_");
					sUsersHtml.append(i);
					sUsersHtml.append("\" onclick=\"updateUserPermission(this, ");
					sUsersHtml.append(ROLE_REVIEWER);
					sUsersHtml.append(", '");
					sUsersHtml.append(getUserGroupIdentifier(auths[i].userGroup));
					sUsersHtml.append("')\" ");
					if (auths[i].canVote) {
						sUsersHtml.append("checked=\"true\"");
					}
					if(auths[i].inherited){
						sUsersHtml.append("disabled=\"disabled\"");
					}
					sUsersHtml.append("\>");
				}
				sUsersHtml.append("</td><td class=\"actionColumn\" nowrap=\"true\">");
				if (!auths[i].inherited && !isCommunityLifecycle) {
					sUsersHtml.append("<a id=\"collaborateRemove_");
					sUsersHtml.append(i);
					sUsersHtml.append("\" href=\"#\" onclick=\"removeAuthorization('" );
					sUsersHtml.append(getUserGroupIdentifier(auths[i].userGroup));
					sUsersHtml.append("')\">");
					sUsersHtml.append(bundle.linkRemove);
					sUsersHtml.append("</a>");
				}
				sUsersHtml.append("</td></tr>");
			}
		}
		
		sUsersHtml.append("</tbody></table>");
		
		if (!isCommunityLifecycle && (!isAssetLifecycle || canEdit)) {
			sUsersHtml.append("<table cellpadding=\"3\" cellspacing=\"0\" class=\"secondaryActionGroup\"><tr><td>");
			sUsersHtml.append("<input onclick=\"showAddCollaboratorDialog(ROLE_CAN_VIEW);\" class=\"commandExButton\" type=\"button\" value=\"");
			sUsersHtml.append(bundle.buttonAddCollaborators);
			sUsersHtml.append("\" />");
			sUsersHtml.append("</td></tr></table>");
		}
		sUsersHtml.append("<div id=\"voting_state_config\"></div>");
		
		//	Add collaborator instructions inside a collapsable pane. 
		//	If no instructions are available some text is printed and 
		//	the link to 'Edit' is changed to 'Add'. This will display both inherited instructions 
		//	and the current level instructions inline as they would appear to the user.
		var inheritedInstructions = getInheritedInstructions(sc);
		var instructions = getCurrentInstruction(sc);
		var hasInherited = (inheritedInstructions && inheritedInstructions != null)? true : false ;
		var hasInstructions = (instructions && instructions != null && instructions.body && instructions.body != null) ? true : false;
		sUsersHtml.append("<div dojoType=\"dijit.TitlePane\" title='");
		sUsersHtml.append("<span id=\"collabInstructionsText\" class=\"jazz-app-ua-TextHoverHelp\">");
		sUsersHtml.append(bundle.collabInstructions);
		sUsersHtml.append("</span>' open=\"true\">");
		sUsersHtml.append("<div id=\"instructionsContainer\" class=\"deemphasized\">");
		addInstructionText(sUsersHtml);
		show(elem);
	}
	
	elem.innerHTML = sUsersHtml.toString();
	dojo.parser.parse(elem);
	createPopup('reviewersHeaderText', 'aclc0210', null, true);
	createPopup('collabInstructionsText', 'aclc0215', null, true);
}

/**
 * This function saves the current value of the editor to the 
 * instruction body. This occurs when the instruction editor 
 * fires the onChange event. This does not commit the change 
 * to the lifecycle though. This has to be done by pressing 
 * the save button within the lifecycle editor.
 * @param editor
 * @since 7.5.1
 * 
 */
function saveInstructions() {
	var instructions = getCurrentInstruction(sc);
//	var editorVal = editor.getValue();
//	// 	These values get stuck in there by the editor and will 
//	//	cause confusion when determining if the instruction 
//	//	body is empty. Just removing them for the time being.
//	if(editorVal == "<br />" || editorVal  == "<br _moz_editor_bogus_node=\"TRUE\" />" || editorVal == "<br/>" || editorVal == "<br>" ){
//		instructions.body = "";
//		editor.set("value","");
//	}else
//		instructions.body = editor.getValue();
	instructions.body = CKEDITOR.instances['instructionEditor'].getData();
}



/**
 * This function will display the editor for the current state level instructions.
 * If there are inherited instructions, a separate container is made to house them.
 * @param item
 * @since 7.5.1
 */
function editInstructions() {
	var instructionDiv = dojo.byId('instructionsContainer');
	var sUsersHtml = new StringBuffer();
	dojo.removeClass(instructionDiv, 'deemphasized');
	dojo.addClass(instructionDiv, 'collaboratorInstructionsEdit');
	var sInstructionsHtml = new StringBuffer();
	var inheritedInstructions = getInheritedInstructions(sc);
	var instructions = getCurrentInstruction(sc);
	// 	If there are inherited instructions and this is not a master lifecycle, 
	//	add a section for inherited instructions and current level instructions.
	if (inheritedInstructions && inheritedInstructions != null && !isMasterLifecycle ) {
		// Add the inherited instructions
		sInstructionsHtml.append('<div style="border-top-color: #D8D8D8; border-bottom-color: #D8D8D8; border-top-style: solid; border-bottom-style: solid;  border-top-width: 1px; border-bottom-width: 1px; color: #666666; font-weight: bold; padding: 1px 0px 1px 0px;"><div style="background-color:#EEEEEE;"><span style="margin-left:5px;">');
		sInstructionsHtml.append(bundle.inheritedInstructions);
		sInstructionsHtml.append('</span></div></div><div class="deemphasized">');
		sInstructionsHtml.append(inheritedInstructions);
		sInstructionsHtml.append('</div> <br/>');
		//	Add the current state level instructions header if this is not a master lifecycle
		sInstructionsHtml.append('<div style="border-top-color: #D8D8D8; border-bottom-color: #D8D8D8; border-top-style: solid; border-bottom-style: solid;  border-top-width: 1px; border-bottom-width: 1px; color: #666666; font-weight: bold; padding: 1px 0px 1px 0px;"><div style="background-color:#EEEEEE;"><span style="margin-left:5px;">');
		sInstructionsHtml.append(bundle.currentInstructions);
		sInstructionsHtml.append("</span></div></div>");
	}
	//	Add the current state level instructions
	//sInstructionsHtml.append("<div class=\"instructionEditor\" dojoType=\"dijit.Editor\" onChange=\"saveInstructions(this);\" style=\"width:100%;\" plugins=\"['undo','redo','|','foreColor','hiliteColor','|','createLink','insertImage','|','bold','italic','underline','|','justifyLeft','justifyCenter','justifyRight','|','insertOrderedList','insertUnorderedList','|','indent','outdent','|']\">");
	sInstructionsHtml.append('<textarea id="instructionEditor" style="display: none;"></textarea>');
	sInstructionsHtml.append('</div>');
	sInstructionsHtml.append('<input type="button" value="');
	sInstructionsHtml.append(bundle.saveInstructions);
	sInstructionsHtml.append('" onclick="saveInstructions();hideInstructionEditor();" class="commandExButton" style="float:right; margin-top:5px;">');
	instructionDiv.innerHTML = sInstructionsHtml.toString();
//	dojo.parser.parse(instructionDiv);
	if (instructions && instructions != null && instructions.body && instructions.body != null) {		
		//sInstructionsHtml.append(instructions.body);
		dojo.byId('instructionEditor').value = instructions.body;
	}
	showInstructionEditor();
}

function showInstructionEditor() {
	var editor = CKEDITOR.instances['instructionEditor'];
	if (!editor) {
		if (isAssetLifecycle) 
			initCKEditor('instructionEditor');
		else
			initCKEditor('instructionEditor', {hideArtifactTab: true});
	} else {
		var node = editor.container.$;
		var textarea = dojo.byId('instructionEditor');
		editor.setData(dojo.attr(textarea, 'value'));
		dojo.place(node, textarea.parentNode, 'first');
		dojo.style(node, 'display', '');
	}
}

function addInstructionText(strBuff){
	var inheritedInstructions = getInheritedInstructions(sc);
	var instructions = getCurrentInstruction(sc);
	var hasInherited = (inheritedInstructions && inheritedInstructions != null)? true : false ;
	var hasInstructions = (instructions && instructions != null && instructions.body && instructions.body != null) ? true : false;
	if (hasInherited == true)
		strBuff.append(inheritedInstructions);
	if (hasInstructions == true || hasInherited == true) {	
		strBuff.append(instructions.body);
		if (!isCommunityLifecycle) {
			strBuff.append("<a href=\"javascript:editInstructions();resizeEditor();\"><br />");
			strBuff.append(bundle.editInstructions);
			strBuff.append("</a>");
		}
	} else {
		strBuff.append("<p>");
		strBuff.append(bundle.noInstructions);
		strBuff.append("</p>");
		if (!isCommunityLifecycle) {
			strBuff.append("<a href=\"javascript:editInstructions();resizeEditor();\">");
			strBuff.append(bundle.addInstructions);
			strBuff.append("</a> ");
		}
	}
}

function hideInstructionEditor() {
	var editor = CKEDITOR.instances['instructionEditor'];
	if (editor) {
		var node = editor.container.$;
		dojo.style(node, 'display', 'none');
		dojo.place(node, dojo.body());
	}
	var strBuff = new StringBuffer();
	var instructionDiv = dojo.byId('instructionsContainer');
	dojo.addClass(instructionDiv, 'deemphasized');
	addInstructionText(strBuff);
	instructionDiv.innerHTML = strBuff.toString();
	show(instructionDiv);
	dojo.parser.parse(instructionDiv);
}

function setOverrideRoles(checkbox) {
	if(sc.roleOverride == null){
		sc.roleOverride = new RoleOverride();
	}
	sc.roleOverride.value = "OVERRIDE_ALL";
	saveStateConfiguration(sc);
}

function setReadOnly(checkbox) {
	if(sc.roleOverride == null){
		sc.roleOverride = new RoleOverride();
	}
	sc.roleOverride.value = "OVERRIDE_MODIFY";
	saveStateConfiguration(sc);
}

function setNoOverride(checkbox) {
	if(sc.roleOverride == null){
		sc.roleOverride = new RoleOverride();
	}
	sc.roleOverride.value = "NO_CHANGE";
	saveStateConfiguration(sc);
}

function setPublishedState(value) {
	sc.publishedState = value;
	if (value) {
		sc.roleOverride = null;
		
		dojo.byId('no_override_radio').checked = true;
		dojo.byId('no_override_radio').disabled = true;

		dojo.byId('override_roles_ck').checked = false;
		dojo.byId('override_roles_ck').disabled = true;

		dojo.byId('readonly_radio').checked = false;
		dojo.byId('readonly_radio').disabled = true;
	} else {
		dojo.byId('no_override_radio').disabled = false;
		dojo.byId('override_roles_ck').disabled = false;
		dojo.byId('readonly_radio').disabled = false;
	}
	
	saveStateConfiguration(sc);
}

function addSelectedAuthorization(roleId, selectBox, scope) { 
	var v1 = selectBox.value; // the next line of code doesn't work without calling this first, very bizarre.
	var id;
	var name;
	
	var isUser = (scope*1)!=1;
	
	for (var i = 0; i < selectBox.options.length; i++) {
		if (selectBox.options[i].selected) {
			id = selectBox.options[i].value;
			name = selectBox.options[i].text;
			addAuthorization(roleId, id, name, isUser);
		}
	}
}

function addAuthorization(roleId, id, name, isUser) {
	var oldAuths;
	var newAuth;
	if (roleId == ROLE_REVIEW_BOARD) {
		oldAuths = editor_getReviewBoardMembers();
		if (!oldAuths) {
			oldAuths = new Array();
		}
		newAuth = new Authorization();
	} else {
		oldAuths = sc.reviewer;
		if (!oldAuths) {
			oldAuths = new Array();
		}
		newAuth = new Reviewer();
		newAuth.canUpdate = false;
		newAuth.canVote = false;
		newAuth.isReceiveNotifications = true;
	}
	
	// Determine if this id is already in oldAuths, don't continue if so
	for (var i in oldAuths) {
		if (oldAuths[i].user && oldAuths[i].user !== null && getUserIdentifier(oldAuths[i].user) == id) {
			return;
		} else if (oldAuths[i].userGroup && oldAuths[i].userGroup !== null && getUserGroupIdentifier(oldAuths[i].userGroup) == id) {
			return;
		}
	}
	
	if (isUser) {
		newAuth.user = new UserInformation();
		newAuth.user.title.content[0] = name;
		newAuth.user.href = USER_REST_URL + "/" + id;
		newAuth.user.value.identifier = id;
	} else {
		newAuth.userGroup = new UserGroupInformation();
		newAuth.userGroup.title.content[0] = name;
		newAuth.userGroup.href = USER_GROUP_REST_URL + "/" + id;
		newAuth.userGroup.value.identifier = id;
	}	
	
	oldAuths[oldAuths.length] = newAuth;
	
	if (roleId == ROLE_REVIEW_BOARD) {
		updateReviewBoardTable(oldAuths);
		editor_setReviewBoardMembers(oldAuths);
	} else {
		sc.reviewer = oldAuths;
		updateReviewersTable(sc.reviewer);
		saveStateConfiguration(sc);
	}
}

function updateUserPermission(checkbox, roleId, id) {
	for (var i in sc.reviewer) {
		if ((sc.reviewer[i].user && sc.reviewer[i].user !== null && getUserIdentifier(sc.reviewer[i].user)==id) || (sc.reviewer[i].userGroup && sc.reviewer[i].userGroup !== null && getUserGroupIdentifier(sc.reviewer[i].userGroup)==id)) {
			if (roleId == ROLE_CAN_MODIFY) {
				sc.reviewer[i].canUpdate = checkbox.checked;
			} else if (roleId == ROLE_REVIEWER) {
				sc.reviewer[i].canVote = checkbox.checked;
			}
		}
	}
	
	var isVoting = false;
	for (var i in sc.reviewer) {
		if (sc.reviewer[i].canVote) {
			isVoting = true;
		}
	}
	
	if (isVoting) {
		// check to see if this state already has a reviewConfiguration, 
		if (!sc.reviewConfiguration || sc.reviewConfiguration=== null) {
			// if it doesnt create one so that the section shows up
			var vc = new ReviewConfiguration();
			sc.reviewConfiguration = vc;
		}
	} else {
		sc.reviewConfiguration = null;
	}
	
	updateReviewConfiguration(sc.reviewConfiguration);
	saveStateConfiguration(sc);
}

function removeBoardMember(id) {
	var oldAuths = editor_getReviewBoardMembers();
	var newAuths = new Array(oldAuths.length-1);
	
	var j = 0;
	for (var i in oldAuths) {
		if (oldAuths[i].user && oldAuths[i].user !== null && getUserIdentifier(oldAuths[i].user)==id) {
		
		} else if (oldAuths[i].userGroup && oldAuths[i].userGroup !== null && getUserGroupIdentifier(oldAuths[i].userGroup)==id) {
		
		} else {
			// Wasn't this user or usergroup, so keep it
			newAuths[j] = oldAuths[i];
			j++;
		}		
	}

	updateReviewBoardTable(newAuths);
	editor_setReviewBoardMembers(newAuths);
	
}


function removeAuthorization(id) {
	var newAuths = new Array(sc.reviewer.length-1);
	
	var j = 0;
	for (var i in sc.reviewer) {
		if (sc.reviewer[i].user && sc.reviewer[i].user !== null && getUserIdentifier(sc.reviewer[i].user)==id) {
		
		} else if (sc.reviewer[i].userGroup && sc.reviewer[i].userGroup !== null && getUserGroupIdentifier(sc.reviewer[i].userGroup)==id) {
		
		} else {
			// Wasn't this user or usergroup, so keep it
			newAuths[j] = sc.reviewer[i];
			j++;
		}
	}
	
	if (newAuths.length == 0) {
		sc.reviewConfiguration = null;
	}
	sc.reviewer = newAuths;

	updateReviewersTable(sc.reviewer);
	updateReviewConfiguration(sc.reviewConfiguration);
	saveStateConfiguration(sc);
}

/**
 * Remove a community from the restriction table.
 * @param href
 * @return
 */
function removeCommunity(href){
	var communityScoping = getCommunityScoping();
    var newCommunities = new Array();
    
    if(communityScoping.communities != null){
    	var oldCommunities = communityScoping.communities;
		var j = 0;
		for (var i in oldCommunities) {
			//Only add it to the new list if does not == href
			if (oldCommunities[i].resource != href) {
				// Wasn't this user or usergroup, so keep it
				newCommunities[j++] = oldCommunities[i];
			}		
		}
		
		communityScoping.communities = newCommunities;
    }
	updateCommunityScopingSection();
}

function updateReviewConfiguration(reviewConfig) {
	
	// show a warning if there are approvers but no approver conditions or if there are
	// approver conditions but no approvers
	var messageElement = dojo.byId('missingReviewConditions');
	
	if(messageElement) {
		var messageHTML = new StringBuffer();
		
		// check the exit conditions for approval rules
		var exitConditionsRequiringApproval = false;
		for(var x in sc.exitCondition) {
			var exitCond = sc.exitCondition[x];
			if(exitCond.rule != null && isReviewRuleDefined(exitCond.rule)) {
				exitConditionsRequiringApproval = true;
				break;
			}
		}
		
		// check the approvers
		var approvers = false;
		if(reviewConfig && reviewConfig !== null) {
			var showMissingReviewConditions = false;
			for (var x in sc.reviewer) {
				if(sc.reviewer[x].canVote) {
					approvers = true;
					break;
				}
			}
		}
		
		if(approvers && !exitConditionsRequiringApproval) {
			messageHTML.append("<div class='info'><div class='body'><div class='message'>");
			messageHTML.append(bundle.inlineHelpNoCollaboratorConditions);
			messageHTML.append("</div></div></div>");
		}
		
		if(exitConditionsRequiringApproval && !approvers) {
			messageHTML.append("<div class='warning'><div class='body'><div class='message'>");
			messageHTML.append(bundle.inlineHelpNoApprovers);
			messageHTML.append("</div></div></div>");
		}
		
		// check if there are conditions requiring approval, but no approvers
		var showMissingReviewConditions = false;
		
		
		messageElement.innerHTML = messageHTML.toString();;
	}
	
	// voting restart configuration
	var elem = dojo.byId('voting_state_config');
	
	if (elem) {
		var voteHtml = new StringBuffer();
		if (reviewConfig && reviewConfig!== null) {
			if(reviewConfig.inherited) {
				voteHtml.append("<div id=\"voting_restart\" class=\"inherited\">");
			} else {
				voteHtml.append("<div id=\"voting_restart\">");
			}
			voteHtml.append("<label for=\"voting_restart_select\"");
			voteHtml.append(">");
			voteHtml.append(bundle.labelRestartReview);
			voteHtml.append("</label>");
			voteHtml.append("<select id=\"voting_restart_select\" style=\"margin-left: 5px\" onchange=\"setVoteReset(this);\"");
			if (isCommunityLifecycle || reviewConfig.inherited) {
				voteHtml.append(" disabled=\true\"");
			}
			voteHtml.append(">");
			voteHtml.append("<option value=\"never\">");
			voteHtml.append(bundle.optionEventNever);
			voteHtml.append("</option>");
			voteHtml.append("<option value=\"");
			voteHtml.append(EVENT_TYPE_ASSET_SAVE);
			voteHtml.append("\"");
			if (reviewConfig.voteResetOn && reviewConfig.voteResetOn==EVENT_TYPE_ASSET_SAVE) {
				voteHtml.append(" selected");
			}
			voteHtml.append(">");
			voteHtml.append(bundle.optionEventAssetSave);
			voteHtml.append("</option>");
			voteHtml.append("</select>");
			if(reviewConfig.inherited) {
				voteHtml.append(INHERITED_TEXT);
			}
			voteHtml.append("</div>");
		}
		
		elem.innerHTML = voteHtml.toString();
	}
}

function setVoteReset(component) {
	if (component.value == EVENT_TYPE_ASSET_SAVE) {
		sc.reviewConfiguration.voteResetOn = EVENT_TYPE_ASSET_SAVE;
	} else {
		sc.reviewConfiguration.voteResetOn = null;
	}
	
	saveStateConfiguration(sc);
}

function setPrivateCollaboration(component) {
	sc.privateCollaboration = new BooleanProperty();
	sc.privateCollaboration.value = component.checked;
	saveStateConfiguration(sc);
}


function event_setScope(value) {
	dojo.byId("scope_users").value = value;
	
	dijit.byId("menu_item_u").attr("iconClass", "");
	dijit.byId("menu_item_ug").attr("iconClass", "");
	if (dijit.byId("menu_item_r")) {
		dijit.byId("menu_item_r").attr("iconClass", "");
	}
	
	switch (value) {
		case 0:
			dijit.byId("menu_item_u").attr("iconClass", "dijitEditorIcon bullet");
			break;
		case 1:
			dijit.byId("menu_item_ug").attr("iconClass", "dijitEditorIcon bullet");
			break;
		case 2:
			dijit.byId("menu_item_r").attr("iconClass", "dijitEditorIcon bullet");
			break;
	}
	
}

function showAddCommunityDialog() {
	var udlg = new StringBuffer();
	udlg.append("<div>");
	udlg.append("<table id=\"showAddCommunityDialogTable\" class=\"searchForm\" cellpadding=\"3\" cellspacing=\"0\" width=\"525\"><tbody><tr><td class=\"searchInput\"><tbody><tr><td>");
	udlg.append("<input id=\"communitySearchInput\" value=\"\" style=\"width: 450px; margin-right: 3px;\" title=\"");
	udlg.append(bundle.altSearchInputTitle);
	udlg.append("\" type=\"text\"><input onclick=\"searchCommunities(dojo.byId('communitySearchInput').value, 'addCommunityResults');\" class=\"commandExButton\" type=\"button\" value=\"");
	udlg.append(bundle.buttonSearch);
	udlg.append("\" \>");
	udlg.append("</td></tr></tbody></table>");
	udlg.append("</div>");
	udlg.append("<div id=\"addCommunityResults\">");
	udlg.append("<select id=\"communitiySelect\" size=\"15\" multiple=\"\" class=\"result\"></select>");
	udlg.append("</div>");
	udlg.append("<div class=\"dialogActionGroup\">");
	udlg.append("<input type=\"button\" id=\"add_community_button\" class=\"commandExButton_disabled\" disabled=\"disabled\" ");
	udlg.append("onclick=\"addSelectedCommunity(document.getElementById('communitiySelect'));resizeEditor();dijit.byId('adCommunityDialog').hide();\" value=\"");
	udlg.append(bundle.buttonAdd);
	udlg.append("\" />");
	udlg.append("<input type=\"button\" id=\"add_community_dialog_cancel_button\" class=\"commandExButton\" onclick=\"dijit.byId('adCommunityDialog').hide();\" value=\"");
	udlg.append(bundle.buttonCancel);
	udlg.append("\" />");
	udlg.append("</div>");
	
	//Launch the dialog
	var dialogTitle = bundle.dialogTitleAddCommunityRestriction;
	createDialog("adCommunityDialog", dialogTitle, udlg.toString(), true, "communitySearchDialog", 'aclc0106');
	
	//Default populate 
	searchCommunities('*', 'addCommunityResults');
	
	setTimeout("dojo.byId('communitySearchInput').focus()",100); // Hack to focus the input field
}

function searchCommunities(text, resultId) {
	
	var resourceURL = getAbsoluteUrl(COMMUNITIES_URL);

	dojo.xhrGet({
		url: resourceURL,
		handleAs: "json",
		headers: {"Accept": "application/json"},
		content: {q: text},
		
		// The LOAD function will be called on a successful response.
		load: function(response, ioArgs) {
			var sug = response;
			debug(response);
			var select =  "<select id=\"communitiySelect\" size=\"15\" multiple=\"\" class=\"result\" onchange=\"document.getElementById('add_community_button').className='commandExButton'; document.getElementById('add_community_button').disabled=false;\">";
			for (var i in sug) {
				select += "<option value=\""+sug[i].href+"\">"+sug[i].name+"</option>";
			}
			select += "</select>";
			var resultElement = dojo.byId(resultId);
			resultElement.innerHTML = select;
			return response;
		},
		
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}

/**
 * Adds a selected community to the list of restrict communities
 */
function addSelectedCommunity(selectBox) { 
	var v1 = selectBox.value; // the next line of code doesn't work without calling this first, very bizarre.
	
	//Iterate over selected options
	for(i=0; i<selectBox.options.length; i++) {
		if(selectBox.options[i].selected){
			var ref = new ResourceRef();
			ref.resource = selectBox.options[i].value;
			ref.value = selectBox.options[i].text;
			
			var comScoping = getCommunityScoping();
			//If null initalize the community list array
			if(comScoping.communities == null){
				comScoping.communities = new Array();
			}
			
			//Add community to the end of the list
			comScoping.communities[comScoping.communities.length] = ref;
		}
	}
	
	updateCommunityScopingSection();
}

function showAddCollaboratorDialog(roleId) {
	var udlg = new StringBuffer();
	udlg.append("<div>");
	udlg.append("<table class=\"searchForm\" cellpadding=\"3\" cellspacing=\"0\" width=\"525\"><tbody><tr><td class=\"searchInput\">");
	udlg.append("<div style=\"display: none;\">");
	udlg.append("<input type=\"text\" id=\"scope_users\" value=\"0\" />");
	udlg.append("</div>");
	if(!isMasterLifecycle || dojo.byId("mainForm:searchLDAP").value=="true") {
		udlg.append("<div dojoType=\"dijit.form.DropDownButton\" iconClass=\"scopeIcon\" showLabel=\"false\"><span>");
		udlg.append(bundle.altSearchScope);
		udlg.append("</span><div dojoType=\"dijit.Menu\" id=\"user_search_scope\">");
		udlg.append("<div dojoType=\"dijit.MenuItem\" label=\"");
		udlg.append(bundle.menuItemUsers);
		udlg.append("\" onclick=\"event_setScope(0, this);\" iconClass=\"dijitEditorIcon bullet\" id=\"menu_item_u\"></div>");
		if(!isMasterLifecycle) {
			udlg.append("<div dojoType=\"dijit.MenuItem\" label=\"");
			udlg.append(bundle.menuItemUserGroups);
			udlg.append("\" onclick=\"event_setScope(1, this);\" id=\"menu_item_ug\"></div>");
		}
		if (dojo.byId("mainForm:searchLDAP").value=="true") {
			udlg.append("<div dojoType=\"dijit.MenuItem\" label=\"");
			udlg.append(bundle.menuItemCompanyRegistry);
			udlg.append("\" onclick=\"event_setScope(2);\" id=\"menu_item_r\"></div>");
		}
		udlg.append("</div></div>");
	}
	udlg.append("<input id=\"userSearchInput\" onkeydown=\"if(event.keyCode==13) {searchCollaborators(dojo.byId('userSearchInput'), dojo.byId('scope_users'), 'results', event);return false;}\" value=\"\" style=\"width: 250px; margin-right: 3px;\" title=\"");
	udlg.append(bundle.altSearchInputTitle);
	udlg.append("\" type=\"text\"><input onclick=\"searchCollaborators(dojo.byId('userSearchInput'), dojo.byId('scope_users'), 'results', event);\" class=\"commandExButton\" type=\"button\" value=\"");
	udlg.append(bundle.buttonSearch);
	udlg.append("\" \>");
	udlg.append("</td></tr></tbody></table>");
	udlg.append("</div>");
	udlg.append("<div id=\"results\">");
	udlg.append("<select id=\"userSelect\" size=\"15\" multiple=\"\" class=\"result\"></select>");
	udlg.append("</div>");
	udlg.append("<div class=\"dialogActionGroup\">");
	udlg.append("<input type=\"button\" id=\"add_users_button\" class=\"commandExButton_disabled\" disabled=\"disabled\" onclick=\"addSelectedAuthorization('");
	udlg.append(roleId);
	udlg.append("', document.getElementById('userSelect'), dojo.byId('scope_users').value);resizeEditor();dijit.byId('addUserDialog').hide();\" value=\"");
	udlg.append(bundle.buttonAdd);
	udlg.append("\" />");
	udlg.append("<input type=\"button\" id=\"add_users_dialog_cancel_button\" class=\"commandExButton\" onclick=\"dijit.byId('addUserDialog').hide();\" value=\"");
	udlg.append(bundle.buttonCancel);
	udlg.append("\" />");
	udlg.append("</div>");
	
	var dialogTitle;
	if (roleId==ROLE_REVIEW_BOARD) {
		dialogTitle = bundle.dialogTitleAddReviewBoard;
	} else {
		dialogTitle = bundle.dialogTitleAddCollaborators;
	}
	
	createDialog("addUserDialog", dialogTitle, udlg.toString(), true, "userSearchDialog", 'aclc0135');
	
	setTimeout("dojo.byId('userSearchInput').focus()",100); // Hack to focus the input field
}

function searchCollaborators(field, searchScope, resultId, event) {
	var text = field.value;
	
	switch ((searchScope.value*1)) {
		case 0:
			searchUsers(text, false, resultId);
			break;
		case 1:
			searchUserGroups(text, resultId);
			break;
		case 2:
			searchUsers(text, true, resultId);
			break;
	}
}

function searchUsers(text, searchLdap, resultId) {
	dojo.xhrGet({
		url: getAbsoluteUrl(USER_SERVLET_URL),
		handleAs: "json",
		headers: {"Accept": "application/json"},
		content: {q: text, unreg: searchLdap},
		
		// The LOAD function will be called on a successful response.
		load: function(response, ioArgs) {
			var sug = response;
			debug(response);
			var select =  "<select id=\"userSelect\" size=\"15\" multiple=\"\" class=\"result\" onchange=\"document.getElementById('add_users_button').className='commandExButton'; document.getElementById('add_users_button').disabled=false;\">";
			for (var i in sug) {
				select += "<option value=\""+sug[i].identifier+"\">"+sug[i].name+"</option>";
			}
			select += "</select>";
			var resultElement = dojo.byId(resultId);
			resultElement.innerHTML = select;
			return response;
		},
		
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}

function getMasterLifecycle(rpid, dupid) {
	if (!rpid) {
		rpid = getUrlParameter("rpid");
	}
	if (!dupid) {
		dupid = getUrlParameter("dupid");
	}
	
	var comLc;
	if (dupid && dupid!=null && dupid!="") {
		dojo.xhrGet({
			url: getEncodedAbsoluteUrl(MASTER_LIFECYLE_URL+"/"+dupid+".json"),
			handleAs: "json",
			headers: {"Accept": "application/json"},
			sync: true,
			load: function(response, ioArgs) {
				comLc = response;
				comLc.identifier = DUMMY_LIFECYCLE_IDENTIFIER;
			},
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	} else if (!rpid || rpid==null || rpid=="" || rpid.indexOf("/") != -1 || rpid.indexOf("\\") != -1) {
		// New lifecycle case.  Need to get the workflow to use and new up a lifecycle
		var workflowId = dojo.byId("mainForm:workflowId").value;
		dojo.xhrPost({
			url: getAbsoluteUrl(NEW_LIFECYCLE_URL+"?workflowId="+workflowId),
			handleAs: "json",
			headers: {"Accept": "application/json"},
			sync: true,
			load: function(response, ioArgs) {
				comLc = response;
			},
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	} else {
		dojo.xhrGet({
			url: getEncodedAbsoluteUrl(MASTER_LIFECYLE_URL+"/"+rpid+".json"),
			handleAs: "json",
			headers: {"Accept": "application/json"},
			sync: true,
			load: function(response, ioArgs) {
				comLc = response;
			},
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	}
	
	return comLc;
}

function getCommunityLifecycle(gid, rpid, dupid) {
	if (!rpid) {
		rpid = getLifecycleId(); //getUrlParameter("rpid");
	}
	if (!gid) {
		gid = getGID(); //getUrlParameter("gid");
	}
	if (!dupid) {
		dupid = getUrlParameter("dupid");
	}
	
	var comLc;
	if (dupid && dupid!=null && dupid!="") {
		dojo.xhrGet({
			url: getEncodedAbsoluteUrl(COMMUNITIES_URL+"/"+gid+"/lifecycles/"+dupid+".json"),
			handleAs: "json",
			headers: {"Accept": "application/json"},
			sync: true,
			load: function(response, ioArgs) {
				comLc = response;
				comLc.identifier = DUMMY_LIFECYCLE_IDENTIFIER;
			},
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	} else if (!rpid || rpid==null || rpid=="" || rpid.indexOf("/") != -1 || rpid.indexOf("\\") != -1) {
		// New lifecycle case.  Need to get the workflow to use and new up a lifecycle
		var masterId = dojo.byId("mainForm:masterLifecycleId").value;
		dojo.xhrPost({
			url: getAbsoluteUrl(NEW_LIFECYCLE_URL+"?masterLifecycleId="+masterId+"&resourceGroupId="+gid),
			handleAs: "json",
			headers: {"Accept": "application/json"},
			sync: true,
			load: function(response, ioArgs) {
				comLc = response;
			},
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	} else {
		dojo.xhrGet({
			url: getEncodedAbsoluteUrl(COMMUNITIES_URL+"/"+gid+"/lifecycles/"+rpid+".json"),
			handleAs: "json",
			headers: {"Accept": "application/json"},
			sync: true,
			load: function(response, ioArgs) {
				comLc = response;
			},
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	}
	
	return comLc;
}

function getAsset(guid, version) {
	if (!guid) {
		guid = unescape(getUrlParameter("guid"));
	}
	if (!version) {
		version = getUrlParameter("v");
	}
	var asset;
	dojo.xhrGet({
		url: getAbsoluteUrl(ASSET_URL+"/"+guid+"/"+version+".json"),
		handleAs: "json",
		headers: {"Accept": "application/json"},
		sync: true,
		load: function(response, ioArgs) {
			debug(response);
			asset = response;
		},
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
	
	return asset;
}

function getAssetLifecycle(guid, version) {
	if (!guid) {
		guid = unescape(getUrlParameter("guid"));
	}
	if (!version) {
		version = getUrlParameter("v");
	}
	
	var assetLc;
	dojo.xhrGet({
		url: getEncodedAbsoluteUrl(LIFECYLE_URL+"/"+guid+"/"+version+".json"),
		handleAs: "json",
		headers: {"Accept": "application/json"},
		sync: true,
		load: function(response, ioArgs) {
			assetLc = response;
		},
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
	
	return assetLc;
}

function searchUserGroups(text, resultId) {
	var communityId = getCommunityId();
	
	dojo.xhrPost({
		url: getAbsoluteUrl(USER_GROUP_SERVLET_URL),
		handleAs: "json",
		headers: {"Accept": "application/json"},
		content: {communityId: communityId, q: text},
		
		// The LOAD function will be called on a successful response.
		load: function(response, ioArgs) {
			var ugs = response;
			
			var select =  new StringBuffer("<select id=\"userSelect\" size=\"15\" multiple=\"\" class=\"result\" onchange=\"document.getElementById('add_users_button').className='commandExButton'; document.getElementById('add_users_button').disabled=false;\">");
			for (var i in ugs) {
				select.append("<option value=\"");
				select.append(ugs[i].id);
				select.append("\">");
				select.append(ugs[i].name);
				select.append("</option>");
			}
			select.append("</select>");
			dojo.byId(resultId).innerHTML = select.toString();
			
			return response;
		},
		
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}

function getAssetTypes() {
	if (assetTypes=== null) {
		dojo.xhrGet({
			url: getAbsoluteUrl(ASSET_TYPE_URL),
			handleAs: "json",
			headers: {"Accept": "application/json"},
			sync: true,
			content: {gid: getCommunityId()},
			
			// The LOAD function will be called on a successful response.
			load: function(response, ioArgs) {
				assetTypes = response;
				return response;
			},
			
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	}
	
	return assetTypes;
}

function getCategorySchemas(resultId, rule, uris) {	
	dojo.xhrGet({
		url: getAbsoluteUrl(CATEGORY_SCHEMA_URL),
		handleAs: "json",
		headers: {"Accept": "application/json"},
		content: {gid: getCommunityId()},
		
		// The LOAD function will be called on a successful response.
		load: function(response, ioArgs) {
			var schemas = response;
			//var tree = "";
			
			var expand = getImageUrl(IMAGE_EXPAND);
			var collapse = getImageUrl(IMAGE_COLLAPSE);
			var schemaImg = getImageUrl("/theme/images/icons/obj16/category_schema.gif");
			
			// Clear the loading
			dojo.byId(resultId).innerHTML = "";
			
			for (var i=0; i<schemas.length; i++) {
				var tree = new ram.categorytree.CategoryTree({expandImageUrl: expand, collapseImageUrl: collapse, schemaImageUrl: schemaImg});
				tree.setSchema(schemas[i]);
				dojo.byId(resultId).appendChild(tree.domNode); 
				tree.startup();
				
				if(uris && uris.length > 0) {
					for(var j=0; j<uris.length; j++) {
						if(uris[j].substring(0, uris[j].indexOf('#')) == schemas[i].uri) {
							if(!tree.loaded) {
								tree._getCategories();
								tree.loaded = true;
							}
							selectSchemaNode(dojo.byId(uris[j]+"_image"));
						}
					}
				}
			}
			CategorizeTree_attachListener('mainForm');
			// expand to show the selection
			for(var j=0; j<uris.length; j++) {
				CategorizeTree_expand(dojo.byId(uris[j]+"_image"));
			}
			return response;
		},
		
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}

function selectSchemaNode(element) {
	switch (CategorizeTree_getValue(element)) {
		case RADIO_UNSELECTED:
			CategorizeTree_switchTo(element, RADIO_SELECTED, IMG_RADIO_SELECTED, IMG_RADIO_SELECTED_ALT);
			CategorizeTree_deselectSiblingsAndNephews(element);
			CategorizeTree_selectParents(element);
			return true;
		case CHECKBOX_UNSELECTED:
			CategorizeTree_switchTo(element, CHECKBOX_SELECTED, IMG_CHECKBOX_SELECTED, IMG_CHECKBOX_SELECTED_ALT);
			CategorizeTree_selectParents(element);
			return true;
	}
}

function getPolicyCustomReturnCodes(policyConfigId, sc) {
	// Do some work to return list of possible results for the policy
	debug(policyConfigId);
	
	for (var i in sc.policyConfiguration) {
		if (sc.policyConfiguration[i].identifier == policyConfigId) {
			var policy = getPolicyValue(sc.policyConfiguration[i]);
			return policy.customReturnCode;
		}
	}
}

function getExpandImage() {
	var ei = new StringBuffer("<a href=\"#\" onclick=\"toggleNode(this);\" >");
	ei.append("<img src=\"");
	ei.append(getImageUrl(IMAGE_EXPAND));
	ei.append("\" alt=\"");
	ei.append(bundle.altCollapse);
	ei.append("\" />");
	ei.append("</a>");
	
	return ei.toString();
}

function toggleNode(node) {
	var image;
	var alt;
	if (node.parentNode.className=='collapsed') {
		node.parentNode.className = 'expanded';
		image = getImageUrl(IMAGE_COLLAPSE);
		alt = bundle.altCollapse;
	} else if (node.parentNode.className=='expanded') {
		node.parentNode.className = 'collapsed';
		image = getImageUrl(IMAGE_EXPAND);
		alt = bundle.altExpand;
	}
	var imageNode = node.firstChild;
	while (imageNode.tagName != 'IMG') {
		imageNode = imageNode.nextSibling;
	}
	
	imageNode.src = image;
	imageNode.alt = alt;
}

function getSelectedCategoryURIs() {
	return getSelectedCategoryURIsForElement(document);
}

function getSelectedCategoryURIsForElement(element) {
	var uris = new Array();
	var inputs = element.getElementsByTagName('input');
	var si = 0;
	for (var i in inputs) {
		if (inputs[i].value == 'checkbox_true' || inputs[i].value == 'radio_true') {
			var selectedURI = inputs[i].id;
			uris[si] = selectedURI.substring(0, selectedURI.lastIndexOf("_hidden"));
			si++;
		}
	}
	
	return uris;
}

function showAddPolicyDialog() {
	var policydlg = new StringBuffer();
	policydlg.append( "<div>");
	policydlg.append( 	"<table class=\"searchForm\" cellpadding=\"3\" cellspacing=\"0\" width=\"540\"><tbody><tr><td class=\"searchInput\">");
	policydlg.append(		"<input type=\"text\" value=\"\" style=\"width: 250px; margin-right: 3px;\" onkeyup=\"searchPolicies(this, 'policyResults', event);\" />");
	policydlg.append( 	"</td></tr></tbody></table>");
	policydlg.append( "</div>");
	policydlg.append( "<div id=\"policyResults\">");
	policydlg.append(	 "<select id=\"policySelect\" size=\"20\" class=\"result\"></select>");
	policydlg.append( "</div>");
	policydlg.append( "<div class=\"dialogActionGroup\">");
	policydlg.append(	"<input id=\"add_policy_button\" type=\"button\" class=\"commandExButton_disabled\" disabled=\"disabled\" onclick=\"addSelectedPolicy(document.getElementById('policySelect'));resizeEditor();dijit.byId('addPolicyDialog').hide();\" value=\"");
	policydlg.append(bundle.buttonAdd);
	policydlg.append( "\" />");
	policydlg.append( 	"<input type=\"button\" class=\"commandExButton\" onclick=\"dijit.byId('addPolicyDialog').hide();\" value=\"");
	policydlg.append(bundle.buttonCancel);
	policydlg.append( "\" />");
	policydlg.append( "</div>");
	createDialog("addPolicyDialog", bundle.dialogTitleAddPolicy, policydlg.toString(), true, "addPolicyDialogDoJo", "aclc0225");
	searchPolicies(null, 'policyResults', null);
}

function showConfigurePolicyDialog(index, policyId, inherited) {
	var config = sc.policyConfiguration[index];
	
	if(getPolicyValue(config).identifier != policyId)
		return;
	
	//refresh the details from a live policy
	var freshPolicy = getValueFromHref(getAbsoluteUrl(config.policy.href));
	var freshDetails = freshPolicy.configurationDetail;
	if(freshDetails == null)
		freshDetails = new Array();
	for (var x in freshDetails) {
		var matchFound = false;
		for (var y in config.configurationDetail) {
			if(freshDetails[x].key == config.configurationDetail[y].key) {
				freshDetails[x].values = config.configurationDetail[y].values;
				matchFound = true;
				break;
			}
		}
		if(!matchFound) {
			freshDetails[x].values = freshDetails[x].defaultValues;
		}
	}
	config.configurationDetail = freshDetails;
	
	var configdlg = new StringBuffer();
	configdlg.append("<table class=\"displayTable\" border=\"0\">");
	
	// add the configuration display name field
	configdlg.append("<tr style=\"vertical-align:top\"><td style=\"width:40%;\">");
	configdlg.append(bundle.labelPolicyDisplayName );
	configdlg.append("&nbsp;");
	configdlg.append(createInfopopHtml('policyDisplayName', 'inlineInfopop', '/theme/images/icons/obj16/info_indicator.gif'));
	configdlg.append("</td><td style=\"width:60%;\">");
	configdlg.append("<input id=\"config_display_name\" style=\"width:100%;\" value=\"");
	configdlg.append(config.name);
	if(inherited){
		configdlg.append("\" disabled=\"disabled");
	}
	configdlg.append("\"/>");
	configdlg.append("</td></tr>");
	
	// add all of the configuration details
	for (var i in config.configurationDetail) {
		configdlg.append("<tr style=\"vertical-align:top\"><td style=\"width:40%;\">");
		configdlg.append(config.configurationDetail[i].label);
		configdlg.append("&nbsp;");
		configdlg.append(createInfopopHtml('policyConfig'+i, 'inlineInfopop', '/theme/images/icons/obj16/info_indicator.gif'));
		configdlg.append("</td><td style=\"width:60%;\">");
		if("CHECKBOX" == config.configurationDetail[i].type) {
			if(config.configurationDetail[i].values[0] == "true") {
				configdlg.append("<input id=\"config_");
				configdlg.append(config.configurationDetail[i].key);
				if(inherited){
					configdlg.append("\" disabled=\"disabled");
				}
				configdlg.append("\" type=\"checkbox\" class=\"checkboxText\" checked=\"\"/>");
			} else {
				configdlg.append("<input id=\"config_");
				configdlg.append(config.configurationDetail[i].key);
				if(inherited){
					configdlg.append("\" disabled=\"disabled");
				}
				configdlg.append("\" type=\"checkbox\" class=\"checkboxText\"/>");
			}
		} else if("COMBOBOX" == config.configurationDetail[i].type) {
			configdlg.append("<select id=\"config_");
			configdlg.append(config.configurationDetail[i].key);
			if(inherited){
				configdlg.append("\" disabled=\"disabled");
			}
			configdlg.append("\" class=\"result\">");
			for (var j in config.configurationDetail[i].option) {
				var matches = false;
				for (var k in config.configurationDetail[i].values) {
					if(config.configurationDetail[i].option[j].value == config.configurationDetail[i].values[k]) {
						matches = true;
						break;
					}
				}
				if(matches) {
					configdlg.append("<option selected=\"yes\" value=\"");
					configdlg.append(config.configurationDetail[i].option[j].value);
					configdlg.append("\">");
					configdlg.append(config.configurationDetail[i].option[j].name);
					configdlg.append("</option>");
				} else {
					configdlg.append("<option value=\"");
					configdlg.append(config.configurationDetail[i].option[j].value);
					configdlg.append("\">");
					configdlg.append(config.configurationDetail[i].option[j].name);
					configdlg.append("</option>");
				}
			}
			configdlg.append("</select>");
		} else if("LISTBOX" == config.configurationDetail[i].type) {
			configdlg.append("<select id=\"config_");
			configdlg.append(config.configurationDetail[i].key);
			if(inherited){
				configdlg.append("\" disabled=\"disabled");
			}
			configdlg.append("\" size=\"4\" class=\"result\" multiple=\"multiple\">");
			for (var j in config.configurationDetail[i].option) {
				var matches = false;
				for (var k in config.configurationDetail[i].values) {
					if(config.configurationDetail[i].option[j].value == config.configurationDetail[i].values[k]) {
						matches = true;
						break;
					}
				}
				if(matches) {
					configdlg.append("<option selected=\"yes\" value=\"");
					configdlg.append(config.configurationDetail[i].option[j].value);
					configdlg.append("\">");
					configdlg.append(config.configurationDetail[i].option[j].name);
					configdlg.append("</option>");
				} else {
					configdlg.append("<option value=\"");
					configdlg.append(config.configurationDetail[i].option[j].value);
					configdlg.append("\">");
					configdlg.append(config.configurationDetail[i].option[j].name);
					configdlg.append("</option>");
				}
			}
			configdlg.append("</select>");
		} else if("RELATIONSHIP" == config.configurationDetail[i].type) {
			configdlg.append("<select id=\"config_");
			configdlg.append(config.configurationDetail[i].key);
			if(inherited){
				configdlg.append("\" disabled=\"disabled");
			}
			configdlg.append("\" size=\"4\" class=\"result\" multiple=\"multiple\">");
			for (var j in config.configurationDetail[i].option) {
				var matches = false;
				for (var k in config.configurationDetail[i].values) {
					if(config.configurationDetail[i].option[j].value == config.configurationDetail[i].values[k]) {
						matches = true;
						break;
					}
				}
				if(matches) {
					configdlg.append("<option selected=\"yes\" value=\"");
					configdlg.append(config.configurationDetail[i].option[j].value);
					configdlg.append("\">");
					configdlg.append(config.configurationDetail[i].option[j].name);
					configdlg.append("</option>");
				} else {
					configdlg.append("<option value=\"");
					configdlg.append(config.configurationDetail[i].option[j].value);
					configdlg.append("\">");
					configdlg.append(config.configurationDetail[i].option[j].name);
					configdlg.append("</option>");
				}
			}
			configdlg.append("</select>");
		} else if("CATEGORY" == config.configurationDetail[i].type) { 
			//TODO how do I disable
			configdlg.append("<div id=\"config_");
			configdlg.append(config.configurationDetail[i].key);
			configdlg.append("\" class=\"categoryTreeContainer\" style=\"margin-right:0px;height:250px;\">");
			configdlg.append(bundle.textLoadingSchemas);
			configdlg.append("</div>");
		} else if("TEXTAREA" == config.configurationDetail[i].type) { 
			configdlg.append("<textarea id=\"config_");
			configdlg.append(config.configurationDetail[i].key);
			if(inherited){
				configdlg.append("\" disabled=\"disabled");
			}
			configdlg.append("\" style=\"width:100%;\" rows=10>"); 
		
			// provide a value if there is one
			if(config.configurationDetail[i].values) {
				configdlg.append(config.configurationDetail[i].values[0]);
				configdlg.append( "</textarea>");
			} else {
				configdlg.append("</textarea>");
			}
		} else {
			configdlg.append("<input id=\"config_");
			configdlg.append(config.configurationDetail[i].key);
			if(inherited){
				configdlg.append("\" disabled=\"disabled");
			}
			configdlg.append("\" style=\"width:100%;\"");
			
			// decide if its a password field or not
			if(config.configurationDetail[i].password)
				configdlg.append(" type=\"password\"");
			else
				configdlg.append(" type=\"text\"");
			
			// provide a value if there is one
			if(config.configurationDetail[i].values) {
				configdlg.append(" value=\"");
				configdlg.append(config.configurationDetail[i].values[0]);
				configdlg.append("\"/>");
			} else {
				configdlg.append(" value=\"\"/>");
			}
		}
		configdlg.append("</td></tr>");
	}
	
	configdlg.append("</table>");
	configdlg.append("<div class=\"dialogActionGroup\">");
	configdlg.append("<input type=\"button\" class=\"commandExButton\" onclick=\"configureSelectedPolicy('");
	configdlg.append(index);
	configdlg.append("');dijit.byId('configPolicyDialog').hide();\" value=\"");
	configdlg.append(bundle.buttonOk);
	configdlg.append("\" />");
	configdlg.append(	"<input type=\"button\" class=\"commandExButton\" onclick=\"dijit.byId('configPolicyDialog').hide();\" value=\"");
	configdlg.append(bundle.buttonCancel);
	configdlg.append("\" />");
	configdlg.append("</div>");
	createDialog("configPolicyDialog", bundle.dialogTitleConfigurePolicy + " - " + freshPolicy.name, configdlg.toString(), true, "configPolicyDialogDoJo");
	
	// after creating the dialog, create the infopops and categorizations for any of the policies
	createPopup('policyDisplayName', null, bundle.inlineHelpPolicyDisplayName, true);
	for (var j in config.configurationDetail) {
		createPopup('policyConfig'+j, null, config.configurationDetail[j].description, true);
		if("CATEGORY" == config.configurationDetail[j].type) {
			getCategorySchemas("config_"+config.configurationDetail[j].key, "categorySchemas", config.configurationDetail[j].values);
		}
	}
	
}

function configureSelectedPolicy(index) {
	var config = sc.policyConfiguration[index];
	
	// assign the display name to this PolicyConfiguration
	var input = dojo.byId("config_display_name");
	if(input.value && input.value != "") {
		var originalPolicyName = input.value;
		var policyName = originalPolicyName;
		var count = 1;
		for (var configCount = 0; configCount < sc.policyConfiguration.length; configCount++) {
			if (index == configCount) {
				continue;
			}
			if (sc.policyConfiguration[configCount].name == policyName) {
				policyName = originalPolicyName + " (" + count + ")";
				configCount = 0;
				count++;
			}
		}
		config.name = policyName;
	}

	// assign the configurationDetails values
	for (var i in config.configurationDetail) {
		config.configurationDetail[i].values = new Array();
	
		if("CHECKBOX" == config.configurationDetail[i].type && dojo.byId("config_"+config.configurationDetail[i].key).checked) {
			config.configurationDetail[i].values[0] = "true";
		} else if("COMBOBOX" == config.configurationDetail[i].type) {
			var comboElement = dojo.byId("config_"+config.configurationDetail[i].key);
			config.configurationDetail[i].values[0] = comboElement.options[comboElement.options.selectedIndex].value;
		} else if("LISTBOX" == config.configurationDetail[i].type || "RELATIONSHIP" == config.configurationDetail[i].type) {
			var listElement = dojo.byId("config_"+config.configurationDetail[i].key);
			for (var j=0; j<listElement.options.length; j++) {
				if(listElement.options[j].selected==true) {
					config.configurationDetail[i].values[config.configurationDetail[i].values.length] = listElement.options[j].value;
				}
			}
		} else if("CATEGORY" == config.configurationDetail[i].type) {
			var categoryElement = dojo.byId("config_"+config.configurationDetail[i].key);
			var selectedCategories = getSelectedCategoryURIsForElement(categoryElement);
			for (var j=0; j<selectedCategories.length; j++) {
				config.configurationDetail[i].values[config.configurationDetail[i].values.length] = selectedCategories[j];
			}
		} else {
			config.configurationDetail[i].values[0] = dojo.byId("config_"+config.configurationDetail[i].key).value;
		}
	}
	
	saveStateConfiguration(sc);
	updatePolicyConfigurations(sc.policyConfiguration);
}

function searchPolicies(field, resultId, event) {
	var text;
	if(!field || field===null)
		text = "";
	else
		text = field.value;
	
	dojo.xhrGet({
		url: getAbsoluteUrl('internal/service/PolicyService.searchPolicies'),
		handleAs: "json",
		headers: {"Accept": "application/json"},
		content: {q: text},
		
		// The LOAD function will be called on a successful response.
		load: function(response, ioArgs) {
			var policies = response;
			debug(response);
			var select = new StringBuffer("<select id=\"policySelect\" size=\"20\" class=\"result\" onchange=\"document.getElementById('add_policy_button').className='commandExButton'; document.getElementById('add_policy_button').disabled=false;\">");
			for (var i in policies) {
				select.append("<option value=\"");
				select.append(escape(dojo.toJson(policies[i])));
				select.append("\">");
				select.append(policies[i].governor.title.content[0]);
				select.append(" > ");
				select.append(policies[i].name);
				select.append("</option>");
			}
			select.append("</select>");
			dojo.byId(resultId).innerHTML = select.toString();
			return response;
		},
		
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			return response;
		}
	});
}

function addSelectedPolicy(selectBox) { 
	selectBox.value; // the next line of code doesn't work without calling this first, very bizarre.
	var policy = dojo.fromJson(unescape(selectBox.options[selectBox.selectedIndex].value));
	addPolicy(policy);
}

function addPolicy(policy) {
	debug(sc);
	var policyConfigurations = sc.policyConfiguration;
	if (policyConfigurations === null) {
		policyConfigurations = new Array();
	}
	
	var originalPolicyName = policy.governor.title.content[0] + " > " + policy.name;
	var policyName = originalPolicyName;
	var count = 1;
	for (var i = 0; i < policyConfigurations.length; i++) {
		if (policyConfigurations[i].name == policyName) {
			policyName = originalPolicyName + " (" + count + ")";
			i = 0;
			count ++;
		}
	}

	var policyConfiguration;
	var xhrArgs = {
		url: getAbsoluteUrl('internal/service/PolicyService.createPolicyConfig?policyId=' + policy.identifier + '&governorId=' + getLastURLSegment(policy.governor.href)),
		handleAs: 'json',
		headers: {"Accept": "application/json"},
		sync: true,
		load: function(response) {
			policyConfiguration = response;
		}
	};
	dojo.xhrGet(xhrArgs);
	if (policyConfiguration) {
		// set the name to the unique name calculated above
		policyConfiguration.name = policyName;
		
		// add the policy configuration to the list
		policyConfigurations[policyConfigurations.length] = policyConfiguration;
		debug(policyConfigurations);
		
		sc.policyConfiguration = policyConfigurations;

		updatePolicyConfigurations(sc.policyConfiguration);
		saveStateConfiguration(sc);
	}
}

function updatePolicyConfigurations(policyConfigurations) {
	var configs = dojo.byId("state_buttons_bar_policy");
	var elem = dojo.byId("policy_state_config");
	
	var policiesButton = dojo.byId("addPoliciesButton");
	
	var plcyHtml = new StringBuffer();
	if (!policyConfigurations || policyConfigurations=== null || policyConfigurations.length==0) {
		if (!policiesButton && !isCommunityLifecycle && (!isAssetLifecycle || canEdit)) {
			var button = document.createElement("input");
			
			var id = document.createAttribute("id");
			id.nodeValue = "addPoliciesButton";
			button.setAttributeNode(id);
			
			var type = document.createAttribute("type");
			type.nodeValue = "button";
			button.setAttributeNode(type);
	
			var value = document.createAttribute("value");
			value.nodeValue = bundle.buttonAddPolicies;
			button.setAttributeNode(value);
			
			button.onclick = function(){showAddPolicyDialog();};
			
			var classAttr = document.createAttribute("class");
			classAttr.nodeValue = "commandExButton";
			button.setAttributeNode(classAttr);
			
			configs.appendChild(button);
		}
		hide(elem);
	} else {
		if (policiesButton) {
			configs.removeChild(policiesButton);
		}
		
//		// show a warning if there are policies but no conditions
//		var showMissingPolicyConditions = true;
//		// at least one policy, need to check exit conditions
//		for (var x in sc.exitCondition) {
//			var exitCond = sc.exitCondition[x];
//			//Rule could be null if there are no conditions defined on the transition
//			if(exitCond.rule != null && isPolicyRuleDefined(exitCond.rule)) {
//				showMissingPolicyConditions = false;
//				break;
//			}
//		}
//		
//		if(showMissingPolicyConditions) {
//			plcyHtml.append("<span id='missingPolicyConditions'><div class='info'><div class='body'><div class='message'>");
//			plcyHtml.append(bundle.inlineHelpNoPolicyConditions);
//			plcyHtml.append("</div></div></div></span>");
//		}
		
		plcyHtml.append("<div class=\"primarySectionHeader\">");
		plcyHtml.append("<h2>");
		plcyHtml.append("<span id=\"policyHeaderText\" class=\"jazz-app-ua-TextHoverHelp\">");
		plcyHtml.append(bundle.sectionHeaderPolicies);
		plcyHtml.append("</span>");
		plcyHtml.append("</h2></div>");
		
		plcyHtml.append("<div class=\"primarySectionContent\">");
		
		plcyHtml.append("<table class=\"displayTable\" border=\"0\"><thead></thead><tbody>");
	
		for (var i in policyConfigurations) {
			if (policyConfigurations[i].policy !== null) {
				var policy = getPolicyValue(policyConfigurations[i]);
				if(!policy || policy === null) {
					// can't find the policy. hide the configuration and display a warning
					if (!policyConfigurations[i].name || policyConfigurations[i].name == "") {
						var governor = policy.governor.value;
						if (!governor) {
							governor = getValueFromHref(policy.governor.href);
						}
						policyConfigurations[i].name = governor.name + " > " + policy.name;
						sc.policyConfiguration = policyConfigurations;
					}
					plcyHtml.append("<tr>");
					plcyHtml.append(getPolicyArrows(i, policyConfigurations.length));
					plcyHtml.append("<td width=\"100%\">");
					plcyHtml.append(policyConfigurations[i].name);
					plcyHtml.append("&nbsp;");
					plcyHtml.append(createInfopopHtml('policyHelp'+i, 'inlineInfopop', '/theme/images/icons/obj16/warning_obj.gif'));
					plcyHtml.append("</td>");
					plcyHtml.append("<td class=\"actionColumn\" nowrap=\"true\"></td>");
					if (!isCommunityLifecycle) {
						plcyHtml.append("<td class=\"actionColumn\" nowrap=\"true\"><a href=\"#\" onclick=\"removePolicy(");
						plcyHtml.append(i);
						plcyHtml.append(", '");
						plcyHtml.append(policyConfigurations[i].identifier);
						plcyHtml.append("')\">");
						plcyHtml.append(bundle.linkRemove);
						plcyHtml.append("</a></td>");
					}
					plcyHtml.append("</tr>");
				} else {
					if (!policyConfigurations[i].name || policyConfigurations[i].name == "") {
						var governor = policy.governor.value;
						if (!governor) {
							governor = getValueFromHref(policy.governor.href);
						}
						policyConfigurations[i].name = governor.name + " > " + policy.name;
						sc.policyConfiguration = policyConfigurations;
					}
					
					//If inherited add a style class
					if(policyConfigurations[i].inherited){
						plcyHtml.append("<tr class=\"inherited\">");
					}
					else{
						plcyHtml.append("<tr>");
					}
					plcyHtml.append(getPolicyArrows(i, policyConfigurations.length));
					plcyHtml.append("<td width=\"100%\">");
					plcyHtml.append(policyConfigurations[i].name);
					plcyHtml.append("&nbsp;");
					plcyHtml.append(createInfopopHtml('policyHelp'+i, 'inlineInfopop', '/theme/images/icons/obj16/info_indicator.gif'));
					if(policyConfigurations[i].inherited){
						plcyHtml.append(INHERITED_TEXT);
					}
					plcyHtml.append("</td>");
					plcyHtml.append("<td class=\"actionColumn\" nowrap=\"true\">");
					
					//If inherited flag does not exist assume false
					var inherited = false;
					if(policyConfigurations[i].inherited){
						inherited = policyConfigurations[i].inherited;
					}
					
					if (!isCommunityLifecycle) {
						plcyHtml.append("<a href=\"#\" onclick=\"showConfigurePolicyDialog(");
						plcyHtml.append(i);
						plcyHtml.append(",'");
						plcyHtml.append(policy.identifier);
						plcyHtml.append("',");
						plcyHtml.append(inherited);
						plcyHtml.append(")\">");
						if(policyConfigurations[i].inherited){
							plcyHtml.append(bundle.linkViewConfiguration);
						}
						else{
							plcyHtml.append(bundle.linkConfigure);
						}
						plcyHtml.append("</a>");
					}
					plcyHtml.append("</td>");
					//If inherited policy configuration or a shown on the read only community page do not show remove link
					if (!policyConfigurations[i].inherited && !isCommunityLifecycle) {
						plcyHtml.append("<td class=\"actionColumn\" nowrap=\"true\"><a href=\"#\" onclick=\"removePolicy(");
						plcyHtml.append(i);
						plcyHtml.append(", '");
						plcyHtml.append(policyConfigurations[i].identifier);
						plcyHtml.append("')\">");
						plcyHtml.append(bundle.linkRemove);
						plcyHtml.append("</a></td>");
					}
					
					//If inherited policy configuration or a shown on the read only community page do not show remove link
					if (isAssetLifecycle) {
						plcyHtml.append("<td class=\"actionColumn\" nowrap=\"true\"><a href=\"#\" onclick=\"showPolicyDialog(");
						plcyHtml.append(i);
						plcyHtml.append(", '");
						plcyHtml.append(policyConfigurations[i].identifier);
						plcyHtml.append("')\">");
						plcyHtml.append(bundle.linkRun);
						plcyHtml.append("</a></td>");
					}
					
					
					plcyHtml.append("</tr>");
					//If inherited add a style class
					if(policyConfigurations[i].inherited){
						plcyHtml.append("<tr class=\"inherited\">");
					}
					else{
						plcyHtml.append("<tr>");
					}
					plcyHtml.append("<td colspan=\"4\"><div>");
					
					if (!isCommunityLifecycle) {
						plcyHtml.append(getPolicyEventCheckboxLabelHtml(i, policy.identifier, EVENT_TYPE_ASSET_SAVE, bundle.eventTypeAssetSave));
						plcyHtml.append(getPolicyEventCheckboxLabelHtml(i, policy.identifier, EVENT_TYPE_ASSET_STATE_CHANGE, bundle.eventTypeStateEntrance));
						plcyHtml.append(getPolicyEventCheckboxLabelHtml(i, policy.identifier, EVENT_TYPE_ACTION, bundle.eventTypeAction));
						plcyHtml.append(getPolicyEventCheckboxLabelHtml(i, policy.identifier, EVENT_TYPE_DELETE, bundle.eventTypeDelete));
						plcyHtml.append(getPolicyEventCheckboxLabelHtml(i, policy.identifier, EVENT_TYPE_TIMER, bundle.eventTypeTimer));						
						plcyHtml.append("<span style=\"margin-left:5px;vertical-align:-4px;\"");
						plcyHtml.append("id=\"");
						plcyHtml.append(i+"_LINK\"");
						plcyHtml.append(">");
						plcyHtml.append("<a href=\"#\"><img onclick=\"createTimerDialog('");
						plcyHtml.append(i);
						plcyHtml.append("','");
						plcyHtml.append(policy.identifier);
						plcyHtml.append("','");
						plcyHtml.append(policyConfigurations[i].inherited);
						plcyHtml.append("');\"");
						plcyHtml.append(" src=\"");
						plcyHtml.append(getImageUrl("\/theme\/images\/icons\/elcl16\/config.gif"));
						plcyHtml.append("\" alt=\"");
						plcyHtml.append(bundle.timerImgTitle);
						plcyHtml.append("\"");
						plcyHtml.append(" title=\"");
						plcyHtml.append(bundle.timerImgTitle);
						plcyHtml.append("\"/></a>");
						plcyHtml.append("</span>");
						plcyHtml.append("</div></div>");
					} else {
						plcyHtml.append("<ul id=\"policyItems\">");
						plcyHtml.append("<li class=\"policyItem checked\" style=\"display: none\" id=\"");
						plcyHtml.append(i);
						plcyHtml.append(policy.identifierplcyHtml.append(EVENT_TYPE_ASSET_SAVE));
						plcyHtml.append("\">");
						plcyHtml.append(bundle.eventTypeAssetSave);
						plcyHtml.append("</li>");
						plcyHtml.append("<li class=\"policyItem checked\" style=\"display: none\" id=\"");
						plcyHtml.append(i);
						plcyHtml.append(policy.identifier);
						plcyHtml.append(EVENT_TYPE_ASSET_STATE_CHANGE);
						plcyHtml.append("\">");
						plcyHtml.append(bundle.eventTypeStateEntrance);
						plcyHtml.append("</li>");
						plcyHtml.append("<li class=\"policyItem checked\" style=\"display: none\" id=\"");
						plcyHtml.append(i);
						plcyHtml.append(policy.identifier);
						plcyHtml.append(EVENT_TYPE_ACTION);
						plcyHtml.append("\">");
						plcyHtml.append(bundle.eventTypeAction);
						plcyHtml.append("</li>");
						plcyHtml.append("<li class=\"policyItem checked\" style=\"display: none\" id=\"");
						plcyHtml.append(i);
						plcyHtml.append(policy.identifier);
						plcyHtml.append(EVENT_TYPE_DELETE);
						plcyHtml.append("\">");
						plcyHtml.append(bundle.eventTypeDelete);
						plcyHtml.append("</li>");
						plcyHtml.append("<li class=\"policyItem checked\" style=\"display: none\" id=\"");
						plcyHtml.append(i);
						plcyHtml.append(policy.identifier);
						plcyHtml.append(EVENT_TYPE_TIMER);
						plcyHtml.append("\">");
						plcyHtml.append(bundle.eventTypeTimer);
						plcyHtml.append("</li>");
						plcyHtml.append("</ul>");
						//plcyHtml.append("<input id=\"timerAmount_"+i+"_"+policy.identifier+"\" style=\"margin-left:5px;text-align:right;\" type=\"text\" size=\"2\" disabled=\"\" onchange=\"policyTimerAmountChanged(this,"+i+",'"+policy.identifier+"');\"");
					}
					plcyHtml.append("</div></td></tr>");
					//If inherited add a style class
					if(policyConfigurations[i].inherited){
						plcyHtml.append("<tr class=\"inherited\">");
					}
					else{
						plcyHtml.append("<tr>");
					}
					plcyHtml.append("<td colspan=\"4\">");
					
					var ecs = getECsWithPolicyRulesDefined(policyConfigurations[i].identifier, sc);
					if(ecs == null){
						plcyHtml.append("<span style=\"margin-left:50px;\" id='missingPolicyConditions_");
						plcyHtml.append(policyConfigurations[i].identifier);
						plcyHtml.append("'><div style=\"margin-left:50px;\" class='info'><div class='body'><div class='message'>");
						plcyHtml.append(bundle.inlineHelpPolicyNotUsed);
						plcyHtml.append("</div></div></div></span>");
					}else{
						plcyHtml.append("<span id='foundPolicyConditions_");
						plcyHtml.append(policyConfigurations[i].identifier);
						plcyHtml.append("'><div style=\"margin-left:50px;\" class='body'>");
						plcyHtml.append(bundle.inlineHelpPolicyUsedIn);
						for(var ecc=0; ecc < ecs.length; ecc++){
							var ec = ecs[ecc];
							plcyHtml.append("<a href=\"#\" onclick=\"loadTransitionById('");
							plcyHtml.append(getLastURLSegment(sc.state.href));
							plcyHtml.append("', '");
							plcyHtml.append(getLastURLSegment(ec.action.href));
							plcyHtml.append("');\">");
							plcyHtml.append(ec.action.title.content[0]);
							plcyHtml.append("</a>");
							
							if(ecc < ecs.length - 1) plcyHtml.append(', ');
						}
						
						//remove the last common
						if(plcyHtml.end)
						
						plcyHtml.append("</div></span>");
					}
					
					plcyHtml.append("</td></tr>");
				}
			}
		}
		
		plcyHtml.append("</tbody></table>");
		
		if (!isCommunityLifecycle && (!isAssetLifecycle || canEdit)) {
			plcyHtml.append("<table cellpadding=\"3\" cellspacing=\"0\" class=\"secondaryActionGroup\"><tr><td>");
			plcyHtml.append("<input onclick=\"showAddPolicyDialog();\" class=\"commandExButton\" type=\"button\" value=\"");
			plcyHtml.append(bundle.buttonAddPolicy);
			plcyHtml.append("\" />");
			plcyHtml.append("</td></tr></table>");
		}
		
		plcyHtml.append("</div>");
		show(elem);
	}
	
	elem.innerHTML = plcyHtml.toString();
	//dojo.parser.parse(dojo.byId('policy_state_config'));
	createPopup('policyHeaderText', 'aclc0220', null, true);
	
	for (var j in policyConfigurations) {
		var currentConfig = policyConfigurations[j];
		var policy = getPolicyValue(currentConfig);
		if (policy && policy !== null) {
			defaultPolicyEvent(j, policy.identifier, EVENT_TYPE_ASSET_SAVE, currentConfig.assetSaveEventConfig != null, policyConfigurations[j].inherited);
			defaultPolicyEvent(j, policy.identifier, EVENT_TYPE_ASSET_STATE_CHANGE, currentConfig.stateEntranceEventConfig != null, policyConfigurations[j].inherited);
			defaultPolicyEvent(j, policy.identifier, EVENT_TYPE_ACTION, currentConfig.actionEventConfig != null, policyConfigurations[j].inherited);
			defaultPolicyEvent(j, policy.identifier, EVENT_TYPE_DELETE, currentConfig.deleteEventConfig != null, policyConfigurations[j].inherited);
			defaultPolicyEvent(j, policy.identifier, EVENT_TYPE_TIMER, currentConfig.timerEventConfig != null, policyConfigurations[j].inherited);
			var imgSrc  = getImageUrl("/theme/images/icons/elcl16/config.gif");
			var enabled = false;
			if(document.getElementById(j + policy.identifier + EVENT_TYPE_TIMER).checked) {
				imgSrc = getImageUrl("/theme/images/icons/elcl16/config.gif");
				enabled = true;
			} else {
			  imgSrc = getImageUrl("/theme/images/icons/dlcl16/config.gif");
			}
			if(policyConfigurations[j].inherited) {
				imgSrc  = getImageUrl("/theme/images/icons/dlcl16/config.gif");
				enabled = true;
			}
			changeConfigImage(j +"_LINK", imgSrc);
			createPopup('policyHelp'+j, null, policy.name + '<br/><br/>' + policy.description, true);
		} else {
			createPopup('policyHelp'+j, null, bundle.missingPolicyWarning , true);
		}
	}
}
		
function changeConfigImage(containerId, imgSrc) {
	var containerStr = '#'+containerId+' img';
	dojo.attr(dojo.query(containerStr)[0], "src", imgSrc);
}
function getPolicyEventCheckboxLabelHtml(index, policyId, eventType, label) {
	var sb = new StringBuffer();
	var id = index + policyId + eventType;
	sb.append("<input style=");
	if(eventType == EVENT_TYPE_TIMER_ATTRIBUTE) {
		sb.append("\"margin-right:2px;margin-left:50px;\" disabled=\"\""); 
	} else {
		sb.append("\"margin-right:2px;margin-left:50px;\"");
	}
	sb.append("type=\"checkbox\" class=\"checkboxText\" onclick=\"toggleEvent(this,");
	sb.append(index);
	sb.append(",'");
	sb.append(policyId);
	sb.append("', '");
	sb.append(eventType);
	sb.append("');\" name=\"");
	sb.append(id);
	sb.append("\" id=\"");
	sb.append(id);
	sb.append("\" /><label for=\"");
	sb.append(id);
	sb.append("\" class=\"checkboxText\" ");
	if(eventType == EVENT_TYPE_TIMER_ATTRIBUTE) {
		sb.append("style=\"margin-right:2px;margin-right:30px;\""); 
	}
	sb.append(">");
	sb.append(label);
	sb.append("</label>");
	
	return sb.toString();
}

function getPolicyArrows(index, size) {
	var arrowHtml = "";
	
	arrowHtml += "<td width=\"18\" class=\"noClass\"><div style=\"overflow: hidden; width: 18px;\"><span style=\"float: left;\">";
	arrowHtml += 	"<span style=\"display: block;\">";
	if(index == 0) {
		arrowHtml +=	"<img src=\""+getImageUrl("/theme/images/icons/dlcl16/moveup.gif")+"\" alt=\"\" />";
	} else {
		arrowHtml +=	"<img src=\""+getImageUrl("/theme/images/icons/elcl16/moveup.gif")+"\" onclick=\"movePolicyUp("+index+")\" alt=\""+bundle.altMoveRowUp+"\" />";
	}
	arrowHtml += 	"</span>";
	arrowHtml += 	"<span style=\"display: block;\">";
	if(index == size - 1) {
		arrowHtml += 	"<img src=\""+getImageUrl("/theme/images/icons/dlcl16/movedown.gif")+"\" alt=\"\" />";
	} else {
		arrowHtml += 	"<img src=\""+getImageUrl("/theme/images/icons/elcl16/movedown.gif")+"\" onclick=\"movePolicyDown("+index+")\" alt=\""+bundle.altMoveRowDown+"\" />";
	}
	arrowHtml += 	"</span>";
	arrowHtml += "</span></div></td>";
	
	return arrowHtml;
}

function movePolicyUp(index) {
	var policyConfigurations = sc.policyConfiguration;
	
	var tempConfig = policyConfigurations[index];
	policyConfigurations[index] = policyConfigurations[index-1];
	policyConfigurations[index-1] = tempConfig;
	
	sc.policyConfiguration = policyConfigurations;
	updatePolicyConfigurations(sc.policyConfiguration);
	saveStateConfiguration(sc);
}

function movePolicyDown(index) {
	var policyConfigurations = sc.policyConfiguration;
	
	var tempConfig = policyConfigurations[index];
	policyConfigurations[index] = policyConfigurations[index+1];
	policyConfigurations[index+1] = tempConfig;
	
	sc.policyConfiguration = policyConfigurations;
	updatePolicyConfigurations(sc.policyConfiguration);
	saveStateConfiguration(sc);
}

function getPolicyValue(policyConfig) {
	var policy = policyConfig.policy.value;
	if (!policy) {
		policy = getValueFromHref(getAbsoluteUrl(policyConfig.policy.href));
	}
	return policy;
}
function defaultPolicyEvent(index, policyId, eventId, checked, inherited) {
	var checkboxElement = document.getElementById(index + policyId + eventId);
	if (checked && isCommunityLifecycle) {
		checkboxElement.style.display = "inline";
	} else {
		//If checked check the checkbox
		if(checked){
			checkboxElement.checked = true;
		}
		//If inherited disable the checkbox
		if(inherited){
			checkboxElement.disabled = true;
		}		
	}
}

function removePoliciesInExitCondition(rule, policyId) {
	if(rule.childRule != null && rule.childRule.length > 0) {
		var updatedChildRules = new Array();
		for(var i in rule.childRule) {
			if(!removePoliciesInExitCondition(rule.childRule[i], policyId)) {
				updatedChildRules.push(rule.childRule[i]);
			}
		}
		rule.childRule = updatedChildRules;
	} else {
		if("POLICY_RESULT" == rule.type && policyId == rule.target && !rule.inherited) {
			return true;
		} else {
			return false;
		}
	}
	return false;
}

function removePolicy(index, policyConfigId) {
	var newPolicyConfigurations = new Array();
	
	for (var i in sc.policyConfiguration) {
		if (!(i == index && sc.policyConfiguration[i].identifier == policyConfigId)) {
			newPolicyConfigurations[newPolicyConfigurations.length] = sc.policyConfiguration[i];
		}
	}
	
	sc.policyConfiguration = newPolicyConfigurations;
	updatePolicyConfigurations(sc.policyConfiguration);
	saveStateConfiguration(sc);
	
	// remove this policy from any exit conditions
	for(var i=0; i<sc.exitCondition.length; i++) {
		removePoliciesInExitCondition(sc.exitCondition[i].rule, policyConfigId);
		updateTransitionConditions(sc.exitCondition[i]);
	}
}
function createTimerDialog(i, policyId, inherited) {
	if (sc.policyConfiguration[i].policy !== null) {
	var policyT = getPolicyValue(sc.policyConfiguration[i]);
	if(policyT || policyT != null) {
	var timerAmount = "";
	var timerUnit = "";
	var timerAttUse = false;
	if(sc.policyConfiguration[i].timerEventConfig != null) {
		if(sc.policyConfiguration[i].timerEventConfig.configurationDetail != null) {
			if(sc.policyConfiguration[i].attributeUsed) timerAttUse = true;
			for(j in sc.policyConfiguration[i].timerEventConfig.configurationDetail) {
				if(sc.policyConfiguration[i].timerEventConfig.configurationDetail[j].key == CONFIG_DETAIL_ID_TIMER_AMOUNT) {
					timerAmount = sc.policyConfiguration[i].timerEventConfig.configurationDetail[j].values[0];
				} else if(sc.policyConfiguration[i].timerEventConfig.configurationDetail[j].key == CONFIG_DETAIL_ID_TIMER_UNIT) {
					timerUnit = sc.policyConfiguration[i].timerEventConfig.configurationDetail[j].values[0];
					
				}
			}
		}
	}	
	var plcyHtmlT = new StringBuffer();
	plcyHtmlT.append("<table class=\"displayTable\" border=\"0\" style=\"padding-bottom:3px;\" id='timerTable_");
	plcyHtmlT.append(i);
	plcyHtmlT.append("'><tr><td>");
	plcyHtmlT.append("<input type=\"radio\" value=\"No\"  class=\"checkboxText\" onclick=\"toggleRadioEvent(this,");
	plcyHtmlT.append(i);
	plcyHtmlT.append(",'");
	plcyHtmlT.append(policyT.identifier);
	plcyHtmlT.append("', '");
	plcyHtmlT.append(EVENT_TYPE_TIMER_ATTRIBUTE);
	plcyHtmlT.append("');\" name=\"");
	plcyHtmlT.append(i + policyT.identifier + EVENT_TYPE_TIMER_ATTRIBUTE);
	plcyHtmlT.append("\" id=\"");
	plcyHtmlT.append(i + policyT.identifier + EVENT_TYPE_TIMER_ATTRIBUTE+"_NO\" ");
	if(!timerAttUse) plcyHtmlT.append(" checked=\"\" ");
	plcyHtmlT.append("/>");
	plcyHtmlT.append("&nbsp;<span class=\"checkboxText\" style=\"padding-top:5px\">");
	plcyHtmlT.append(bundle.no);
	plcyHtmlT.append("</span>");
	plcyHtmlT.append("<div style=\"padding-top:10px\" id=\"div_attr_no_");
	plcyHtmlT.append(i);
	plcyHtmlT.append("_");
	plcyHtmlT.append(policyT.identifier);
	plcyHtmlT.append("\">");
	plcyHtmlT.append("<input  onchange =\"removeRequired();\" id=\"timerAmount_");
	plcyHtmlT.append(i);
	plcyHtmlT.append("_");
	plcyHtmlT.append(policyT.identifier);
	plcyHtmlT.append("\" style=\"margin-left:10px;text-align:right;");
	plcyHtmlT.append("\"");
	plcyHtmlT.append(" type=\"text\" size=\"2\"");		
	if(timerAmount > 0) {
		plcyHtmlT.append("value=\"");
		if(!sc.policyConfiguration[i].attributeUsed) plcyHtmlT.append(timerAmount);
		plcyHtmlT.append("\"/>");
	} else {
		plcyHtmlT.append("value=\"\"/>");
	}
	plcyHtmlT.append("<select  onchange =\"removeRequired();\" id=\"timerUnit_");
	plcyHtmlT.append(i);
	plcyHtmlT.append("_");
	plcyHtmlT.append(policyT.identifier);
	plcyHtmlT.append("\" style=\"margin-left:8px;\"");
	plcyHtmlT.append(">");
/*	plcyHtmlT.append("<option ");
	plcyHtmlT.append("value=");
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.select);
	plcyHtmlT.append("</option>");*/
	plcyHtmlT.append("<option ");
	//if(timerUnit == "" || timerUnit == TIMER_UNIT_DAYS) {
	if(timerUnit == TIMER_UNIT_DAYS && !timerAttUse) {
		plcyHtmlT.append("selected=\"true\" ");
	} 
	plcyHtmlT.append("value=");
	plcyHtmlT.append(TIMER_UNIT_DAYS);
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.timerUnitDays);
	plcyHtmlT.append("</option>");
	plcyHtmlT.append("<option ");
	if(timerUnit == TIMER_UNIT_WEEKS && !timerAttUse) {
		plcyHtmlT.append("selected=\"true\" ");
	}
	plcyHtmlT.append("value=");
	plcyHtmlT.append(TIMER_UNIT_WEEKS);
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.timerUnitWeeks);
	plcyHtmlT.append("</option>");
	plcyHtmlT.append("<option ");
	if(timerUnit == TIMER_UNIT_MONTHS && !timerAttUse) {
		plcyHtmlT.append("selected=\"true\" ");
	}
	plcyHtmlT.append("value=");
	plcyHtmlT.append(TIMER_UNIT_MONTHS);
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.timerUnitMonths);
	plcyHtmlT.append("</option>");
	plcyHtmlT.append("<option ");
	if(timerUnit == TIMER_UNIT_YEARS && !timerAttUse) {
		plcyHtmlT.append("selected=\"true\" ");
	}
	plcyHtmlT.append("value=");
	plcyHtmlT.append(TIMER_UNIT_YEARS);
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.timerUnitYears);
	plcyHtmlT.append("</option></select>");
	plcyHtmlT.append("</div><br/>");
	plcyHtmlT.append("<input type=\"radio\"  value=\"Yes\"  class=\"checkboxText\"  onclick=\"toggleRadioEvent(this,");
	plcyHtmlT.append(i);
	plcyHtmlT.append(",'");
	plcyHtmlT.append(policyT.identifier);
	plcyHtmlT.append("', '");
	plcyHtmlT.append(EVENT_TYPE_TIMER_ATTRIBUTE);
	plcyHtmlT.append("');\" name=\"");
	plcyHtmlT.append(i + policyT.identifier + EVENT_TYPE_TIMER_ATTRIBUTE);
	plcyHtmlT.append("\" id=\"");
	plcyHtmlT.append(i + policyT.identifier + EVENT_TYPE_TIMER_ATTRIBUTE+"_YES\" ");
	if(timerAttUse) plcyHtmlT.append(" checked=\"\" ");
	plcyHtmlT.append("/>");
	plcyHtmlT.append("&nbsp;<span class=\"checkboxText\" style=\"padding-top:5px\">");
	plcyHtmlT.append(bundle.yes);
	plcyHtmlT.append("</span><div style=\"padding-top:10px\" id=\"div_attr_yes_");
	plcyHtmlT.append(i);
	plcyHtmlT.append("_");
	plcyHtmlT.append(policyT.identifier);
	plcyHtmlT.append("\">");
	plcyHtmlT.append("<span  id=\"s_attr_");
	plcyHtmlT.append(i);
	plcyHtmlT.append("_");
	plcyHtmlT.append(policyT.identifier);
	plcyHtmlT.append("\"></span>");
	plcyHtmlT.append("<select  onchange =\"removeRequired();\" id=\"timerUnitAttr_");
	plcyHtmlT.append(i);
	plcyHtmlT.append("_");
	plcyHtmlT.append(policyT.identifier);
	plcyHtmlT.append("\" style=\"margin-left:8px;\"");
	plcyHtmlT.append(">");
/*	plcyHtmlT.append("<option ");
	plcyHtmlT.append("value=");
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.select);
	plcyHtmlT.append("</option>");*/
	plcyHtmlT.append("<option ");
	//if(timerUnit == "" || timerUnit == TIMER_UNIT_DAYS) {
	if(timerUnit == TIMER_UNIT_DAYS && timerAttUse) {
		plcyHtmlT.append("selected=\"true\" ");
	} 
	plcyHtmlT.append("value=");
	plcyHtmlT.append(TIMER_UNIT_DAYS);
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.timerUnitDays);
	plcyHtmlT.append("</option>");
	plcyHtmlT.append("<option ");
	if(timerUnit == TIMER_UNIT_WEEKS && timerAttUse) {
		plcyHtmlT.append("selected=\"true\" ");
	}
	plcyHtmlT.append("value=");
	plcyHtmlT.append(TIMER_UNIT_WEEKS);
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.timerUnitWeeks);
	plcyHtmlT.append("</option>");
	plcyHtmlT.append("<option ");
	if(timerUnit == TIMER_UNIT_MONTHS && timerAttUse) {
		plcyHtmlT.append("selected=\"true\" ");
	}
	plcyHtmlT.append("value=");
	plcyHtmlT.append(TIMER_UNIT_MONTHS);
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.timerUnitMonths);
	plcyHtmlT.append("</option>");
	plcyHtmlT.append("<option ");
	if(timerUnit == TIMER_UNIT_YEARS && timerAttUse) {
		plcyHtmlT.append("selected=\"true\" ");
	}
	plcyHtmlT.append("value=");
	plcyHtmlT.append(TIMER_UNIT_YEARS);
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.timerUnitYears);
	plcyHtmlT.append("</option>");
	/*plcyHtmlT.append("<option ");
	if(timerUnit == TIMER_UNIT_DATE && timerAttUse) {
		plcyHtmlT.append("selected=\"true\" ");
	}
	plcyHtmlT.append("value=");
	plcyHtmlT.append(TIMER_UNIT_DATE);
	plcyHtmlT.append(">");
	plcyHtmlT.append(bundle.timerUnitDate);
	plcyHtmlT.append("</option></select>");*/
	plcyHtmlT.append("</select>");
	plcyHtmlT.append("</div>");
	plcyHtmlT.append("</td></tr></table><div class=\"dialogActionGroup\">");
	plcyHtmlT.append("<input type=\"button\" class=\"commandExButton\" onclick=\"configureSelectedTimer('");
	plcyHtmlT.append(i);
	plcyHtmlT.append("','");
	plcyHtmlT.append(policyT.identifier);
	plcyHtmlT.append("');");
	plcyHtmlT.append("\" value=\"");
	plcyHtmlT.append(bundle.buttonOk);
	plcyHtmlT.append("\" id=\"SUBMIT_");
	plcyHtmlT.append(i);
	plcyHtmlT.append("\"/>");
	plcyHtmlT.append("<input type=\"button\" class=\"commandExButton\" onclick=\"dijit.byId('");
	plcyHtmlT.append(i);
	plcyHtmlT.append("_showTimerDialog').hide();\" value=\"");
	plcyHtmlT.append(bundle.buttonCancel);
	plcyHtmlT.append("\" />");
	plcyHtmlT.append("</div>");
	var timerCheckBoxid = i + policyId + EVENT_TYPE_TIMER;
	var showDialog = true ;
	if(document.getElementById(timerCheckBoxid).checked == false) showDialog = false;
	if(showDialog) {
	createDialog(i+"_showTimerDialog", bundle.timerTitle, plcyHtmlT.toString(), false, i+"_showTimerDialog");
	if(inherited) {
		dojo.style("SUBMIT_"+i, "display", "none");
	} else {
		dojo.style("SUBMIT_"+i, "display", "inline");
	}
	//dojo.style("errorSection_"+i, "display", "none");
	var filterSelectid = "attribute_"+i+"_"+policyId;
	var filterAmount = "";
    if(timerAttUse) filterAmount = timerAmount;
	if (dijit.byId("widget_"+filterSelectid)) {
		dijit.byId("widget_"+filterSelectid).destroy();
	}
    document.getElementById("s_attr_"+i+"_"+policyId).innerHTML="";
    document.getElementById("s_attr_"+i+"_"+policyId).innerHTML="<input id='"+filterSelectid+"'/>";
	 var filteringSelect = new dijit.form.FilteringSelect({
            id: filterSelectid,
            store: newAttrStore,
            autoComplete: true,
            highlightMatch:true,
            //pageSize: 5,
            value: filterAmount,
            placeHolder: bundle.timerSearchAttributesPrompt,
            hasDownArrow: true,
            style:"margin-left:10px;margin-left:10px",
            searchAttr: "name",
            onChange: function(){
            	var currentId= (this.id);
            	var timerId= currentId.replace("attribute","timerUnitAttr");
            	var selectedVal = this.get('value');
            	dojo.style(timerId, "display", "none");
            	removeRequired();
                dojo.forEach(newAttrStore.data, function(item, idx) {
                if(item.id == selectedVal) {
                	if(item.type == "NUMBER") {
                		dojo.style(timerId, "display", "inline");
                		document.getElementById(timerId).selectedIndex = 0;
                	}
                }
               });
          }
    }, filterSelectid);	
	 if(inherited) {
		dojo.query("input,select", dojo.byId("div_attr_no_"+i+"_"+policyId)).attr("disabled", true);
		dojo.query("input,select", dojo.byId("div_attr_yes_"+i+"_"+policyId)).attr("disabled", true);
		dijit.byId(filterSelectid).set('disabled', true);
		dojo.setAttr(i + policyId + EVENT_TYPE_TIMER_ATTRIBUTE+"_YES", "disabled", true);
		dojo.setAttr(i + policyId + EVENT_TYPE_TIMER_ATTRIBUTE+"_NO", "disabled", true);
		if(document.getElementById(i + policyId + EVENT_TYPE_TIMER_ATTRIBUTE+"_YES").checked) {
			if(timerUnit == TIMER_UNIT_DATE) {
				dojo.style("timerUnitAttr_"+i+"_"+policyId, "display", "none");
			} else {
				dojo.style("timerUnitAttr_"+i+"_"+policyId, "display", "inline");
			}
		} else {
			dojo.style("timerUnitAttr_"+i+"_"+policyId, "display", "none");
		}
		
	 } else {
		if(document.getElementById(i + policyId + EVENT_TYPE_TIMER_ATTRIBUTE+"_YES").checked) {
			dojo.query("input,select", dojo.byId("div_attr_no_"+i+"_"+policyId)).attr("disabled", true);
			dojo.query("input,select", dojo.byId("div_attr_yes_"+i+"_"+policyId)).attr("disabled", false);
			dijit.byId(filterSelectid).set('disabled', false);
			if(timerUnit == TIMER_UNIT_DATE) {
				dojo.style("timerUnitAttr_"+i+"_"+policyId, "display", "none");
			} else {
				dojo.style("timerUnitAttr_"+i+"_"+policyId, "display", "inline");
			}
		} else {
			dojo.query("input,select", dojo.byId("div_attr_no_"+i+"_"+policyId)).attr("disabled", false);
			dojo.query("input,select", dojo.byId("div_attr_yes_"+i+"_"+policyId)).attr("disabled", true);
			dijit.byId(filterSelectid).set('disabled', true);
			dojo.style("timerUnitAttr_"+i+"_"+policyId, "display", "none");
		}	
	 }
	dijit.byId(i+'_showTimerDialog').show();
	} else {
	}
			} }
}
function showPolicyDialog(index, policyConfigId) {
	var config = sc.policyConfiguration[index];
	if(config == null)
		return;
	
    var guid = unescape(getUrlParameter("guid"));
    var v = getUrlParameter("v");
    var message = dojo.string.substitute(bundle.runPolicyMessage, {policyName: config.policy.title.content[0]});
    var dlgHtml = new StringBuffer();
    dlgHtml.append("<div>");
    dlgHtml.append("<span style=\"margin-left: 5px;\">")
    dlgHtml.append(message);
    dlgHtml.append("</span>");
    dlgHtml.append("</div>");
    dlgHtml.append("<div class=\"dialogActionGroup\">");
    dlgHtml.append("<input type=\"button\" id=\"run_policy_ok_button\" class=\"commandExButton\"  onclick=\"runPolicy('");
    dlgHtml.append(index);
    dlgHtml.append("','");
    dlgHtml.append(policyConfigId);
    dlgHtml.append("');dijit.byId('showRunPolicyDialog').hide();\" value=\"");
    dlgHtml.append(bundle.buttonOk);
    dlgHtml.append("\" />");
    dlgHtml.append("<input type=\"button\" id=\"run_policy_ok_button\" class=\"commandExButton\" onclick=\"dijit.byId('showRunPolicyDialog').hide();\" value=\"");
    dlgHtml.append(bundle.buttonCancel);
    dlgHtml.append("\" />");
    dlgHtml.append("</div>"); 
    createDialog("showRunPolicyDialog", bundle.runPolicyTitle, dlgHtml.toString(), true, "showRunPolicyDialog"); 
}

function runPolicy(index, policyConfigId) {
	var guid = unescape(getUrlParameter("guid"));
    var v = getUrlParameter("v");
	dojo.xhrGet({
		url: getAbsoluteUrl('internal/service/PolicyService.runPolicy'),
		handleAs: "json",
		headers: {"Accept": "application/json"},
		content: {policyConfigId: policyConfigId, guid: guid, v: v},
		
		// The LOAD function will be called on a successful response.
		load: function(response, ioArgs) {
			window.location.hash = '#loadEditor';
    		window.location.reload();
			return response;
		},
		
		// The ERROR function will be called in an error case.
		error: function(response, ioArgs) {
			console.error("HTTP status code: ", ioArgs.xhr.status);
			alert(response);
			return response;
		}
	});
}

function toggleRadioEvent(input, index, policyId, eventId) {
	removeRequired();
	var policyConfigurations = sc.policyConfiguration;
	if (policyConfigurations === null) {
		policyConfigurations = new Array();
	}
	var filterSelectid = "attribute_"+index+"_"+policyId;
	if(policyConfigurations.length <= index)
		return;
	// if we are removing the event
	if(input.value == "No") {
		if (getPolicyValue(policyConfigurations[index]).identifier == policyId) {
			if (EVENT_TYPE_TIMER_ATTRIBUTE == eventId && document.getElementById(index + policyId + EVENT_TYPE_TIMER).checked) {
				dojo.query("input,select", dojo.byId("div_attr_no_"+index+"_"+policyId)).attr("disabled", false);
				dojo.query("input,select", dojo.byId("div_attr_yes_"+index+"_"+policyId)).attr("disabled", true);
				dijit.byId(filterSelectid).set('disabled', true);
			}
			
		}
	} 
	// if we are adding the event
	else {
		if (getPolicyValue(policyConfigurations[index]).identifier == policyId) {
			if(eventId !== null) {
				if (EVENT_TYPE_TIMER_ATTRIBUTE == eventId && document.getElementById(index + policyId + EVENT_TYPE_TIMER).checked) {
					dojo.query("input,select", dojo.byId("div_attr_no_"+index+"_"+policyId)).attr("disabled", true);
					dojo.query("input,select", dojo.byId("div_attr_yes_"+index+"_"+policyId)).attr("disabled", false);
					dijit.byId(filterSelectid).set('disabled', false);
				}
				
			}
		}
	}
	
	//sc.policyConfiguration = policyConfigurations;
	//saveStateConfiguration(sc);
}

function toggleEvent(input, index, policyId, eventId) {
	var policyConfigurations = sc.policyConfiguration;
	if (policyConfigurations === null) {
		policyConfigurations = new Array();
	}
	
	if(policyConfigurations.length <= index)
		return;
	
	// if we are removing the event
	if(!input.checked) {
		if (getPolicyValue(policyConfigurations[index]).identifier == policyId) {
			if(EVENT_TYPE_ASSET_SAVE == eventId) {
				policyConfigurations[index].assetSaveEventConfig = null;
			} else if(EVENT_TYPE_ASSET_STATE_CHANGE == eventId) {
				policyConfigurations[index].stateEntranceEventConfig = null;
			} else if(EVENT_TYPE_ACTION == eventId) {
				policyConfigurations[index].actionEventConfig = null;				
			} else if(EVENT_TYPE_DELETE == eventId) {
				policyConfigurations[index].deleteEventConfig = null;
			} else if(EVENT_TYPE_TIMER == eventId) {
				policyConfigurations[index].timerEventConfig = null;
				policyConfigurations[index].attributeUsed = false;
			}
			if (EVENT_TYPE_TIMER == eventId) {
				changeConfigImage(index +"_LINK", getImageUrl("/theme/images/icons/dlcl16/config.gif"));
			}
						
		}
	} 
	// if we are adding the event
	else {
		if (getPolicyValue(policyConfigurations[index]).identifier == policyId) {
			if(eventId !== null) {
				if(EVENT_TYPE_ASSET_SAVE == eventId) {
					policyConfigurations[index].assetSaveEventConfig = new EventConfiguration();
				} else if(EVENT_TYPE_ASSET_STATE_CHANGE == eventId) {
					policyConfigurations[index].stateEntranceEventConfig = new EventConfiguration();
				} else if(EVENT_TYPE_ACTION == eventId) {
					policyConfigurations[index].actionEventConfig = new EventConfiguration();				
				} else if(EVENT_TYPE_DELETE == eventId){
					policyConfigurations[index].deleteEventConfig = new EventConfiguration();
				} else if(EVENT_TYPE_TIMER == eventId) {
					policyConfigurations[index].timerEventConfig = new EventConfiguration();
				}
				if (EVENT_TYPE_TIMER == eventId) {
					changeConfigImage(index +"_LINK", getImageUrl("/theme/images/icons/elcl16/config.gif")); 		
				}
			}
		}
	}
	sc.policyConfiguration = policyConfigurations;
	saveStateConfiguration(sc);
}
function removeRequired(){
	var l = dojo.query(".timerError");
	l.forEach(function(node, index, nodeList){
	dojo.empty(node);
	});
}
function checkErrors(type, index, policyId){
	removeRequired();
	var foundError = false;
	var requiredElm = "<span style=\"margin-left:2px;\" class=\"timerError required\">*"+bundle.messageRequiredField+"</span>";
	if(type =="ATT") {
		var _timerUnitAttr = document.getElementById('timerUnitAttr_'+index+'_'+policyId).value;
		var _timerAttr = dijit.byId('attribute_'+index+'_'+policyId).get('value');
		if(_timerUnitAttr == "" && document.getElementById('timerUnitAttr_'+index+'_'+policyId).style.display =="inline") {
			 dojo.place(requiredElm, 'timerUnitAttr_'+index+'_'+policyId,'after'); 
			foundError = true;
		}
		if(_timerAttr == "") {
			dojo.place(requiredElm, 'widget_attribute_'+index+'_'+policyId,'after');
			foundError = true;
		}
	} else {
		var _timerUnit = document.getElementById('timerUnit_'+index+'_'+policyId).value;
		var _timerAmount = document.getElementById('timerAmount_'+index+'_'+policyId).value;
		if(_timerUnit == "") {
			 dojo.place(requiredElm, 'timerUnit_'+index+'_'+policyId,'after'); 
			foundError = true;
		}
		if(_timerAmount == "") {
			dojo.place(requiredElm, 'timerAmount_'+index+'_'+policyId,'after');
			foundError = true;
		}
	}
	return foundError;
}

function configureSelectedTimer(index, policyId) {
	var isError = false;
	if(document.getElementById(index + policyId + EVENT_TYPE_TIMER_ATTRIBUTE+"_YES").checked) {
		//alert("yes");
		isError = checkErrors("ATT", index, policyId);
		if(!isError) {
			if(document.getElementById('timerUnitAttr_'+index+'_'+policyId).style.display =="inline") {
				policyTimerAttrAmountChanged('attribute_numeric', dijit.byId('attribute_'+index+'_'+policyId).get('value'), index, policyId);
			} else {
				policyTimerAttrAmountChanged('attribute_date', dijit.byId('attribute_'+index+'_'+policyId).get('value'), index, policyId);
			}
			 dijit.byId(index+"_showTimerDialog").hide();
		}
	} else {
		//alert("no");
		isError = checkErrors("NOATT", index, policyId);
		if(!isError) {
			 policyTimerUnitChanged(document.getElementById('timerUnit_'+index+'_'+policyId).value, index, policyId);
			 policyTimerAmountChanged(document.getElementById('timerAmount_'+index+'_'+policyId).value, index, policyId, false);
			 dijit.byId(index+"_showTimerDialog").hide();	
		}
	}
	
	//alert("configureSelectedTimer : "+dojo.toJson(sc.policyConfiguration));
	
}

function policyTimerAttrAmountChanged(type, input, index, policyId) {
	if(type == 'attribute_date') {
		policyTimerUnitChanged(TIMER_UNIT_DATE, index, policyId);
	} else {
		policyTimerUnitChanged(document.getElementById('timerUnitAttr_'+index+'_'+policyId).value, index, policyId);
	}
	policyTimerAmountChanged(input, index, policyId, true);
}

function policyTimerAmountChanged(input, index, policyId, isAttribute) {
	var policyConfigurations = sc.policyConfiguration;
	if (policyConfigurations === null) {
		policyConfigurations = new Array();
	}

	// input is valid
	//if(input.value > 0 && policyConfigurations.length > index) {
	//if(input.value.length > 0 && policyConfigurations.length > index) {
	if(input.length > 0 && policyConfigurations.length > index) {
		if (getPolicyValue(policyConfigurations[index]).identifier == policyId) {
			var timerConfig = policyConfigurations[index].timerEventConfig;
			if(timerConfig == null) {
				timerConfig = new EventConfiguration();
			}
			
			var configDetail = new ConfigurationDetail();
			configDetail.key = CONFIG_DETAIL_ID_TIMER_AMOUNT
			configDetail.values = new Array();
			//configDetail.values[0] = input.value;
			configDetail.values[0] = input;
			
			if(timerConfig.configurationDetail == null) {
				timerConfig.configurationDetail = new Array();
				timerConfig.configurationDetail[0] = configDetail;
			} else {
				
				// clean out old values of the key.  See defect 71368.  It was possible for multiple
				// values of the same key to exist
				for(var i=0; i<timerConfig.configurationDetail.length; i++) {
					if(timerConfig.configurationDetail[i].key == CONFIG_DETAIL_ID_TIMER_AMOUNT) {
						timerConfig.configurationDetail.splice(i, 1);
						i--;
					}
				}

				timerConfig.configurationDetail[timerConfig.configurationDetail.length] = configDetail;
			}
			
			policyConfigurations[index].timerEventConfig = timerConfig;
			if(isAttribute){
				policyConfigurations[index].attributeUsed = true;
			} else {
				policyConfigurations[index].attributeUsed = false;
			}
		}
	}
	
	sc.policyConfiguration = policyConfigurations;
	//alert(" policyTimerAmountChanged : "+dojo.toJson(sc.policyConfiguration));
	saveStateConfiguration(sc);
}

function policyTimerUnitChanged(input, index, policyId) {
	var policyConfigurations = sc.policyConfiguration;
	if (policyConfigurations === null) {
		policyConfigurations = new Array();
	}
	
	if(policyConfigurations.length > index) {
		if (getPolicyValue(policyConfigurations[index]).identifier == policyId) {
			var timerConfig = policyConfigurations[index].timerEventConfig;
			if(timerConfig == null) {
				timerConfig = new EventConfiguration();
			}
			
			var configDetail = new ConfigurationDetail();
			configDetail.key = CONFIG_DETAIL_ID_TIMER_UNIT
			configDetail.values = new Array();
			//configDetail.values[0] = input.value;
			configDetail.values[0] = input;
			
			if(timerConfig.configurationDetail == null) {
				timerConfig.configurationDetail = new Array();
				timerConfig.configurationDetail[0] = configDetail;
			} else {
				
				// clean out old values of the key.  See defect 71368.  It was possible for multiple
				// values of the same key to exist
				for(var i=0; i<timerConfig.configurationDetail.length; i++) {
					if(timerConfig.configurationDetail[i].key == CONFIG_DETAIL_ID_TIMER_UNIT) {
						timerConfig.configurationDetail.splice(i, 1);
						i--;
					}
				}
				
				timerConfig.configurationDetail[timerConfig.configurationDetail.length] = configDetail;
				
				policyConfigurations[index].timerEventConfig = timerConfig;
			}
		}		
	}
	
	sc.policyConfiguration = policyConfigurations;
	//alert("policyTimerUnitChanged :"+dojo.toJson(sc.policyConfiguration));
	saveStateConfiguration(sc);
	
}

/*
 * Utilities
 */
function editor_getState(state) {
	var retState = state.value;
	if (!retState) {
		retState = getValueFromHref(getAbsoluteUrl(state.href));
	}
	return retState;
}

function getAction(action) {
	var retAction = action.value;
	if (!retAction) {
		retAction = getValueFromHref(getAbsoluteUrl(action.href));
	}
	return retAction;
}
 
function toggle(section) {
	if (section.style.display=='none') {
		section.style.display = 'block';
	} else {
		section.style.display = 'none';
	}
}

function show(section) {
	section.style.display = 'block';
}

function showInline(section) {
	section.style.display = 'inline';
}

function hide(section) {
	section.style.display = 'none';
}

function getCommunityId() {
	var communityId = getGID();
	if (!communityId || communityId.length==0) {
		// No community id in the URL, maybe we're on the asset page?
		var guid = unescape(getUrlParameter("guid"));
		var version = getUrlParameter("v");
		dojo.xhrGet({
			url: getAbsoluteUrl(ASSET_URL+"/"+guid+"/"+version+".json"),
			handleAs: "json",
			headers: {"Accept": "application/json"},
			sync: true,
			load: function(response, ioArgs) {
				debug(response);
				communityId = response.community.value.identifier;
			},
			// The ERROR function will be called in an error case.
			error: function(response, ioArgs) {
				console.error("HTTP status code: ", ioArgs.xhr.status);
				return response;
			}
		});
	}
	
	return communityId;
}

function createDialog(dialogId, title, content, show, styleClass, helpId) {
	var dialog = dijit.byId(dialogId);
	if (!dialog) {
		if (styleClass) {
			dialog = new ram.RamDialog({ id:dialogId, title: title, content: content, "class": styleClass, helpId: helpId});
		} else {
			dialog = new ram.RamDialog({ id:dialogId, title: title, content: content, helpId: helpId});
		}
		dojo.body().appendChild(dialog.domNode); 
		dialog.startup();
	} else {
		dialog.titleNode.innerHTML = title;
		dialog.setContent(content);
	}
	
	if (show) {
		dialog.show();
	}
	
	return dialog;
}

function getImageUrl(image) {
	return getAbsoluteUrl(image);
}

function checkNumber(key) {
	var c = (key.which) ? key.which : key.keyCode;
	if (c > 31 && (c < 48 || c > 57)) {
		return false;
	}  
	return true;
}
/*
 * End utilities
 */

/*
 * Objects
 */

function Lifecycle(workflow) {
	this.name = "";
	this.description = "";
	this.restrictOwnerFromReviewBoard=false;
	this.reviewBoardMember = new Array();
	this.selectionCriteria = null;
	this.workflow = workflow;
	this.stateConfiguration = new Array();
	
	for (var i=0; i<workflow.state.length; i++) {
		this.stateConfiguration[i] = new StateConfiguration(workflow.state[i]);
	}
}
function StateConfiguration(workflowState) {
	this.identifier = workflowState.identifier;
	this.state = new State(workflowState.href);
	this.exitCondition = new Array();
	
	for (var i=0; i<workflowState.action.length; i++) {
		this.exitCondition[i] = new ExitCondition(workflowState.action[i]);
	}
}

function State(href) {
	this.href = href;
}

function ExitCondition(workflowAction) {
	this.action = new Action(workflowAction.href);
}

function Action(href) {
	this.href = href;
}

function BooleanProperty() {
	this.value;
	this.inherited;
}

function CommunityScoping(){
	this.restricted;
	this.communities;
}

function Rule() {
	this.type;
	this.target;
	this.operator;
	this.inherited = false;
	this.integerValue;
	this.stringValue;
	this.childRule;
	this.valueDisplayName;
}

function ResourceRef(){
	this.resource;
	this.value;
}

function Reviewer() {
	this.user;
	this.userGroup = null;
	this.isReceiveNotifications = true;
	this.canUpdate = false;
	this.canVote = false;
}

function RoleOverride() {
	this.value;
	this.inheritedValue;
}

function Authorization() {
	this.user;
	this.userGroup = null;
	this.inherited;
}

function UserInformation() {
	this.href;
	this.title = new SimpleLiteral();
	this.value = new Value_User();
}

function Value_User(){
	this.identifier;
	this.name;
}

function SimpleLiteral() {
	this.content = new Array();
}

function Instruction() {
	this.inherited;
	this.body = "";
}

function UserGroupInformation() {
	this.title = new SimpleLiteral();
	this.identifier;
	this.href;
	this.value = new Value_UserGroup();
}

function Value_UserGroup() {
	this.identifier;
	this.name;
	this.description;
	this.community;
	this.users;
}

function ReviewConfiguration() {
	this.voteResetOn;
	this.approvalCondition;
}

function Policy() {
	this.href;
	this.title = new SimpleLiteral();
	this.value = new Value_Policy();
}

function Value_Policy() {
	this.identifier;
	this.name = '';
	this.description = '';
	this.governor;
	this.configurationDetail;
	this.customReturnCodes;
}

function Governor() {
	this.title = new SimpleLiteral();
	this.value = new Value_PolicyGovernor();
}

function Value_PolicyGovernor() {
	this.identifier;
	this.name = '';
}

function ConfigurationDetail() {
	this.type;
	this.key;
	this.label;
	this.description;
	this.option;
	this.password;
	this.values;
}

function ConfigurationOption() {
	this.name;
	this.value;
}

function CustomReturnCode() {
	this.identifier;
	this.description;
}

function EventConfiguration(){
	this.type;
	this.configurationDetail;
}

function PolicyConfiguration() {
	this.name;
	this.inherited;
	this.attributeUsed;
	this.policy;
	this.identifier;
	this.actionEventConfig;
	this.assetSaveEventConfig;
	this.deleteEventConfig;
	this.stateEntranceEventConfig;
	this.timerEventConfig;
	this.configurationDetail;
}

function getUserGroupIdentifier(userGroupInfo){
	if(userGroupInfo.value != null && userGroupInfo.value.identifier != null){
		return userGroupInfo.value.identifier;
	}
	
	if(userGroupInfo.href != null){
		//Remove internal/userGroup/
		var id = getLastURLSegment(userGroupInfo.href);
		
		//Remove any suffix
		id = stripExtension(id);
		
		if(userGroupInfo.value == null){
			userGroupInfo.value = new Value_User();
		}
		
		userGroupInfo.value.identifier = id;
		return id;
	}
}

function getUserIdentifier(userInfo){
	if(userInfo.value != null && userInfo.value.identifier != null){
		return userInfo.value.identifier;
	}

	var init = userInfo.href; // the next line of code doesn't work without calling this first, very bizarre.	
	if(userInfo.href != null){
		//Remove internal/user/
		var id = getLastURLSegment(userInfo.href);
		
		//Remove any suffix
		id = stripExtension(id);
		
		if(userInfo.value == null){
			userInfo.value = new Value_User();
		}
		
		userInfo.value.identifier = id;
		return id;
	}
}

function getLastURLSegment(href){
	var index = href.lastIndexOf("/");
	if(index != -1)
		return href.substring(index+1, href.length);
	else return href;
}

function stripExtension(href){
	var id = href;
	//Remove any sufix
	if(id.lastIndexOf(".json") >=0 && id.lastIndexOf(".json") == id.length-5){
		id = id.substring(0, id.length-5);
	}
	else if(id.lastIndexOf(".xml") >=0 && id.lastIndexOf(".xml") == id.length-4){
		id = id.substring(0, id.length-4);
	}
	return id;
}

/*
 * These are referenced in categorize_tree.js, need to be full path (unless we come up with workaround
 */
var IMG_RADIO_SELECTED = getImageUrl("/theme/images/icons/elcl16/radio-full-select.gif");
var IMG_RADIO_UNSELECTED = getImageUrl("/theme/images/icons/elcl16/radio-none-select.gif");
var IMG_RADIO_CHILD_SELECTED = getImageUrl("/theme/images/icons/elcl16/radio-part-select.gif");
var IMG_CHECKBOX_SELECTED = getImageUrl("/theme/images/icons/elcl16/check-full-select.gif");
var IMG_CHECKBOX_UNSELECTED = getImageUrl("/theme/images/icons/elcl16/check-none-select.gif");
var IMG_CHECKBOX_CHILD_SELECTED = getImageUrl("/theme/images/icons/elcl16/check-part-select.gif");