<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">

<%-- jsf:pagecode language="java" location="/JavaSource/pagecode/search/Index.java" --%><%-- /jsf:pagecode --%>
<%------------------------------------------------------------------------------
 - Licensed Materials - Property of IBM
 - 
 - (C) Copyright IBM Corporation 2006. All Rights Reserved.
 - Note to U.S. Government Users Restricted Rights:  Use, duplication or disclosure
 - restricted by GSA ADP  Schedule Contract with IBM Corp.
  -----------------------------------------------------------------------------%>

<%@ taglib uri="http://java.sun.com/jsf/core" prefix="f"%>
<%@ taglib uri="http://java.sun.com/jsf/html" prefix="h"%>
<%@ taglib uri="http://www.ibm.com/jsf/html_extended" prefix="hx"%>
<%@ taglib uri="http://www.ibm.com/ram/repository/tags" prefix="ram"%>
<%@ page language="java" contentType="text/html; charset=utf-8" pageEncoding="utf-8" %>

<html lang="${pageContext.response.locale}">
<head>
	<%@include file="/theme/metaHeader.jspf"%>
	<link rel="stylesheet" type="text/css" href="${pageContext.request.contextPath}/${applicationScope.themePath}/custom/css/hideRightColumn.css">
	<link rel="stylesheet" type="text/css" href="${pageContext.request.contextPath}/${applicationScope.themePath}/custom/css/showLeftColumn.css">	
	<link rel="alternate" type="application/rss+xml" title="${bundle.search_feed}" href="${pc_Search.feedUrl}" />
	<link rel="csh" href="${applicationScope.cshPath}">
	<script language="JavaScript" type="text/javascript" src="${pageContext.request.contextPath}/${applicationScope.javascriptPath}/js/search.js"></script>
	
	<title>${pc_Search.title}</title> 
	<style>
		#saveSearchDialog .dijitDialogTitle {
			padding-right: 32px;
		}
		.longField {
			width: 95% !important;
		}
		td.panelFormBox_Label-Cell {
			white-space: nowrap;
			padding-right: 4px;
		}
		.search-toolbar-infopop {
			margin-bottom: 5px;
		}
		#facetCountLink:hover {
			color: #8A9084;
			text-decoration: none;
		}
		table.labeledTable {
			width: 100%;
			border-top: 1px solid #ccc;
		}
	</style>
	
	<%-- Dojo layer imports  --%>
	${pc_Search.JSLayers['ram/layers/Search']}
	
	<script>
		dojo.require('dojo.fx.easing');
		dojo.require('jazz.ui.FilterBox');
		dojo.require('dojo.NodeList-traverse');
		function getOpenSearchURL(){
			var url = '<%
				String opensearchURL = "";
				try{
					String requestURL = request.getRequestURL().toString();
					String contextPath = request.getContextPath();
					int contextStartIndex = requestURL.indexOf(contextPath);
					int contextEndIndex = contextStartIndex + contextPath.length();
					String ramURL = requestURL.substring(0, contextEndIndex);
					opensearchURL = ramURL + "/search/suggest/opensearch.jsp";
				}catch(Throwable t){
				}
				out.print(opensearchURL); %>';
			return url;
		}
		
		function addSearchColumn() {
			var value = dojo.attr('selectColumnsForm:selectColumnsMenu', 'value');
			if (value && value.length > 0) {
				dojo.query('option[value="' + value + '"]', 'selectColumnsForm:selectColumnsMenu').forEach(function(option) {
					createSearchColumn(option.innerHTML, value);
				});
				dojo.attr('selectColumnsForm:selectColumnsMenu', 'value', '');
			}
		}
		
		function createSearchColumn(name, id) {
			// This will create a table row for the new search column and insert it in the correct spot.
			// The order of standard and legacy columns are hard coded. Attribute columns are sorted in alphabetical order.
			var refNode;
			var pos = 'after';
			var index;
			var section;
			if (id <= 8) {
				section = dojo.byId('mainColumnSection');
				index = id - 0;
			} else if (id >= 9 && id <= 16) {
				section = dojo.byId('legacyColumnSection');
				index = id - 9;
			} else {
				section = dojo.byId('attributeColumnSection');
				index = id;
			}
			section = dojo.byId(section);
			var prevSibling = dojo.query('tr', section).filter(function(node) {
				return node.id < index;
			}).last();
			if (prevSibling.length > 0)
				refNode = prevSibling[0];
			dojo.style(section, 'display', '');
			dojo.query('table', section).forEach(function(table) {
				var tbody = table.firstChild;
				if (!tbody)
					tbody = dojo.create('tbody', null, table);
				if (!refNode) {
					refNode = tbody;
					pos = 'first';
				}
				var tr = dojo.create('tr', {id: id}, refNode, pos);
				var td = dojo.create('td', null, tr);
				var a = dojo.create('a', {href: 'javascript:'}, td);
				var img = dojo.create('img', {src: getAbsoluteUrl('theme/images/icons/etool16/remove-link-user.gif')}, a);
				var span = dojo.create('span', null, td);
				dojo.place(document.createTextNode(name), span);
				dojo.connect(a, 'onclick', dojo.hitch({name: name, id: id, node: tr}, removeSearchColumn));
				dojo.query('option[value="' + id + '"]', 'selectColumnsForm:selectColumnsMenu').style('display', 'none');
			});
		}
		
		function removeSearchColumn() {
			if (dojo.query(this.node).parent('tbody').children().length == 1) {
				// this is the last column in the group, so hide the group
				dojo.query(this.node).parents('div').first().style('display', 'none');
			}
			dojo.query(this.node).orphan();
			dojo.query('option[value="' + this.id + '"]', 'selectColumnsForm:selectColumnsMenu').style('display', '');
		}
		
		function updateSearchColumnDialog() {
			dojo.xhrGet({
				url: getAbsoluteUrl('internal/service/UserPreferencesService.getSearchColumns'),
				handleAs: 'json',
				load: function(result) {
					var udpateSection = function(section, columns) {
						if (section) {
							if (columns) {
								dojo.style(section, 'display', '');
								dojo.query('table', section).forEach(function(table) {
									dojo.empty(table);
									var tbody = dojo.create('tbody', null, table);
									dojo.forEach(columns, function(column) {
										createSearchColumn(column.name, column.id);
									});
								});
							} else {
								dojo.style(section, 'display', 'none');
							}
						}
					};
					dojo.query('option', 'selectColumnsForm:selectColumnsMenu').style('display', '');
					udpateSection(dojo.byId('mainColumnSection'), result.mainColumns);
					udpateSection(dojo.byId('attributeColumnSection'), result.attributeColumns);
					udpateSection(dojo.byId('legacyColumnSection'), result.legacyColumns);
				}
			});
		}
		dojo.addOnLoad(updateSearchColumnDialog);
		
		function getColumnPrefPostData() {
			var sb = new StringBuffer();
			dojo.query('tr', 'selectColumnsForm:selectColumnsDialog').forEach(function(item) {
				sb.append(item.id);
				sb.append('\n');
			});
			return sb.toString();
		}
		
		function persistColumnPreference() {
			addSearchColumn(); // in case they selected something in the dropdown, but didn't click the add button
			dojo.xhrPost({
				url: getAbsoluteUrl('internal/service/UserPreferencesService.setSearchColumns'),
				sync: true,
				headers: {'Content-Type': 'text/plain'},
				postData: getColumnPrefPostData()
			});
		}
		function openSaveSearchDialog() {
			var dialog = dijit.byId('saveSearchDialog');
			if (!dialog) {
				var content = '<p><label for="savedSearchTitle">${bundle.label_title} </label><input class="longField" name="savedSearchTitle" id="savedSearchTitle" /></p>';
				content += '<p style="text-align: right"><input id="saveSearchSubmitButton" type="button" onclick="saveSearch();" value="${bundle.button_ok}" />';
				content += '<input type="button" value="${bundle.button_cancel}" onclick="dijit.byId(\'saveSearchDialog\').hide();" /></p>';
				dialog = new ram.RamDialog({id: 'saveSearchDialog', title: '${bundle.dialogTitle_SaveSearch}', content: content});
				dojo.body().appendChild(dialog.domNode); 
				dialog.startup();
			}
			dialog.show();
		}
		function saveSearch() {
			var title = dojo.byId('savedSearchTitle').value;
			var url = getAbsoluteUrl('internal/service/GadgetService.addGadget?q=' + encodeURIComponent(dojo.attr('resultsForm:searchNodeField', 'value'))) + '&url=' + getAbsoluteUrl('opensocial/gadgets/assetSearch.xml');
			if (title)
				url = url + '&title=' + title;
			dojo.xhrGet({
				url: url,
				load: function(response) {
					var dialog = dijit.byId('saveSearchDialog');
					if (dialog) {
						dialog.hide();
						dojo.byId('savedSearchTitle').value = '';
					}
					dojo.style('saveSearchMessage', 'display', '');
				}
			});
		}
	</script>
</head>
<f:view>
	<body class="ram" onload="document.getElementById('searchForm:searchText').focus();getUpdatedSearchResultCount(true);">
	<hx:scriptCollector id="scriptCollector1">
		<%@ include file="/theme/header.jspf" %>
		
			<ram:form id="selectColumnsForm">
			<hx:panelDialog type="modeless" id="selectColumnsDialog" align="center" valign="middle" styleClass="panelDialog selectColumnsDialog" 
				title="#{bundle.dialogTitle_search_selectColumns}">
				<h:outputText id="selectColumnsText" value="#{bundle.dialog_search_selectColumns}" styleClass="sectionInstructions" />
				<h:selectOneMenu id="selectColumnsMenu">
					<f:selectItems id="selectColumnsItems" value="#{pc_Search.availableSearchColumns}" />
				</h:selectOneMenu>
				<a href="javascript:;" onclick="addSearchColumn();">
					<hx:graphicImageEx id="addColumnImg" value="/theme/images/icons/elcl16/add.gif" style="vertical-align: top;"
						alt="#{bundle.alt_add_search_column}" title="#{bundle.alt_add_search_column}" />
				</a>
				<div style="max-height: 400px; overflow-y: auto;">
					<div id="mainColumnSection" style="display: none;">
						<table id="mainColumnTable"></table>
					</div>
					<div id="attributeColumnSection" style="display: none;">
						<h:outputText id="attributeColumnSectionLabel" value="#{bundle.section_custom_attributes}" styleClass="sectionInstructions" />
						<table id="attributeColumnTable" class="labeledTable"></table>
					</div>
					<hx:jspPanel id="legacyColumnPanel" rendered="#{pc_Search.showLegacyColumns}">
						<div id="legacyColumnSection" style="display: none;">
							<h:outputText id="legacyColumnSectionLabel" value="#{bundle.label_legacy_review}" styleClass="sectionInstructions" />
							<table id="legacyColumnTable" class="labeledTable"></table>
						</div>
					</hx:jspPanel>
				</div>
				<h:panelGroup id="selectColumnDialogGroup" styleClass="dialogActionGroup">
					<hx:commandExButton id="selectColumnsDialogOK" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" type="submit" 
						value="#{bundle.button_ok}" action="#{pc_Search.persistSearchResultColumns}" onclick="persistColumnPreference();"></hx:commandExButton>
					<hx:commandExButton id="selectColumnsDialogCancel" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif" type="button" value="#{bundle.button_cancel}">
						<hx:behavior id="selectColumnsDialogCancelBehavior" event="onclick" behaviorAction="hide;stop" targetAction="selectColumnsDialog" />
					</hx:commandExButton>
				</h:panelGroup>	
				<ram:infopop id="selectColumnsHelp" image="/theme/images/icons/obj16/info_indicator.gif" 
					contextId="sscl0001" styleClass="dialogInfopop" />
			</hx:panelDialog>
			<ram:context id="nContext" name="n" explicitValue="#{pc_Search.fullNode}"/>
			<ram:context id="dContext" name="d"/>
			<ram:context id="sContext" name="s"/>
			<ram:context id="sartContext" name="sart"/>
		</ram:form>

		<ram:form id="dialogForm">
			<hx:panelDialog type="modeless" align="center" valign="middle"
				id="subscribeDialog" styleClass="panelDialog subscribeDialog"
				for="subscribeLink" title="#{bundle.dialogTitle_search_subscribe}">
				<h:panelGroup id="subscribeDialogGroup">
					<h:outputText id="help_dialog_search_subscribe"
						value="#{bundle.help_dialog_search_subscribe}"
						styleClass="sectionInstructions" style="width:275px" />
					<hx:panelFormBox id="subscribeDialogFormBox"
						styleClass="dialogForm" showInPopup="true"
						labelPosition="over">
						<hx:formItem id="subscriptionNameFormItem"
							label="#{bundle.label_subscription_name} ">
							<h:inputText id="subscriptionName" styleClass="shortField"
								value="#{pc_Search.subscriptionName}" />
						</hx:formItem>
						<hx:formItem id="subscriptionFreqFormItem"
							label="#{bundle.label_frequency} ">
							<h:selectOneMenu styleClass="shortSelect"
								id="subscriptionFrequency" converter="ram.converter.Standard"
								value="#{pc_Search.subscriptionFrequency}">
								<f:selectItems id="selectSubscriptionFreq" value="#{pc_Search.subscriptionFrequencies}" />
							</h:selectOneMenu>
						</hx:formItem>
					</hx:panelFormBox>
					<h:panelGroup id="subscriptionButtons"
						styleClass="dialogActionGroup">
						<hx:commandExButton id="subscribeSubmit"
							styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif" type="submit"
							value="#{bundle.button_ok}"
							action="#{pc_Search.doSubscribeAction}">
						</hx:commandExButton>
						<hx:commandExButton id="subscribeCancel"
							styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif" type="reset"
							value="#{bundle.button_cancel}">
							<hx:behavior id="subscribeCancelBehavior" event="onclick"
								behaviorAction="hide;stop" targetAction="subscribeDialog" />
						</hx:commandExButton>
					</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
			<ram:context id="nodeContext" name="n"
				explicitValue="#{pc_Search.fullNode}"></ram:context>
			<ram:context id="directionContext" name="d"></ram:context>
			<ram:context id="sortContext" name="s"></ram:context>
		</ram:form>

		<div id="leftColumn">
		<div class="inside">
		
			<ram:form id="submitAssetButtonForm">
				<div style="width: 205px;"> <!-- This div is for IE6 -->
				<h:commandLink id="submitAssetButton" action="#{pc_Search.doSubmitAssetAction}"
					styleClass="action-Button" title="#{bundle.alt_submit_an_asset}">
					<hx:jspPanel id="submitButtonPanel">
					<div class="buttonWrapper largeButton">
						<div class="buttonLeft">
						<table>
							<tbody>
							<tr>
								<td valign="middle"><div class="image create-asset-command"></div></td>
								<td valign="middle">${bundle.button_submit_an_asset_html}</td>
							</tr>
							</tbody>
						</table>
						</div>
						<div class="buttonRight" style="right: 0px;"></div>
					</div>
					</hx:jspPanel>
				</h:commandLink>
				</div>
			</ram:form>
			
			<h:outputLink id="visualBrowseLink" value="javascript:browseGraphically('#{pc_Search.visualBrowseURL}')" styleClass="goActionButton">
				<h:outputText id="visualBrowseLinkText" value="#{bundle.link_browse_graphically}"/>
			</h:outputLink>		
			
			<div id="filters" class="sidebarContent filters">
					
				<div id="leftFilters" style="width: 190px;">
					<div class="sidebarHeader">
						<h2><ram:infopop styleClass="jazz-app-ua-TextHoverHelp" id="filterHelp" contextId="sass0010" text="#{bundle.search_filter}" /></h2>
					</div>
					
					<div style="margin-bottom: 10px;"></div>
					
					<%--
					<hx:jspPanel rendered="#{pc_Search.renderFacetFilter}">
						<div style="text-align: center; margin-bottom: 10px;">
							<h:inputText id="filterFacetInput" style="width: 95%;" title="#{bundle.label_search_terms}" onkeyup="filterFacets(this.value, document.getElementById('facetCounts'))">
							</h:inputText>
						</div>
					</hx:jspPanel>
					 --%>
					 
					
						<ram:facetCounts2 id="facetCounts" value="#{pc_Search.facetResults}" facetNameStyle="sidebarTitle" var="item" mapping="itemMapping" maxItems="5">
							<f:facet name="moreLink">
								<h:outputLink id="moreLink" styleClass="#{moreLinkStyle}" onclick="javascript:showFacetFlyout('#{facetName}', false, this)" value="javascript:">
									<h:outputText id="moreLinkText" value="#{bundle.link_view_more}"/>
									<h:outputText id="lessLinkText" value="#{bundle.link_view_less}" style="display: none;"/>
								</h:outputLink>
							</f:facet>
							<hx:jspPanel id="facetCountsJspPanel">
								<table cellpadding="0" cellspacing="0" width="100%">
									<tr height="16px" onmouseover="showAllAnyNoneOptions(this);" onmouseout="hideCurrentAllAnyNoneOptions();">
										<td width="70%">
											<hx:requestLink id="facetCountLink">
												<h:outputText id="facetCountLinkText" value="#{itemMapping} #{bundle.common_ltr_mark}[#{item.displayCount}]" />
												<f:param id="refineParamA" name="a" value="#{item.encodedFacetName},#{item.encodedItemName}" />
												<f:param id="refineParamN" name="n" value="#{pc_Search.fullNode}" />
												<f:param id="refineParamS" name="s" value="#{pc_Search.sort}" />
												<f:param id="refineParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
												<f:param id="refineParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
												<f:param id="refineParamForum" name="forum" value="#{pc_Search.searchForums}" />
											</hx:requestLink>
										</td>
										<td style="white-space: nowrap;" valign="top">
											<hx:jspPanel id="allAnyNonePanel">
												<span id="allAnyNoneContainer" style="white-space: nowrap; display: none;">
													<hx:requestLink id="facetAndCountLink">
														<h:graphicImage id="facetCountAllImage" value="/theme/images/icons/filter_all.gif" 
																style="vertical-align: middle; background-color: #D8E7EB;" title="#{bundle.alt_search_filters_all}"></h:graphicImage>
														<f:param id="refineAndParamA" name="a" value="#{item.encodedFacetName},#{item.encodedItemName}" />
														<f:param id="refineAndParamN" name="n" value="#{pc_Search.fullNode}" />
														<f:param id="refineAndParamS" name="s" value="#{pc_Search.sort}" />
														<f:param id="refineAndParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
														<f:param id="refineAndParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
														<f:param id="refineAndParamForum" name="forum" value="#{pc_Search.searchForums}" />
													</hx:requestLink>
													<hx:requestLink id="facetAnyCountLink">
														<h:graphicImage id="facetCountAnyImage" value="/theme/images/icons/filter_part.gif" 
															style="vertical-align: middle; background-color: #D8E7EB;" title="#{bundle.alt_search_filters_any}"></h:graphicImage>
														<f:param id="refineAnyParamA" name="a" value="com.ibm.ram.orcom.ibm.ram.facet.name#{item.encodedFacetName},#{item.encodedItemName}" />
														<f:param id="refineAnyParamN" name="n" value="#{pc_Search.fullNode}" />
														<f:param id="refineAnyParamS" name="s" value="#{pc_Search.sort}" />
														<f:param id="refineAnyParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
														<f:param id="refineAnyParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
														<f:param id="refineAnyParamForum" name="forum" value="#{pc_Search.searchForums}" />
													</hx:requestLink>
													<hx:requestLink id="facetNoneCountLink">
														<h:graphicImage id="facetCountNoneImage" value="/theme/images/icons/filter_none.gif" 
															style="vertical-align: middle; background-color: #D8E7EB; " title="#{bundle.alt_search_filters_none}"></h:graphicImage>
														<f:param id="refineNoneParamA" name="a" value="com.ibm.ram.notcom.ibm.ram.facet.name#{item.encodedFacetName},#{item.encodedItemName}" />
														<f:param id="refineNoneParamN" name="n" value="#{pc_Search.fullNode}" />
														<f:param id="refineNoneParamS" name="s" value="#{pc_Search.sort}" />
														<f:param id="refineNoneParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
														<f:param id="refineNoneParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
														<f:param id="refineNoneParamForum" name="forum" value="#{pc_Search.searchForums}" />
													</hx:requestLink>
												</span>
											</hx:jspPanel>
										</td>
									</tr>
								</table>
							</hx:jspPanel>
						</ram:facetCounts2>
					
					<h:panelGroup id="noFacetPanel" rendered="#{empty pc_Search.results.facets}">
						<h:outputText id="noFacetCounts" value="#{bundle.search_noMoreRefinements}" />
					</h:panelGroup>
				</div>
				
				
					<div id="flyout" style="position: absolute; top:0; display: none;">
						
						<div id="flyoutHeader" class="sidebarHeader">
							<div class="sidebarSubHeader" style="float: right; margin: 6px 10px 0px 0px;" onmouseover="this.style.cursor='pointer'" onclick="hideFacetFlyout()">
								${bundle.link_close_low} X
							</div>
							
							<table style="padding-left: 10px;">
								<tr>
									<td>
										<input id="flyoutFilterInput" dojoType="jazz.ui.FilterBox" onChange="filterFacets"></input>
									</td>
									<td>
										<h:graphicImage id="categorySearchBusyIcon" value="/theme/images/icon_animated_busy.gif"
											style="margin-left: 10px; display: none;" alt="#{bundle.alt_loading_icon}" />
									</td>
								</tr>
							</table>
						</div>
						
						<div id="flyoutScrollDiv" style="overflow: scroll; overflow-x: hidden; overflow: auto; padding-left: 10px;">
						
							<hx:jspPanel id="categoryFlyoutPanel" rendered="#{pc_Search.renderCategoryFacetFilterFlyout}">
								<div id="ClassificationFlyout" style="display: none;"></div>
								<div style="padding: 3px;">
									<div id="classificationSearchFlyoutTitle" class="sidebarTitle" style="display: none;">Category</div>
									<div id="classificationSearchFlyout" style="display: none;">
								</div>
								</div>
								<h:inputHidden id="classificationSearchFullNode" value="#{pc_Search.fullNode}"></h:inputHidden>
								<h:inputHidden id="classificationSearchSort" value="#{pc_Search.sort}"></h:inputHidden>
								<h:inputHidden id="classificationSearchArtifacts" value="#{pc_Search.searchArtifacts}"></h:inputHidden>
								<h:inputHidden id="classificationSearchShadowAssets" value="#{pc_Search.searchShadowAssets}"></h:inputHidden>
								<h:inputHidden id="classificationSearchForums" value="#{pc_Search.searchForums}"></h:inputHidden>
							</hx:jspPanel>
							
							<hx:jspPanel id="typeFlyoutPanel" rendered="#{pc_Search.renderTypeFacetFilterFlyout}">
								<div id="fTypeFlyout" style="display: none;"></div>
							</hx:jspPanel>
							
							<hx:jspPanel id="stateFlyoutPanel" rendered="#{pc_Search.renderStateFacetFilterFlyout}">
								<div id="fStateFlyout" style="display: none;"></div>
							</hx:jspPanel>
							
							<hx:jspPanel id="communityFlyoutPanel" rendered="#{pc_Search.renderCommunityFacetFilterFlyout}">
								<div id="fGroupFlyout" style="display: none;"></div>
							</hx:jspPanel>
							
							<hx:jspPanel id="relationshipTypeFlyoutPanel" rendered="#{pc_Search.renderRelationshipTypeFacetFilterFlyout}">
								<div id="fRelationshipTypeFlyout" style="display: none;"></div>
							</hx:jspPanel>
						</div>
					</div>
				
			</div>
		
			<h:panelGroup id="setShowTags">
				<hx:ajaxRefreshRequest id="setTagsAjax" onstart="toggleTagClouds()"></hx:ajaxRefreshRequest>
			</h:panelGroup>
			
			<h:panelGroup id="tagDiv" styleClass="#{pc_Search.sideBarTagsClass}" rendered="#{not empty pc_Search.results.tags}">
				<hx:jspPanel id="tagPanel">
				
				<div class="ram-section">
					<div class="top-section-no-title"><div class="top-right"></div></div>
					<div class="middle-section">
					<div class="content-wrapper">
					<div class="content" style="width: 186px;">
						<ram:tagCloud id="tagCloud" value="#{pc_Search.results.tags}" tagVar="tag" tagCountVar="tagCount" tagClass="tagCloud" maxTags="20">
							<hx:requestLink id="tagCloudLink">
								<h:outputText id="tagCloudText" value="#{tag}" />
								<h:outputText id="tagCloudCount" styleClass="hidden" value="#{bundle.common_ltr_mark}(#{tagCount})" />
								<f:param id="tagParamA" name="a" value="#{pc_Search.results.tags.facetName},#{tag}" />
								<f:param id="tagParamN" name="n" value="#{pc_Search.fullNode}" />
								<f:param id="tagParamS" name="s" value="#{pc_Search.sort}" />
								<f:param id="tagParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
								<f:param id="tagParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
								<f:param id="tagParamForum" name="forum" value="#{pc_Search.searchForums}" />
							</hx:requestLink>
						</ram:tagCloud>
						<div id="tagLinks">
							<a id="toggleLink" href="javascript:toggleTagCounts('tagCloud', 'toggleLink', 'hideText')">${bundle.link_show_tag_counts}</a>
							<h:outputText id="linkSeparator" value=" | " rendered="#{pc_Search.results.tagCount > 20}" />
							<h:outputLink id="viewMoreTagsLink" rendered="#{pc_Search.results.tagCount > 20}" value="#">
								<h:outputText id="viewMoreTagsText" value="#{bundle.link_view_all_tags}" />
								<hx:behavior id="showTagsBehavior1" event="onclick" behaviorAction="get;stop" targetAction="setShowTags"></hx:behavior>
							</h:outputLink>
						</div>
						<div class="hidden" id="hideText">${bundle.link_hide_tag_counts}</div>
					</div>
					</div>
					</div>
					<div class="bottom-section"><div class="bottom-right"></div></div>
				</div>
				</hx:jspPanel>
			</h:panelGroup>
			
		</div>
		</div>
		
		<div id="contentColumn">
		<div class="inside">
		
		<h1>${bundle.search_searchAssets}<ram:infopop id="pageHelp" styleClass="pageHelp" 
			image="/theme/images/icons/obj16/info_indicator.gif" contextId="sass0001"/></h1>
		<ram:messagesEx id="globalMessages" />
				
		<ram:form id="submitEditorBusyDialogForm">
			<hx:panelDialog type="modal" align="center" valign="middle" 
				id="submitEditorBusyDialog" styleClass="panelDialog" style="width: 600px;"
				title="#{bundle.submit_wiz_submit_header_wait_text}" initiallyShow="#{pc_Search.submitEditorBusyDialogVisible}">
					<div id="submitEditorBusyErrorMessage" class="warningBlock" style="margin-left: 15px">
						<div class="body">
							<div class="message">
								<h:outputText id="submitEditorBusyText" value="#{bundle.SubmitAssetHandler_submitEditorBusy}" escape="false"></h:outputText>
							</div>
						</div>
					</div>
				<h:panelGroup id="submitEditorBusyDialogGroup" style="width: 600px;">
					<h:panelGroup id="submitEditorBusyGroup" styleClass="dialogActionGroup">
						<hx:commandExButton id="submitWizYes" styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif"
							type="submit"
							value="#{bundle.button_continue}" action="#{pc_Search.doSubmitActionForce}">
						</hx:commandExButton>
						<hx:commandExButton id="submitWizNo" styleClass="commandExButton"
							iconDepressed="/theme/images/transparent.gif"
							type="submit"
							action="#{pc_Search.doCancelSubmitEditorBusyAction}"
							value="#{bundle.button_cancel}">
						</hx:commandExButton>
					</h:panelGroup>
				</h:panelGroup>
			</hx:panelDialog>
		</ram:form>
							
		<ram:form id="searchForm">
			<div id="saveSearchMessage" class="info" style="display: none; margin-top: 5px; overflow: hidden;">
				<div class="body">
					<div class="message">
						<h:outputText id="saveSearchMessageText" value="#{pc_Search.saveSearchMessage}" escape="false" style="color: #555555;" />
					</div>
				</div>
			</div>
			<div id="normalSearch">
				<table width="100%" class="searchForm" cellpadding="3" cellspacing="0" style="padding-right: 2px">
					<tr><td class="searchInput">
						<div style="float: right; padding-top:2px;" class="searchOptionLink">
						<h:outputLink id="showAdvLink" value="#" styleClass="moreLink">
							<h:outputText id="showAdvText" value="#{bundle.search_advanced}" />
							<hx:behavior event="onclick" id="showAdvBehavior" onActionFunction="toggleSearchOptions();enableScopeImage();return setFieldValue('advSearchForm:renderAdv','true')"
								target="showAdvLink" targetAction="advSearchAjaxGroup;advSearchAjaxGroupSubmitted" behaviorAction="get;get;stop"></hx:behavior>
						</h:outputLink>
						</div>
						
						<a href="javascript:;" onclick="toggleScopeMenu();" title="${bundle.alt_change_search_scope}">
							<h:graphicImage id="scopeImage" value="/theme/custom/images/buttons/search_scope_enabled.gif"
								  style="vertical-align: middle; margin-right: -4px;" alt="#{bundle.alt_search_scope_menu}"
								  onmouseover="hoverOnScope(this);" onmouseout="hoverOffScope(this);" />
						</a>
							    
						<h:inputText id="searchText" style="width:46%" value="#{pc_Search.txtSearch}" title="#{bundle.label_search_terms}" 
							onclick="enableScopeImage()" onfocus="if(this.value.length > 0 && !this.value.endsWith(' ')){this.value = this.value + ' ';}">
						<%-- <hx:inputHelperTypeahead id="searchSuggest" styleClass="inputText_Typeahead" 
						size="10" type="suggest" value="#{pc_Search.suggestions}" maxSuggestions="25" matchWidth="true"></hx:inputHelperTypeahead> --%>
							<hx:behaviorKeyPress id="searchBehaviorEnter" key="ENTER" targetAction="searchButton" behaviorAction="click" />
						</h:inputText>
						<h:outputLabel id="searchTextLabel" for="searchText">
						<hx:commandExButton id="searchButton" styleClass="searchButton" type="image" 
							image="/theme/custom/images/buttons/search_enabled.gif"
							himage="/theme/custom/images/buttons/search_hover.gif"
							pimage="/theme/custom/images/buttons/search_press.gif"
							onclick="return basicSearch()"
							alt="#{bundle.alt_search_assets}" title="#{bundle.alt_search_assets}" />
						</h:outputLabel>
						
						<span style="white-space: nowrap; display: none;">
						<h:selectBooleanCheckbox id="searchArtifacts" style="margin-left: 15px; margin-top: -1px;" value="#{pc_Search.searchArtifacts}" />
						<h:outputLabel id="searchArtLabel" for="searchArtifacts">
							<h:outputText id="searchArtLabelText" value="#{bundle.label_search_scope_artifacts}" />
						</h:outputLabel> 
						 
						<h:selectBooleanCheckbox id="searchShadowAssets" style="margin-left: 15px; margin-top: -1px;" value="#{pc_Search.searchShadowAssets}" />
						<h:outputLabel id="searchShadowLabel" for="searchShadowAssets">
							<h:outputText id="searchShadowLabelText" value="#{bundle.label_search_scope_remote}" />
						</h:outputLabel> 
						
						<h:selectBooleanCheckbox id="searchForums" style="margin-left: 15px; margin-top: -1px;" value="#{pc_Search.searchForums}" />
						<h:outputLabel id="searchForumsLabel" for="searchForums">
							<h:outputText id="forumLabelText" value="#{bundle.label_search_scope_forums}" />
						</h:outputLabel> 
						</span>
						
						<h:inputHidden id="hiddenNode" value="#{pc_Search.facetNode}" />
					</td></tr>
				</table>
				<hx:requestLink id="hiddenBasicLink" style="display:none">
					<f:param id="hiddenBasicParamN" name="n" value="#{pc_Search.facetNode}" />
				</hx:requestLink>
				<hx:requestLink action="#{pc_Search.advancedSearch}" id="hiddenAdvancedLink" style="display:none">
					<f:param id="hiddenAdvancedParamN" name="n" value="#{pc_Search.facetNode}" />
				</hx:requestLink>
			</div>	
		</ram:form>
		
		<ram:form id="advSearchForm">
			<h:inputHidden id="renderAdv"></h:inputHidden>

				<div id="searchOptions" style="display:none">
					
					<table width="100%" cellspacing="2" cellpadding="4" class="searchForm" style="margin-top: -2px">
						<tr>
							<td class="searchTitle" colspan="2">
								<div style="float: right" class="searchOptionLink">
									<a href="#" onclick="toggleSearchOptions();" class="lessLink">${bundle.search_basic}</a>
								</div>
								${bundle.search_advancedSearch}
							</td>
						</tr>
						<tr style="vertical-align: top;">
							<td width="50%">
								<hx:panelFormBox helpPosition="under" labelPosition="left" id="formBox3" styleClass="panelFormBox" style="width: 100%">
									<hx:formItem id="formItem18" styleClass="searchLabel" label="#{bundle.label_all_words}" showHelp="none">
										<h:inputText id="advSearchAnd" styleClass="longField" value="#{pc_Search.andSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem19" styleClass="searchLabel" label="#{bundle.label_exact_phrase}" showHelp="none">
										<h:inputText id="advSearchExact" styleClass="longField" value="#{pc_Search.exactSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem20" styleClass="searchLabel" label="#{bundle.label_at_least_words}" showHelp="none">
										<h:inputText id="advSearchOr" styleClass="longField" value="#{pc_Search.orSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem21" styleClass="searchLabel" label="#{bundle.label_none_words}" showHelp="none">
										<h:inputText id="advSearchNot" styleClass="longField" value="#{pc_Search.notSearch}" />
									</hx:formItem>
								</hx:panelFormBox>	
							</td>
							<td>
								<hx:panelFormBox helpPosition="under" labelPosition="left" id="formBox4" styleClass="panelFormBox" style="width: 100%">
									<hx:formItem id="formItem22" styleClass="searchLabel" label="#{bundle.label_id}">
										<h:inputText id="advSearchId" styleClass="longField" value="#{pc_Search.idSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem23" styleClass="searchLabel" label="#{bundle.label_name}">
										<h:inputText id="advSearchName" styleClass="longField" value="#{pc_Search.nameSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem24" styleClass="searchLabel" label="#{bundle.label_version}">
										<h:inputText id="advSearchVersion" styleClass="longField" value="#{pc_Search.versionSearch}" />
									</hx:formItem>
									<hx:formItem id="formItemAdvancedSeachShortDescription" styleClass="searchLabel" label="#{bundle.label_short_description}">
										<h:inputText id="advSearchShortDescription" styleClass="longField" value="#{pc_Search.shortDescriptionSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem25" styleClass="searchLabel" label="#{bundle.label_description}">
										<h:inputText id="advSearchDescription" styleClass="longField" value="#{pc_Search.descriptionSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem26" styleClass="searchLabel" label="#{bundle.label_owners}">
										<h:inputText id="advSearchOwner" styleClass="longField" value="#{pc_Search.ownerSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem27" styleClass="searchLabel" label="#{bundle.label_modified_by}">
											<h:inputText id="advSearchLastModifier" styleClass="longField" value="#{pc_Search.modifierSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem28" styleClass="searchLabel" label="#{bundle.label_attribute_name}">
											<h:inputText id="advSearchAttributeName" styleClass="longField" value="#{pc_Search.attributeNameSearch}" />
									</hx:formItem>
									<hx:formItem id="formItem29" styleClass="searchLabel" label="#{bundle.label_attribute_value}">
											<h:inputText id="advSearchAttributeValue" styleClass="longField" value="#{pc_Search.attributeValueSearch}" />
									</hx:formItem>
								</hx:panelFormBox>
							</td>
						</tr>
						<tr>
							<td colspan="2">
							<table width="100%">
							<tr>
								<td class="label" style="padding-top: 0; vertical-align: middle; white-space: nowrap;">${bundle.label_modified}</td>
								<td class="advancedInput" style="width:100%">
								<h:panelGroup id="advSearchAjaxGroup">
									<hx:ajaxRefreshRequest id="showAdvAjax" params="renderAdv"></hx:ajaxRefreshRequest>
									<h:panelGroup rendered='#{param.renderAdv!=null}' id="ajaxAdvPanelGroup">
										<hx:jspPanel id="advSearchGroup" >
											<span style="white-space:nowrap; margin-right: 5px;">
												<h:inputText id="fromCalField" styleClass="inputText" value="#{pc_Search.fromDate}">
													<hx:convertDateTime type="date" dateStyle="medium"/>
													<hx:inputHelperDatePicker id="fromCalDatePicker"/>
												</h:inputText>
											</span>
											 ${bundle.search_advanced_to}
											<span style="white-space:nowrap">
												<h:inputText id="toCalField" styleClass="inputText" value="#{pc_Search.toDate}">
													<hx:convertDateTime type="date" dateStyle="medium"/>
													<hx:inputHelperDatePicker id="toCalDatePicker"  />
												</h:inputText> 
											</span>
										</hx:jspPanel>
									</h:panelGroup>						
								</h:panelGroup> 
								</td>
							</tr>
							<tr>
								<td class="label" style="padding-top: 0; vertical-align: middle; white-space: nowrap;">${bundle.label_submitted}</td>
								<td class="advancedInput" style="width:100%">
								<h:panelGroup id="advSearchAjaxGroupSubmitted">
									<hx:ajaxRefreshRequest id="showAdvAjaxSubmitted" params="renderAdv"></hx:ajaxRefreshRequest>
									<h:panelGroup rendered='#{param.renderAdv!=null}' id="ajaxAdvPanelGroupSubmitted">
										<hx:jspPanel id="advSearchGroupSubmitted" >
											<span style="white-space:nowrap; margin-right: 5px;">
												<h:inputText id="fromCalFieldSubmitted" styleClass="inputText" value="#{pc_Search.fromDateSubmitted}">
													<hx:convertDateTime type="date" dateStyle="medium"/>
													<hx:inputHelperDatePicker id="fromCalDatePickerSubmitted"/>
												</h:inputText>
											</span>
											 ${bundle.search_advanced_to}
											<span style="white-space:nowrap">
												<h:inputText id="toCalFieldSubmitted" styleClass="inputText" value="#{pc_Search.toDateSubmitted}">
													<hx:convertDateTime type="date" dateStyle="medium"/>
													<hx:inputHelperDatePicker id="toCalDatePickerSubmitted"  />
												</h:inputText> 
											</span>
										</hx:jspPanel>
									</h:panelGroup>						
								</h:panelGroup> 
								</td>
							</tr>
							</table>
							</td>
						</tr>
						<tr>
							<td colspan="2">
							<table width="100%">
							<tr>
								<td class="label" style="padding-top: 0; vertical-align: top; white-space: nowrap;">${bundle.label_search_scope}</td>
								<td align="left" valign="top" width="100%">
									<div style="white-space: nowrap;">
										<h:selectBooleanCheckbox id="advSearchArtifacts" value="#{pc_Search.searchArtifacts}" style="margin-top: -1px; vertical-align: middle" />
										<h:outputLabel id="advSearchArtLabel" for="advSearchArtifacts">
											<h:outputText id="advSearchArtLabelText" value="#{bundle.label_search_scope_artifacts}" />
										</h:outputLabel> 
									</div>
									<div style="white-space: nowrap;">
										<h:selectBooleanCheckbox id="advSearchShadow" value="#{pc_Search.searchShadowAssets}" style="margin-top: -1px; vertical-align: middle" />
										<h:outputLabel id="advSearchShadowLabel" for="advSearchShadow">
											<h:outputText id="advSearchShadowLabelText" value="#{bundle.label_search_scope_remote}" />
										</h:outputLabel>
									</div>
									<div style="white-space: nowrap;">
										<h:selectBooleanCheckbox id="advSearchForums" value="#{pc_Search.searchForums}" style="margin-top: -1px; vertical-align: middle" />
										<h:outputLabel id="advSearchForumsLabel" for="advSearchForums">
											<h:outputText id="advSearchShadowForumsText" value="#{bundle.label_search_scope_forums}" />
										</h:outputLabel> 
									</div>
								</td>
								<td align="right" valign="bottom">
									<hx:commandExButton id="advSearchButton3" style="margin-left: 15px; margin-bottom: 3px; vertical-align: middle" value="#{bundle.button_search}" onclick="return advancedSearch()" styleClass="commandExButton" iconDepressed="/theme/images/transparent.gif"/>			
								</td>
							</tr>
						</table>
						</td></tr>
					</table>
				</div>
		</ram:form>
			
		<ul id="scopeMenu">
			<li>
				<ul id="scopeItems">
					<li id="assetScope" class="scopeItem checked"><a href="#" title="${bundle.label_search_scope_assets_title}" class="assetsScope" style="cursor: default;">${bundle.label_search_scope_assets}</a></li>
					<li id="remoteAssetScope" class="scopeItem"><a href="#" onclick="toggleSearchScope(this, '1')" class="shadowsScope" title="${bundle.label_search_scope_remote_title}">${bundle.label_search_scope_remote}</a></li>
					<li id="artifactScope" class="scopeItem"><a href="#" onclick="toggleSearchScope(this, '2')" class="artifactsScope" title="${bundle.label_search_scope_artifacts_title}">${bundle.label_search_scope_artifacts}</a></li>									
					<li id="forumScope" class="scopeItem"><a href="#" onclick="toggleSearchScope(this, '3')" class="forumsScope" title="${bundle.label_search_scope_forums_title}">${bundle.label_search_scope_forums}</a></li>
				</ul>
			</li>
		</ul>
			
			<script type="text/javascript">
				setStyleClass('searchForm:searchArtifacts', 'artifactScope');
				setStyleClass('searchForm:searchShadowAssets', 'remoteAssetScope');
				setStyleClass('searchForm:searchForums', 'forumScope');
				function setStyleClass(checkBoxId, listItemId) {
					if (document.getElementById(checkBoxId).checked) {
						document.getElementById(listItemId).className = document.getElementById(listItemId).className + ' checked';
					}
				}
				function hoverOnScope(image) {
					var v = document.getElementById('scopeItems').style.visibility;
					if (v != 'visible') {
						var src = image.src;
						src = src.substr(0, src.indexOf("/search_")) + '/search_scope_hover.gif';
						image.src = src;
					}
				}
				function hoverOffScope(image) {
					var v = document.getElementById('scopeItems').style.visibility;
					if (v != 'visible') {
						var src = image.src;
						src = src.substr(0, src.indexOf("/search_")) + '/search_scope_enabled.gif';
						image.src = src;
					}
				}
			</script>
			
			<ram:form id="resultsForm">
				<h:inputHidden id="n" value="#{pc_Search.fullNode}" />
				<h:inputHidden id="aid" value="" />
				<h:inputHidden id="aver" value="" />
				<h:inputHidden id="s" value="#{pc_Search.sort}" />
				<h:inputHidden id="d" value="#{pc_Search.sortDirection}" />
				<h:inputHidden id="sart" value="#{pc_Search.searchArtifacts}" />
				<h:inputHidden id="sshdw" value="#{pc_Search.searchShadowAssets}" />
				<h:inputHidden id="forum" value="#{pc_Search.searchForums}" />
				<h:inputHidden id="renderResults" value="#{pc_Search.renderResults}" />
				<h:inputHidden id="resultCount" value="#{pc_Search.results.totalMatchesIncludingGroupedVersions}" />
				
				<div id="synchronizedSearchMessage" class='info' style="display: none; margin-top: 5px; height: 0px; overflow: hidden;"><div class='body'><div class='message'>
					<span id="synchronizedSearchMessageText" style="color: #000000;"></span>
				</div></div></div>
				
				<table id="topPager" width="100%"><tr>
					<td align="left" valign="top" nowrap="nowrap" width="49%">
					
						<hx:jspPanel id="currentAndFacetsJspPanel" rendered="#{not empty pc_Search.currentAndFacets}">
							<div style="margin-top: 5px;">
								<fieldset style="border: 0px">
									<legend>
										<img src="<%=request.getContextPath() + "/theme/images/icons/filter_all.gif"%>" align="top">
										<span style="color: #838184">${bundle.alt_search_filters_all}</span>
									</legend>
									<hx:jspPanel id="currentAndFacetsTable">
										<table width="100%;" cellspacing="0" cellpadding="2" style="margin-left: 15px;">
											<hx:dataIterator id="currentAndFacets" value="#{pc_Search.currentAndFacets}" var="facet">
												<hx:jspPanel id="currentAndFacetsTableRow">
													<tr onmouseover="showRemoveAllAnyNoneOptions(this)" onmouseout="hideCurrentRemoveAllAnyNoneOptions()" height="21px;">
														<td>
															<hx:requestLink id="removeFacet" title="#{bundle.alt_remove_filter_link}">
																<hx:graphicImageEx id="removeFacetImg" value="/theme/images/icons/elcl16/delete.gif" style="vertical-align: middle; margin-bottom: 2px;"/>
																<f:param id="facetParamN" name="n" value="#{pc_Search.fullNode}" />
																<f:param id="facetParamS" name="s" value="#{pc_Search.sort}" />
																<f:param id="facetParamD" name="d" value="#{pc_Search.sortDirection}" />
																<f:param id="facetParamR" name="r" value="#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																<f:param id="facetParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
																<f:param id="facetParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
																<f:param id="facetParamForum" name="forum" value="#{pc_Search.searchForums}" />
															</hx:requestLink>
														</td>
														<td>
															<hx:jspPanel id="removeAllAnyNoneTextPanel">
																<span>
																	<h:outputText id="currentFacetText" value=" #{facet.facetNameMapping}: " styleClass="facetName" />
																	<h:outputText id="firstItem" value="#{facet.itemList[0]}" styleClass="facetSelection" />
																	<hx:dataIterator id="facetItemIterator" value="#{facet.itemList}" var="item" first="1">
																		<h:outputText id="itemListText" value="/#{item}" styleClass="facetSelection" />
																	</hx:dataIterator>
																</span>
															</hx:jspPanel>
														</td>
														<td>
															<hx:jspPanel id="removeAllAnyNonePanel">
																<span style="white-space: nowrap; display: none;">
																	<hx:requestLink id="facetAnyCountLinkRemove">
																		<h:graphicImage id="facetCountAnyImageRemove" value="/theme/images/icons/filter_part.gif" 
																			style="vertical-align: middle;" title="#{bundle.alt_search_filters_any}"></h:graphicImage>
																		<f:param id="facetParamRRemove" name="r" value="#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineAnyParamARemove" name="a" value="com.ibm.ram.orcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineAnyParamNRemove" name="n" value="#{pc_Search.fullNode}" />
																		<f:param id="refineAnyParamSRemove" name="s" value="#{pc_Search.sort}" />
																		<f:param id="refineAnyParamSartRemove" name="sart" value="#{pc_Search.searchArtifacts}" />
																		<f:param id="refineAnyParamSshdwRemove" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
																		<f:param id="refineAnyParamForumRemove" name="forum" value="#{pc_Search.searchForums}" />
																	</hx:requestLink>
																	<hx:requestLink id="facetNoneCountLinkRemove">
																		<h:graphicImage id="facetCountNoneImageRemove" value="/theme/images/icons/filter_none.gif" 
																			style="vertical-align: middle;" title="#{bundle.alt_search_filters_none}"></h:graphicImage>
																		<f:param id="facetParamRemove" name="r" value="#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineNoneParamARemove" name="a" value="com.ibm.ram.notcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineNoneParamNRemove" name="n" value="#{pc_Search.fullNode}" />
																		<f:param id="refineNoneParamSRemove" name="s" value="#{pc_Search.sort}" />
																		<f:param id="refineNoneParamSartRemove" name="sart" value="#{pc_Search.searchArtifacts}" />
																		<f:param id="refineNoneParamSshdwRemove" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
																		<f:param id="refineNoneParamForumRemove" name="forum" value="#{pc_Search.searchForums}" />
																	</hx:requestLink>
																</span>
															</hx:jspPanel>
														</td>
														<td width="100%"></td>
													</tr>
												</hx:jspPanel>
											</hx:dataIterator>
										</table>
									</hx:jspPanel>
								</fieldset>
							</div>
						</hx:jspPanel>
						
						<hx:jspPanel id="currentOrFacetsJspPanel" rendered="#{not empty pc_Search.currentOrFacets}">
							<div style="margin-top: 5px;">
								<fieldset style="border: 0px">
									<legend>
										<img src="<%=request.getContextPath() + "/theme/images/icons/filter_part.gif"%>" align="top">
										<span style="color: #838184">${bundle.alt_search_filters_any}</span>
									</legend>
									<hx:jspPanel id="currentOrFacetsTable">
										<table width="100%;" cellspacing="0" cellpadding="2" style="margin-left: 15px;">
											<hx:dataIterator id="currentOrFacets" value="#{pc_Search.currentOrFacets}" var="facet">
												<hx:jspPanel id="currentOrFacetsTableRow">
													<tr onmouseover="showRemoveAllAnyNoneOptions(this)" onmouseout="hideCurrentRemoveAllAnyNoneOptions()" height="21x;">
														<td>
															<hx:requestLink id="removeFacetOr" title="#{bundle.alt_remove_filter_link}">
																<hx:graphicImageEx id="removeFacetImgOr" value="/theme/images/icons/elcl16/delete.gif" style="vertical-align: middle; margin-bottom: 2px;"/>
																<f:param id="facetParamNOr" name="n" value="#{pc_Search.fullNode}" />
																<f:param id="facetParamSOr" name="s" value="#{pc_Search.sort}" />
																<f:param id="facetParamDOr" name="d" value="#{pc_Search.sortDirection}" />
																<f:param id="facetParamROr" name="r" value="com.ibm.ram.orcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																<f:param id="facetParamSartOr" name="sart" value="#{pc_Search.searchArtifacts}" />
																<f:param id="facetParamSshdwOr" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
																<f:param id="facetParamForumOr" name="forum" value="#{pc_Search.searchForums}" />
															</hx:requestLink>
														</td>
														<td>
															<hx:jspPanel id="removeAllAnyNoneTextPanelOr">
																<span>
																	<h:outputText id="currentFacetTextOr" value=" #{facet.facetNameMapping}: " styleClass="facetName" />
																	<h:outputText id="firstItemOr" value="#{facet.itemList[0]}" styleClass="facetSelection" />
																	<hx:dataIterator id="facetItemIteratorOr" value="#{facet.itemList}" var="item" first="1">
																		<h:outputText id="itemListTextOr" value="/#{item}" styleClass="facetSelection" />
																	</hx:dataIterator>
																</span>
															</hx:jspPanel>
														</td>
														<td>
															<hx:jspPanel id="removeAllAnyNonePanelOr">
																<span style="white-space: nowrap; display: none;">
																	<hx:requestLink id="facetAndCountLinkRemoveOr">
																		<h:graphicImage id="facetCountAllImageRemoveOr" value="/theme/images/icons/filter_all.gif" 
																				style="vertical-align: middle;" title="#{bundle.alt_search_filters_all}"></h:graphicImage>
																		<f:param id="facetParamRemoveOr" name="r" value="com.ibm.ram.orcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineAndParamARemoveOr" name="a" value="#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineAndParamNRemoveOr" name="n" value="#{pc_Search.fullNode}" />
																		<f:param id="refineAndParamSRemoveOr" name="s" value="#{pc_Search.sort}" />
																		<f:param id="refineAndParamSartRemoveOr" name="sart" value="#{pc_Search.searchArtifacts}" />
																		<f:param id="refineAndParamSshdwRemoveOr" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
																		<f:param id="refineAndParamForumRemoveOr" name="forum" value="#{pc_Search.searchForums}" />
																	</hx:requestLink>
																	<hx:requestLink id="facetNoneCountLinkRemoveOr">
																		<h:graphicImage id="facetCountNoneImageRemoveOr" value="/theme/images/icons/filter_none.gif" 
																			style="vertical-align: middle;" title="#{bundle.alt_search_filters_none}"></h:graphicImage>
																		<f:param id="facetParamRemove" name="r" value="com.ibm.ram.orcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineNoneParamARemoveOr" name="a" value="com.ibm.ram.notcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineNoneParamNRemoveOr" name="n" value="#{pc_Search.fullNode}" />
																		<f:param id="refineNoneParamSRemoveOr" name="s" value="#{pc_Search.sort}" />
																		<f:param id="refineNoneParamSartRemoveOr" name="sart" value="#{pc_Search.searchArtifacts}" />
																		<f:param id="refineNoneParamSshdwRemoveOr" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
																		<f:param id="refineNoneParamForumRemoveOr" name="forum" value="#{pc_Search.searchForums}" />
																	</hx:requestLink>
																</span>
															</hx:jspPanel>
														</td>
														<td width="100%"></td>
													</tr>
												</hx:jspPanel>											
											</hx:dataIterator>
										</table>
									</hx:jspPanel>
								</fieldset>
							</div>
						</hx:jspPanel>

						<hx:jspPanel id="currentNotFacetsJspPanel" rendered="#{not empty pc_Search.currentNotFacets}">
							<div style="margin-top: 5px;">
								<fieldset style="border: 0px;">
									<legend>
										<img src="<%=request.getContextPath() + "/theme/images/icons/filter_none.gif"%>" align="top">
										<span style="color: #838184">${bundle.alt_search_filters_none}</span>
									</legend>
									<hx:jspPanel id="currentNotFacetsTable">
										<table width="100%;" cellspacing="0" cellpadding="2" style="margin-left: 15px;">
											<hx:dataIterator id="currentNotFacets" value="#{pc_Search.currentNotFacets}" var="facet">
												<hx:jspPanel id="currentNotFacetsTableRow">
													<tr onmouseover="showRemoveAllAnyNoneOptions(this)" onmouseout="hideCurrentRemoveAllAnyNoneOptions()" height="21px;">
														<td>
															<hx:requestLink id="removeFacetNot" title="#{bundle.alt_remove_filter_link}">
																<hx:graphicImageEx id="removeFacetImgNot" value="/theme/images/icons/elcl16/delete.gif" style="vertical-align: middle; margin-bottom: 2px;"/>
																<f:param id="facetParamNNot" name="n" value="#{pc_Search.fullNode}" />
																<f:param id="facetParamSNot" name="s" value="#{pc_Search.sort}" />
																<f:param id="facetParamDNot" name="d" value="#{pc_Search.sortDirection}" />
																<f:param id="facetParamRNot" name="r" value="com.ibm.ram.notcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																<f:param id="facetParamSartNot" name="sart" value="#{pc_Search.searchArtifacts}" />
																<f:param id="facetParamSshdwNot" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
																<f:param id="facetParamForumNot" name="forum" value="#{pc_Search.searchForums}" />
															</hx:requestLink>
														</td>
														<td>
															<hx:jspPanel id="removeAllAnyNoneTextPanelNone">
																<span>
																	<h:outputText id="currentFacetTextNot" value=" #{facet.facetNameMapping}: " styleClass="facetName" />
																	<h:outputText id="firstItemNot" value="#{facet.itemList[0]}" styleClass="facetSelection" />
																	<hx:dataIterator id="facetItemIteratorNot" value="#{facet.itemList}" var="item" first="1">
																		<h:outputText id="itemListTextNot" value="/#{item}" styleClass="facetSelection" />
																	</hx:dataIterator>
																</span>
															</hx:jspPanel>
														</td>
														<td>
															<hx:jspPanel id="removeAllAnyNonePanelNone">
																<span style="white-space: nowrap; display: none;">
																	<hx:requestLink id="facetAndCountLinkRemoveNone">
																		<h:graphicImage id="facetCountAllImageRemoveNone" value="/theme/images/icons/filter_all.gif" 
																				style="vertical-align: middle;" title="#{bundle.alt_search_filters_all}"></h:graphicImage>
																		<f:param id="facetParamRemoveNone" name="r" value="com.ibm.ram.notcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineAndParamARemoveNone" name="a" value="#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineAndParamNRemoveNone" name="n" value="#{pc_Search.fullNode}" />
																		<f:param id="refineAndParamSRemoveNone" name="s" value="#{pc_Search.sort}" />
																		<f:param id="refineAndParamSartRemoveNone" name="sart" value="#{pc_Search.searchArtifacts}" />
																		<f:param id="refineAndParamSshdwRemoveNone" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
																		<f:param id="refineAndParamForumRemoveNone" name="forum" value="#{pc_Search.searchForums}" />
																	</hx:requestLink>
																	<hx:requestLink id="facetAnyCountLinkRemoveNone">
																		<h:graphicImage id="facetCountAnyImageRemoveNone" value="/theme/images/icons/filter_part.gif" 
																			style="vertical-align: middle;" title="#{bundle.alt_search_filters_any}"></h:graphicImage>
																		<f:param id="facetParamRRemoveNone" name="r" value="com.ibm.ram.notcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineAnyParamARemoveNone" name="a" value="com.ibm.ram.orcom.ibm.ram.facet.name#{facet.encodedFacetName},#{facet.facetSelections[0].encodedItem}" />
																		<f:param id="refineAnyParamNRemoveNone" name="n" value="#{pc_Search.fullNode}" />
																		<f:param id="refineAnyParamSRemoveNone" name="s" value="#{pc_Search.sort}" />
																		<f:param id="refineAnyParamSartRemoveNone" name="sart" value="#{pc_Search.searchArtifacts}" />
																		<f:param id="refineAnyParamSshdwRemoveNone" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
																		<f:param id="refineAnyParamForumRemoveNone" name="forum" value="#{pc_Search.searchForums}" />
																	</hx:requestLink>
																</span>
															</hx:jspPanel>
														</td>
														<td width="100%"></td>
													</tr>
												</hx:jspPanel>
											</hx:dataIterator>
										</table>
									</hx:jspPanel>
								</fieldset>
							</div>
						</hx:jspPanel>
						
					</td>
					<%-- Remove clear all filters for now to see if we can get use to it
					<td align="left" valign="top" nowrap="nowrap">
						<hx:jspPanel id="currentFacetPanel" rendered="#{not empty pc_Search.currentFacets}">
							<hx:requestLink id="removeAllFacets">
								<h:outputText id="removeAllText" value="#{bundle.search_clearAll}" />
							</hx:requestLink>
						</hx:jspPanel>
					</td>
					--%>
					<td align="right" valign="top" nowrap="nowrap">
					
						<hx:requestLink id="startBulkTask" action="#{pc_Search.doStartBulkOperationsTask}" 
							rendered="#{pc_Search.renderResults && not empty pc_Search.results.assetsList}">
							<f:param id="modParamN" name="n" value="#{pc_Search.fullNode}" />
							<f:param id="modParamR" name="r" value="#{facet.facetName},#{facet.facetSelections[0].item}" />
							<f:param id="modParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
							<f:param id="modParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
							<f:param id="modParamForum" name="forum" value="#{pc_Search.searchForums}" />
							<h:graphicImage id="modifyImage" 
								value="/theme/images/icons/obj16/return_bulk_asst.gif" 
								alt="#{bundle.search_modify}" title="#{bundle.search_modify}"
								style="margin: 0 3px 5px 0;" />
						</hx:requestLink>
						
						<hx:requestLink id="downloadCSV" action="#{pc_Search.doExportToCSV}" 
							rendered="#{pc_Search.renderResults && not empty pc_Search.results.assetsList}">
							<f:param id="csvParamN" name="n" value="#{pc_Search.fullNode}" />
							<f:param id="csvParamR" name="r" value="#{facet.facetName},#{facet.facetSelections[0].item}" />
							<f:param id="csvParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
							<f:param id="csvParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
							<f:param id="csvParamForum" name="forum" value="#{pc_Search.searchForums}" />
							<h:graphicImage id="download_as_spreadsheet" 
								value="/theme/images/icons/obj16/download_as_spreadsheet.png" 
								alt="#{bundle.alt_download_assets}" title="#{bundle.alt_download_assets}"
								style="margin: 0 3px 5px 0;" />
						</hx:requestLink>
					
						<a href="javascript:;" onclick="toggleSearchNodeField(this, 'resultsForm:searchNodeField')">
							<label for="resultsForm:searchNodeField" style="cursor: pointer;">
							<h:graphicImage id="searchNodeImage" 
								value="/theme/images/icons/obj16/search-string.gif" 
								alt="#{bundle.alt_view_search_shortcut}" title="#{bundle.alt_view_search_shortcut}"
								style="margin: 0 0 5px 3px;" />
							</label>
						</a>
						
						<h:inputText id="searchNodeField" value="#{pc_Search.searchNodeString}" style="display: none; margin: 0 0 8px 3px;">
							<hx:behaviorKeyPress id="searchNodeFieldBehavior" key="ENTER" onActionFunction="" />
						</h:inputText>
					
						<h:outputLink id="saveSearch" value="javascript:;" rendered="#{pc_Search.renderResults && not empty pc_Search.results.assetsList && !pc_Search.RAMUser.anonymous}">
							<h:graphicImage id="saveSearchImage" value="/theme/images/icons/etool16/save.gif" 
								alt="#{bundle.alt_save_search}" title="#{bundle.alt_save_search}" style="margin: 0 0 5px 3px;" />
							<hx:behavior id="saveSearchBehavior" event="onclick" onActionFunction="openSaveSearchDialog();" />
						</h:outputLink>
						
						<h:graphicImage id="spacer1" value="/theme/images/toolbar-spacer.gif" alt="" />
					
						<h:outputLink id="subscribeLink" value="javascript:;"
							rendered="#{pc_Search.subscribeAllowed}" title="#{bundle.alt_opens_dialog}">
							<h:graphicImage id="subscribeImage" 
								value="/theme/images/icons/elcl16/subscribe_asset.gif" 
								alt="#{bundle.search_subscribe}" title="#{bundle.search_subscribe}"
								style="margin: 0 3px 5px 0;" />
							<hx:behavior id="subscribeBehavior" event="onclick" targetAction="subscribeDialog" behaviorAction="show" />
						</h:outputLink>
						
						<h:outputLink id="feedLink"
							value="#{pc_Search.feedUrl}">
							<h:graphicImage id="feedImage" 
								value="/theme/images/icons/obj16/RSS_feed.gif" 
								alt="#{bundle.search_feed}" title="#{bundle.search_feed}"
								style="margin: 0 0 5px 3px;" />
						</h:outputLink>
						
						
						<h:graphicImage id="spacer2" value="/theme/images/toolbar-spacer.gif" alt="" />
						
						<ram:infopop id="resultsHelp" contextId="sass0030" styleClass="search-toolbar-infopop"
								image="/theme/images/icons/obj16/info_indicator.gif"/>
						
					</td>
				</tr></table>	
				
				<h:panelGroup id="moreTagsDiv" styleClass="#{pc_Search.splashTagsClass}" rendered="#{not empty pc_Search.results.tags}">
					<hx:jspPanel id="moreTagsPanel">
					
					<div class="ram-section">
						<div class="top-section-no-title"><div class="top-right"></div></div>
						<div class="middle-section">
						<div class="content-wrapper">
						<div class="content">
							<ram:tagCloud id="moreTagsCloud" value="#{pc_Search.results.tags}" tagVar="tag" tagCountVar="tagCount" tagClass="tagCloud" maxTags="150">
								<hx:requestLink id="moreTagsCloudLink">
									<h:outputText id="moreTagsCloudText" value="#{tag}" />
									<h:outputText id="moreTagsCloudCount" styleClass="hidden" value="#{bundle.common_ltr_mark}(#{tagCount})" />
									<f:param id="moreTagsParamA" name="a" value="#{pc_Search.results.tags.facetName},#{tag}" />
									<f:param id="moreTagsParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="moreTagsParamS" name="s" value="#{pc_Search.sort}" />
									<f:param id="moreTagsParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="moreTagsParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="moreTagsParamForums" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</ram:tagCloud>
							<div id="moreTagsLinks">
								<a id="moreTagsToggleLink" href="javascript:toggleTagCounts('moreTagsCloud', 'moreTagsToggleLink', 'moreTagsHideText')">${bundle.link_show_tag_counts}</a>
								<h:panelGroup id="viewLessGroup" rendered="#{pc_Search.renderResults}">
									<h:outputText id="viewLessTagsSep" value=" | " />
									<h:outputLink id="viewLessTags" value="#">
										<h:outputText id="viewLessText" value="#{bundle.link_view_less_tags}" />
										<hx:behavior id="showTagsBehavior2" event="onclick" behaviorAction="get;stop" targetAction="setShowTags"></hx:behavior>
									</h:outputLink>
								</h:panelGroup>
							</div>
							<div class="hidden" id="moreTagsHideText">${bundle.link_hide_tag_counts}</div>
						</div>
						</div>
						</div>
						<div class="bottom-section"><div class="bottom-right"></div></div>
					</div>
					
					</hx:jspPanel>
				</h:panelGroup>

				
				<hx:jspPanel id="searchResultsJspPanel" rendered="#{pc_Search.renderResults}">
				
				<h:panelGroup id="spellingHelpPanel" rendered="#{pc_Search.correctedQuery != null}" styleClass="spellHelp">
					<h:outputText id="spellingText" value="#{bundle.search_spelling} " styleClass="spellHelpText"/>
					<hx:requestLink id="spellingLink"
							value="#{pc_Search.correctedQuery}" styleClass="spellHelpLink">
							<f:param id="spellingParamN" name="n" value="#{pc_Search.fullNode}" />
							<f:param id="spellingParamTxt" name="txt" value="#{pc_Search.correctedQuery}" />
							<f:param id="spellingParamS" name="s" value="#{pc_Search.sort}" />
							<f:param id="spellingParamD" name="d" value="#{pc_Search.sortDirection}" />
							<f:param id="spellingParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
							<f:param id="spellingParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
							<f:param id="spellingParamForum" name="forum" value="#{pc_Search.searchForums}" />
						</hx:requestLink>
				</h:panelGroup>
				
				<h:panelGroup id="searchResultsPanel" rendered="#{not empty pc_Search.results.assetsList}">
					<h:inputHidden id="sortSetting" value="#{pc_Search.sort}"></h:inputHidden>
					<h:panelGroup id="viewButtonsPanelGroup" style="display: block; margin: 6px 0px 0px 0px; float: right;" >
						<h:panelGroup id="viewButtonsViewPanel" styleClass="searchViewButtonPanel" style="display: block;">
							<hx:commandExButton id="defaultDisplayButtonEnabled" styleClass="searchViewButton" type="image"
									rendered="#{not pc_Search.groupVersions}" 
									image="/theme/custom/images/buttons/defaultSearchViewSelected.png"
									himage="/theme/custom/images/buttons/defaultSearchViewSelected.png"
									pimage="/theme/custom/images/buttons/defaultSearchViewSelected.png"
									onclick="return basicSearch(true, 'false')"
									alt="#{bundle.alt_search_display_all_assets}" title="#{bundle.alt_search_display_all_assets}" />
							<hx:commandExButton id="displayGroupedVersionsButtonDisabled" styleClass="searchViewButton" type="image"
									rendered="#{not pc_Search.groupVersions}"  
									image="/theme/custom/images/buttons/groupedVersionSearchViewHover.png"
									himage="/theme/custom/images/buttons/groupedVersionSearchViewHover.png"
									pimage="/theme/custom/images/buttons/groupedVersionSearchViewHover.png"
									onclick="return basicSearch(true, 'true')"
									alt="#{bundle.alt_search_display_group_assets_by_version}" title="#{bundle.alt_search_display_group_assets_by_version}" />
							<hx:commandExButton id="defaultDisplayButtonDisabled" styleClass="searchViewButton" type="image"
									rendered="#{pc_Search.groupVersions}" 
									image="/theme/custom/images/buttons/defaultSearchViewHover.png"
									himage="/theme/custom/images/buttons/defaultSearchViewHover.png"
									pimage="/theme/custom/images/buttons/defaultSearchViewHover.png"
									onclick="return basicSearch(true, 'false')"
									alt="#{bundle.alt_search_display_all_assets}" title="#{bundle.alt_search_display_all_assets}" />
							<hx:commandExButton id="displayGroupedVersionsButtonEnabled" styleClass="searchViewButton" type="image"
									rendered="#{pc_Search.groupVersions}"  
									image="/theme/custom/images/buttons/groupedVersionSearchViewSelected.png"
									himage="/theme/custom/images/buttons/groupedVersionSearchViewSelected.png"
									pimage="/theme/custom/images/buttons/groupedVersionSearchViewSelected.png"
									onclick="return basicSearch(true, 'true')"
									alt="#{bundle.alt_search_display_group_assets_by_version}" title="#{bundle.alt_search_display_group_assets_by_version}" />
						</h:panelGroup>
					</h:panelGroup>
					
					<h:panelGroup id="viewTextPanelGroup" style="display: block; margin: 10px 5px 0px 0px; float: right;">
						<h:outputText id="searchViewDisplayText" value="#{bundle.label_display}"></h:outputText>
					</h:panelGroup>
				
					<h:panelGroup id="topPagerGroup" style="display: block; margin: 6px 0;" >
						<hx:requestLink id="topPreviousPageLink"
							rendered="#{pc_Search.page>0}"
							value="#{bundle.link_previous}">
							<f:param id="tprevParamN" name="n" value="#{pc_Search.fullNode}" />
							<f:param id="tprevParamS" name="s" value="#{pc_Search.sort}" />
							<f:param id="tprevParamD" name="d" value="#{pc_Search.sortDirection}" />
							<f:param id="tprevParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
							<f:param id="tprevParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
							<f:param id="tprevParamForum" name="forum" value="#{pc_Search.searchForums}" />
							<f:param id="tprevParamPage" name="page" value="#{pc_Search.page-1}" />
						</hx:requestLink>
						
						<h:outputText id="topPreviousPageText" styleClass="deactivatedLink" rendered="#{pc_Search.page<=0}"
							value="#{bundle.link_previous}" />
							
						<h:outputText id="topPagerSeparator1" value="  |  " style="font-size: 12pt;" />
						
						<h:outputText id="topPagerText" value="#{pc_Search.pagerMessage}" escape="false" />
						
						<h:outputText id="topPagerSeparator2" value="  |  " style="font-size: 12pt;" />
						
						<hx:requestLink id="topNextPageLink"
							rendered="#{pc_Search.results.offset + pc_Search.rowsPerPage < pc_Search.results.totalMatches}"
							value="#{bundle.link_next}">
							<f:param id="tnextParamN" name="n" value="#{pc_Search.fullNode}" />
							<f:param id="tnextParamS" name="s" value="#{pc_Search.sort}" />
							<f:param id="tnextParamD" name="d" value="#{pc_Search.sortDirection}" />
							<f:param id="tnextParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
							<f:param id="tnextParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
							<f:param id="tnextParamForum" name="forum" value="#{pc_Search.searchForums}" />
							<f:param id="tnextParamPage" name="page" value="#{pc_Search.page+1}" />
						</hx:requestLink>
						
						
						<h:outputText id="topNextPageText" styleClass="deactivatedLink" value="#{bundle.link_next}" 
							rendered="#{pc_Search.results.offset + pc_Search.rowsPerPage >= pc_Search.results.totalMatches}" />
					
					</h:panelGroup>
					
					<h:panelGroup id="scrollPanel" style="display:block; overflow:auto; width:100%; padding: 1px 0 0 1px;">
					<h:dataTable id="searchResults" value="#{pc_Search.results.groupedVersionAssetsList}" var="assets" styleClass="displayTable assetSearchResults"
						rowClasses="#{pc_Search.searchResultsRowClasses}" border="0"
						binding="#{pc_Search.searchResults}"
						width="100%"
						
						summary="#{bundle.section_search_results} - #{pc_Search.results.footerMessage}">
						<hx:columnEx id="artifactMatch" width="18px" rendered="#{(pc_Search.searchArtifacts || pc_Search.searchForums || pc_Search.groupVersions)  && (pc_Search.showNameColumn) }" valign="top">
							<h:outputLink style="text-decoration:none" id="artifactMatchLink" rendered="#{(not empty assets.matchingArtifacts) || (not empty assets.matchingPosts) || (not empty assets.groupedVersions)}" onclick="showArtifacts(this); return false;">
								<h:outputText id="artifactMatchText" value="[+]" />
							</h:outputLink>
							<h:outputLink style="text-decoration:none; display:none" id="artifactMatchMinusLink" rendered="#{(not empty assets.matchingArtifacts) || (not empty assets.childShadowAssets) || (not empty assets.matchingPosts) || (not empty assets.groupedVersions)}" onclick="hideArtifacts(this); return false;">
								<h:outputText id="artifactMatchMinusText" escape="false" value="[&ndash;]" />
							</h:outputLink>
						</hx:columnEx>
						
						<hx:columnEx id="name" valign="top" rendered="#{pc_Search.showNameColumn}">
							<f:facet name="header">
								<hx:requestLink id="nameHeaderLink" styleClass="sort">
									<h:outputText value="#{bundle.column_name}" id="nameHeaderText" />
									<hx:graphicImageEx id="nameHeaderImg" styleClass="sortImg" value="#{pc_Search.nameSort.sortImage}" />
									<f:param id="nameParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="nameParamS" name="s" value="#{pc_Search.nameSort.sortField}" />
									<f:param id="nameParamD" name="d" value="#{pc_Search.nameSort.sortDirection}" />
									<f:param id="nameParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="nameParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="nameParamForums" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="detailsLinksPanel">
								<div style="overflow: hidden">
								    <hx:graphicImageEx id="asset_img" value="/theme/images/icons/obj16/asset.gif" style="padding-right: 3px; vertical-align: text-top" rendered="#{(assets.managementStyle.value==0 ||  assets.managementStyle.value==5) && pc_Search.searchShadowAssets}"/>	
								    <hx:graphicImageEx id="shadow_asset_img" value="/theme/images/icons/obj16/shadow_asset.gif" style="padding-right: 3px; vertical-align: text-top" rendered="#{(assets.managementStyle.value==1 ||  assets.managementStyle.value==2 )&& pc_Search.searchShadowAssets}"/>
								    <hx:graphicImageEx id="groupedVersionImg" value="/theme/images/icons/obj16/asset.gif" style="padding-right: 3px; vertical-align: text-top; margin-left: 16px;" rendered="#{not assets.display}"/>	
									<ram:resourceRequestLink id="detailsLinkActive" action="assetDetails" 
										rendered="#{assets.readDetails}" value="#{assets.encodedName}" uri="#{assets.resourceURI}">
										<f:param id="detailActiveParamGuid" name="guid" value="#{assets.id}"></f:param>
										<f:param id="detailActiveParamV" name="v" value="#{assets.version}"></f:param>
										<f:param id="detailActiveParamS" name="submission" value="#{assets.submissionAsset}"></f:param>
									</ram:resourceRequestLink>
									<ram:resourceRequestLink id="detailsLinkInactive" action="assetDetails" 
										rendered="#{not assets.readDetails}" value="#{assets.encodedName}" styleClass="deactivatedLink" uri="#{assets.resourceURI}">
										<f:param id="detailInactiveParamGuid" name="guid" value="#{assets.id}"></f:param>
										<f:param id="detailInactiveParamV" name="v" value="#{assets.version}"></f:param>
										<f:param id="detailInactiveParamS" name="submission" value="#{assets.submissionAsset}"></f:param>
									</ram:resourceRequestLink>
									<hx:graphicImageEx id="nonviewable_img" value="/theme/images/icons/obj16/no_permission_obj.gif" style="padding-right: 3px; vertical-align: text-bottom" rendered="#{not assets.readDetails}"
										alt="#{bundle.alt_no_permission_view_asset}" title="#{bundle.alt_no_permission_view_asset}"/>							
								</div>
							</hx:jspPanel>
							
							<h:panelGroup id="artifactZoomPanel" rendered="#{(not empty assets.matchingArtifacts) || (not empty assets.childShadowAssets) || (not empty assets.matchingPosts) || (not empty assets.groupedVersions)}" style="display:none">
							
								<hx:dataIterator id="artifactIterator" value="#{assets.matchingArtifacts}" var="artifact">
									<h:panelGroup id="artifactPanelGroup" style="display:block; padding:0 0 3px 0; margin-left:16px;">
										<h:panelGroup id="artifactTitleGroup" styleClass="#{artifact.styleClass}">
											<hx:outputLinkEx id="artifactZoomLink" value="#{artifact.link}" target="_blank">
												<h:outputText id="artifactName" value="#{artifact.name}" />
											</hx:outputLinkEx>
											<hx:outputLinkEx id="artifactCacheLink" rendered="#{artifact.cacheURL != null}" value="#{artifact.cacheURL}" 
												target="_blank" style="margin-left: 5px;" styleClass="cacheLink">
												<h:outputText id="artifactCacheName" value="#{bundle.link_cache}" />
												<h:outputText id="artifactCacheAgeText" value="#{artifact.creationDate}" style="margin-left: 5px;">
													<f:convertDateTime type="date" dateStyle="short" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
												</h:outputText>
											</hx:outputLinkEx>
										</h:panelGroup>
										<hx:dataIterator id="artifactElementIterator" value="#{artifact.elements}" var="artifactElement">
											<h:panelGroup id="artifactElementGroup" style="display:block; padding:7px 0 0 0; margin-left:21px;">
												<h:outputText id="artifactElementPath" value="#{artifactElement.pathWithoutNamespace}" styleClass="labelBackgroundImage xmlElement deemphasized"/>
												<hx:dataIterator id="elementAttributeIterator" value="#{artifactElement.attributes}" var="artifactAttribute">
												<h:panelGroup id="artifactAttributeGroupAttribute" style="display:block; padding:7px 0 0 0; margin-left:21px;" rendered="#{!artifactAttribute.textAttribute}">
													<h:outputText id="artifactAttributeName" value="#{artifactAttribute.name}" styleClass="labelBackgroundImage xmlAttribute deemphasized"/>
													<h:outputText id="artifactAttributeEquals" styleClass="deemphasized"  value="="/>
													<h:outputText id="artifactAttributeValue" value="#{artifactAttribute.value}"/>
												</h:panelGroup>
												<h:panelGroup id="artifactAttributeGroupText" style="display:block; padding:7px 0 0 20px; margin-left:21px;" 
													styleClass="panelGroupLabelBackgroundImage xmlText" rendered="#{artifactAttribute.textAttribute}">
													<h:outputText id="artifactAttributeNameText" value="#{artifactAttribute.value}"/>
												</h:panelGroup>
												</hx:dataIterator>
												
											</h:panelGroup>
										</hx:dataIterator>
									</h:panelGroup>
								</hx:dataIterator>
								
								<hx:dataIterator id="postIterator" value="#{assets.matchingPosts}" var="post">
									<h:panelGroup id="postHeadingGroup" style="display:block; padding:0 0 3px 0; margin-left:16px;">
										<h:panelGroup id="forumTitleGroup" styleClass="labelBackgroundImage forumResult">
											<hx:requestLink id="linkToTopicTitle" rendered="#{post.topic}" action="#{pc_Search.getDiscussionTopicString}" style="padding-right: 5px">
												<h:outputText id="topicNameText" value="#{post.topicName}" />
												<f:param id="topicGuid" name="guid" value="#{assets.id}" />
												<f:param id="topicV" name="v" value="#{assets.version}" />
												<f:param id="topicTid" name="tid" value="#{post.topicId}" /> 
											</hx:requestLink>
											<hx:requestLink id="linkToTopicTitlePost" rendered="#{post.post}" action="#{pc_Search.getDiscussionTopicString}" style="padding-right: 5px">
												<h:outputText id="postTNameText" value="#{post.topicName}"></h:outputText>
												<f:param id="postGuid" name="guid" value="#{assets.id}"></f:param>
												<f:param id="postTopicV" name="v" value="#{assets.version}"></f:param>
												<f:param id="postTidPid" name="tid" value="#{post.topicId}#post#{post.postId}"></f:param> 
											</hx:requestLink>
											<h:outputText id="postResultSeparator" value=" | "/>
											<hx:requestLink id="linkToForumTitle" action="#{pc_Search.getDiscussionForumString}" style="padding-left: 5px">
												<h:outputText id="forumNameText" value="#{post.forumName}"></h:outputText>
												<f:param id="forumGuid" name="guid" value="#{assets.id}"></f:param>
												<f:param id="forumV" name="v" value="#{assets.version}"></f:param>
												<f:param id="forumFid" name="fid" value="#{post.forumId}"></f:param>
											</hx:requestLink>
										</h:panelGroup>
									</h:panelGroup>
									<h:outputText id="postDescText" escape="false" value="#{post.displayMessage}" style="display:block; margin-left: 40px"/>
								</hx:dataIterator>
								
								<h:panelGroup id="shadowPanel" rendered="#{not empty assets.childShadowAssets}"  >
									<h:panelGroup id="shadowedAssets" style="display:block; width:100%; padding:0 0 3px 6px">
									<h:dataTable id="shadowChildren" value="#{assets.childShadowAssets}" var="shadowChildren" 
										border="0" cellpadding="2" cellspacing="2" 
										width="100%">
										<hx:columnEx id="shadowAsset" width="18px" rendered="#{not empty shadowChildren.matchingArtifacts}" valign="top">
											<h:outputLink style="text-decoration:none" id="shadowAssetMatchLink" rendered="#{not empty shadowChildren.matchingArtifacts}" onclick="showPanel(this,'shadowAssetMatchLink','shadowAssetMatchMinusLink','shadowAssetZoomPanel'); return false;">
												<h:outputText id="shadowAssetMatchText" value="[+]" />
											</h:outputLink>
											<h:outputLink style="text-decoration:none; display:none" id="shadowAssetMatchMinusLink" rendered="#{not empty shadowChildren.matchingArtifacts}" onclick="hidePanel(this,'shadowAssetMatchLink','shadowAssetMatchMinusLink','shadowAssetZoomPanel'); return false;">
												<h:outputText id="shadowAssetMatchMinusText" escape="false" value="[&ndash;]" />
											</h:outputLink>
										</hx:columnEx>
										<hx:columnEx id="shadowAssetName"   valign="top"> 
										<hx:jspPanel id="shadowDetailsLinksPanel">
											<div style="overflow: hidden">
														<hx:requestLink id="shadowDtailsLinkActive" action="assetDetails" rendered="#{shadowChildren.readDetails}">
															<f:param id="shadowDtailActiveParamGuid" name="guid" value="#{shadowChildren.id}"></f:param>
															<f:param id="shadowDetailActiveParamV" name="v" value="#{shadowChildren.version}"></f:param>
															<f:param id="shadowDetailActiveParamS" name="submission" value="#{shadowChildren.submissionAsset}"></f:param>
															<h:outputText id="shadowActiveNameText" value="#{shadowChildren.name}" />
												</hx:requestLink>
														<hx:requestLink id="shadowDetailsLinkInactive" action="assetDetails" style="color: #999999; text-decoration: none" rendered="#{not shadowChildren.readDetails}">
															<f:param id="shadowDetailInactiveParamGuid" name="guid" value="#{shadowChildren.id}"></f:param>
															<f:param id="shadowDetailInactiveParamV" name="v" value="#{shadowChildren.version}"></f:param>
															<f:param id="shadowDetailInactiveParamS" name="submission" value="#{shadowChildren.submissionAsset}"></f:param>
															<h:outputText id="shadowInActiveNameText" value="#{shadowChildren.name}" />
												</hx:requestLink>
														<hx:graphicImageEx id="shadowNonviewable_img" value="/theme/images/icons/obj16/no_permission_obj.gif" style="padding-right: 3px; vertical-align: text-bottom" rendered="#{not shadowChildren.readDetails}"/>							
											</div>
										</hx:jspPanel>
											
										<h:panelGroup id="shadowAssetZoomPanel" rendered="#{not empty shadowChildren.matchingArtifacts}" style="display:none">
											 	<hx:dataIterator id="artifactIterator2" value="#{shadowChildren.matchingArtifacts}" var="artifact2">
													<h:panelGroup id="artifactPanelGroup2" style="display:block; padding:0 0 3px 15px">
														<hx:outputLinkEx id="artifactZoomLink2" value="#{artifact2.link}">
															<h:outputText id="artifactName2" value="#{artifact2.name}" />
														</hx:outputLinkEx>
													</h:panelGroup> 
												</hx:dataIterator>
										</h:panelGroup>
							
										</hx:columnEx>
							
									</h:dataTable>
									</h:panelGroup>
								</h:panelGroup>
								
							</h:panelGroup>
						</hx:columnEx>
						<hx:columnEx id="errorType" valign="top" rendered="#{pc_Search.indexingErrorQuery}">
							<f:facet name="header">
								<h:outputText value="#{bundle.column_indexing_error_type}" id="errorTypeHeader" />
							</f:facet>
							<hx:jspPanel id="errorTypePanel">
								<div style="overflow: hidden">
									<h:outputText id="errorTypeText" value="#{assets.indexingErrorType}"></h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="errorId" valign="top" rendered="#{pc_Search.indexingErrorQuery}">
							<f:facet name="header">
								<h:outputText value="#{bundle.column_indexing_error_id}" id="errorIdHeader" />
							</f:facet>
							<hx:jspPanel id="errorIdPanel">
								<div style="overflow: hidden">
									<h:outputText id="errorIdText" value="#{assets.indexingErrorId}"></h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="dbIdCol" valign="top" rendered="#{pc_Search.indexingErrorQuery}">
							<f:facet name="header">
								<h:outputText value="#{bundle.column_database_id}" id="dbIdColHeader" />
							</f:facet>
							<hx:jspPanel id="dbIdColPanel">
								<div style="overflow: hidden">
									<h:outputText id="dbIdColText" value="#{assets.dbId}"></h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="guidCol" valign="top" rendered="#{pc_Search.indexingErrorQuery}">
							<f:facet name="header">
								<h:outputText value="#{bundle.column_guid}" id="guidColHeader" />
							</f:facet>
							<hx:jspPanel id="guidColPanel">
								<div style="overflow: hidden">
									<h:outputText id="guidColText" value="#{assets.id}"></h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="version" valign="top" rendered="#{pc_Search.showVersionColumn}">
							<f:facet name="header">
								<hx:requestLink id="versionHeaderLink" styleClass="sort">
									<h:outputText value="#{bundle.column_version}" id="versionHeader" />
									<hx:graphicImageEx id="versionHeaderImg" styleClass="sortImg" value="#{pc_Search.versionSort.sortImage}" />
									<f:param id="versionParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="versionParamS" name="s" value="#{pc_Search.versionSort.sortField}" />
									<f:param id="versionParamD" name="d" value="#{pc_Search.versionSort.sortDirection}" />
									<f:param id="versionParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="versionParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="versionParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="versionPanel">
								<div style="overflow: hidden">
									<h:outputText id="versionText" value="#{assets.version}" />
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						
						<hx:columnEx id="server" valign="top" rendered="#{pc_Search.searchShadowAssets}">
							<f:facet name="header">
								<hx:requestLink id="serverHeaderLink" styleClass="sort">
									<h:outputText value="#{bundle.column_server}" id="serverHeader" />
									<hx:graphicImageEx id="serverHeaderImg" styleClass="sortImg" value="#{pc_Search.serverSort.sortImage}" />
									<f:param id="serverParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="serverParamS" name="s" value="#{pc_Search.serverSort.sortField}" />
									<f:param id="serverParamD" name="d" value="#{pc_Search.serverSort.sortDirection}" />
									<f:param id="serverParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="serverParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="serverParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="serverPanel">
								<div style="overflow: hidden">
									<h:outputText id="serverText" value="#{assets.serverName}" />
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="state" valign="top" rendered="#{pc_Search.showStateColumn}">
							<f:facet name="header">
								<hx:requestLink id="stateHeaderLink" styleClass="sort">
									<h:outputText value="#{bundle.column_state}" id="stateHeader" />
									<hx:graphicImageEx id="stateHeaderImg" styleClass="sortImg" value="#{pc_Search.stateSort.sortImage}" />
									<f:param id="stateParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="stateParamS" name="s" value="#{pc_Search.stateSort.sortField}" />
									<f:param id="stateParamD" name="d" value="#{pc_Search.stateSort.sortDirection}" />
									<f:param id="stateParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="stateParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="stateParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="stateTextPanel">
								<div style="overflow: hidden">
									<h:graphicImage id="stateImage" styleClass="stateIcon" value="#{assets.stateIconURL}"></h:graphicImage>
									<h:outputText id="stateText" value="#{assets.stateDisplayName}" />
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="type" valign="top" rendered="#{pc_Search.showTypeColumn}">
							<f:facet name="header">
								<hx:requestLink id="typeHeaderLink" styleClass="sort">
									<h:outputText value="#{bundle.column_type}" id="typeHeader" />
									<hx:graphicImageEx id="typeHeaderImg" styleClass="sortImg" value="#{pc_Search.typeSort.sortImage}" />
									<f:param id="typeParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="typeParamS" name="s" value="#{pc_Search.typeSort.sortField}" />
									<f:param id="typeParamD" name="d" value="#{pc_Search.typeSort.sortDirection}" />
									<f:param id="typeParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="typeParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="typeParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="typeTextPanel">
								<div style="overflow: hidden">
									<h:outputText id="typeText" value="#{assets.typeStr}" />
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="group" valign="top" rendered="#{pc_Search.showTeamspaceColumn}">
							<f:facet name="header">
								<hx:requestLink id="groupHeaderLink" styleClass="sort">
									<h:outputText value="#{bundle.column_teamspace}" id="groupHeader" />
									<hx:graphicImageEx id="groupHeaderImg" styleClass="sortImg" value="#{pc_Search.groupSort.sortImage}" />
									<f:param id="groupParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="groupParamS" name="s" value="#{pc_Search.groupSort.sortField}" />
									<f:param id="groupParamD" name="d" value="#{pc_Search.groupSort.sortDirection}" />
									<f:param id="groupParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="groupParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="groupParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="groupTextPanel">
								<div style="overflow: hidden">
									<h:outputText id="groupText" value="#{assets.groupStr}"></h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="submitter" valign="top" rendered="#{pc_Search.showSubmitterColumn}">
							<f:facet name="header">
								<hx:requestLink id="submitterHeaderLink" styleClass="sort">
									<h:outputText value="#{bundle.column_submitter}" id="submitterHeader" />
									<hx:graphicImageEx id="submitterHeaderImg" styleClass="sortImg" value="#{pc_Search.submitterSort.sortImage}" />
									<f:param id="submitterParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="submitterParamS" name="s" value="#{pc_Search.submitterSort.sortField}" />
									<f:param id="submitterParamD" name="d" value="#{pc_Search.submitterSort.sortDirection}" />
									<f:param id="submitterParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="submitterParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="submitterParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="submitterTextPanel">
								<div style="overflow: hidden">
									<h:outputText id="submitterText" value="#{assets.submitterName}"></h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="rating" valign="top" rendered="#{pc_Search.showRatingColumn}">
							<f:facet name="header">
								<hx:requestLink id="ratingHeaderLink" styleClass="sort">
									<h:outputText value="#{bundle.column_rating}" id="ratingHeader" />
									<hx:graphicImageEx id="rateHeaderImg" styleClass="sortImg" value="#{pc_Search.ratingSort.sortImage}" />
									<f:param id="ratingParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="ratingParamS" name="s" value="#{pc_Search.ratingSort.sortField}" />
									<f:param id="ratingParamD" name="d" value="#{pc_Search.ratingSort.sortDirection}" />
									<f:param id="ratingParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="ratingParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="ratingParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<h:panelGroup id="ratingStars" style="white-space:nowrap" rendered="#{assets.managementStyle.value == 0}">
								<ram:rating id="ramRatingId" value="#{assets.avgRating}" 
									onImg="/theme/custom/images/icons/obj16/grp_rate_1.gif" 
									halfImg="/theme/custom/images/icons/obj16/grp_rate_half.gif" 
									offImg="/theme/custom/images/icons/obj16/grp_rate_none.gif" styleClass="ustar"/>
							</h:panelGroup>
						</hx:columnEx>						
						<hx:columnEx id="lastModified" valign="top" rendered="#{pc_Search.showDateModifiedColumn}">
							<f:facet name="header">
								<hx:requestLink id="lastModifiedLink" styleClass="sort">
									<h:outputText value="#{bundle.column_modified}" id="lastModifiedHeader" />
									<hx:graphicImageEx id="lastModifiedImg" styleClass="sortImg" value="#{pc_Search.lastModifiedSort.sortImage}" />
									<f:param id="lastModifiedParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="lastModifiedParamS" name="s" value="#{pc_Search.lastModifiedSort.sortField}" />
									<f:param id="lastModifiedParamD" name="d" value="#{pc_Search.lastModifiedSort.sortDirection}" />
									<f:param id="lastModifiedParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="lasetModifiedParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="lastModifiedParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="lastModifiedPanel">
								<div style="overflow: hidden">
									<h:outputText id="lastModifiedText" value="#{assets.lastModified}">
										<%-- performance issues with current ICU4J
											<hx:convertDateTime type="date" /> --%>
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="submitted" valign="top" rendered="#{pc_Search.showSubmitDateColumn}">
							<f:facet name="header">
								<hx:requestLink id="submittedLink" styleClass="sort">
									<h:outputText value="#{bundle.column_submitted}" id="submittedHeader" />
									<hx:graphicImageEx id="submittedImg" styleClass="sortImg" value="#{pc_Search.submitDateSort.sortImage}" />
									<f:param id="submittedParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="submittedParamS" name="s" value="#{pc_Search.submitDateSort.sortField}" />
									<f:param id="submittedParamD" name="d" value="#{pc_Search.submitDateSort.sortDirection}" />
									<f:param id="submittedParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="submittedParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="submittedParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="dateSubmittedPanel">
								<div style="overflow: hidden">
									<h:outputText id="submittedText" value="#{assets.lastSubmitDate}">
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						
						<hx:columnEx id="attrColumn1" valign="top" rendered="#{pc_Search.attributeColumnCount > 0}">
							<f:facet name="header">
								<hx:requestLink id="attrHeaderLink1" styleClass="sort">
									<h:outputText value="#{pc_Search.attribute1Name}" id="attrHeader1" />
									<hx:graphicImageEx id="attrHeaderImg1" styleClass="sortImg" value="#{pc_Search.attribute1Sort.sortImage}" />
									<f:param id="attr1ParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="attr1ParamS" name="s" value="#{pc_Search.attribute1Sort.sortField}" />
									<f:param id="attr1ParamD" name="d" value="#{pc_Search.attribute1Sort.sortDirection}" />
									<f:param id="attr1ParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="attr1ParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="attr1ParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="attrPanel1">
								<div style="overflow: hidden">
									<ram:outputAttribute id="attr1" value="#{pc_Search.attribute1.attributeValue}" type="#{pc_Search.attribute1.type}" />
								</div>
							</hx:jspPanel>
						</hx:columnEx>

						<hx:columnEx id="attrColumn2" valign="top" rendered="#{pc_Search.attributeColumnCount > 1}">
							<f:facet name="header">
								<hx:requestLink id="attrHeaderLink2" styleClass="sort">
									<h:outputText value="#{pc_Search.attribute2Name}" id="attrHeader2" />
									<hx:graphicImageEx id="attrHeaderImg2" styleClass="sortImg" value="#{pc_Search.attribute2Sort.sortImage}" />
									<f:param id="attr2ParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="attr2ParamS" name="s" value="#{pc_Search.attribute2Sort.sortField}" />
									<f:param id="attr2ParamD" name="d" value="#{pc_Search.attribute2Sort.sortDirection}" />
									<f:param id="attr2ParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="attr2ParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="attr2ParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="attrPanel2">
								<div style="overflow: hidden">
									<ram:outputAttribute id="attr2" value="#{pc_Search.attribute2.attributeValue}" type="#{pc_Search.attribute2.type}" />
								</div>
							</hx:jspPanel>
						</hx:columnEx>

						<hx:columnEx id="attrColumn3" valign="top" rendered="#{pc_Search.attributeColumnCount > 2}">
							<f:facet name="header">
								<hx:requestLink id="attrHeaderLink3" styleClass="sort">
									<h:outputText value="#{pc_Search.attribute3Name}" id="attrHeader3" />
									<hx:graphicImageEx id="attrHeaderImg3" styleClass="sortImg" value="#{pc_Search.attribute3Sort.sortImage}" />
									<f:param id="attr3ParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="attr3ParamS" name="s" value="#{pc_Search.attribute3Sort.sortField}" />
									<f:param id="attr3ParamD" name="d" value="#{pc_Search.attribute3Sort.sortDirection}" />
									<f:param id="attr3ParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="attr3ParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="attr3ParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="attrPanel3">
								<div style="overflow: hidden">
									<ram:outputAttribute id="attr3" value="#{pc_Search.attribute3.attributeValue}" type="#{pc_Search.attribute3.type}" />
								</div>
							</hx:jspPanel>
						</hx:columnEx>

						<hx:columnEx id="attrColumn4" valign="top" rendered="#{pc_Search.attributeColumnCount > 3}">
							<f:facet name="header">
								<hx:requestLink id="attrHeaderLink4" styleClass="sort">
									<h:outputText value="#{pc_Search.attribute4Name}" id="attrHeader4" />
									<hx:graphicImageEx id="attrHeaderImg4" styleClass="sortImg" value="#{pc_Search.attribute4Sort.sortImage}" />
									<f:param id="attr4ParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="attr4ParamS" name="s" value="#{pc_Search.attribute4Sort.sortField}" />
									<f:param id="attr4ParamD" name="d" value="#{pc_Search.attribute4Sort.sortDirection}" />
									<f:param id="attr4ParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="attr4ParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="attr4ParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="attrPanel4">
								<div style="overflow: hidden">
									<ram:outputAttribute id="attr4" value="#{pc_Search.attribute4.attributeValue}" type="#{pc_Search.attribute4.type}" />
								</div>
							</hx:jspPanel>
						</hx:columnEx>

						<hx:columnEx id="attrColumn5" valign="top" rendered="#{pc_Search.attributeColumnCount > 4}">
							<f:facet name="header">
								<hx:requestLink id="attrHeaderLink5" styleClass="sort">
									<h:outputText value="#{pc_Search.attribute5Name}" id="attrHeader5" />
									<hx:graphicImageEx id="attrHeaderImg5" styleClass="sortImg" value="#{pc_Search.attribute5Sort.sortImage}" />
									<f:param id="attr5ParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="attr5ParamS" name="s" value="#{pc_Search.attribute5Sort.sortField}" />
									<f:param id="attr5ParamD" name="d" value="#{pc_Search.attribute5Sort.sortDirection}" />
									<f:param id="attr5ParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="attr5ParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="attr5ParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="attrPanel5">
								<div style="overflow: hidden">
									<ram:outputAttribute id="attr5" value="#{pc_Search.attribute5.attributeValue}" type="#{pc_Search.attribute5.type}" />
								</div>
							</hx:jspPanel>
						</hx:columnEx>

						<!-- Legacy review columns -->
						<hx:columnEx id="approved" valign="top" rendered="#{pc_Search.showApproveDateColumn}">
							<f:facet name="header">
								<hx:requestLink id="approvedLink" styleClass="sort">
									<h:outputText value="#{bundle.column_approved}" id="approvedHeader" />
									<hx:graphicImageEx id="approvedImg" styleClass="sortImg" value="#{pc_Search.approveDateSort.sortImage}" />
									<f:param id="approvedParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="approvedParamS" name="s" value="#{pc_Search.approveDateSort.sortField}" />
									<f:param id="approvedParamD" name="d" value="#{pc_Search.approveDateSort.sortDirection}" />
									<f:param id="approvedParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="approvedParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="approvedParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="dateApprovedPanel">
								<div style="overflow: hidden">
									<h:outputText id="approvedText" value="#{assets.lastApproveDate}">
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="archived" valign="top" rendered="#{pc_Search.showArchiveDateColumn}">
							<f:facet name="header">
								<hx:requestLink id="archivedLink" styleClass="sort">
									<h:outputText value="#{bundle.column_archived}" id="archivedHeader" />
									<hx:graphicImageEx id="archivedImg" styleClass="sortImg" value="#{pc_Search.archiveDateSort.sortImage}" />
									<f:param id="archivedParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="archivedParamS" name="s" value="#{pc_Search.archiveDateSort.sortField}" />
									<f:param id="archivedParamD" name="d" value="#{pc_Search.archiveDateSort.sortDirection}" />
									<f:param id="archivedParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="archivedParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="archivedParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="dateArchivedPanel">
								<div style="overflow: hidden">
									<h:outputText id="archivedText" value="#{assets.lastArchiveDate}">
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="asIs" valign="top" rendered="#{pc_Search.showAsIsDateColumn}">
							<f:facet name="header">
								<hx:requestLink id="asIsLink" styleClass="sort">
									<h:outputText value="#{bundle.column_asIs}" id="asIsHeader" />
									<hx:graphicImageEx id="asIsImg" styleClass="sortImg" value="#{pc_Search.asIsDateSort.sortImage}" />
									<f:param id="asIsParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="asIsParamS" name="s" value="#{pc_Search.asIsDateSort.sortField}" />
									<f:param id="asIsParamD" name="d" value="#{pc_Search.asIsDateSort.sortDirection}" />
									<f:param id="asIsParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="asIsParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="asIsParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="dateAsIsPanel">
								<div style="overflow: hidden">
									<h:outputText id="asIsText" value="#{assets.lastAsIsDate}">
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="draft" valign="top" rendered="#{pc_Search.showDraftDateColumn}">
							<f:facet name="header">
								<hx:requestLink id="draftLink" styleClass="sort">
									<h:outputText value="#{bundle.column_draft}" id="draftHeader" />
									<hx:graphicImageEx id="draftImg" styleClass="sortImg" value="#{pc_Search.draftDateSort.sortImage}" />
									<f:param id="draftParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="draftParamS" name="s" value="#{pc_Search.draftDateSort.sortField}" />
									<f:param id="draftParamD" name="d" value="#{pc_Search.draftDateSort.sortDirection}" />
									<f:param id="draftParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="draftParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="draftParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="dateDraftPanel">
								<div style="overflow: hidden">
									<h:outputText id="draftText" value="#{assets.lastDraftDate}">
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="evalReview" valign="top" rendered="#{pc_Search.showEvalReviewDateColumn}">
							<f:facet name="header">
								<hx:requestLink id="evalReviewLink" styleClass="sort">
									<h:outputText value="#{bundle.column_evaluateReview}" id="evalReviewHeader" />
									<hx:graphicImageEx id="evalReviewImg" styleClass="sortImg" value="#{pc_Search.evaluateReviewDateSort.sortImage}" />
									<f:param id="evalReviewParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="evalReviewParamS" name="s" value="#{pc_Search.evaluateReviewDateSort.sortField}" />
									<f:param id="evalReviewParamD" name="d" value="#{pc_Search.evaluateReviewDateSort.sortDirection}" />
									<f:param id="evalReviewParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="evalParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="evalParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="dateEvalReviewPanel">
								<div style="overflow: hidden">
									<h:outputText id="evalReviewText" value="#{assets.lastEvaluateReviewDate}">
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="planReview" valign="top" rendered="#{pc_Search.showPlanReviewDateColumn}">
							<f:facet name="header">
								<hx:requestLink id="planReviewLink" styleClass="sort">
									<h:outputText value="#{bundle.column_planReview}" id="planReviewHeader" />
									<hx:graphicImageEx id="planReviewImg" styleClass="sortImg" value="#{pc_Search.planReviewDateSort.sortImage}" />
									<f:param id="planReviewParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="planReviewParamS" name="s" value="#{pc_Search.planReviewDateSort.sortField}" />
									<f:param id="planReviewParamD" name="d" value="#{pc_Search.planReviewDateSort.sortDirection}" />
									<f:param id="planReviewParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="planParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="planParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="datePlanReviewPanel">
								<div style="overflow: hidden">
									<h:outputText id="planReviewText" value="#{assets.lastPlanReviewDate}">
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>	
						</hx:columnEx>
						<hx:columnEx id="retired" valign="top" rendered="#{pc_Search.showRetireDateColumn}">
							<f:facet name="header">
								<hx:requestLink id="retiredLink" styleClass="sort">
									<h:outputText value="#{bundle.column_retired}" id="retiredHeader" />
									<hx:graphicImageEx id="retiredImg" styleClass="sortImg" value="#{pc_Search.retireDateSort.sortImage}" />
									<f:param id="retiredParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="retiredParamS" name="s" value="#{pc_Search.retireDateSort.sortField}" />
									<f:param id="retiredParamD" name="d" value="#{pc_Search.retireDateSort.sortDirection}" />
									<f:param id="retiredParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="retiredParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="retiredParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="dateRetiredPanel">
								<div style="overflow: hidden">
									<h:outputText id="retiredText" value="#{assets.lastRetireDate}">
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="review" valign="top" rendered="#{pc_Search.showReviewDateColumn}">
							<f:facet name="header">
								<hx:requestLink id="reviewLink" styleClass="sort">
									<h:outputText value="#{bundle.column_review}" id="reviewHeader" />
									<hx:graphicImageEx id="reviewImg" styleClass="sortImg" value="#{pc_Search.reviewDateSort.sortImage}" />
									<f:param id="reviewParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="reviewParamS" name="s" value="#{pc_Search.reviewDateSort.sortField}" />
									<f:param id="reviewParamD" name="d" value="#{pc_Search.reviewDateSort.sortDirection}" />
									<f:param id="reviewParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="reviewParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="reviewParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="dateReviewPanel">
								<div style="overflow: hidden">
									<h:outputText id="reviewText" value="#{assets.lastReviewDate}">
										<f:convertDateTime type="date" dateStyle="medium" timeZone="#{pc_Search.timezone}" locale="#{pc_Search.locale}" />
									</h:outputText>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
						<hx:columnEx id="score" valign="top" rendered="#{not empty pc_Search.textQueries}">
							<f:facet name="header">
								<hx:requestLink id="scoreHeaderLink" styleClass="sort">
									<h:outputText value="#{bundle.column_relevance}" id="scoreHeader" />
									<hx:graphicImageEx id="scoreHeaderImg" styleClass="sortImg" value="#{pc_Search.relevanceSort.sortImage}" />
									<f:param id="scoreParamN" name="n" value="#{pc_Search.fullNode}" />
									<f:param id="scoreParamS" name="s" value="#{pc_Search.relevanceSort.sortField}" />
									<f:param id="scoreParamD" name="d" value="#{pc_Search.relevanceSort.sortDirection}" />
									<f:param id="scoreParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
									<f:param id="scoreParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
									<f:param id="scoreParamForum" name="forum" value="#{pc_Search.searchForums}" />
								</hx:requestLink>
							</f:facet>
							<hx:jspPanel id="scoreJspPanel">
								<div style="overflow: hidden">
									<h:panelGroup id="scorePanel" style="float: left; display: block; background: #8c9ca4; width: #{assets.relevance}%">
										<h:outputText id="scoreSpace" escape="false" value="#{assets.relevance}" style="color:#8c9ca4;"></h:outputText>
									</h:panelGroup>
									<h:panelGroup id="scoreTotalPanel" style="float:right; display: block; background: #b4ccd4; width: #{100 - assets.relevance}%">
										<h:outputText id="scoreTotalSpace" escape="false" value="&nbsp;"></h:outputText>
									</h:panelGroup>
								</div>
							</hx:jspPanel>
						</hx:columnEx>
					</h:dataTable>
					</h:panelGroup>
					
					<h:panelGroup id="bottomPagerGroup" style="display: block; margin: 6px 0;" >
					
						<hx:requestLink id="bottomPreviousPageLink"
							rendered="#{pc_Search.page>0}"
							value="#{bundle.link_previous}">
							<f:param id="bprevParamN" name="n" value="#{pc_Search.fullNode}" />
							<f:param id="bprevParamS" name="s" value="#{pc_Search.sort}" />
							<f:param id="bprevParamD" name="d" value="#{pc_Search.sortDirection}" />
							<f:param id="bprevParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
							<f:param id="bprevParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
							<f:param id="bprevParamForum" name="forum" value="#{pc_Search.searchForums}" />
							<f:param id="bprevParamPage" name="page" value="#{pc_Search.page-1}" />
						</hx:requestLink>
						
						<h:outputText id="bottomPreviousPageText" styleClass="deactivatedLink" rendered="#{pc_Search.page<=0}"
							value="#{bundle.link_previous}" />
							
						<h:outputText id="bottomPagerSeparator1" value="  |  " style="font-size: 12pt;" />
						
						<h:outputText id="bottomPagerText" value="#{pc_Search.pagerMessage}" escape="false" />
						
						<h:outputText id="bottomPagerSeparator2" value="  |  " style="font-size: 12pt;" />
						
						<hx:requestLink id="bottomNextPageLink"
							rendered="#{pc_Search.results.offset + pc_Search.rowsPerPage < pc_Search.results.totalMatches}"
							value="#{bundle.link_next}">
							<f:param id="bnextParamN" name="n" value="#{pc_Search.fullNode}" />
							<f:param id="bnextParamS" name="s" value="#{pc_Search.sort}" />
							<f:param id="bnextParamD" name="d" value="#{pc_Search.sortDirection}" />
							<f:param id="bnextParamSart" name="sart" value="#{pc_Search.searchArtifacts}" />
							<f:param id="bnextParamSshdw" name="sshdw" value="#{pc_Search.searchShadowAssets}" />
							<f:param id="bnextParamForum" name="forum" value="#{pc_Search.searchForums}" />
							<f:param id="bnextParamPage" name="page" value="#{pc_Search.page+1}" />
						</hx:requestLink>
						
						<h:outputText id="bottomNextPageText" styleClass="deactivatedLink" value="#{bundle.link_next}" 
							rendered="#{pc_Search.results.offset + pc_Search.rowsPerPage >= pc_Search.results.totalMatches}" />
					
					</h:panelGroup>
					
					<h:outputLink id="selectColumns" title="#{bundle.alt_opens_dialog}" value="#" rendered="#{loginUser.user.registered}">
						<h:outputText id="selectColumnsText" value="#{bundle.link_select_columns}"/>
						<hx:behavior id="selectColumnsBehavior" target="selectColumns" event="onclick" targetAction="selectColumnsDialog" behaviorAction="show;stop" />
					</h:outputLink>
					<h:outputLink id="selectColumns2" title="#{bundle.alt_opens_dialog}" value="#{loginUser.loginAction}" rendered="#{!loginUser.user.registered}">
						<h:outputText id="selectColumnsText2" value="#{bundle.link_select_columns}"/>
					</h:outputLink>
					
				</h:panelGroup>
					
			<hx:jspPanel id="noResultsPanel" rendered="#{empty pc_Search.results.assetsList}">
				<div style="padding: 0 3px">
				<p>${bundle.search_noResults}</p>
				</div>
			</hx:jspPanel>
			
			<hx:jspPanel id="noResultsTipsPanel" rendered="#{not loginUser.user.registered && empty pc_Search.results.assetsList}">
				<div style="padding: 0 3px">
				<p><b>${bundle.search_tips}</b></p>
				<ul>
					<li>${bundle.search_tips5}</li>
					<li>${bundle.search_tips2}</li>
					<li>${bundle.search_tips1}</li>
					<li>${bundle.search_tips4}</li>
				</ul>
				</div>
			</hx:jspPanel>
			</hx:jspPanel>
			</ram:form>
			
		</div>
		</div>
		
		<%@ include file="../theme/footer.jspf" %>
	</hx:scriptCollector>
	</body>
</f:view>
 
</html>
